SystemOrganization addCategory: #'SightL-Evaluation'!
SystemOrganization addCategory: #'SightL-Example-Observer'!
SystemOrganization addCategory: #'SightL-Models'!
SystemOrganization addCategory: #'SightL-Morphic'!
SystemOrganization addCategory: #'SightL-PF-Callgraph'!
SystemOrganization addCategory: #'SightL-PF-Debugger'!
SystemOrganization addCategory: #'SightL-PF-TestChooser'!
SystemOrganization addCategory: #'SightL-PF-Tracer'!
SystemOrganization addCategory: #'SightL-PM-Base'!
SystemOrganization addCategory: #'SightL-PM-Coloring'!
SystemOrganization addCategory: #'SightL-PM-Metrics'!
SystemOrganization addCategory: #'SightL-PM-Morphic'!
SystemOrganization addCategory: #'SightL-PM-Options'!
SystemOrganization addCategory: #'SightL-PM-Tracer'!
SystemOrganization addCategory: #'SightL-PM-Wrapper'!
SystemOrganization addCategory: #'SightL-PV-ClassMorph'!
SystemOrganization addCategory: #'SightL-PV-Morphic'!
SystemOrganization addCategory: #'SightL-Projects'!
SystemOrganization addCategory: #'SightL-Record-Replay'!
SystemOrganization addCategory: #'SightL-Scripts'!
SystemOrganization addCategory: #'SightL-Specs'!
SystemOrganization addCategory: #'SightL-StateView'!
SystemOrganization addCategory: #'SightL-Tests-Callgraph'!
SystemOrganization addCategory: #'SightL-Tests-MethodWrappers'!
SystemOrganization addCategory: #'SightL-Tests-PathFinder'!
SystemOrganization addCategory: #'SightL-Tests-Projects'!
SystemOrganization addCategory: #'SightL-Tests-Record-Replay'!
SystemOrganization addCategory: #'SightL-Tests-Sandbox'!
SystemOrganization addCategory: #'SightL-Tests-Tracer'!
SystemOrganization addCategory: #'SightL-Tools'!
SystemOrganization addCategory: #'SightL-Tracer'!

Object subclass: #Driver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

!Driver methodsFor: 'as yet unclassified' stamp: 'mp 6/18/2010 21:24'!
run
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := AnalogClock on: timer.
	digitalClock := DigitalClock on: timer.
	
	timer tick.! !

Object subclass: #Observer
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

Observer subclass: #AnalogClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

!AnalogClock methodsFor: 'as yet unclassified' stamp: 'fg 4/12/2010 15:39'!
draw
	| hour minute second |

	hour := subject hour.
	minute := subject minute.
	second := subject second.
	
	"draw the digital clock"! !

!AnalogClock methodsFor: 'as yet unclassified' stamp: 'fg 4/12/2010 15:39'!
update: aSubject
	aSubject = subject ifTrue: [ self draw]! !

Observer subclass: #DigitalClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

!DigitalClock methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:38'!
draw
	| hour minute second |

	hour := subject hour.
	minute := subject minute.
	second := subject second.
	
	"draw the digital clock"! !

!DigitalClock methodsFor: 'accessing' stamp: 'mp 3/19/2011 18:26:20.3'!
update: aSubject
	aSubject = subject ifTrue: [self draw]! !

!Observer class methodsFor: 'as yet unclassified' stamp: 'mp 4/28/2010 14:12'!
on: aSubject
	| observer |
	observer := self new
				subject: aSubject;
				yourself.
	aSubject attach: observer.
	^ observer.! !

!Observer methodsFor: 'accessing' stamp: 'mp 4/28/2010 14:11'!
subject
	"Answer the value of subject"

	^ subject! !

!Observer methodsFor: 'accessing' stamp: 'mp 4/28/2010 14:11'!
subject: anObject
	"Set the value of subject"

	subject := anObject! !

!Observer methodsFor: 'as yet unclassified' stamp: 'mp 4/28/2010 14:11'!
update: aSubject

	self subclassResponsibility.! !

Object subclass: #SCallgraphTracer
	instanceVariableNames: 'selectedCategories callgraphModel profilingMode viewMode active currentId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

!SCallgraphTracer class methodsFor: 'as yet unclassified' stamp: 'mp 1/18/2010 16:29'!
on: aCollectionOfCategories

	^ self new
		selectedCategories: aCollectionOfCategories! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:33'!
active
	^ active! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:33'!
active: anObject
	active := anObject! !

!SCallgraphTracer methodsFor: 'callgraph' stamp: 'mp 1/25/2010 15:56'!
addProfileInformation:  aValue node: anId

	(self getNode: anId) profiles at: self profilingMode put: aValue.! !

!SCallgraphTracer methodsFor: 'callgraph' stamp: 'mp 1/25/2010 15:19'!
addView:  aString to: aSymbol

	self callgraphModel currentNode views at: aSymbol put: aString.! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'mp 11/8/2010 15:17:54.236'!
byteCodeCoverageAt: aCallNode
	| wrapper |
	wrapper := self runTestWithSpecificWrapper: (
					self createByteCodeCoverageWrapperOn: aCallNode).
	^ wrapper coveredByteCodes
! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:29'!
callgraphModel
	^ callgraphModel! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:29'!
callgraphModel: anObject
	callgraphModel := anObject! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'mp 11/8/2010 15:19:41.521'!
createByteCodeCoverageWrapperOn: aCallNode

	^ SByteCodeCoverageWrapper 
			on: aCallNode clientSelector 
			inClass: aCallNode clientClass 
			waitingCalls: (self callgraphModel numberOfCallsBefore: aCallNode)! !

!SCallgraphTracer methodsFor: 'callgraph' stamp: 'mp 7/7/2010 17:07:23.694'!
createCodeRootNode: aSourceCodeString

	self callgraphModel rootNode: (SRootCodeCallNode 
								id: self rootId
								code: aSourceCodeString
								fromSender: nil
								model: self callgraphModel).
	self currentId: self rootId.
	self callgraphModel currentNode: self callgraphModel rootNode.! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'mp 7/7/2010 17:21:01.772'!
createDebugWrapperOn: aCallNode

	^ SDebugWrapper 
			on: aCallNode clientSelector 
			inClass: aCallNode clientClass 
			waitingCalls: (self callgraphModel numberOfCallsBefore: aCallNode)! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'mp 7/7/2010 17:21:11.71'!
createExploreWrapper: aSymbol on: aCallNode 
	
	^ SExploreWrapper 
		on: aCallNode clientSelector
		inClass: aCallNode clientClass
		waitingCalls: aCallNode callsBefore
		exploreWhat: aSymbol! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 7/7/2010 17:06:53.646'!
createNewCallNodeOn: aClass with: aSelector receiverType: aTypeClass callsBefore: aNumber

	| node |
	node := SCallNode 
			id: self nextId 
			class: aClass
			methodName: aSelector
			fromSender: self callgraphModel currentNode
			model: self callgraphModel
			receiverType: aTypeClass
			callsBefore: aNumber.
	self callgraphModel currentNode addCall: node.
	self callgraphModel currentNode: node.
	self callgraphModel currentNode 
		selectedView: self viewMode;
		selectedProfile: self profilingMode.
	^ node id! !

!SCallgraphTracer methodsFor: 'callgraph' stamp: 'mp 1/25/2010 13:37'!
createNewCallgraphOn: aTestCaseClass with: aMethodSelector

	self 
		resetCallgraph;
		createRootNode: aTestCaseClass withTest: aMethodSelector.! !

!SCallgraphTracer methodsFor: 'callgraph' stamp: 'mp 5/2/2010 12:34'!
createNewCallgraphOnCode: aSourceCodeString
	self 
		resetCallgraph;
		createCodeRootNode: aSourceCodeString.! !

!SCallgraphTracer methodsFor: 'callgraph' stamp: 'mp 7/7/2010 17:07:08.57'!
createRootNode: aTestClass withTest: aSelector

	self callgraphModel rootNode: (SRootTestCallNode 
								id: self rootId
								class: aTestClass
								methodName: aSelector 
								fromSender: nil
								model: self callgraphModel
								receiverType: aTestClass
								callsBefore: 0).
	self currentId: self rootId.
	self callgraphModel currentNode: self callgraphModel rootNode.! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 1/25/2010 15:22'!
createWrapperOn: aClass and: aSelector addTo: aCollection
	| wrapper |
	wrapper := self getCallWrapperClass on: aSelector inClass: aClass withTracer: self.
	wrapper ifNotNil: [
		wrapper selectedView: self viewMode.
		aCollection add: wrapper.
		wrapper install].! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 1/18/2010 17:01'!
createWrappers
	| wrappers |
	wrappers := OrderedCollection new.
	self selectedClasses do: [:klass | 
			klass selectors do: [:selector | 
				self createWrapperOn: klass and: selector addTo: wrappers].		
			klass class selectors do: [:selector | 
				self createWrapperOn: klass class and: selector addTo: wrappers]].
	^ wrappers! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:59'!
currentId
	^ currentId! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:59'!
currentId: anObject
	currentId := anObject! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'mp 7/7/2010 16:59:59.875'!
debugAt:	aCallNode
	
	| wrapper |
	(self callgraphModel numberOfCallsBefore: aCallNode) = 0
		ifTrue: [
			[SBreakpointManager installInClass: aCallNode clientClass selector: aCallNode clientSelector.
			self runRootNode] ensure: [
				SBreakpointManager unInstall:  aCallNode clientClass >> aCallNode clientSelector]]
		ifFalse: [
			[wrapper := self createDebugWrapperOn: aCallNode.
			wrapper install.
			self runRootNode] ensure: [
				SBreakpointManager unInstall:  aCallNode clientClass >> aCallNode clientSelector.
				wrapper uninstall]]! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'bs 7/17/2010 14:25:54.337'!
explore: aSymbol on: aCallNode

	| instVars |
	instVars := self runTestWithSpecificWrapper: (self createExploreWrapper: aSymbol on: aCallNode).
	^ instVars objects! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 7/7/2010 17:21:52.072'!
getCallWrapperClass

	(#(% ms) includes: self profilingMode)
		ifTrue: [^ SProfilingWrapper].
	(#(identities objects) includes: self viewMode)
		ifTrue: [^ SViewWrapper].
	^ SCallWrapper! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 2/6/2010 16:55'!
getNode: aNumber

	self callgraphModel currentNode id = aNumber
		ifTrue: [^ self callgraphModel currentNode]
		ifFalse: [^ self callgraphModel findNodeInSubGraph: aNumber startNode: self callgraphModel rootNode].! !

!SCallgraphTracer methodsFor: '-- all --' stamp: 'mp 3/5/2010 17:53'!
initialize

	self 
		stopTracing;
		viewMode: #classes;
		profilingMode: #normal;
		currentId: -1.! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 18:08'!
isActive
	
	^ self active! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 17:26'!
nextId
	
	self currentId: self currentId + 1.
	^ self currentId! !

!SCallgraphTracer methodsFor: 'profiling' stamp: 'mp 1/25/2010 16:08'!
postProfilingCounts

	| bag |
	bag := Bag new.
	self callgraphModel 
		traverseCallGraph: self callgraphModel rootNode 
		with: [:node | bag add: node clientClass -> node clientSelector.
			node profiles 
				at: #counts 
				put: '#', (bag occurrencesOf: node clientClass -> node clientSelector) asString].! !

!SCallgraphTracer methodsFor: 'profiling' stamp: 'mp 1/25/2010 16:07'!
postProfilingMilliSeconds

	| duration |
	self callgraphModel 
		traverseCallGraph: self callgraphModel rootNode 
		with: [:node | 
			duration := node profiles at: #ms.
			node profiles at: #ms put: duration asMilliSeconds asString, 'ms'].! !

!SCallgraphTracer methodsFor: 'profiling' stamp: 'mp 2/6/2010 22:13'!
postProfilingPercentage

	| fullDuration duration |
	fullDuration := self callgraphModel startingCallNodes 
					inject: 0 into: [:sum :each | sum := sum + (each profiles at: #%) asNanoSeconds].
					
	self callgraphModel 
		traverseCallGraph: self callgraphModel rootNode 
		with: [:node | 
			(node profiles includesKey: #%) 
				ifTrue: [duration := (node profiles at: #%) asNanoSeconds.
					node profiles at: #% put: ((duration / fullDuration) * 100.0) rounded asString, '%']].! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 17:11'!
profilingMode
	^ profilingMode ifNil: [profilingMode := #normal]! !

!SCallgraphTracer methodsFor: 'public API' stamp: 'mp 1/18/2010 16:31'!
profilingMode: anObject
	profilingMode := anObject! !

!SCallgraphTracer methodsFor: 'profiling' stamp: 'mp 1/25/2010 15:47'!
profilingPostProcessing

	self profilingMode == #ms
		ifTrue: [self postProfilingMilliSeconds].
	self profilingMode == #%
		ifTrue: [self postProfilingPercentage].
	self profilingMode == #counts
		ifTrue: [self postProfilingCounts].! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 1/18/2010 17:17'!
removeWrappers: aWrapperCollection
	
	aWrapperCollection do: [:each | each uninstall].! !

!SCallgraphTracer methodsFor: 'public API' stamp: 'mp 4/15/2010 14:10'!
resetCallgraph

	self currentId: -1.
	self callgraphModel 
		reset; 
		refresh.! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 2/6/2010 22:24'!
returnFromNode: id

	| node |
	self callgraphModel currentNode id = id
		ifTrue: [self callgraphModel currentNode: self callgraphModel currentNode fromSender]
		ifFalse: [node := self callgraphModel findNodeInSubGraph: id startNode: self callgraphModel rootNode.
					self callgraphModel currentNode: node fromSender].! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:46'!
rootId

	^ 0! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 5/2/2010 12:07'!
runRootNode
	^ self callgraphModel rootNode run! !

!SCallgraphTracer methodsFor: 'specific runs' stamp: 'mp 7/12/2010 11:37:26.051'!
runTestWithSpecificWrapper: aWrapper

	aWrapper install.
	[self runRootNode]
		ensure: [aWrapper uninstall.
			      ^ aWrapper].! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:29'!
selectedCategories
	^ selectedCategories! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:29'!
selectedCategories: anObject
	selectedCategories := anObject! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 1/18/2010 16:30'!
selectedClasses

	^ Smalltalk allClasses select: [:aClass | self selectedCategories includes: aClass category]! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 1/18/2010 17:32'!
startTracing

	self active: true.! !

!SCallgraphTracer methodsFor: 'tracing' stamp: 'mp 1/18/2010 17:32'!
stopTracing

	self active: false.! !

!SCallgraphTracer methodsFor: 'public API' stamp: 'mp 5/2/2010 12:26'!
traceSourceCode: aSourceCodeString

	| wrappers result |
	self createNewCallgraphOnCode: aSourceCodeString.
	wrappers := self createWrappers.
	self startTracing.
	result := self runRootNode.
	self 
		stopTracing;
		removeWrappers: wrappers;
		profilingPostProcessing.
	self callgraphModel refresh.
	^ result! !

!SCallgraphTracer methodsFor: 'public API' stamp: 'mp 5/2/2010 12:08'!
traceTest: aTestCaseClass method: aMethodSelector

	| wrappers result |
	self createNewCallgraphOn: aTestCaseClass with: aMethodSelector.
	wrappers := self createWrappers.
	self startTracing.
	result := self runRootNode.
	self 
		stopTracing;
		removeWrappers: wrappers;
		profilingPostProcessing.
	self callgraphModel refresh.
	^ result! !

!SCallgraphTracer methodsFor: 'accessing' stamp: 'mp 1/18/2010 17:18'!
viewMode
	^ viewMode ifNil: [viewMode := #classes]! !

!SCallgraphTracer methodsFor: 'public API' stamp: 'mp 1/18/2010 16:31'!
viewMode: anObject
	viewMode := anObject! !

Object subclass: #SClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

!SClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/5/2010 12:54'!
methodOne

	^ true! !

!SClassA methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2010 17:09'!
methodTwo: aNumber

	^ aNumber! !

Object subclass: #SConcernsRepository
	instanceVariableNames: 'groups colors mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Projects'!

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.463'!
colors
	"Answer the value of colors"

	^ colors! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.466'!
colors: anObject
	"Set the value of colors"

	colors := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 15:06:58.411'!
concernsOfGroup: aGroupString andTest: aMethodRef
	^ ((self groups at: aGroupString) 
		select: [:each | (self mapping at: each ifAbsent: [#()]) includes: aMethodRef]) 		
			asSortedCollection! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:01:05.578'!
concernsOfTest: aMethodRef
	| concerns |
	concerns := IdentitySet new.
	self mapping keysAndValuesDo: [:key :value | 
		(value includes: aMethodRef) ifTrue: [concerns add: key]].
	^ concerns! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:12:42.325'!
groupOfConcern: concern
	self groups keysAndValuesDo: [:key :value | 
		(value detect: [:each | each == concern] ifNone: [nil])
			ifNotNil: [^ key]].! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.454'!
groups
	"Answer the value of groups"

	^ groups! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.459'!
groups: anObject
	"Set the value of groups"

	groups := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 15:05:04.788'!
groupsOfConcerns: aCollection
	| groups |
	groups := IdentitySet new.
	aCollection do: [:concern | groups add: (self groupOfConcern: concern)].
	^ groups asSortedCollection! !

!SConcernsRepository methodsFor: 'initialize-release' stamp: 'mp 9/2/2010 10:01:46.174'!
initialize
	self groups: IdentityDictionary new.
	self mapping: IdentityDictionary new.
	self colors: IdentityDictionary new.! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/2/2010 10:05:01.002'!
mapping
	"Answer the value of mappings"

	^ mapping ifNil: [mapping := IdentityDictionary new]! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/2/2010 10:01:36.495'!
mapping: anObject
	"Set the value of mappings"

	mapping := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 16:56:34.549'!
mappingExisting: aConcern and: aMethodRef
	(self mapping includesKey: aConcern) ifFalse: [^ false].
	^ (self mapping at: aConcern) includes: aMethodRef! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 13:34:52.482'!
testClassesOfConcern: aConcern
	| testClasses map |
	testClasses := IdentitySet new.
	map := self mapping at: aConcern.
	map do: [:each | testClasses add: each actualClass].
	^ testClasses asSortedCollection: [:a :b | a asString <= b asString]! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:56:18.818'!
testSelectorsOfClass: aClass andConcern: aConcern
	^ ((self mapping at: aConcern) 
		select: [:each | each actualClass == aClass] 
		thenCollect: [:each | each methodSymbol]) asSortedCollection! !

Object subclass: #SDefinitionModel
	instanceVariableNames: 'defClass defSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Models'!

SDefinitionModel subclass: #SCallNodeDefinitionModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SCallNodeDefinitionModel class methodsFor: 'as yet unclassified' stamp: 'mp 1/4/2010 16:12'!
on: aCallGraphModel

	^ self new
		callGraphModel: aCallGraphModel! !

!SCallNodeDefinitionModel methodsFor: 'updating' stamp: 'mp 1/31/2010 18:31'!
update: aCallNode

	(aCallNode notNil and: [aCallNode isLiteral]) ifTrue: [^ self].
	aCallNode ifNil:[^ self setClass: nil andSelector: nil]. 
	self setClass: aCallNode clientClass andSelector: aCallNode clientSelector.	
! !

!SDefinitionModel methodsFor: '-- all --' stamp: 'mp 1/25/2010 17:10'!
aboutToStyle: aStyler

	aStyler classOrMetaClass: self classOrMetaClass.
	^ true! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
classOrMetaClass

	(self defClass notNil and: [self defSelector notNil]) 
		ifTrue: [^ self defClass].
	^ nil! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
contents

	| sourceString |
	self defClass ifNil: [^ ''].
	self defSelector ifNil: [^ self defClass definition].
	sourceString := self defClass sourceCodeAt: self defSelector ifAbsent: [^'error'].
	^ sourceString copy asText! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defClass
	^ defClass! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defClass: anObject
	defClass := anObject! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defSelector
	^ defSelector! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defSelector: anObject
	defSelector := anObject! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
setClass: aClass andSelector: aSelector

	^ self 
		defClass: aClass;
		defSelector: aSelector;
		changed: #contents;
		yourself! !

Object subclass: #SEntryPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tracer'!

!SEntryPoint methodsFor: 'execution' stamp: 'mp 7/12/2010 13:24:46.524'!
execute

	self subclassResponsibility.! !

SEntryPoint subclass: #SSourceCodeEntryPoint
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tracer'!

!SSourceCodeEntryPoint class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 13:25:55.81'!
onCode: aString

	^ self new
		code: aString;
		yourself.! !

!SSourceCodeEntryPoint methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:26:15.125'!
code
	"Answer the value of code"

	^ code! !

!SSourceCodeEntryPoint methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:26:15.13'!
code: anObject
	"Set the value of code"

	code := anObject! !

!SSourceCodeEntryPoint methodsFor: 'execution' stamp: 'mp 7/12/2010 13:26:56.369'!
execute
	^ Compiler evaluate: self code! !

!SSourceCodeEntryPoint methodsFor: 'printing' stamp: 'mp 7/12/2010 14:16:05.892'!
printString

	^ 'Source code entry point'! !

SEntryPoint subclass: #STestCaseEntryPoint
	instanceVariableNames: 'testClass selector lastResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tracer'!

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/17/2010 12:43:32.121'!
class: aClass selector: aSelector
	^ self new
		testClass: aClass;
		selector: aSelector;
		yourself! !

!STestCaseEntryPoint class methodsFor: 'converting' stamp: 'bs 7/20/2010 14:52:12.685'!
convertTestSuite: aTestSuite

	^ aTestSuite tests collect: [ :each | 
		STestCaseEntryPoint class: each class selector: each selector ]! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/17/2010 12:42:12.429'!
onTestCase: aTestCase

	^ self class: aTestCase class selector: aTestCase selector! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/20/2010 14:52:04.177'!
onTestMethodReference: aMethodReference

	^ self class: aMethodReference actualClass selector: aMethodReference methodSymbol! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/20/2010 14:52:07.313'!
testMethod: aCompiledMethod

	^ self class: aCompiledMethod methodClass selector: aCompiledMethod selector! !

!STestCaseEntryPoint methodsFor: 'comparing' stamp: 'mp 7/14/2010 09:29:14.346'!
= other
	self class == other class
		ifFalse: [^ false].
	^ self asMethodReference = other asMethodReference! !

!STestCaseEntryPoint methodsFor: 'converting' stamp: 'bs 7/20/2010 14:54:47.724'!
asMethodReference

	^ MethodReference class: self testClass selector: self selector! !

!STestCaseEntryPoint methodsFor: 'execution' stamp: 'mp 7/20/2010 17:47:35.417'!
execute
 	self lastResult: (self testClass selector: self selector) run.
	^ self lastResult! !

!STestCaseEntryPoint methodsFor: 'comparing' stamp: 'mp 7/14/2010 09:28:50.007'!
hash

	^ self asMethodReference hash! !

!STestCaseEntryPoint methodsFor: 'testing' stamp: 'mp 9/29/2010 13:49:43.777'!
isInheritedTest
	^ (self testClass testSelectors includes: self selector) not! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:52:00.283'!
lastResult
	"Answer the value of lastResult"

	^ lastResult! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:52:00.287'!
lastResult: anObject
	"Set the value of lastResult"

	lastResult := anObject! !

!STestCaseEntryPoint methodsFor: 'printing' stamp: 'mp 9/29/2010 13:48:34.75'!
printString
	self isInheritedTest 
		ifTrue: [^ self testClass asString, ' >> ', self selector asString, ' (inherited)'].
	^ (self testClass >> self selector) qualifiedName! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:02.943'!
selector
	^ selector! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:02.95'!
selector: anObject
	selector := anObject! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:18.191'!
testClass
	^ testClass! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:18.197'!
testClass: anObject
	testClass := anObject! !

Object subclass: #SEvaluator
	instanceVariableNames: 'pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Evaluation'!

!SEvaluator class methodsFor: 'constants' stamp: 'mp 2/8/2011 15:00:55.029'!
evaluatedProjects

	"^ #(aweSOM compiler z80 monticello sunit systemBrowser seaside magritte pier xml)"
	^ #(Seaside)! !

!SEvaluator class methodsFor: 'constants' stamp: 'mp 6/23/2010 18:05'!
repetition

	^ 10! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:14:53.884'!
addAuthor: aMethodReference to: aCollection
	| author |
	author := aMethodReference compiledMethod lastChange first.
	aCollection add: author.
	^ author! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:32:37.769'!
addCoverageRanking: aMethodReference to: aCollection		
	| coveredMethods coveredAuthors author ranking methodsPerAuthor rankedAuthor |
	coveredMethods := self pathMap tracer getAllCoveredMethods keys.
	coveredAuthors := coveredMethods 
							inject: Set new 
							into: [:set :meth | 
								author := meth compiledMethod lastChange first.
								set 
									add: author; 
									yourself].
		
	ranking := (coveredAuthors collect: [:each | 
			methodsPerAuthor := coveredMethods 
				select: [:meth | meth compiledMethod lastChange first = each].
			each -> (methodsPerAuthor size / coveredMethods size)]) 
				asSortedCollection: [:a :b | a value > b value].
				
	rankedAuthor := ranking detect: [:assoc | assoc key = author] ifNone: [nil].
	rankedAuthor
		ifNil: [2 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [aCollection 
					add: rankedAuthor value asFloat;
					add: (ranking indexOf: rankedAuthor)].
	aCollection add: ranking size.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:25:42.996'!
addDeveloperRanking: aMethodReference to: aCollection	
	| author ranking opportuneAuthor overallRanking |
	author := aMethodReference compiledMethod lastChange first.
	ranking := self pathMap tracer mostOpportuneAuthors.
	opportuneAuthor := ranking detect: [:assoc | assoc key = author] ifNone: [nil].
	overallRanking := ranking inject: 0 into: [:sum :ea | sum + ea value].
	opportuneAuthor 
		ifNil: [2 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [aCollection
					add: opportuneAuthor value / overallRanking;
					add: (ranking indexOf: opportuneAuthor)].
	aCollection add: ranking size.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:12:36.583'!
addMethod: aMethodReference to: aCollection
	aCollection add: aMethodReference asString.! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 6/23/2010 14:16'!
addProjectHeaderRowTo: aCollection
	| header |
	header := OrderedCollection new.
	header 
		add: 'Project Name';
		add: '#Categories';
		add: '#Classes';
		add: '#Methods';
		add: 'LoC';
		add: '#Tests';
		add: 'Test Coverage'.				
	aCollection add: header.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/11/2011 15:33:15.843'!
addSuspiciousMethods: aMethodReference to: aCollection
	| suspiciousMethods method rank nextElement sameScore |
	suspiciousMethods := self pathMap tracer mostSuspiciousMethods.
	method := suspiciousMethods detect: [:assoc | assoc key = aMethodReference] ifNone: [nil].
	method
		ifNil: [3 timesRepeat: [aCollection add: 'N/A']]
		ifNotNil: [
			rank := (suspiciousMethods indexOf: method).
			aCollection 
					add: method value first;
					add: rank.
				nextElement := suspiciousMethods at: rank + 1.
				sameScore := 0.
				[nextElement value first = method value first] 
					whileTrue: [	sameScore := sameScore + 1.
								nextElement := suspiciousMethods at: rank + 1 + sameScore].
				aCollection add: sameScore].
	aCollection add: suspiciousMethods size.
	! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 7/7/2010 16:54:32.473'!
addTestMeasurmentsTo: aCollection
	| tests measurements | 
	tests := SProject current allTestsWithoutLongRunning.
	tests 
		do: [:each | 
			measurements := OrderedCollection new.
			self 
				measureCommonTestBehavior: each on: measurements;
				measureShallowAnalysis: each on: measurements;
				measureRefinementAnalysis: each on: measurements.
			aCollection add: measurements] 
		displayingProgress: 'Run Test Measurements of ', SProject current projectName asString.	! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 20:16:42.036'!
addTestResultsTo: aCollection
	aCollection
		add: self pathMap tracer allPassed;
		add: self pathMap tracer allFailures.! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 6/23/2010 14:07'!
convertCollectionToCSV: aCollection  on: aStream

	aCollection withIndexDo: [:row :index |
		aStream nextPutAll: index asString.
		aStream nextPut: $,.
		row do: [:column | 
			aStream nextPutAll: column asString.
			aStream nextPut: $,.].
		aStream cr; flush.].
	! !

!SEvaluator methodsFor: 'tracing' stamp: 'mp 7/7/2010 17:20:37.234'!
createDynamicTracerModel

	| tracer model |
	tracer := SCallgraphTracer on: SProject current categories.
	model := SCallgraphModel on: tracer.
	tracer callgraphModel: model.	
	^ tracer! !

!SEvaluator methodsFor: 'project' stamp: 'mp 7/7/2010 16:54:24.801'!
currentProjectStatistics
	| stats |
	stats := OrderedCollection new.
	stats 
		add: SProject current projectName;
		add: SProject current nop;
		add: SProject current noc;
		add: SProject current nom;
		add: SProject current loc;
		add: SProject current allTestsWithoutLongRunning size;
		add: self getTestCoverage;
		yourself.
	^ stats! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 2/8/2011 15:16:14.412'!
developerRanking: aCollection forProject: aProjectName
	self do: [
		aCollection 
			add: (OrderedCollection with: aProjectName);
			add: self developerRankingHeaderRow;
			yourself.
		self developerRankingEvaluationTo: aCollection]
		withCurrentProject: aProjectName.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/11/2011 15:43:21.428'!
developerRankingEvaluationTo: aCollection
	| coveredMethods row wrapper |
	self initializePathMap.
	coveredMethods := self methodsCoveredByTests asSortedCollection.
	{101. 151. 201. 301. 351. 501. 551. 601. 701. 801. 901. 951. 1001. 1051. 1101. 1151. 1201. 1251. 1301} do: [:start | | stop |
	stop := start + 49.
	(coveredMethods copyFrom: start to: stop) do: [:each | 
		Transcript show: DateAndTime now; space; show: each asString; cr.
		row := OrderedCollection new.
		[wrapper := SBlockMethodWrapper 
						on: each methodSymbol inClass: each actualClass.
		wrapper install.
		[self pathMap runAllTestsWith: #faultLocalization.
		self 
			addMethod: each to: row;
			"addAuthor: each to: row;
			addTestResultsTo: row;"
			addSuspiciousMethods: each to: row
			"addDeveloperRanking: each to: row"
			"addCoverageRanking: each to: row"]
		on: Error do: [:e | row add: 'Error thrown!!']
		] ensure: [
			wrapper uninstall.
			self pathMap tracer: nil.
			Smalltalk garbageCollect].
		aCollection add: row]
		displayingProgress: 'Run developer ranking for ', 
							coveredMethods size asString, 
							' methods.'.
		"Store collection"			
		self storeCollection: aCollection 
			 asCSVFile: start asString, '-', stop asString, '_developerRanking.csv'	].! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 2/8/2011 19:10:21.134'!
developerRankingHeaderRow
	^ OrderedCollection new
		add: 'Method';
		add: 'Author';
		add: 'Passed';
		add: 'Failed';
		add: 'Suspiciousness';
		add: 'Method rank';
		add: 'Number of suspicious methods';
		add: 'FL Developer rating';
		add: 'FL Author rank';
		add: 'FL Number of authors';
		add: 'Coverage rating';
		add: 'Coverage rank';
		add: 'Coverage number of authors';
		yourself! !

!SEvaluator methodsFor: 'project' stamp: 'mp 7/7/2010 16:54:59.333'!
do: aBlock withCurrentProject: aProjectName
	| previousCurrentProject result |
	[previousCurrentProject := SProject current.
	SProject setCurrent: aProjectName.
	result := aBlock value]
		ensure: [SProject setCurrentProject: previousCurrentProject].
	^ result! !

!SEvaluator methodsFor: 'tracing' stamp: 'mp 6/23/2010 18:48'!
getCurrentMemoryConsumption
	"Browse: [SmalltalkImage vmStatisticsReportString]"
	| params youngSpaceEnd |
	Smalltalk garbageCollect.
	params := SmalltalkImage current getVMParameters.
	youngSpaceEnd := params at: 2.
	^ youngSpaceEnd! !

!SEvaluator methodsFor: 'project' stamp: 'mp 7/7/2010 17:05:57.946'!
getTestCoverage
	| tests wrappers coverage |
	tests := SProject current allTestsWithoutLongRunning.
	wrappers := self installWrappersOfType: STestCoverageWrapper.
	[tests 
		do: [:each | wrappers do: [:wrapper | wrapper currentTest: each].
			each actualClass run: each methodSymbol] 
		displayingProgress: 'Run Tests for Coverage of ', SProject current projectName asString.
	coverage := (wrappers select: [:each | each tests notEmpty]) size / SProject current nom]
	ensure: [wrappers do: [:each | each uninstall].
		      STestCoverageWrapper nuke.
		      Smalltalk garbageCollect].
	^ coverage asFloat! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/8/2011 15:37:42.709'!
initializePathMap
	| testRunner |
	testRunner := ToolBuilder build: SPathMapTestRunner new.
	self pathMap: testRunner model pathMap.
	self pathMap globalOptions
		switchShowQuickAndAccessorMethods;
		switchShowMethodCategories;
		switchVisualizeIntermediateSteps.! !

!SEvaluator methodsFor: 'tracing' stamp: 'mp 7/7/2010 16:54:52.849'!
installWrappersOfType: aClass

	| wrappers wrapper |
	wrappers := OrderedCollection new.
	SProject current allMethods do: [:each | 
		wrapper := aClass on: each methodSymbol inClass: each actualClass.
		wrapper ifNotNil: [wrappers add: wrapper]].
	wrappers do: [:each | each install].
	^ wrappers! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/23/2010 18:12'!
measureCommonTestBehavior: aTestReference on: aCollection

	aCollection 
		add: aTestReference asStringOrText;
		add: (self runTest: aTestReference) hasPassed asString;
		add: [self class repetition timesRepeat: [self runTest: aTestReference]] timeToRun;
		yourself.! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/24/2010 08:56'!
measureRefinementAnalysis: aTestReference on: aCollection
	| tracer callNode id |
	tracer := self createDynamicTracerModel.
	tracer traceTest: aTestReference actualClass method: aTestReference methodSymbol.
	id :=  ((tracer currentId - 1) / 2) asInteger.
	id <= 0 "e.g. ClassTestCase triggers no behavior in partial traces"
		ifTrue: [aCollection add: 'N/A']
		ifFalse: [	
			callNode := tracer getNode: id.
			aCollection add: [tracer explore: #return on: callNode] timeToRun.].
	Smalltalk garbageCollect.		! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/24/2010 17:39'!
measureShallowAnalysis: aTestReference on: aCollection
	| tracer result runtime bytesBefore |
	bytesBefore := self getCurrentMemoryConsumption.
	tracer := self createDynamicTracerModel.
	runtime := [result := tracer 
						traceTest: aTestReference actualClass 
						method: aTestReference methodSymbol] timeToRun.
	aCollection
		add: result hasPassed;
		add: runtime;
		add: tracer currentId;
		add: self getCurrentMemoryConsumption - bytesBefore.
	tracer := nil.
	Smalltalk garbageCollect.! !

!SEvaluator methodsFor: 'developer ranking' stamp: 'mp 2/10/2011 11:42:02.741'!
methodsCoveredByTests
	self pathMap runAllTestsWith: #testQuality.
	^ self pathMap tracer getAllCoveredMethods keys 
		reject: [:each | ((each methodSymbol beginsWith: 'test') 
						or: [each compiledMethod isQuick])
						or: [each actualClass inheritsFrom: TestCase]].! !

!SEvaluator methodsFor: 'accessing' stamp: 'mp 2/8/2011 15:28:52.59'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SEvaluator methodsFor: 'accessing' stamp: 'mp 2/8/2011 15:28:52.632'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 6/23/2010 13:56'!
projectStatisticsFor: aProjectName

	^ self do: [self currentProjectStatistics] withCurrentProject: aProjectName

! !

!SEvaluator methodsFor: 'test measurement' stamp: 'mp 6/23/2010 18:06'!
runTest: aTestMethodReference

	^ aTestMethodReference actualClass run: aTestMethodReference methodSymbol! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 6/23/2010 14:08'!
storeCollection: aCollection asCSVFile: aFileName
	| file |
	[file := FileDirectory default forceNewFileNamed: aFileName.
	 self convertCollectionToCSV: aCollection  on: file]
	ensure: [file close].! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 2/8/2011 15:11:53.994'!
storeDeveloperRanking
	| measurements |
	measurements := OrderedCollection new.
	self class evaluatedProjects do: [:each | self 
												developerRanking: measurements 
												forProject: each].
	self storeCollection: measurements asCSVFile: '_developerRanking.csv'.
	^ measurements! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 6/23/2010 17:00'!
storeProjectStatisticsOfAllProjects

	| stats |
	stats := OrderedCollection new.
	self addProjectHeaderRowTo: stats.
	self class evaluatedProjects do: [:each | stats add: (self projectStatisticsFor: each)].
	self storeCollection: stats asCSVFile: '_projects.csv'.
	^ stats! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 6/23/2010 17:16'!
storeTestMeasurementsOfAllProjects

	| measurements |
	measurements := OrderedCollection new.
	self class evaluatedProjects do: [:each | self testMeasurements: measurements forProject: each].
	self storeCollection: measurements asCSVFile: '_testMeasurements.csv'.
	^ measurements! !

!SEvaluator methodsFor: 'csv file' stamp: 'mp 6/23/2010 18:37'!
testMeasurementHeaderRow

	^ OrderedCollection new
		add: 'test name';
		add: 'test passed';
		add: 'test run-time x10';
		add: 'SA test passed';
		add: 'SA run-time';
		add: 'SA call nodes';		
		add: 'SA memory';
		add: 'RA run-time';
		yourself									! !

!SEvaluator methodsFor: 'public API' stamp: 'mp 6/23/2010 17:44'!
testMeasurements: aCollection forProject: aProjectName
	^ self do: [
		aCollection 
			add: (OrderedCollection with: aProjectName);
			add: self testMeasurementHeaderRow;
			yourself.
		self addTestMeasurmentsTo: aCollection] 
		withCurrentProject: aProjectName.! !

Object subclass: #SEvaluatorDeprecated
	instanceVariableNames: 'selectedCategories projectName'
	classVariableNames: 'Repetition'
	poolDictionaries: ''
	category: 'SightL-Evaluation'!

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 2/13/2010 20:33'!
convertCollectionToCSV: aCollection on: aStream

	| index |
	index := 1.
	aCollection do: [:each |
		aStream nextPutAll: index asString.
		aStream nextPut: $,.
		aStream nextPutAll: each key asStringOrText.
		aStream nextPut: $,.
		aStream nextPutAll: each value asString.
		aStream cr; flush.
		index := index + 1].! !

!SEvaluatorDeprecated class methodsFor: 'example' stamp: 'mp 6/23/2010 13:34'!
example
	"Do it"

	"TEST RUN-TIME"
	| file |
	file := FileDirectory default forceNewFileNamed: 'MonticelloTestsRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello testRuntime  on: file.
	file close.

	"ON DEMAND REFINEMENT"
	file := FileDirectory default forceNewFileNamed: 'MonticelloSpecificWrapperRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello specificWrapperRuntime  on: file.
	file close.

	"CORE ANALYSIS"
	file := FileDirectory default forceNewFileNamed: 'MonticelloCallWrapperRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello callWrapperRuntime  on: file.
	file close.

	"FULL ANALYSIS"
	file := FileDirectory default forceNewFileNamed: 'MonticelloFullTraceRuntime.csv'.
	self convertCollectionToCSV: self projectMonticello fullExploreStateAndViewProfileWrapperRuntime  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:43'!
projectMonticello

	^ self new
		projectName: 'Monticello';
		selectedCategories:  #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:43'!
projectSUnit

	^ self new
		projectName: 'SUnit';	
		selectedCategories:  #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/6/2010 19:26'!
projectSWA

	^ self new
		projectName: 'SWA';	
		selectedCategories:  #(#'Swa-DoubleDispatch')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:43'!
projectSystemBrowser

	^ self new
		projectName: 'SystemBrowser';	
		selectedCategories:   #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SEvaluatorDeprecated class methodsFor: 'instance creation' stamp: 'mp 2/5/2010 16:44'!
projectZ80

	^ self new
		projectName: 'Z80';	
		selectedCategories: #(#Z80 #'Z80-Assembler' #'Z80-Peripherals' #'Z80-Tests')! !

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 5/5/2010 21:31'!
repetition

	^ Repetition! !

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 2/6/2010 19:32'!
run: anEvaluator on: aStream

	aStream nextPutAll: 'Number of Classes: '.
	aStream nextPutAll: anEvaluator numberOfClasses asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Number of Methods '.
	aStream nextPutAll: anEvaluator numberOfMethods asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Lines of Code: '.
	aStream nextPutAll: anEvaluator linesOfCode  asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Number of Tests: '.
	aStream nextPutAll: anEvaluator numberOfTests  asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Test Coverage: '.
	aStream nextPutAll: anEvaluator testCoverage asFloat asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Number of Method Calls per Test:  '.
	aStream nextPutAll: anEvaluator numberOfMethodCallsPerTest asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Run-time of Tests: '.
	aStream nextPutAll: anEvaluator testRuntime asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Run-time of Tests with Call Tracer: '.
	aStream nextPutAll: anEvaluator callWrapperRuntime asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Run-time of Tests with View/Profile Tracer: '.
	aStream nextPutAll: anEvaluator viewProfileWrapperRuntime asString.
	aStream cr.
	aStream flush.

	aStream nextPutAll: 'Run-time of Tests with Specific Explore Wrapper: '.
	aStream nextPutAll: anEvaluator specificWrapperRuntime asString.
	aStream cr.
	aStream flush.

	aStream nextPutAll: 'Run-time of Tests with Full Instrumentation: '.
	aStream nextPutAll: anEvaluator fullExploreStateAndViewProfileWrapperRuntime asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Memory Consumption of Tests with Call Tracer:'.
	aStream nextPutAll: anEvaluator callWrapperMemory asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Memory Consumption of Tests with View/Profile Tracer:'.
	aStream nextPutAll: anEvaluator viewProfileWrapperMemory asString.
	aStream cr.
	aStream flush.
	
	aStream nextPutAll: 'Memory Consumption with Full Instrumentation: '.
	aStream nextPutAll: anEvaluator fullExploreStateAndViewProfileWrapperMemory asString.
	aStream cr.
	aStream flush.

	aStream nextPutAll: 'Set Up Costs'.
	aStream nextPutAll: anEvaluator setUpCosts asString.
	aStream cr.
	aStream flush.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestMemoryShallowAnalysis
	" self runAllProjectTestShallowAnalysis"
	| file |
	Repetition := 10.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestShallowAnalysisMemory_10.csv'.
	self convertCollectionToCSV: self projectSUnit testShallowAnalysisMemory  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestShallowAnalysisMemory_10.csv'.
	self convertCollectionToCSV: self projectMonticello testShallowAnalysisMemory  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestShallowAnalysisMemory_10.csv'.
	self convertCollectionToCSV: self projectZ80 testShallowAnalysisMemory  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestRefinementAnalysis
	" self runAllProjectTestRuntimes"
	| file |
	Repetition := 10.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestRefinementAnalysis_10.csv'.
	self convertCollectionToCSV: self projectSUnit testRefinementAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestRefinementAnalysis_10.csv'.
	self convertCollectionToCSV: self projectMonticello testRefinementAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestRefinementAnalysis_10.csv'.
	self convertCollectionToCSV: self projectZ80 testRefinementAnalysis  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestRuntimes
	" self runAllProjectTestRuntimes"
	| file |
	Repetition := 100.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestRuntime_100.csv'.
	self convertCollectionToCSV: self projectSUnit testRuntime  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestRuntime_100.csv'.
	self convertCollectionToCSV: self projectMonticello testRuntime  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestRuntime_100.csv'.
	self convertCollectionToCSV: self projectZ80 testRuntime  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runAllProjectTestShallowAnalysis
	" self runAllProjectTestShallowAnalysis"
	| file |
	Repetition := 10.
	file := FileDirectory default forceNewFileNamed: '__SUnitTestShallowAnalysis_10.csv'.
	self convertCollectionToCSV: self projectSUnit testShallowAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__MonticelloTestShallowAnalysis_10.csv'.
	self convertCollectionToCSV: self projectMonticello testShallowAnalysis  on: file.
	file close.

	file := FileDirectory default forceNewFileNamed: '__Z80TestShallowAnalysis_10.csv'.
	self convertCollectionToCSV: self projectZ80 testShallowAnalysis  on: file.
	file close.! !

!SEvaluatorDeprecated class methodsFor: 'running' stamp: 'mp 2/6/2010 15:35'!
runAllProjectsOn: aStream

	aStream clear.
	aStream nextPutAll: '--------------- Project SUnit --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectSUnit on: aStream.
	aStream cr; cr.
	aStream flush.

	aStream nextPutAll: '--------------- Project System Browser --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectSystemBrowser on: aStream.
	aStream cr; cr.
	aStream flush.
	
	aStream nextPutAll: '--------------- Project Monticello --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectMonticello on: aStream.
	aStream cr; cr.
	aStream flush.
	
	aStream nextPutAll: '--------------- Project Z80 --------------- '.
	aStream cr.
	aStream flush.
	self run: self projectZ80 on: aStream.
	aStream cr; cr.
	aStream flush.
	
	! !

!SEvaluatorDeprecated class methodsFor: 'new evaluation' stamp: 'mp 6/23/2010 13:34'!
runMonticelloProjectTestGUIStartUp
	"self runMonticelloProjectTestGUIStartUp"
	| file |
	file := FileDirectory default forceNewFileNamed: '__MonticelloTestGuiStartUp.csv'.
	self convertCollectionToCSV: self projectMonticello testGUIStartUpTime  on: file.
	file close.! !

!SEvaluatorDeprecated methodsFor: 'memory consumption' stamp: 'mp 2/6/2010 17:34'!
callWrapperMemory

	| tracer tests memory bytesBefore |
	tracer := self createDynamicTracerModel.
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			tracer resetCallgraph.
			bytesBefore := self getCurrentMemoryConsumption. 
			tracer traceTest: each actualClass method: each methodSymbol.
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Lightweight Tracer'.
	Smalltalk garbageCollect.
	^ self getResultsFrom: memory! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/13/2010 20:52'!
callWrapperRuntime

	| tracer tests runtime stopWatch |
	tracer := self createDynamicTracerModel.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			stopWatch reset.
			stopWatch activate.
			tracer traceTest: each actualClass method: each methodSymbol.
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			] 
		displayingProgress: 'Run Tests for Run-time of Lightweight Tracer'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 7/7/2010 17:20:40'!
createDynamicTracerModel

	| tracer model |
	tracer := SCallgraphTracer on: self selectedCategories.
	model := SCallgraphModel on: tracer.
	tracer callgraphModel: model.	
	^ tracer! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 7/7/2010 16:37:21.284'!
createExploreWrapperOn: aTracer

	| wrappers |
	wrappers := OrderedCollection new.
	self getAllMethods do: [:each | wrappers add: (SExploreEvaluationWrapper 
										on: each methodSymbol 
										inClass: each actualClass 
										withTracer: aTracer)].
	wrappers do: [:each | each install].
	^ wrappers! !

!SEvaluatorDeprecated methodsFor: 'memory consumption' stamp: 'mp 2/6/2010 19:35'!
fullExploreStateAndViewProfileWrapperMemory

| tracer tests memory bytesBefore wrappers |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.	
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			tracer resetCallgraph.
			bytesBefore := self getCurrentMemoryConsumption. 
			wrappers := self createExploreWrapperOn: tracer.
			tracer traceTest: each actualClass method: each methodSymbol.
			wrappers do: [:wrapper | wrapper uninstall].
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Full Tracer'.
	Smalltalk garbageCollect.
	^ self getResultsFrom: memory! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/16/2010 19:59'!
fullExploreStateAndViewProfileWrapperRuntime

	| tracer tests runtime stopWatch wrappers |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			stopWatch reset.
			stopWatch activate.
			wrappers := self createExploreWrapperOn: tracer.
			tracer traceTest: each actualClass method: each methodSymbol.
			wrappers do: [:wrapper | wrapper uninstall].
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			Transcript show: stopWatch duration asString; cr.
			Smalltalk garbageCollect.
			] 
		displayingProgress: 'Run Tests for Run-time of Full Tracer'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/5/2010 16:53'!
getAllMethods

	| methods |
	methods := OrderedCollection new.
	self getAllProjectClasses do: [:klass | 
		klass methodDict keysDo: [:aSelector | 
			methods add: (MethodReference class: klass selector: aSelector)].
		klass class methodDict keysDo: [:aSelector | 
			methods add: (MethodReference class: klass class selector: aSelector)]].
	^ methods! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/5/2010 16:45'!
getAllProjectClasses

	^ Smalltalk allClasses select: [:each | self selectedCategories includes: each category]! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 17:05'!
getAllTestMethods

	^ self getAllMethods select: [:each | ((each methodSymbol beginsWith: 'test') and: [each actualClass inheritsFrom: TestCase]) and: [each methodSymbol numArgs = 0]].! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 17:35'!
getCurrentMemoryConsumption
	"Browse: [SmalltalkImage vmStatisticsReportString]"
	| params youngSpaceEnd |
	Smalltalk garbageCollect.
	params := SmalltalkImage current getVMParameters.
	youngSpaceEnd := params at: 2.
	^ youngSpaceEnd
	! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 22:37'!
getResultsFrom: aCollection

	| results sortedCollection startValue |
	startValue := 0.
	(aCollection first value isKindOf: Duration)
		ifTrue: [startValue := startValue asDuration].
	results := Dictionary new.
	results 
		at: #average 
		put: ((aCollection inject: startValue into: [:sum :each | sum := sum + each value]) / aCollection size).
	sortedCollection := aCollection asSortedCollection: [:a :b | a value < b value].
	results
		at: #min
		put: sortedCollection first value.
	results
		at: #max
		put: sortedCollection last value.
	results
		at: #median
		put: sortedCollection median value.	
	^ results! !

!SEvaluatorDeprecated methodsFor: 'private' stamp: 'mp 2/6/2010 14:54'!
installWrappersOfType: aClass

	| wrappers |
	wrappers := OrderedCollection new.
	self getAllMethods do: [:each | wrappers add: (aClass on: each methodSymbol inClass: each actualClass)].
	wrappers do: [:each | each install].
	^ wrappers! !

!SEvaluatorDeprecated methodsFor: 'project size' stamp: 'mp 2/5/2010 16:56'!
linesOfCode

	^ self getAllMethods inject: 0 into: [:sum :each | sum := sum + each compiledMethod linesOfCode].! !

!SEvaluatorDeprecated methodsFor: 'project size' stamp: 'mp 2/5/2010 16:46'!
numberOfClasses

	^ self getAllProjectClasses size.! !

!SEvaluatorDeprecated methodsFor: 'test statistics' stamp: 'mp 2/13/2010 20:22'!
numberOfMethodCallsPerTest

	| tracer tests callNodes |
	tracer := self createDynamicTracerModel.
	callNodes := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			tracer traceTest: each actualClass method: each methodSymbol.
			callNodes add: each -> tracer nextId.
			] 
		displayingProgress: 'Run Tests for Method Calls per Test'.
	Smalltalk garbageCollect.
	^ callNodes
	"^ self getResultsFrom: callNodes"! !

!SEvaluatorDeprecated methodsFor: 'project size' stamp: 'mp 2/5/2010 16:49'!
numberOfMethods

	^ self getAllMethods size! !

!SEvaluatorDeprecated methodsFor: 'test statistics' stamp: 'mp 2/6/2010 14:31'!
numberOfTests

	^ self getAllTestMethods size ! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:43'!
projectName
	"Answer the value of projectName"

	^ projectName! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:43'!
projectName: anObject
	"Set the value of projectName"

	projectName := anObject! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:23'!
selectedCategories
	"Answer the value of selectedCategories"

	^ selectedCategories! !

!SEvaluatorDeprecated methodsFor: 'accessing' stamp: 'mp 2/5/2010 16:23'!
selectedCategories: anObject
	"Set the value of selectedCategories"

	selectedCategories := anObject! !

!SEvaluatorDeprecated methodsFor: 'setup costs' stamp: 'mp 2/6/2010 18:08'!
setUpCosts

	| tracer test stopWatch wrappers |
	tracer := self createDynamicTracerModel.
	test := self getAllTestMethods first.
	stopWatch := Stopwatch new.
	stopWatch activate.
	
	tracer createNewCallgraphOn: test actualClass with: test methodSymbol.
	wrappers := tracer createWrappers.
	tracer startTracing.
	"Run Test"
	tracer 
		stopTracing;
		removeWrappers: wrappers.
	stopWatch suspend.
	^ stopWatch duration! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/13/2010 20:49'!
specificWrapperRuntime

	| tracer tests runtime stopWatch |
	tracer := self createDynamicTracerModel.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			tracer traceTest: each actualClass method: each methodSymbol.
			stopWatch reset.
			stopWatch activate.
			[tracer explore: #return on: (tracer getNode: tracer currentId atRandom)] on: Error do: [:signal | ].
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			] 
		displayingProgress: 'Run Tests for Run-time of Specific Exploring'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'test statistics' stamp: 'mp 7/7/2010 17:06:05.288'!
testCoverage

	| tests wrappers coverage |
	tests := self getAllTestMethods.
	wrappers := self installWrappersOfType: STestCoverageWrapper.
	tests 
		do: [:each | 
			wrappers do: [:wrapper | wrapper currentTest: each].
			each actualClass run: each methodSymbol] 
		displayingProgress: 'Run Tests for Coverage'.
	coverage := (wrappers select: [:each | each tests notEmpty]) size / self getAllMethods size.
	wrappers do: [:each | each uninstall].
	Smalltalk garbageCollect.
	^ coverage! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 7/8/2010 17:21:05.641'!
testGUIStartUpTime

	| tests  runtime |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			runtime add: each -> (SPathFinder openWithPerformanceMesaureOn: each)] 
		displayingProgress: 'Run Tests for Test Run-time'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/5/2010 23:07'!
testRefinementAnalysis

	| tests  runtime tracer callNode |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tracer := self createDynamicTracerModel.
	tests 
		do: [:each | 
			tracer traceTest: each actualClass method: each methodSymbol.
			callNode := tracer getNode: (tracer currentId - 1).
			runtime add: each -> ([self class repetition	
								timesRepeat: [tracer explore: #return on: callNode]] timeToRun)] 
		displayingProgress: 'Run Tests for Run-time of Specific Exploring'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/4/2010 16:00'!
testRuntime

	| tests  runtime |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			runtime add: each -> ([self class repetition 
								timesRepeat: [each actualClass run: each methodSymbol]] timeToRun)] 
		displayingProgress: 'Run Tests for Test Run-time'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/5/2010 22:23'!
testShallowAnalysis

	| tests  runtime tracer |
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	tracer := self createDynamicTracerModel.
	tests 
		do: [:each | 
			runtime add: each -> ([self class repetition 
					timesRepeat: [tracer traceTest: each actualClass method: each methodSymbol]] timeToRun)] 
		displayingProgress: 'Run Tests for Run-time of Lightweight Tracer'.
	Smalltalk garbageCollect.
	^ runtime! !

!SEvaluatorDeprecated methodsFor: 'new evaluation' stamp: 'mp 5/6/2010 08:55'!
testShallowAnalysisMemory

	| tracer tests memory bytesBefore results |
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			results := OrderedCollection new.
			bytesBefore := self getCurrentMemoryConsumption.
			self class repetition timesRepeat: [			
					tracer := self createDynamicTracerModel.
					tracer traceTest: each actualClass method: each methodSymbol.
					results add: tracer].			
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			results := nil.
			Smalltalk garbageCollect.
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Lightweight Tracer'.
	Smalltalk garbageCollect.
	^ memory! !

!SEvaluatorDeprecated methodsFor: 'memory consumption' stamp: 'mp 2/6/2010 17:52'!
viewProfileWrapperMemory

	| tracer tests memory bytesBefore |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.
	memory := OrderedCollection new.
	tests := self getAllTestMethods.
	tests 
		do: [:each | 
			tracer resetCallgraph.
			bytesBefore := self getCurrentMemoryConsumption. 
			tracer traceTest: each actualClass method: each methodSymbol.
			memory add: each -> (self getCurrentMemoryConsumption - bytesBefore).
			] 
		displayingProgress: 'Run Tests for Memory Consumption of Profile/View Tracer'.
	Smalltalk garbageCollect.
	^ self getResultsFrom: memory! !

!SEvaluatorDeprecated methodsFor: 'performance measurement' stamp: 'mp 2/13/2010 20:54'!
viewProfileWrapperRuntime

	| tracer tests runtime stopWatch |
	tracer := self createDynamicTracerModel.
	tracer viewMode: #objects.
	tracer profilingMode: #%.
	runtime := OrderedCollection new.
	tests := self getAllTestMethods.
	stopWatch := Stopwatch new.
	tests 
		do: [:each | 
			Transcript show: each; cr.
			stopWatch reset.
			stopWatch activate.
			tracer traceTest: each actualClass method: each methodSymbol.
			stopWatch suspend.
			runtime add: each -> stopWatch duration.
			] 
		displayingProgress: 'Run Tests for Run-time of View/Profile Tracer'.
	Smalltalk garbageCollect.
	"^ self getResultsFrom: runtime"
	^ runtime! !

Object subclass: #SImageRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

SImageRepository class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

SImageRepository class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:21.275'!
afterIcon
	"afterIcon := nil"
	^ afterIcon ifNil: [afterIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:      #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279571733 4294967295 4294967295 4294967295 4294967295 4294967295 4287861651 4289901234 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4289440683 4279111182 4289506476 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4280361249 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288848546 4279637526 4290032820 4294967295 4294967295 4294967295 4294901502 4294967295 4279111182 4289769648 4289638062 4290032820 4289440683 4289572269 4289901234 4289506476 4278519045 4278190080 4285756275 4294967295 4294967295 4294835709 4294967295 4279111182 4279111182 4279900698 4279111182 4280295456 4279111182 4280361249 4279111182 4278519045 4278519045 4279769112 4294967295 4294967295 4294967295 4294967295 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293980400 4279308561 4281479730 4294901502 4294967295 4294967295 4294967295 4294967295 4279637526 4294901502 4294967295 4294967295 4294967295 4294967295 4293454056 4282269246 4282466625 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4281348144 4294967295 4294967295 4294967295 4294967295 4294967295 4282729797 4281282351 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294506744 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:28.675'!
beforeIcon
	"beforeIcon := nil"
	^ beforeIcon ifNil: [beforeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:     #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287861651 4289901234 4294967295 4294967295 4294967295 4279571733 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289440683 4279111182 4289506476 4294967295 4294967295 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288848546 4279637526 4290032820 4294967295 4280361249 4294967295 4294967295 4294967295 4294901502 4289769648 4289638062 4290032820 4289440683 4289572269 4289901234 4289506476 4278519045 4278190080 4285756275 4279111182 4294967295 4294967295 4294967295 4294835709 4279111182 4279900698 4279111182 4280295456 4279111182 4280361249 4279111182 4278519045 4278519045 4279769112 4279111182 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293980400 4279308561 4281479730 4294901502 4279111182 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4293454056 4282269246 4282466625 4294967295 4294967295 4279637526 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4282729797 4281282351 4294769916 4294967295 4294967295 4281348144 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294506744 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:37.11'!
bugIcon
	"bugIcon := nil"
	^ bugIcon ifNil: [bugIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4293190884 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293849328 4292796383 4291677646 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4293783021 4294572537 4293651949 4291481294 4289371545 4285098079 4288254582 4291216834 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375158 4288850090 4287528567 4291317554 4292816651 4288555781 4279898114 4278255872 4290756022 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4293980914 4290353808 4289736722 4289069312 4291431424 4290654215 4279900689 4281151532 4289241217 4294638071 4293848814 4294967295 4294967295 4294967295 4294967295 4291480780 4292627748 4291300864 4285136896 4293077760 4291636480 4284422146 4290789913 4286799694 4290757314 4291611852 4294967295 4294967295 4294967295 4294112501 4289363311 4293863936 4290252800 4285470209 4293276928 4294587136 4294926389 4294938742 4292243025 4294506743 4294967295 4294967295 4294967295 4294309365 4291218124 4287584327 4290387712 4293667840 4294916352 4293080322 4284881927 4292323235 4293102199 4293830804 4294967295 4294967295 4294967295 4294967295 4293717227 4291547087 4291334786 4293340160 4294522880 4294128896 4293608210 4289102461 4292978849 4288163857 4293120460 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293450454 4294063361 4294062592 4294193920 4294331163 4294929480 4294920726 4291396203 4292862434 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294835709 4292786090 4292883467 4291958528 4290059266 4290523149 4293442735 4294045678 4292993762 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293780447 4293249730 4291144097 4290294706 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292204504 4293848814 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:42.579'!
closeIcon
	"closeIcon := nil"
	^ closeIcon ifNil: [closeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 7105644 7105644 6974058 795371624 2525135490 3550716835 3971331509 3836784816 3079967892 1618113138 57108327 7105644 7105644 16777215 16777215 7105644 6842472 1785753712 4105351858 4292861919 4293322470 4293322470 4293388263 4293190884 4291875024 3079638927 375809638 7105644 16777215 16777215 6908265 1937077621 4290690750 4292730333 4292401368 4292532954 4292598747 4292598747 4292335575 4292598747 4292335575 3415643798 375941224 16777215 16777215 627665257 4188777387 4292072403 4291809231 4292993505 4292203989 4292203989 4292072403 4292993505 4292072403 4291809231 4291546059 2709619073 16777215 16777215 2373482616 4290690750 4291085508 4293256677 4294967295 4293783021 4291414473 4292861919 4294967295 4294111986 4291282887 4291217094 3953501605 16777215 16777215 3515517578 4290493371 4290559164 4292467161 4294967295 4294967295 4293914607 4294901502 4294967295 4293256677 4290822336 4290493371 4004491183 16777215 16777215 3951922573 4289967027 4290295992 4290295992 4292006610 4294835709 4294967295 4294967295 4292796126 4290295992 4290427578 4290032820 3987385002 16777215 16777215 3900143479 4288190616 4289440683 4289572269 4291677645 4294835709 4294967295 4294967295 4292598747 4289638062 4289703855 4288914339 3985213833 16777215 16777215 3379457646 4286479998 4287269514 4290822336 4294967295 4294967295 4293190884 4294901502 4294967295 4292335575 4287861651 4287006342 4017386612 16777215 16777215 2053925996 4286216826 4286743170 4290888129 4294967295 4292532954 4287730065 4290756543 4294967295 4292664540 4287269514 4286611584 3849417073 16777215 16777215 392915819 4000412017 4286545791 4287137928 4289835441 4288190616 4288124823 4287861651 4289901234 4287730065 4286874756 4286019447 2272029804 16777215 16777215 7105644 1600941164 4218581618 4286545791 4286743170 4287401100 4287664272 4287598479 4286940549 4286808963 4286085240 3094179181 174877804 16777215 16777215 7105644 7105644 1147956332 3564138608 3984095352 3984424317 3984555903 3984555903 3984226938 3950211955 2423090541 107768940 7105644 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:48.241'!
documentIcon
	"documentIcon := nil"
	^ documentIcon ifNil: [documentIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293717485 4288982445 4290823878 4293981171 4294770173 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638587 4291153100 4289704883 4289704112 4288981931 4291087564 4294178550 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293257448 4289047724 4290558650 4288651167 4289769134 4289441197 4289179053 4291021771 4294572794 4294967295 4294967295 4294967295 4294967295 4294967295 4294441465 4289640375 4290624957 4288914082 4288256409 4288651167 4290164406 4290822079 4289048238 4294112243 4294967295 4294967295 4294967295 4294967295 4294967295 4291811287 4289047210 4290229685 4288914339 4288848546 4288059030 4290887872 4288982447 4292666858 4294967295 4294967295 4294967295 4294967295 4294967295 4294441466 4289179824 4291216580 4288585117 4288585375 4288585374 4290690237 4290033849 4287142296 4290099373 4290626496 4293323756 4294967295 4294967295 4293455084 4288983736 4287665564 4288388516 4287138706 4287664793 4287467415 4289638584 4286545262 4285358122 4287590433 4286343470 4288719520 4294967295 4294967295 4288587425 4287400040 4288516205 4289042294 4288384622 4288779120 4289173877 4289635464 4287002708 4287655453 4290877235 4290878271 4289506977 4294967295 4294967295 4289573806 4290486620 4294300020 4294036592 4294036333 4294036851 4294038406 4294566817 4293121452 4287659338 4291141441 4289894221 4291416270 4294967295 4294967295 4293258478 4288450921 4294627951 4294300019 4294498440 4294697373 4294830000 4294897085 4294964678 4289107823 4290944325 4288646227 4292929512 4294967295 4294967295 4294573052 4288389269 4292656497 4294631067 4294435243 4294436793 4294568123 4294369708 4294960798 4291409022 4289630020 4288254057 4294178550 4294967295 4294967295 4294835967 4291350995 4290095747 4294965440 4294963393 4294962357 4294960544 4294827147 4294957435 4294563971 4288776268 4288191111 4294507001 4294967295 4294967295 4294967295 4294244600 4288059789 4291806111 4291673231 4291606143 4291473776 4291473002 4291407210 4292459636 4286608463 4289047979 4294704381 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:53.828'!
infoIcon
	"infoIcon := nil"
	^ infoIcon ifNil: [infoIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294770173 4291944172 4289249501 4288395225 4289052636 4291418344 4294507259 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292930034 4286620877 4283466172 4282940601 4282480567 4282480567 4283203258 4285700293 4292141035 4294967295 4294967295 4294967295 4294967295 4294967295 4293061363 4284912068 4282743481 4283269307 4283203515 4285569223 4286160842 4283334843 4282809273 4283991484 4291878121 4294967295 4294967295 4294967295 4294769917 4286817999 4282743480 4283400636 4283334844 4283137722 4292535278 4294507002 4284057790 4283203515 4282940602 4285108671 4294046709 4294967295 4294967295 4292338671 4283597757 4283269051 4283400636 4283400636 4283006394 4283991998 4284846018 4283400636 4283400636 4283335100 4283006136 4290168023 4294967295 4294967295 4290038242 4282940601 4283400636 4283334844 4283466171 4287014603 4290169569 4287672018 4283006137 4283400636 4283400636 4283006394 4287408070 4294967037 4294967295 4289381342 4282874809 4283400636 4283400636 4282677688 4288723671 4294967295 4287935188 4282743481 4283400636 4283400636 4283071931 4286750657 4294900729 4294967295 4290760933 4283006393 4283335100 4283400636 4283006393 4292338157 4294638588 4284189119 4283071930 4283400636 4283400636 4283006651 4287801796 4294966779 4294967295 4293324276 4284057533 4283137723 4283071930 4285240516 4294967295 4291483880 4285437636 4284517824 4283269051 4283269308 4283466169 4290495952 4294967295 4294967295 4294967295 4288854999 4282743223 4283006394 4285109188 4292535279 4290695138 4286423497 4283466428 4283334844 4282940859 4286355899 4293848555 4294967295 4294967295 4294967295 4294507259 4287408846 4282940344 4282875066 4283137722 4283466172 4283006395 4283072188 4283072187 4285567674 4292204762 4294967295 4294967295 4294967295 4294967295 4294967295 4294704380 4289577431 4285042621 4283597241 4283334585 4283597241 4284647866 4287867073 4292730591 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294046451 4291877088 4290824919 4291219159 4292927971 4294769143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself]! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:18:58.89'!
ladybugIconLarge
	"ladybugIconLarge := nil"
	^ ladybugIconLarge ifNil: [ladybugIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4286743170 4293914607 4294967295 4294638330 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294111986 4281150765 4290559164 4294967295 4291282887 4293783021 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291414473 4286479998 4294835709 4292401368 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4284243036 4294243572 4293717228 4293388263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4284637794 4289703855 4294967295 4294967295 4293519849 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290822336 4284637794 4292861919 4290822336 4288256408 4287598479 4293848814 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292664540 4283124555 4284045137 4289703066 4291873716 4289176986 4283387465 4283782222 4287861651 4294967295 4294967295 4294967295 4294177779 4291151301 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289309097 4278848010 4281216295 4291281576 4294439635 4291281834 4283782224 4282532418 4281676845 4287993236 4293585642 4291414473 4293388263 4294901502 4292467161 4290032820 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292006610 4291018943 4294568935 4289758587 4286479998 4281545523 4279900698 4279834646 4278585352 4281481277 4280624679 4284637534 4281084714 4290822336 4294835709 4290756543 4286216826 4282269246 4286085240 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638073 4286597694 4292310101 4294224269 4294880658 4293908948 4293188826 4283256141 4282203453 4279243284 4282402379 4278585354 4289373841 4291018671 4290164405 4294769916 4284111450 4292467161 4294440951 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293173138 4294017628 4294289545 4294365892 4294298811 4287977542 4286141774 4284436558 4288976018 4288387224 4281611318 4278190080 4288386690 4294967276 4288256148 4291875024 4284440415 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294365128 4293624157 4293893241 4293897618 4294823867 4289960331 4280163870 4282005560 4282000927 4293495667 4292845714 4289361257 4283188806 4281019431 4292663485 4288124301 4287401100 4288256409 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572022 4293887596 4294350704 4294091136 4293897874 4294492839 4291594614 4285354317 4278453252 4282789412 4294221951 4294350966 4294735433 4289812538 4282992712 4280230432 4283913812 4286282619 4294111986 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292664540 4286216826 4285482558 4293883213 4291130195 4292906092 4294222722 4293631102 4293497730 4292248165 4289229917 4292977031 4294429369 4294233277 4293826166 4294339901 4289743660 4286476912 4289967027 4294111986 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291282887 4292136396 4292307534 4289351470 4278190080 4280160782 4292115803 4293428588 4293163613 4294154355 4294617994 4294228640 4294234562 4294234305 4293894275 4293556560 4294601787 4290406483 4293980400 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290621614 4293417007 4292827434 4283375631 4279502851 4290861882 4293293403 4293620551 4294150497 4294220922 4294423189 4294033577 4293965984 4293893501 4294282341 4294277451 4290989874 4290690236 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291480266 4285087029 4293744424 4293679655 4293614120 4292630055 4293026627 4293090357 4293091892 4283574812 4282328605 4290148447 4294356109 4293962380 4293565564 4289948752 4292768589 4291719259 4288321688 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293783021 4283321934 4291531655 4294007592 4293351463 4293482791 4293482538 4292762686 4293613863 4292826662 4279896323 4278190080 4281080596 4294088564 4294681729 4288439888 4278190080 4285741350 4291398012 4284506208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290493371 4284176473 4292978329 4293876520 4293351463 4293417511 4292760110 4292892466 4293417511 4293745192 4291382306 4283047182 4285937956 4294017626 4293888613 4292509790 4289422151 4292504908 4290748570 4287269514 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289901234 4289307555 4293439137 4293942313 4293482791 4293285671 4292364842 4293285928 4293351463 4293285927 4293745192 4293942313 4293878578 4293487423 4293555531 4293753939 4294477145 4293822063 4292991448 4289045925 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286743170 4292465875 4292391853 4284162831 4293548584 4292956198 4292561702 4293417511 4293351463 4293351463 4293351463 4293416999 4293351462 4293351977 4293419058 4293552443 4293682749 4294561993 4294967295 4289506476 4283190348 4290164406 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4290953922 4282927176 4285887861 4294901502 4292530125 4278190080 4291645219 4292889125 4293088294 4293417255 4293745192 4293548327 4293351463 4293351463 4293351463 4293351206 4293351462 4294007338 4289816922 4294967295 4294967295 4294967295 4289703855 4290098613 4294572537 4294967295 4294967295 4294967295 4294967295 4294967295 4285229931 4285756275 4294967295 4294967295 4294506744 4285481267 4293416743 4292560932 4293417255 4293482791 4291316770 4292695077 4293482791 4293351463 4293351463 4293417511 4294203945 4290667858 4287860623 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375158 4294967295 4294967295 4294967295 4294967295 4293901748 4293021477 4292956197 4294073641 4289085212 4278190080 4284359696 4294138921 4293351719 4293548584 4293945151 4291600278 4284043858 4292203989 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293434251 4293351463 4293679912 4291842083 4286984983 4290398239 4293745704 4293416743 4293689703 4292724676 4282006074 4288190616 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294834680 4293299836 4293025850 4293417260 4294008109 4293485114 4293297003 4294233027 4294110700 4287335307 4290624957 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294767602 4294501087 4294500829 4294701551 4294967295 4294967295 4292993505 4282137660 4293848814 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572537 4286545791 4286940549 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4289967027 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:24:59.432'!
leftRightIcon
	"leftRightIcon := nil"
	^ leftRightIcon ifNil: [leftRightIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291880432 4288464607 4286494421 4285706451 4286100436 4287676380 4290566633 4294704638 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289384165 4284984015 4281436862 4279991990 4279663541 4279795126 4280648889 4283735752 4287940059 4293323516 4294967295 4294967295 4294967295 4294967295 4289054183 4283999176 4279466676 4279794870 4280123319 4280123319 4280123319 4279991990 4279466420 4281765567 4287281372 4294178811 4294967295 4294967295 4292142578 4285114576 4279466420 4279400884 4279729333 4280057783 4280123319 4280057783 4279991990 4279400884 4279269555 4282816707 4289318882 4294967295 4294967295 4288530655 4281371325 4279532212 4284326859 4289909734 4280977339 4279006641 4279203763 4288005085 4287019736 4280517305 4279466419 4286428631 4294967295 4294967295 4286297046 4280385976 4289647077 4294967295 4294967295 4292405747 4286297301 4290238184 4294770174 4294967295 4292734196 4281765311 4284918222 4294967295 4294967295 4285837779 4279729077 4283013317 4289975527 4293587960 4290238184 4294967295 4292077297 4291880176 4292340210 4285049295 4279926454 4284063946 4294967295 4294967295 4286165716 4279991990 4279597748 4279663541 4282290882 4281305789 4294638845 4285443536 4281502653 4280714426 4279335091 4279269555 4284983758 4294967295 4294967295 4287808219 4280911547 4279991990 4280057783 4279400884 4281108667 4294638845 4285771986 4278875313 4279926198 4280188855 4279532212 4285969362 4294967295 4294967295 4290960109 4284064458 4279466420 4280123319 4279860662 4281305788 4294967295 4286100436 4279269555 4280123319 4279729333 4281568702 4288398559 4294967295 4294967295 4294835967 4288003297 4282225600 4279466420 4279991990 4280648889 4286625750 4282684867 4279794869 4279729333 4280254903 4286231254 4292864502 4294967295 4294967295 4294967295 4293850361 4288004829 4283275975 4280057783 4279335091 4278612656 4279072434 4279663541 4281765567 4286561234 4291285496 4294967295 4294967295 4294967295 4294967295 4294967295 4294638845 4289712868 4287019737 4285574865 4284392652 4285049295 4286428630 4288595937 4293062645 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:04.585'!
loupeIcon
	"loupeIcon := nil"
	^ loupeIcon ifNil: [loupeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4292795870 4288848292 4286019452 4283848028 4284900717 4287597713 4291216581 4294111986 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4290953411 4282927187 4283649890 4285162618 4286679454 4286749099 4285433751 4283390566 4286874503 4293124835 4294967295 4294967295 4294967295 4294967295 4293256420 4283584855 4286547099 4289445073 4289250774 4289517540 4289716718 4289912556 4288918987 4283190363 4286611329 4294967295 4294967295 4294967295 4294967295 4292138196 4282137149 4286026909 4289194990 4289722360 4289393909 4289196015 4288933100 4287478722 4282072645 4284506208 4294967295 4294967295 4294967295 4294967295 4293322470 4285887610 4284441196 4282602585 4283593075 4284647049 4284975500 4284644223 4283389794 4281545534 4286216827 4294967295 4294967295 4294967295 4294967295 4294704123 4289176743 4283781986 4284833644 4281412400 4285820798 4289242037 4288781745 4285097592 4286084990 4292795870 4294967295 4294967295 4294967295 4294835709 4293059042 4287071887 4285953927 4284243038 4284703331 4287861402 4288519332 4288585123 4290558652 4294177779 4294967295 4294967295 4294967295 4294704123 4290098613 4284440425 4287467169 4284506468 4286282361 4293059042 4293585385 4293388006 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4290164151 4283716700 4284111719 4283519574 4285229930 4293980400 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286217095 4293322473 4286611852 4281281836 4293651179 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288190625 4290493377 4286940558 4291874768 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290295996 4285953663 4289045928 4294309365 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:09.623'!
pathfinderIcon
	"pathfinderIcon := nil"
	^ pathfinderIcon ifNil: [pathfinderIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286412400 4289427508 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286345574 4291526161 4292972315 4290870307 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286476383 4291854347 4293234192 4292380439 4292773904 4291461150 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287461729 4292379657 4290410522 4287455783 4293299992 4293037077 4293299987 4292248341 4287529076 4294967295 4294967295 4294967295 4294967295 4294967295 4289172602 4291526415 4287389475 4281218368 4283319867 4288900388 4289097509 4289491750 4290935837 4292379154 4288645232 4294967295 4294967295 4294967295 4287853903 4292314126 4290803732 4282005559 4280430916 4281481797 4281219142 4281022279 4280957518 4283583814 4292511513 4292510739 4289103199 4294967295 4286802251 4291984384 4292642831 4292511247 4291657491 4285092144 4282269762 4289754663 4290412076 4286340148 4281942604 4291264287 4292708890 4292642581 4289757512 4294967295 4288506664 4292379145 4292314385 4292642320 4292773646 4289229094 4291789595 4293431064 4289294374 4281285965 4290214436 4292643610 4292709145 4290672670 4294967295 4294967295 4288244013 4292379147 4292511250 4292314385 4292773905 4292577302 4292774167 4290213667 4281153866 4288770346 4293103385 4291329046 4287070847 4294967295 4294967295 4294967295 4288047925 4292313614 4292511252 4292314388 4292314646 4292511768 4291395357 4281153350 4286669363 4292708370 4287723354 4294967295 4294967295 4294967295 4294967295 4294967295 4287851066 4292182287 4292577303 4292183318 4292380441 4292249885 4286209073 4288244004 4288836665 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287851839 4292183061 4292446487 4292249367 4292381469 4293169175 4289425699 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287984972 4292117010 4292119591 4292513056 4290015254 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288116303 4291855128 4291000338 4287135347 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287919440 4287657298 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:09.671'!
qualityIconLarge
	"qualityIconLarge := nil"
	^ qualityIconLarge ifNil: [qualityIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294900216 4294766830 4294701038 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4294834166 4294566881 4293305760 4292311928 4293372325 4294102474 4294302681 4294567910 4294700524 4294900731 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294833909 4294301652 4293637296 4293107355 4292577152 4292843153 4293906125 4293174946 4292577668 4292908947 4292709513 4292974482 4294169296 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294434781 4292842381 4292577924 4293242027 4293839044 4294967295 4294967295 4294967295 4294701809 4294635502 4294635502 4292312695 4293107353 4294767602 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294036166 4292179567 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294436581 4292378232 4294036167 4294701038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294900988 4294169552 4292643460 4293109152 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293639609 4292709253 4293770424 4294502116 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294103245 4292576381 4293041817 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294037709 4292179567 4294169038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294900217 4293306531 4292444795 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768374 4292047723 4294367446 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966781 4293704374 4292378488 4294834424 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294302938 4292908688 4294700780 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294236374 4292112746 4294037452 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294435552 4292576895 4294434781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294037195 4292245360 4294436066 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292445824 4293439659 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293770938 4292444025 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966524 4292246388 4293572274 4294834424 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294102988 4292245103 4293705916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768373 4292643975 4293305760 4294301909 4294967038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294701294 4293637810 4292311411 4293042331 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293308073 4292974995 4294434010 4294900730 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294834680 4294036681 4292510846 4294303452 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292511616 4293770938 4294966781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294502631 4293174174 4292444795 4293640382 4293838018 4294502117 4294967295 4294967295 4294834937 4293573046 4293307820 4292577924 4292842124 4294434781 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4293903810 4292643717 4292377722 4292708743 4292644230 4293174689 4293640127 4292643203 4292975252 4292310900 4291980651 4293903809 4294900474 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293705917 4289594624 4290124818 4290257436 4291848291 4292975253 4292445826 4292776331 4290588714 4289528576 4289200128 4292312695 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292246131 4289396736 4289661440 4289660928 4289462272 4290059024 4290523173 4289726976 4289594624 4289727488 4289661184 4289925643 4294236630 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768117 4290456094 4289529088 4289727488 4289727488 4289727488 4289660928 4289462272 4289727232 4289727488 4289727488 4289727488 4289396736 4291649880 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293506481 4289528320 4289727488 4289727488 4289727488 4289727232 4289859846 4290853681 4289660672 4289727488 4289727488 4289727488 4289661440 4289594881 4293573045 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291517010 4289462272 4289727488 4289727488 4289727488 4289528832 4290787888 4294170324 4289926154 4289661184 4289727488 4289727488 4289727488 4289528832 4290323741 4294568424 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294236631 4289859592 4289528832 4289462272 4289661440 4289727488 4289396736 4292445310 4294967295 4291914853 4289396736 4289727488 4289727488 4289727232 4289462272 4289265664 4291450703 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291915365 4289134592 4290124306 4292645002 4290588967 4289528832 4289859077 4294236373 4294967295 4294435809 4289992463 4289594880 4289661440 4289860103 4291649368 4290456354 4289331200 4292444796 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294369760 4289660928 4290655792 4294170067 4294967295 4291583574 4289200128 4291118909 4294967295 4294967295 4294967295 4292843409 4289462272 4289528576 4290721581 4294967295 4294833653 4293706176 4293042847 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292843667 4291981162 4294767602 4294967295 4294967295 4292644746 4289069056 4292711052 4294967295 4294967295 4294967295 4294967295 4291185474 4289134592 4291914596 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294768374 4294967295 4294967295 4294967295 4294967295 4293573559 4289594624 4294170581 4294967295 4294967295 4294967295 4294967295 4294236117 4289661444 4292911001 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294236888 4292179823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293307302 4294104531 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967038 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:15.03'!
replayIcon
	"replayIcon := nil"
	^ replayIcon ifNil: [replayIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4293652728 4289575645 4288260822 4288195031 4287997654 4288655835 4292009200 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4291482346 4286813642 4288720599 4291088102 4291548394 4290956775 4288590042 4285828554 4288787677 4294770431 4294967295 4294967295 4294967295 4294967295 4291417065 4286484935 4290956517 4292338161 4294770174 4294967295 4294967295 4294441212 4291745515 4285236935 4288195288 4294967295 4294967295 4294967295 4293389559 4286879950 4290890724 4294967295 4289117153 4287933148 4291417326 4294901759 4294967295 4294967295 4291219689 4284118718 4290693604 4294967295 4294967295 4289839072 4288129493 4294375675 4294901758 4287736282 4285237452 4284842697 4286946515 4292206064 4294967295 4294901503 4286747849 4286353093 4294967295 4294967295 4288392921 4290299108 4294967295 4294704125 4286880980 4284250564 4283658687 4282671542 4282540212 4287011021 4293981177 4289443031 4285036984 4294967295 4294967295 4287932633 4290891239 4294967295 4294638589 4285894348 4283066555 4282802869 4282078637 4280697503 4279447441 4286747334 4289706457 4284970930 4294967295 4294967295 4287538134 4290036194 4294967295 4294638845 4285104324 4281882285 4281158051 4280434074 4282143650 4288128207 4294967295 4288390346 4284115882 4294967295 4294967295 4288261082 4287209171 4294835710 4294835711 4283591350 4280039833 4281289117 4286089408 4292929011 4294967295 4294638332 4283983266 4285693877 4294967295 4294967295 4292205807 4284118205 4290035937 4294967295 4284379830 4284248241 4290890468 4294967295 4294967295 4294967295 4287994815 4280892039 4291284707 4294967295 4294967295 4294967295 4288983513 4282999472 4289114580 4291416552 4294967295 4294967295 4294967295 4293783027 4287665592 4280430974 4287864520 4294967295 4294967295 4294967295 4294967295 4294967295 4288720340 4282669477 4285036209 4287468735 4287732158 4286416305 4282930065 4281220229 4287996105 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4291744743 4287009475 4284904622 4284444071 4284575399 4286614456 4291547621 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:20.063'!
spiderIcon
	"spiderIcon := nil"
	^ spiderIcon ifNil: [spiderIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:     #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294046193 4289374890 4294243572 4291611852 4293519849 4294967295 4293651435 4290888129 4293848814 4289045925 4294177779 4294967295 4294967295 4294967295 4294572537 4294967295 4291875024 4289572269 4291151301 4288453788 4286019447 4287861651 4288980132 4289111718 4292401368 4294967295 4294243572 4294901502 4294967295 4291546059 4289045925 4292269782 4288585374 4287861651 4284769380 4283321934 4283979864 4286216826 4288190616 4292269782 4288585374 4291019715 4294901502 4294967295 4294901502 4292006610 4288387995 4287335307 4284835173 4284769380 4286019447 4287137928 4284506208 4286414205 4287072135 4291809231 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289703855 4286743170 4284506208 4284966759 4287006342 4284703587 4288585374 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292796126 4288716960 4286874756 4285361517 4284177243 4284900966 4285493103 4286677377 4289045925 4293783021 4294967295 4294967295 4294967295 4294967295 4290361785 4287795858 4290822336 4287598479 4284374622 4283782485 4283979864 4285164138 4289111718 4289374890 4286479998 4292467161 4294967295 4294967295 4291085508 4289703855 4294375158 4289243304 4287203721 4284243036 4287006342 4286216826 4288914339 4287664272 4292401368 4293059298 4289243304 4293388263 4294967295 4293519849 4294967295 4291085508 4289374890 4291940817 4283848278 4291611852 4290230199 4288651167 4293125091 4286414205 4294901502 4294967295 4294704123 4294967295 4294967295 4293914607 4288387995 4294243572 4291217094 4283519313 4289967027 4288651167 4287335307 4294967295 4290032820 4289440683 4294835709 4294967295 4294967295 4294967295 4291743438 4292861919 4294967295 4293388263 4285229931 4283387727 4283585106 4291348680 4294967295 4294967295 4291282887 4293914607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914607 4291940817 4293125091 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself].! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:16.256'!
stopwatchIconLarge
	"stopwatchIconLarge := nil"
	^ stopwatchIconLarge ifNil: [stopwatchIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293321444 4291083198 4291544261 4294045680 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967039 4292004814 4289833130 4291610311 4291017919 4289766822 4293321442 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293584615 4291017403 4293848558 4293058270 4293782251 4293387494 4290622129 4294572279 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292267724 4293189342 4293123548 4291345338 4291806143 4294901501 4291674817 4293782248 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292465361 4292728790 4292860120 4291147958 4291542714 4294769659 4291543746 4294111215 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293914094 4290227372 4290952382 4290950836 4290951607 4291347395 4290688181 4294572280 4294638330 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293058270 4288648598 4291017656 4288254092 4289504419 4294177522 4292136139 4291148471 4293781992 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294835709 4293519081 4292202452 4289306534 4286673782 4287134847 4291544777 4292992992 4288845973 4290490025 4293847785 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292860895 4290819519 4289700524 4289701034 4290227889 4289371809 4289240222 4288713366 4288647831 4286476400 4290293936 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572281 4291610063 4290030002 4290687926 4291610308 4291545287 4291413701 4290953663 4291282372 4291676873 4291610053 4289898406 4288779158 4292268501 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294703867 4291478221 4290490553 4291610050 4291151042 4290559420 4290690750 4289769647 4289111461 4289506219 4290559164 4290756543 4291611081 4290951607 4288779157 4292334037 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292268247 4290885568 4291873478 4291282628 4288519580 4287795857 4289835184 4292072402 4289703598 4291743438 4291217094 4288914082 4289572269 4291611851 4291017658 4289239712 4293584873 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293913840 4291083206 4292268496 4291151043 4291743438 4292861919 4289243047 4290032563 4292203989 4290361785 4292927968 4290295735 4288782752 4293059298 4290822335 4291743180 4290753973 4290556343 4294835452 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292201942 4291741902 4292203730 4289243304 4289374633 4290690493 4292335318 4291808974 4292335575 4286940548 4292796126 4291545802 4292203989 4292796126 4291216837 4289703855 4291610310 4290095791 4293255653 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294506487 4291609549 4292663512 4290953921 4291940817 4289440426 4289374633 4292664540 4289769392 4292137940 4290164149 4292203989 4289637805 4293256677 4290624700 4288058773 4291019715 4291413957 4291148990 4291741645 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293716461 4291478476 4292466646 4290953921 4293585385 4293783021 4293519849 4293454056 4292203989 4290624956 4287466636 4291414473 4292335575 4293651435 4293256677 4293519849 4292927712 4290822078 4292070860 4291148996 4294901246 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293518827 4291741391 4292335316 4290888128 4288650910 4288387738 4293388263 4293388263 4293717228 4291545802 4287006086 4293322470 4293322470 4292335318 4293454056 4290822336 4290098356 4290953920 4292334289 4291082945 4294638074 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293518826 4291675597 4292466646 4291480008 4290427578 4290559164 4293322470 4293322470 4293519849 4291809231 4287730065 4293717228 4293190884 4292006353 4293454056 4289703854 4288848546 4290887870 4292333776 4290951360 4294572538 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293782509 4291280583 4292400596 4291085507 4293717228 4293519849 4293125091 4293322470 4293454056 4292269782 4289308840 4293783021 4293322470 4293519849 4293519849 4293848814 4292730333 4291019457 4292333776 4291016896 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294572280 4291477705 4292466133 4290756542 4291282630 4286611327 4289045668 4293519849 4293388263 4292006610 4290032820 4293585642 4293454056 4292730333 4288716703 4289703598 4291546059 4291414214 4291609542 4291609546 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291806925 4291215042 4291808715 4289506476 4291282887 4291809231 4293651435 4293190884 4291019714 4290295735 4292203988 4293848814 4293190884 4289506476 4289572268 4289638061 4292597460 4290490294 4293255396 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293848046 4289700780 4291676102 4291019714 4291480267 4292269525 4287203721 4291414216 4293519849 4293190884 4293388263 4289703598 4288782753 4293454056 4290624957 4291545544 4291411390 4290687931 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291873232 4290293431 4292400082 4291019714 4288651167 4289177511 4292664283 4290756543 4287072135 4292335575 4290164406 4287795857 4289374890 4291480008 4291412158 4289239970 4293518824 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294703867 4291280326 4290096052 4291939274 4291216579 4290427577 4290888386 4289835184 4288716703 4290756543 4290559164 4289967026 4291610821 4290819252 4288581014 4292202194 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4291478474 4289305767 4290293169 4291478466 4291413443 4291282371 4291413957 4291347907 4291413186 4291016887 4289041304 4288581526 4292400087 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292860895 4289832625 4288647324 4288713370 4289173405 4289305245 4288778647 4288186511 4288252306 4290425015 4293848301 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4293584874 4291939538 4291083203 4290754238 4291215301 4292531673 4294111474 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:22.494'!
traceabilityIconLarge
	"traceabilityIconLarge := nil"
	^ traceabilityIconLarge ifNil: [traceabilityIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray: #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291151300 4285756276 4285098346 4287993237 4294704123 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294901502 4294901502 4294967295 4291348680 4286218637 4281547589 4284181632 4282074961 4288848546 4293519849 4290230199 4286479998 4292203989 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294901502 4294901502 4294967295 4294967295 4294901502 4294967295 4294901502 4294967295 4294967295 4288256152 4289050577 4283852668 4284313222 4278651405 4282598211 4285822068 4285625460 4278584838 4287006342 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4287532687 4285825944 4282798428 4284639596 4288784552 4293127918 4294180349 4286547590 4279967005 4289440683 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294638330 4294967295 4292796126 4287401100 4284112221 4288060828 4292338143 4294246399 4294443007 4294311935 4289904061 4286613383 4288651167 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294704123 4287335311 4292532954 4294967295 4294967295 4291217094 4284770151 4293914607 4294967295 4287993237 4286348669 4288059801 4292074973 4294115070 4294377471 4293918205 4293654776 4293786362 4292667881 4290627527 4287994008 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4290559163 4279638066 4283125093 4294967295 4292006610 4287468692 4284508264 4288980132 4287401100 4290560192 4292667624 4291417557 4292470245 4293852412 4293654776 4293654776 4293654776 4294180606 4285428852 4287336335 4294309365 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292664540 4282796645 4280033883 4287598483 4289047722 4289903804 4285493874 4290363327 4284375393 4289309868 4292864232 4290233283 4293655033 4293720569 4293654776 4293654776 4293654776 4294246142 4289245874 4282400575 4294769916 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4284375151 4278585641 4283652188 4293391603 4293325811 4294574079 4290890956 4285560695 4284507750 4287271313 4288191901 4290693320 4294311935 4294049791 4294115327 4294246399 4294180863 4294705151 4283717977 4287993237 4294967295 4293914607 4290756286 4287006342 4293190884 4294967295 4294967295 4294967295 4294967295 4294967295 4290164406 4282270272 4287732892 4289443510 4293917948 4293786362 4293128175 4285823867 4289048238 4283323476 4288193186 4285954682 4287797657 4291416786 4290956749 4290495941 4290825420 4291943387 4289706425 4280163870 4285493103 4288322973 4290824135 4281875259 4287861651 4294967295 4294967295 4294967295 4294967295 4293980400 4286019447 4292732389 4288193700 4289180338 4293983998 4294443007 4294967295 4286152832 4289377460 4285758074 4285232244 4288522665 4287468178 4283914585 4283981663 4283981663 4284113249 4283652698 4283849820 4278256130 4285362802 4294967295 4289772475 4283585106 4293980400 4294967295 4294967295 4294967295 4294967295 4286151033 4292140252 4294115327 4289838525 4292009951 4293456883 4288982188 4283915099 4280756264 4285034094 4291088335 4285429109 4287732892 4287996321 4289113774 4286151290 4279045132 4278782474 4286481797 4287666585 4285560438 4284836715 4292864489 4282862411 4293256677 4294967295 4294967295 4294967295 4294967295 4294967295 4291940817 4286217854 4292930282 4294705151 4293128175 4282928204 4280361249 4288387995 4289374890 4283190605 4291483350 4289245874 4287337877 4287798685 4287667099 4289443253 4287335821 4279834905 4290167234 4291219921 4292470245 4294508543 4285363573 4287598479 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294177779 4286875013 4292140252 4291219921 4282599496 4291348680 4293059555 4284638565 4281479987 4284770922 4290101183 4288259236 4287667356 4287798685 4287601306 4288654251 4287468178 4285625973 4286613640 4286613383 4292075744 4285626488 4291085508 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289046182 4284309857 4282204738 4292532954 4287994008 4292338659 4283191633 4282335810 4288390565 4287206291 4287864478 4287798685 4287798685 4287864479 4285758329 4285033319 4285955197 4282204481 4286152832 4292602088 4284967273 4294506744 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290559164 4287927444 4290756543 4288982445 4289772218 4281546294 4292141023 4286482054 4287272084 4287864221 4287798685 4287798685 4287864478 4287206548 4286745740 4286942862 4284639593 4284442214 4289574839 4287403413 4286611841 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4293322470 4286612612 4283915613 4288061343 4293260018 4284178785 4287996064 4287798685 4287798685 4287798685 4287798685 4287864478 4287930528 4287930271 4288391079 4285890174 4285558896 4288848803 4288124823 4294375158 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294901502 4294901502 4294967295 4291480266 4282269760 4294639615 4288587687 4284047456 4288786094 4288259236 4288193443 4288061857 4287996064 4288062114 4288061857 4287798685 4287798685 4288193700 4285954425 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4288387995 4290560706 4294967295 4284704872 4281151793 4283718491 4284508264 4285363830 4286153346 4286745483 4285824381 4285955967 4288127650 4287864478 4288522665 4284639593 4292335575 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4293651435 4284637794 4291283658 4290363327 4289442996 4287534742 4286613640 4286481797 4286350211 4286482054 4287074191 4283915099 4284178785 4286021503 4287272341 4286087296 4287335564 4294769916 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294901502 4294967295 4289703855 4279769112 4282664775 4286415490 4286875270 4281282864 4279440403 4279571989 4279637783 4279506197 4279440403 4283716949 4287598736 4286810762 4283718491 4285361517 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4293651435 4291480266 4293519849 4294967295 4292861919 4278519045 4279770658 4278519560 4278190080 4278190080 4278321924 4284703587 4293585642 4287534742 4282400832 4294440951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4289045925 4281284418 4287012535 4284181373 4278255873 4278321666 4281482309 4283782485 4294967295 4292269782 4293256677 4294967295 4294901502 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4294901502 4294967295 4294967295 4294967295 4285559154 4286353581 4290363852 4288723679 4281482308 4280033830 4283523438 4283190348 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289573302 4290889937 4294309366 4289905370 4287407042 4284511109 4283589489 4283585107 4294967295 4294967295 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291678937 4288261058 4284247935 4283190863 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4294901502 4294967295 4294967295 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4294901502 4294967295 4294967295 4294440951 4290494146 4286611843 4294835709 4294967295 4294901502 4294967295 4294901502 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

!SImageRepository class methodsFor: 'icons' stamp: 'mp 3/24/2011 16:25:25.321'!
treeIcon
	"treeIcon := nil"
	^ treeIcon ifNil: [treeIcon := 
		(Form
			extent: 15@15
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293652451 4291614910 4288327307 4290168488 4292403659 4294901500 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292995288 4289773728 4285237327 4283659571 4284381516 4283724860 4283988534 4287603835 4291285946 4294441460 4294967295 4294967295 4294967295 4294967295 4294375668 4284513093 4282935085 4284776274 4283460414 4284052550 4283526461 4284314956 4284316229 4282080287 4289905062 4294967295 4294967295 4294967295 4294967295 4291285941 4283330092 4283461680 4283198260 4283987014 4284052802 4284184389 4283592000 4283330095 4283264300 4286092123 4294835964 4294967295 4294967295 4294244338 4286684004 4283066924 4283724346 4282474794 4282540846 4282737963 4282869549 4282276905 4283264305 4283460920 4283856689 4291220152 4294967295 4294967295 4293323488 4284776777 4283722822 4283657029 4282211364 4282801723 4280696092 4281880114 4282474032 4282868786 4283853904 4283461175 4288787598 4294967295 4294967295 4292074443 4284973134 4284447306 4283592000 4282210860 4281486119 4281617954 4281683749 4281552167 4283066164 4284052295 4284513349 4287800190 4294835708 4294967295 4294638330 4288852883 4282475045 4282146075 4281882399 4280499990 4281157658 4280565782 4281026586 4282343709 4281948702 4284645448 4293060318 4294967295 4294967295 4294967295 4292928988 4288852375 4288787092 4288852382 4287537038 4281615401 4284576347 4288918178 4288260749 4289510050 4289772967 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294770175 4287795852 4292664797 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375158 4292401368 4290756543 4289374890 4287072135 4284900710 4282400830 4284506207 4286611585 4287071879 4287664272 4289769648 4293125091 4294967295 4294967295 4294704123 4293783021 4293256677 4293256677 4293454056 4293125091 4292993505 4292927712 4293519849 4293717228 4293454056 4293651435 4294506744 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				replaceColor: Color white withColor: Color transparent;
				yourself]! !

!SImageRepository class methodsFor: 'large icons' stamp: 'mp 3/24/2011 16:19:28.448'!
worldIconLarge
	"worldIconLarge := nil"
	^ worldIconLarge ifNil: [worldIconLarge := 
		(Form
			extent: 30@30
			depth: 32
			fromArray:   #(4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638331 4294243573 4292600809 4291943910 4289318888 4288071400 4289646306 4291024869 4292733424 4294310137 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294244345 4290695903 4288658897 4288987347 4291220186 4289318373 4285382385 4285118185 4284920549 4284524242 4284981961 4289379271 4291482070 4293521653 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4293455087 4288330962 4289972953 4292271843 4293257193 4292404973 4288402164 4286105076 4286104048 4285709291 4286167782 4285770963 4289708236 4291150270 4288457655 4289316057 4294573052 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294638331 4291157484 4286231252 4287347157 4290305523 4290567408 4288336369 4286236662 4287155445 4286826997 4286892789 4285643242 4288464611 4292336091 4292138196 4291545802 4291019198 4286225335 4285045188 4293850104 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294375931 4288072684 4286367217 4285378776 4285972459 4288205815 4286959354 4285909498 4287089909 4287614193 4285776112 4286891245 4287349994 4291353062 4293190110 4292335574 4292006610 4291414472 4290756027 4288981679 4285634485 4293784311 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294835710 4287876592 4285248479 4286037221 4286696438 4286631418 4286827767 4287024374 4289189875 4292207854 4293586157 4289976817 4290567151 4292863724 4293060070 4293059299 4292598747 4292203989 4291546316 4290428092 4290624440 4289046957 4285174714 4294507259 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290568180 4285644010 4286168809 4286959869 4286959611 4289124598 4287745779 4288795375 4292601324 4290895343 4293783021 4293651950 4294373613 4293848300 4293519592 4293125091 4292861919 4292335575 4291743438 4290560194 4290427835 4290361010 4285368741 4287672014 4294967295 4294967295 4294967295 4294967295 4294967295 4293916410 4286038768 4286366959 4286893818 4286630904 4286696955 4290370802 4290173682 4291223792 4290239216 4292536046 4294176749 4294176749 4293914349 4293717485 4293454056 4293190884 4292927712 4292269782 4291414473 4291085508 4290624957 4290361012 4286813864 4282939043 4292601328 4294967295 4294967295 4294967295 4294967295 4289319143 4285512166 4286894074 4286762747 4286827509 4287877364 4293061358 4294307563 4294176748 4294111213 4294439149 4294176749 4294045421 4294045421 4293848556 4293453799 4293190884 4292861920 4292203989 4291414473 4291019715 4290690750 4290295477 4288521129 4282282147 4284781249 4294967294 4294967295 4294967295 4294441723 4284915651 4285773792 4287025919 4286171127 4291486963 4293060844 4291354348 4292009444 4293454057 4294045419 4293651692 4293651693 4294176749 4293454829 4292929517 4292797157 4293125091 4292467934 4291809747 4291282887 4291151301 4290756543 4290032820 4289703080 4287403681 4280508579 4293521398 4294967295 4294967295 4292470510 4283995065 4285245904 4286171384 4286958582 4291354607 4288598256 4286235892 4288466413 4291353834 4293848041 4287612141 4286693362 4292863724 4289253101 4290041069 4291614690 4292862434 4292401111 4291480266 4291611852 4291414473 4290559164 4289835441 4288980132 4288848030 4281623963 4289710048 4294967295 4294967295 4290039004 4283995064 4284983762 4287745265 4292470253 4293651692 4293192429 4289319662 4285709036 4287743980 4290172397 4292601068 4291025645 4292140774 4290499559 4287151081 4293650147 4292993505 4291743438 4290888129 4291414473 4291151301 4290493371 4289243304 4288716960 4288585116 4281623188 4286357704 4294967295 4294967295 4287475913 4283402672 4287215572 4293914607 4294176749 4293979885 4294505197 4292207598 4285840364 4285577713 4284658163 4287480300 4292863723 4294176490 4292665572 4290498272 4292861918 4292532954 4291611852 4291085508 4290624957 4290361785 4289703855 4289045924 4288913822 4286483611 4280506258 4284911032 4294967295 4294967295 4285898685 4283467692 4289971666 4294045163 4293783021 4293848557 4293914349 4294242541 4292667118 4292601326 4288990961 4288071664 4293323501 4293914092 4292731107 4293124317 4292926938 4292466646 4292137422 4291809230 4291282887 4290361785 4290032563 4289309870 4289373857 4286220696 4279652244 4283136428 4294967295 4294967295 4285701820 4284321713 4292073691 4293387749 4293454056 4293651178 4293651435 4293717228 4293979884 4294045677 4294570732 4292141289 4292600552 4293716454 4291286498 4287280089 4289840083 4291021779 4289707725 4291742922 4291282628 4291019198 4288456885 4282019495 4286746783 4288781718 4281950867 4281887396 4294967295 4294967295 4286751936 4283072423 4290759121 4293256161 4293125091 4293256677 4293388263 4293454055 4293322470 4293454056 4293585126 4291615205 4288660195 4293453281 4292927453 4289709529 4289709012 4284060879 4280710603 4284847045 4290034367 4290821304 4283596204 4279260319 4280573344 4282279573 4280177297 4285764275 4294967295 4294967295 4289052113 4281691034 4287604926 4293386716 4293124318 4293124834 4292862178 4292862435 4293190883 4293125091 4293125091 4293256161 4286755294 4290759898 4292861144 4293451733 4290167759 4281497798 4280512711 4279723969 4286224312 4289310130 4280049060 4279522465 4279390105 4281031571 4281162126 4289378244 4294967295 4294967295 4291549411 4281887898 4283333795 4288197578 4291023068 4292861403 4292401884 4292467934 4292927455 4292796126 4292730333 4292992732 4289774293 4287541457 4291218384 4286751945 4281628868 4280643522 4280775105 4279985078 4281429427 4287076779 4280507810 4278996123 4279520658 4284052628 4281028991 4290102485 4294967295 4294967295 4294178552 4282676898 4282347676 4282217638 4283011023 4288592853 4292335316 4292466904 4292401368 4292335575 4292269782 4292203989 4292137421 4289576397 4286358216 4283270854 4280447175 4280774849 4280247992 4280116148 4279852458 4280573860 4280375451 4278929555 4278600333 4281489285 4281686404 4293126640 4294967295 4294967295 4294967295 4286753487 4281296796 4281821335 4281560742 4283995339 4291809489 4292072145 4292006610 4292006610 4292072146 4291808973 4291151302 4291808457 4291611335 4283008454 4280183489 4280247477 4280116148 4280049580 4279588258 4279127451 4278862988 4278928783 4278664582 4278201452 4282411161 4294901502 4294967295 4294967295 4294967295 4293192948 4281825203 4282021809 4281691555 4282283434 4289575365 4291742665 4291480523 4291546058 4290823368 4290297797 4291479492 4290625731 4284123580 4279854008 4280115891 4280115374 4279983015 4279588258 4279324829 4279126675 4278797195 4278599047 4278598271 4278201969 4291285986 4294967295 4294967295 4294967295 4294967295 4294967295 4287870423 4281364660 4282153144 4281363627 4284581805 4291216578 4290953922 4290953921 4289443262 4289640126 4289836474 4282349495 4279393714 4280115889 4280115115 4279719843 4279522467 4279324828 4279061139 4278862989 4278599304 4278598787 4278203005 4283858866 4294901759 4294967295 4294967295 4294967295 4294967295 4294967295 4294638588 4283401661 4280838056 4281167023 4283530667 4290427062 4290361784 4290296249 4289902008 4290558389 4287208884 4279590578 4279852717 4279786151 4279654052 4279390881 4279258777 4279060882 4278796939 4278598789 4278599044 4278204032 4279717267 4294112760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293849847 4281823918 4280180644 4282611115 4289309355 4289769389 4289703855 4289703598 4289046956 4288652972 4280113566 4281492896 4280704931 4279061915 4279126676 4278994833 4278730890 4278598788 4278599303 4278204291 4278862475 4292798191 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293718518 4282151853 4278865561 4284185759 4289505186 4289045668 4289111459 4288322978 4281555858 4280767629 4287534234 4280110730 4278863504 4278861698 4278663546 4278598786 4278533252 4278203521 4279717267 4292798191 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294441467 4286160582 4279455893 4284446609 4288387735 4288650649 4283722890 4278202228 4280502908 4282079872 4278334063 4278794356 4278728048 4278662253 4278202738 4278204034 4284253108 4294047224 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292075500 4284385206 4281031829 4280372612 4278201450 4278267754 4278333805 4278202221 4278399341 4278201706 4278201193 4278268788 4282872230 4291352294 4294901502 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901503 4293192691 4289183450 4285567158 4282740126 4281030544 4280898701 4282345625 4285106607 4288853711 4292995312 4294835966 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
			offset: 0@0)
				asFormOfDepth: Display depth;
				yourself]! !

Object subclass: #SNode
	instanceVariableNames: 'callgraphModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

SNode subclass: #SMethodNode
	instanceVariableNames: 'clientClass clientSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

SMethodNode subclass: #SCallNode
	instanceVariableNames: 'id fromSender nextCalls selectedView selectedProfile views profiles objects callsBefore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SCallNode class methodsFor: 'instance creation' stamp: 'mp 6/15/2010 16:03'!
id: aNumber class: aClass methodName: aSelector fromSender: aCallNode model: aCallgraphModel receiverType: aTypeClass callsBefore: aCallsNumber

	^ (self forClass: aClass withSelector: aSelector model: aCallgraphModel)
		id: aNumber;
		fromSender: aCallNode;
		callsBefore: aCallsNumber;
		setReceiverType: aTypeClass;
		initClassView;
		yourself! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
addCall: aCallNode

	self nextCalls add: aCallNode.! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 6/15/2010 15:59'!
callsBefore
	"Answer the value of callsBefore"

	^ callsBefore! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 6/15/2010 15:59'!
callsBefore: anObject
	"Set the value of callsBefore"

	callsBefore := anObject! !

!SCallNode methodsFor: 'callgraph' stamp: 'mp 4/24/2010 18:43'!
clearObjectCache

	self objects: nil.! !

!SCallNode methodsFor: 'callgraph' stamp: 'mp 4/24/2010 18:51'!
explore: aSymbol
	^ self objects 
		at: aSymbol 
		ifAbsentPut: [self tracer explore: aSymbol on: self]! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
fromSender
	^ fromSender! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
fromSender: anObject
	fromSender := anObject! !

!SCallNode methodsFor: 'callgraph' stamp: 'mp 1/25/2010 13:59'!
getCallStack

	| callStack currentNode |
	callStack := OrderedCollection new.
	currentNode := self.
	callStack addFirst: currentNode.
	[currentNode fromSender notNil] whileTrue: [
		currentNode := currentNode fromSender.
		callStack addFirst: currentNode].
	^ callStack! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
id
	^ id! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
id: anObject
	id := anObject! !

!SCallNode methodsFor: 'initialize-release' stamp: 'mp 5/5/2010 13:41'!
initClassView

	self views at: #classes put: self clientClass.! !

!SCallNode methodsFor: 'initialize-release' stamp: 'mp 5/5/2010 13:37'!
initialize

	self id: -1.
	self nextCalls: OrderedCollection new.
	self views: Dictionary new.
	self profiles: Dictionary new.
	self selectedView: #classes.
	self selectedProfile: #normal.! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
nextCalls
	^ nextCalls! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:41'!
nextCalls: anObject
	nextCalls := anObject! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:38'!
objects
	"Answer the value of objects"

	^ objects ifNil: [objects := Dictionary new]! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:37'!
objects: anObject
	"Set the value of objects"

	objects := anObject! !

!SCallNode methodsFor: 'printing' stamp: 'mp 4/24/2010 14:04'!
printNodeId

	^ '(', self id asString, ')'	! !

!SCallNode methodsFor: 'printing' stamp: 'mp 1/25/2010 13:57'!
printProfile

	self selectedProfile == #normal ifTrue: [^''].
	^ '[',  (self profiles at: self selectedProfile), ']'! !

!SCallNode methodsFor: 'printing' stamp: 'mp 4/24/2010 14:04'!
printSelector

	^ '>>', self clientSelector! !

!SCallNode methodsFor: 'printing' stamp: 'mp 10/31/2010 12:11:29.179'!
printString

	 ^ (self callgraphModel printInfosForNode: self), 
		self printProfile, 
		self printView, 
		self printSelector

	! !

!SCallNode methodsFor: 'printing' stamp: 'mp 5/5/2010 13:40'!
printView

	(self selectedView == #classes and: [((self views at: #classes) = (self views at: #receiver)) not]) 
		ifTrue: [^ (self views at: #receiver) asString, '(', (self views at: #classes) asString, ')'].
	^ (self views at: self selectedView) asString.

	! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
profiles
	"Answer the value of profiles"

	^ profiles! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
profiles: anObject
	"Set the value of profiles"

	profiles := anObject! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
selectedProfile
	"Answer the value of selectedProfile"

	^ selectedProfile! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
selectedProfile: anObject
	"Set the value of selectedProfile"

	selectedProfile := anObject! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
selectedView
	"Answer the value of selectedView"

	^ selectedView! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
selectedView: anObject
	"Set the value of selectedView"

	selectedView := anObject! !

!SCallNode methodsFor: 'callgraph' stamp: 'mp 1/25/2010 13:41'!
setAsCurrentSelection

	self callgraphModel 
		newSelectedItem: self;
		changed: #getSelectedPath.! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 5/5/2010 13:25'!
setReceiverType: aClass

		self views at: #receiver put: aClass.! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 4/24/2010 18:51'!
tracer

	^ self callgraphModel tracer! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
views
	"Answer the value of views"

	^ views! !

!SCallNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 13:43'!
views: anObject
	"Set the value of views"

	views := anObject! !

SCallNode subclass: #SRootCallNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SRootCallNode methodsFor: 'printing' stamp: 'mp 4/27/2010 20:28'!
printString

	 ^ 'Entry Point'! !

!SRootCallNode methodsFor: 'running' stamp: 'mp 5/2/2010 12:28'!
run

	self subclassResponsibility.! !

SRootCallNode subclass: #SRootCodeCallNode
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SRootCodeCallNode class methodsFor: 'instance creation' stamp: 'mp 5/2/2010 12:31'!
id: aNumber code: aSourceCodeString fromSender: aCallNode model: aCallgraphModel

	^ (self forClass: nil withSelector: nil model: aCallgraphModel)
		id: aNumber;
		fromSender: aCallNode;
		code: aSourceCodeString;
		initClassView;
		yourself! !

!SRootCodeCallNode methodsFor: 'accessing' stamp: 'mp 5/2/2010 12:30'!
code
	"Answer the value of code"

	^ code! !

!SRootCodeCallNode methodsFor: 'accessing' stamp: 'mp 5/2/2010 12:30'!
code: anObject
	"Set the value of code"

	code := anObject! !

!SRootCodeCallNode methodsFor: 'running' stamp: 'mp 5/2/2010 12:55'!
numArgsOfMethod
	"Custom code has no method and no arguments"
	^ 0! !

!SRootCodeCallNode methodsFor: 'running' stamp: 'mp 5/2/2010 12:51'!
run
	^ Compiler evaluate: self code! !

SRootCallNode subclass: #SRootTestCallNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SRootTestCallNode methodsFor: 'running' stamp: 'mp 5/2/2010 12:28'!
run

	^ self clientClass run: self clientSelector! !

!SMethodNode class methodsFor: 'instance creation' stamp: 'mp 1/25/2010 13:50'!
forClass: aClass withSelector: aSelector model: aCallgraphModel

	^ (self for: aCallgraphModel)
			clientClass: aClass;
			clientSelector: aSelector! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 1/3/2010 14:04'!
clientClass
	^ clientClass! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 1/3/2010 14:04'!
clientClass: anObject
	clientClass := anObject! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 1/3/2010 14:04'!
clientSelector
	^ clientSelector! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 1/3/2010 14:04'!
clientSelector: anObject
	clientSelector := anObject! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 4/24/2010 15:04'!
compiledMethod

	^ self clientClass >> self clientSelector! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 4/24/2010 15:03'!
methodReference

	^ MethodReference class: self clientClass selector: self clientSelector! !

!SMethodNode methodsFor: 'accessing' stamp: 'mp 5/2/2010 12:54'!
numArgsOfMethod

	^ self compiledMethod numArgs! !

!SNode class methodsFor: 'instance creation' stamp: 'mp 1/18/2010 16:43'!
for: aCallgraphModel

	^ self new
		callgraphModel: aCallgraphModel! !

!SNode methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:43'!
callgraphModel
	^ callgraphModel! !

!SNode methodsFor: 'accessing' stamp: 'mp 1/18/2010 16:43'!
callgraphModel: anObject
	callgraphModel := anObject! !

Object subclass: #SNullWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tracer'!

!SNullWrapper commentStamp: 'mp 7/13/2010 16:10:38.579' prior: 0!
A SNullWrapper is a null object that is required if you want to use the tracer without tracing (execute entry points only).

Instance Variables
!

!SNullWrapper class methodsFor: 'instance creation' stamp: 'mp 7/13/2010 16:06:23.225'!
on: aSymbol inClass: aClass with: aTracer

	^ self new! !

!SNullWrapper methodsFor: 'installation' stamp: 'mp 7/13/2010 16:07:31.93'!
install! !

!SNullWrapper methodsFor: 'installation' stamp: 'mp 7/13/2010 16:07:43.356'!
uninstall! !

Object subclass: #SPMColorStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Coloring'!

!SPMColorStrategy class methodsFor: 'color propagation' stamp: 'mp 7/9/2010 16:01:50.975'!
for: aPathMapMorph

	"No propagation of color"! !

SPMColorStrategy subclass: #SPMDominantColorStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Coloring'!

!SPMDominantColorStrategy class methodsFor: 'color propagation' stamp: 'mp 7/9/2010 16:35:48.121'!
for: aPathMapMorph
	(aPathMapMorph childrenMorphs anySatisfy: [:each | each color == Color red])
		ifTrue: [^ aPathMapMorph propagateColor: (Color red)].
	(aPathMapMorph childrenMorphs anySatisfy: [:each | each color == Color yellow])
		ifTrue: [^ aPathMapMorph propagateColor: (Color yellow)].
	(aPathMapMorph childrenMorphs anySatisfy: [:each | each color == Color green])
		ifTrue: [^ aPathMapMorph propagateColor: (Color green)].		! !

SPMColorStrategy subclass: #SPMHighestColorStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Coloring'!

!SPMHighestColorStrategy class methodsFor: 'color propagation' stamp: 'mp 9/30/2010 11:43:34.36'!
for: aPathMapMorph
	| coloredChildren maxHue maxSaturation maxBrightness |
	coloredChildren := 0.
	maxHue := 1000.
	maxSaturation := 0.0.
	maxBrightness := 0.0.
	aPathMapMorph childrenMorphs values do: [:each | 
		(each color = Color white) not
			ifTrue: [coloredChildren := coloredChildren + 1.
					maxHue := maxHue min: each color hue.
					maxSaturation := maxSaturation max: each color saturation.
					maxBrightness := maxBrightness max: each color brightness]].
	coloredChildren = 0
		ifTrue: [aPathMapMorph propagateColor: (Color white)] 
		ifFalse: [aPathMapMorph propagateColor: (Color 
													h: maxHue 
													s: maxSaturation 
													v: maxBrightness)].! !

SPMColorStrategy subclass: #SPMPercentageColorStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Coloring'!

!SPMPercentageColorStrategy class methodsFor: 'color propagation' stamp: 'mp 9/3/2010 10:19:17.22'!
for: aPathMapMorph
	| coloredChildren hue saturation brightness |
	coloredChildren := hue := saturation := brightness := 0.
	aPathMapMorph childrenMorphs values do: [:each | 
		(each color = Color white) not
			ifTrue: [	hue := hue + each color hue.
					coloredChildren := coloredChildren + 1].
		saturation := saturation + each color saturation.
		brightness := brightness + each color brightness].
	coloredChildren = 0 
		ifFalse: [hue := hue / coloredChildren].
	saturation := saturation / aPathMapMorph childrenMorphs size.
	brightness := brightness / aPathMapMorph childrenMorphs size.
	aPathMapMorph propagateColor: (Color h: hue s: saturation v: brightness).
! !

Object subclass: #SPMOptions
	instanceVariableNames: 'pathMap colorLegend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Options'!

SPMOptions subclass: #SPMFaultLocalizationOptions
	instanceVariableNames: 'formula singlePointOfFault'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Options'!

!SPMFaultLocalizationOptions class methodsFor: 'constants' stamp: 'mp 9/22/2010 17:48:32.305'!
maxHue
	^ 120! !

!SPMFaultLocalizationOptions methodsFor: 'spec commands' stamp: 'mp 11/15/2010 13:41:44.273'!
authorRanking
	self isSelectedAnalysisOption
		ifTrue: [self informAuthorRanking: self pathMap tracer mostOpportuneAuthors]
		ifFalse: [self inform: 'Please run tests first.']! !

!SPMFaultLocalizationOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 16:50:25.157'!
formula
	"Answer the value of formula"

	^ formula! !

!SPMFaultLocalizationOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 16:34:46.024'!
formula: anObject
	"Set the value of formula"

	formula := anObject! !

!SPMFaultLocalizationOptions methodsFor: 'visualization' stamp: 'mp 9/22/2010 18:19:40.866'!
getLabelString: aPosition
	| label |
	label := ''.
	label := (aPosition x * 100) asInteger asString, '% suspicious'.
	self singlePointOfFault
		ifFalse: [
			label := label, ' / '.
			aPosition y <= 0.1
				ifTrue: [label := label, '100% confidence']
				ifFalse: [label := label, ((1.0 - ((aPosition y - 0.1) / 0.9)) * 100) 
										asInteger asString, '% confidence']].
	^ label! !

!SPMFaultLocalizationOptions methodsFor: 'spec commands' stamp: 'mp 11/15/2010 13:59:19.491'!
informAuthorRanking: aCollection
	| fullValue msg |
	fullValue := aCollection inject: 0 into: [:sum :each | sum + each value].
	msg := ''.
	aCollection 
		do: [:each | msg := msg, each key, Character space, $(, ((each value / fullValue) * 100) asInteger asString, '%)']
		separatedBy: [msg := msg, Character cr].
	UserDialogBoxMorph inform: msg title: ' Developer Ranking '.! !

!SPMFaultLocalizationOptions methodsFor: 'initialize-release' stamp: 'mp 9/22/2010 18:19:12.714'!
initialize

	self 
		formula: #ochiai;
		singlePointOfFault: false.! !

!SPMFaultLocalizationOptions methodsFor: 'visualization' stamp: 'mp 9/22/2010 17:49:49.9'!
refreshColorLegendHorizontal
	self colorLegend horizontalColors: 	{1.0 -> ((Interval from: self class maxHue to: 0 by: -10) 
					collect: [:each | Color h: each s: 1.0 v: 1.0])}.! !

!SPMFaultLocalizationOptions methodsFor: 'visualization' stamp: 'mp 9/22/2010 18:19:46.306'!
refreshColorLegendVertical
	self singlePointOfFault 
		ifTrue: [self colorLegend verticalColors: self class transparentForColorLegend]
		ifFalse: [self colorLegend 
					verticalColors: {0.1 -> {Color white alpha: 0}.
									1.0 -> {Color white alpha: 0.01. Color white}}].! !

!SPMFaultLocalizationOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 16:50:09.643'!
setFormula: aSymbol
	self 
		formula: aSymbol;
		redrawPathMapIfPossible.! !

!SPMFaultLocalizationOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 17:18:32.802'!
showHighscore
	self isSelectedAnalysisOption
		ifTrue: [self pathMap tracer mostSuspiciousMethods explore]
		ifFalse: [self inform: 'Please run tests first.']! !

!SPMFaultLocalizationOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 18:19:02.917'!
singlePointOfFault
	"Answer the value of singlePointOfFault"

	^ singlePointOfFault! !

!SPMFaultLocalizationOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 18:19:02.921'!
singlePointOfFault: anObject
	"Set the value of singlePointOfFault"

	singlePointOfFault := anObject! !

!SPMFaultLocalizationOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 18:20:28.518'!
switchSinglePointOfFault
	self 
		singlePointOfFault: self singlePointOfFault not;
		changed: #singlePointOfFault;
		redrawPathMapIfPossible.! !

SPMOptions subclass: #SPMGlobalOptions
	instanceVariableNames: 'showMethodCategories showQuickAndAccessorMethods ignoreTracingOfSetUpAndTearDownMethods visualizeIntermediateSteps showEmptyCategoriesAndClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Options'!

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.745'!
ignoreTracingOfSetUpAndTearDownMethods
	"Answer the value of ignoreTracingOfSetUpAndTearDownMethods"

	^ ignoreTracingOfSetUpAndTearDownMethods! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.749'!
ignoreTracingOfSetUpAndTearDownMethods: anObject
	"Set the value of ignoreTracingOfSetUpAndTearDownMethods"

	ignoreTracingOfSetUpAndTearDownMethods := anObject! !

!SPMGlobalOptions methodsFor: 'initialize-release' stamp: 'mp 9/28/2010 13:21:03.272'!
initialize

	self 
		showMethodCategories: true;
		showQuickAndAccessorMethods: true;
		ignoreTracingOfSetUpAndTearDownMethods: false;
		visualizeIntermediateSteps: true;
		showEmptyCategoriesAndClasses: false. "This option cannot be changed by the user"! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/28/2010 11:44:27.012'!
showEmptyCategoriesAndClasses
	"Answer the value of showEmptyCategoriesAndClasses"

	^ showEmptyCategoriesAndClasses! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/28/2010 11:44:27.017'!
showEmptyCategoriesAndClasses: anObject
	"Set the value of showEmptyCategoriesAndClasses"

	showEmptyCategoriesAndClasses := anObject! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.727'!
showMethodCategories
	"Answer the value of showMethodCategories"

	^ showMethodCategories! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.732'!
showMethodCategories: anObject
	"Set the value of showMethodCategories"

	showMethodCategories := anObject! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.737'!
showQuickAndAccessorMethods
	"Answer the value of showQuickAndAccessorMethods"

	^ showQuickAndAccessorMethods! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.741'!
showQuickAndAccessorMethods: anObject
	"Set the value of showQuickAndAccessorMethods"

	showQuickAndAccessorMethods := anObject! !

!SPMGlobalOptions methodsFor: 'spec commands' stamp: 'mp 3/23/2011 16:43:33.907'!
switchIgnoreTracingOfSetUpAndTearDownMethods

	self ignoreTracingOfSetUpAndTearDownMethods: 
			self ignoreTracingOfSetUpAndTearDownMethods not.
	self changed: #ignoreTracingOfSetUpAndTearDownMethods.! !

!SPMGlobalOptions methodsFor: 'spec commands' stamp: 'mp 9/28/2010 18:59:57.929'!
switchShowMethodCategories
	self showMethodCategories: 
			self showMethodCategories not.
	self changed: #showMethodCategories.
	self pathMap rebuildPathMap.! !

!SPMGlobalOptions methodsFor: 'spec commands' stamp: 'mp 9/28/2010 18:46:05.847'!
switchShowQuickAndAccessorMethods
	self showQuickAndAccessorMethods: 
			self showQuickAndAccessorMethods not.
	self changed: #showQuickAndAccessorMethods.
	self pathMap rebuildPathMap.! !

!SPMGlobalOptions methodsFor: 'spec commands' stamp: 'mp 9/16/2010 15:55:10.85'!
switchVisualizeIntermediateSteps
	self visualizeIntermediateSteps: 
		self visualizeIntermediateSteps not.
	self changed: #visualizeIntermediateSteps.! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.754'!
visualizeIntermediateSteps
	"Answer the value of visualizeIntermediateSteps"

	^ visualizeIntermediateSteps! !

!SPMGlobalOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:58:57.757'!
visualizeIntermediateSteps: anObject
	"Set the value of visualizeIntermediateSteps"

	visualizeIntermediateSteps := anObject! !

!SPMOptions class methodsFor: 'instance creation' stamp: 'mp 9/15/2010 13:39:25.852'!
on: aPathMap

	^ self new
		pathMap: aPathMap
		yourself! !

!SPMOptions class methodsFor: 'constants' stamp: 'mp 9/22/2010 15:01:33.101'!
transparentForColorLegend
	^ {1.0 -> {Color transparent}}! !

!SPMOptions class methodsFor: 'constants' stamp: 'mp 9/21/2010 13:54:18.041'!
whiteForColorLegend
	^ {1.0 -> {Color white}}! !

!SPMOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:57:31.39'!
colorLegend
	"Answer the value of colorLegend"

	^ colorLegend! !

!SPMOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:57:31.395'!
colorLegend: anObject
	"Set the value of colorLegend"

	colorLegend := anObject! !

!SPMOptions methodsFor: 'visualization' stamp: 'mp 9/17/2010 13:34:51.215'!
getLabelString: aPosition
	^ aPosition asString! !

!SPMOptions methodsFor: 'testing' stamp: 'mp 9/16/2010 15:12:04.154'!
isSelectedAnalysisOption
	^ self == self pathMap selectedOptions! !

!SPMOptions methodsFor: 'accessing' stamp: 'mp 9/15/2010 13:44:21.861'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPMOptions methodsFor: 'accessing' stamp: 'mp 9/15/2010 13:44:21.865'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPMOptions methodsFor: 'visualization' stamp: 'mp 3/22/2011 11:35:58.843'!
redrawPathMapIfPossible
	self refreshColorLegend.
	self isSelectedAnalysisOption
		ifTrue: [self pathMap resetAllChildren.
				self pathMap tracer
					setColorPropagation; 
					visualizeAllInformation].
	^ self isSelectedAnalysisOption! !

!SPMOptions methodsFor: 'visualization' stamp: 'mp 9/20/2010 13:48:53.602'!
refreshColorLegend
	self colorLegend 
		ifNotNil: [
			self 
				refreshColorLegendHorizontal;
				refreshColorLegendVertical.
			self colorLegend changed].! !

!SPMOptions methodsFor: 'visualization' stamp: 'mp 9/21/2010 13:55:39.793'!
refreshColorLegendHorizontal
	self colorLegend horizontalColors: self class whiteForColorLegend.! !

!SPMOptions methodsFor: 'visualization' stamp: 'mp 9/21/2010 13:55:55.958'!
refreshColorLegendVertical
	self colorLegend verticalColors: self class whiteForColorLegend.! !

!SPMOptions methodsFor: 'visualization' stamp: 'mp 9/16/2010 17:55:24.36'!
visualizeStaticMetric
	"Required for subclasses of coverage tracer as they must not visualize these metrics"! !

SPMOptions subclass: #SPMProfilingOptions
	instanceVariableNames: 'kindOfProfiling intentRuntime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Options'!

!SPMProfilingOptions methodsFor: 'visualization' stamp: 'mp 9/23/2010 15:37:02.574'!
getLabelString: aPosition
	| localValue |
	self isSelectedAnalysisOption
		ifTrue: [
			localValue := (((aPosition x * (self pathMap tracer maxValue) ln)) exp) ceiling.
			^ localValue asString, ' ', self pathMap tracer unitForLegend]
		ifFalse: [^ 'Please run tests first.']! !

!SPMProfilingOptions methodsFor: 'initialize-release' stamp: 'mp 9/23/2010 10:41:11.101'!
initialize

	self 
		kindOfProfiling: #numberOfMethodCalls;
		intentRuntime: false.! !

!SPMProfilingOptions methodsFor: 'accessing' stamp: 'mp 9/23/2010 10:31:30.407'!
intentRuntime
	"Answer the value of intentRuntime"

	^ intentRuntime! !

!SPMProfilingOptions methodsFor: 'accessing' stamp: 'mp 9/23/2010 10:31:30.411'!
intentRuntime: anObject
	"Set the value of intentRuntime"

	intentRuntime := anObject! !

!SPMProfilingOptions methodsFor: 'spec commands' stamp: 'mp 9/23/2010 10:39:18.642'!
isRuntimeProfilingSelected
	^ (self kindOfProfiling == #runtime) or: [self kindOfProfiling == #runtimePerCall]! !

!SPMProfilingOptions methodsFor: 'accessing' stamp: 'mp 9/23/2010 10:31:30.398'!
kindOfProfiling
	"Answer the value of kindOfProfiling"

	^ kindOfProfiling! !

!SPMProfilingOptions methodsFor: 'accessing' stamp: 'mp 9/23/2010 10:31:30.402'!
kindOfProfiling: anObject
	"Set the value of kindOfProfiling"

	kindOfProfiling := anObject! !

!SPMProfilingOptions methodsFor: 'visualization' stamp: 'mp 9/23/2010 14:34:08.119'!
refreshColorLegendHorizontal
	self colorLegend 
		horizontalColors: {1.0 -> ((Interval from: SPMTRProfilingTracer maxHue to: 0 by: -10) 
					collect: [:each | Color h: each s: 1.0 v: 1.0])}! !

!SPMProfilingOptions methodsFor: 'visualization' stamp: 'mp 9/23/2010 14:32:26.988'!
refreshColorLegendVertical
	self colorLegend verticalColors: self class transparentForColorLegend.! !

!SPMProfilingOptions methodsFor: 'spec commands' stamp: 'mp 9/23/2010 10:42:52.704'!
setKindOfProfiling: aSymbol
	self kindOfProfiling: aSymbol.
	self changed: #isRuntimeProfilingSelected.! !

!SPMProfilingOptions methodsFor: 'spec commands' stamp: 'mp 9/23/2010 11:47:45.109'!
showHighscore
	self isSelectedAnalysisOption
		ifTrue: [self pathMap tracer getProfilingHighscore explore]
		ifFalse: [self inform: 'Please run tests first.']! !

!SPMProfilingOptions methodsFor: 'spec commands' stamp: 'mp 9/23/2010 10:42:35.793'!
switchIntentRuntime
	self 
		intentRuntime: self intentRuntime not;
		changed: #intentRuntime.! !

SPMOptions subclass: #SPMTestQualityOptions
	instanceVariableNames: 'intensityCoverageEnabled showTestResults staticCodeMetric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Options'!

!SPMTestQualityOptions class methodsFor: 'constants' stamp: 'mp 9/17/2010 17:18:16.668'!
coverageColors
	^ {	0.5 -> {Color black alpha: 0.0}. 
		1.0 -> {Color black alpha: SPMTRCoverageTracer coverageGrayScale}}! !

!SPMTestQualityOptions class methodsFor: 'constants' stamp: 'mp 9/17/2010 17:18:00.821'!
intensityCoverageColors
	^ {	0.25 -> {Color black alpha: 0.0}.
		1.0 -> {	Color black alpha: 1.0 - SPMTRCoverageTracer minGrayValue. 
				Color black alpha: 1.0}}! !

!SPMTestQualityOptions methodsFor: 'visualization' stamp: 'mp 9/29/2010 17:27:03.642'!
addCoverageInfoAt: aPosition toColorLegendLabel: aStream
	self intensityCoverageEnabled
		ifTrue: [aPosition y <= 0.25
					ifTrue: [aStream nextPutAll: 'Method not covered.']
					ifFalse: [aStream nextPutAll: ('Method covered by ', 
										((aPosition y - 0.25) / 0.75 * 
										self pathMap numberOfTests ln) exp floor asString, 
										' tests.')]]
		ifFalse: [aPosition y >= 0.5
					ifTrue: [aStream nextPutAll: 'Method covered.']
					ifFalse: [aStream nextPutAll: 'Method not covered.']].! !

!SPMTestQualityOptions methodsFor: 'visualization' stamp: 'mp 9/16/2010 18:20:41.367'!
addMethodNamesAsAdditionalInformation: morphs
	morphs do: [:each | 
		each additionalInfo: each methodReference asStringOrText, Character cr].! !

!SPMTestQualityOptions methodsFor: 'visualization' stamp: 'mp 9/20/2010 14:01:19.049'!
getLabelString: aPosition
	| label |
	label := WriteStream on: ''.
	self addCoverageInfoAt: aPosition toColorLegendLabel: label.
	self staticCodeMetric addCodeMetricAt: aPosition toColorLegendLabel: label.
	^ label contents! !

!SPMTestQualityOptions methodsFor: 'initialize-release' stamp: 'mp 9/20/2010 12:56:59.559'!
initialize

	self 
		intensityCoverageEnabled: false;
		showTestResults: true;
		staticCodeMetric: SPMStaticMetric new.! !

!SPMTestQualityOptions methodsFor: 'accessing' stamp: 'mp 9/15/2010 14:03:52.562'!
intensityCoverageEnabled
	"Answer the value of intensityCoverageEnabled"

	^ intensityCoverageEnabled! !

!SPMTestQualityOptions methodsFor: 'accessing' stamp: 'mp 9/15/2010 14:03:52.568'!
intensityCoverageEnabled: anObject
	"Set the value of intensityCoverageEnabled"

	intensityCoverageEnabled := anObject! !

!SPMTestQualityOptions methodsFor: 'visualization' stamp: 'mp 9/20/2010 13:03:32.564'!
refreshColorLegendHorizontal
	self colorLegend horizontalColors: self staticCodeMetric getLegendColors.! !

!SPMTestQualityOptions methodsFor: 'visualization' stamp: 'mp 9/17/2010 17:04:34.897'!
refreshColorLegendVertical
	self intensityCoverageEnabled
		ifTrue: [	self colorLegend verticalColors: self class intensityCoverageColors]
		ifFalse: [self colorLegend verticalColors: self class coverageColors].! !

!SPMTestQualityOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 11:43:39.036'!
showTestResults
	"Answer the value of showTestResults"

	^ showTestResults! !

!SPMTestQualityOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 11:43:39.041'!
showTestResults: anObject
	"Set the value of showTestResults"

	showTestResults := anObject! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 10/26/2010 11:49:08.266'!
sortMethodsIsEnabled
	^ self pathMap selectedAnalysis isNil not! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 10/26/2010 11:56:16.359'!
sortMethodsToStaticMetric
	self pathMap selectedAnalysis ifNil: [^ self].
	self pathMap rebuildPathMapWithSortByMetric.
	self pathMap tracer
		setColorPropagation; 
		visualizeAllInformation.! !

!SPMTestQualityOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 14:09:07.707'!
staticCodeMetric
	"Answer the value of staticCodeMetric"

	^ staticCodeMetric! !

!SPMTestQualityOptions methodsFor: 'accessing' stamp: 'mp 9/16/2010 14:09:07.711'!
staticCodeMetric: anObject
	"Set the value of staticCodeMetric"

	staticCodeMetric := anObject! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 3/22/2011 11:40:28.707'!
staticMetricAccessedVariables
	self 
		staticCodeMetric: (SPMVariableAccessStaticMetric on: self);
		changed: #sortMethodsIsEnabled.
	self redrawPathMapIfPossible
		ifFalse: [self visualizeStaticMetric].! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 3/22/2011 11:36:19.367'!
staticMetricAuthors
	self 
		staticCodeMetric: (SPMAuthorStaticMetric on: self);
		changed: #sortMethodsIsEnabled.
	self redrawPathMapIfPossible
		ifFalse: [self visualizeStaticMetric].! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 3/22/2011 11:40:07.862'!
staticMetricComplexity
	self 
		staticCodeMetric: (SPMComplexityStaticMetric  on: self);
		changed: #sortMethodsIsEnabled.
	self redrawPathMapIfPossible
		ifFalse: [self visualizeStaticMetric].! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 3/22/2011 11:39:54.987'!
staticMetricLastChanges
	self 
		staticCodeMetric: (SPMLastChangeStaticMetric on: self);
		changed: #sortMethodsIsEnabled.
	self redrawPathMapIfPossible
		ifFalse: [self visualizeStaticMetric].! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 3/22/2011 11:39:48.713'!
staticMetricLinesOfCode
	self 
		staticCodeMetric: (SPMLinesOfCodeStaticMetric on: self);
		changed: #sortMethodsIsEnabled.
	self redrawPathMapIfPossible
		ifFalse: [self visualizeStaticMetric].! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 3/22/2011 11:40:38.414'!
staticMetricNone
	self 
		staticCodeMetric: (SPMStaticMetric on: self);
		changed: #sortMethodsIsEnabled.
	self redrawPathMapIfPossible
		ifFalse: [self visualizeStaticMetric].! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 09:45:12.856'!
switchIntensityCoverage
	self 
		intensityCoverageEnabled: self intensityCoverageEnabled not;
		changed: #intensityCoverageEnabled;
		redrawPathMapIfPossible.! !

!SPMTestQualityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 09:45:37.759'!
switchShowTestResults
	self 
		showTestResults: self showTestResults not;
		changed: #showTestResults;
		redrawPathMapIfPossible.! !

!SPMTestQualityOptions methodsFor: 'visualization' stamp: 'mp 3/22/2011 11:25:07.139'!
visualizeStaticMetric
	| morphs |
	morphs := self pathMap getAllMethodMorphs.
	self addMethodNamesAsAdditionalInformation: morphs.
	self staticCodeMetric visualizeMorphs: (morphs reject: [:each | 
														each isInheritedTestSelector]).
	! !

SPMOptions subclass: #SPMTracabilityOptions
	instanceVariableNames: 'specificConcernMethodsOnly multipleColorsPerMethod concernGroup selectedConcerns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Options'!

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 16:04:09.331'!
allConcerns
	| concerns |
	self concerns groups ifEmpty: [^ #()].
	concerns := self concerns groups at: self concernGroup.
	self selectedConcerns: (concerns collect: [:each | each -> true]).
	^ concerns! !

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/23/2010 17:45:16.598'!
concernColorAt: anIndex
	^ self concerns colors at: (self selectedConcerns at: anIndex) key! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 11:36:19.746'!
concernGroup
	"Answer the value of concernGroup"

	^ concernGroup ifNil: [concernGroup := self concerns groups keys first]! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 10:34:43.556'!
concernGroup: anObject
	"Set the value of concernGroup"

	concernGroup := anObject! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 11:36:14.631'!
concerns
	^ self pathMap project concerns! !

!SPMTracabilityOptions methodsFor: 'visualization' stamp: 'mp 3/7/2011 21:49:07.365'!
getLabelString: aPosition
	| maxConcerns stepWidth count |
	self selectedConcerns ifNil: [^ 'No concerns available. See  PathProjects.'].
	maxConcerns := self getSelectedConcerns size.
	(maxConcerns <= 1 or: [self specificConcernMethodsOnly])
		ifTrue: [^ 'No selected concern covered this method.'].
	aPosition x <= 0.25
		ifTrue: [^ 'No selected concern covered this method.'].
	stepWidth := 0.75 / (maxConcerns - 1).
	count := (((aPosition x - 0.25) / stepWidth) ceiling) + 1.
	^ count asString, ' concerns covered this method'! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 14:19:47.87'!
getSelectedConcerns
	^ self selectedConcerns
		select: [:each | each value]
		thenCollect: [:each | each key]! !

!SPMTracabilityOptions methodsFor: 'initialize-release' stamp: 'mp 9/22/2010 11:10:40.089'!
initialize

	self 
		multipleColorsPerMethod: true;
		specificConcernMethodsOnly: false.! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 09:39:42.375'!
multipleColorsPerMethod
	"Answer the value of multipleColorsPerMethod"

	^ multipleColorsPerMethod! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 09:39:42.379'!
multipleColorsPerMethod: anObject
	"Set the value of multipleColorsPerMethod"

	multipleColorsPerMethod := anObject! !

!SPMTracabilityOptions methodsFor: 'visualization' stamp: 'mp 9/22/2010 16:10:24.839'!
refreshColorLegendHorizontal
	| colors maxConcerns stepWidth position minGray |
	self selectedConcerns 
		ifNil: [^ self colorLegend horizontalColors: self class whiteForColorLegend].
	maxConcerns := self getSelectedConcerns size.
	(maxConcerns <= 1 or: [self specificConcernMethodsOnly])
		ifTrue: [^ self colorLegend horizontalColors: self class whiteForColorLegend].
	colors := OrderedCollection new.
	colors add: 0.25 -> {Color white}.
	stepWidth := 0.75 / (maxConcerns - 1).
	position := 0.25.
	minGray := SPMTRCoverageTracer minGrayValue.
	2 to: maxConcerns do: [:index | 
		position := position + stepWidth.
		colors 
			add: position -> {Color h: 0 s: 0 v: (minGray - ((index / maxConcerns) * minGray))}].
	self colorLegend horizontalColors: colors.
		! !

!SPMTracabilityOptions methodsFor: 'visualization' stamp: 'mp 9/22/2010 15:01:24.146'!
refreshColorLegendVertical
	self colorLegend verticalColors: self class transparentForColorLegend.! !

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 11:46:03.098'!
selectedConcernAt: anIndex
	^ (self selectedConcerns at: anIndex) value! !

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 14:17:23.011'!
selectedConcernAt: anIndex put: aBoolean
	(self selectedConcerns at: anIndex) value: aBoolean.
	self changed: #selectedConcernAt:.
	self redrawPathMapIfPossible.
	^ anIndex! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 11:44:44.612'!
selectedConcerns
	"Answer the value of selectedConcerns"

	^ selectedConcerns! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 11:44:44.617'!
selectedConcerns: anObject
	"Set the value of selectedConcerns"

	selectedConcerns := anObject! !

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 11:37:27.456'!
setConcernGroup: aConcernGroup
	self 
		concernGroup: aConcernGroup;
		changed: #allConcerns;
		redrawPathMapIfPossible.
	! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 09:39:42.366'!
specificConcernMethodsOnly
	"Answer the value of specificConcernMethodsOnly"

	^ specificConcernMethodsOnly! !

!SPMTracabilityOptions methodsFor: 'accessing' stamp: 'mp 9/22/2010 09:39:42.371'!
specificConcernMethodsOnly: anObject
	"Set the value of specificConcernMethodsOnly"

	specificConcernMethodsOnly := anObject! !

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 09:46:07.405'!
switchMultipleColorsPerMethod
	self 
		multipleColorsPerMethod: self multipleColorsPerMethod not;
		changed: #multipleColorsPerMethod;
		redrawPathMapIfPossible.! !

!SPMTracabilityOptions methodsFor: 'spec commands' stamp: 'mp 9/22/2010 09:46:29.395'!
switchSpecificConcernMethodsOnly
	self 
		specificConcernMethodsOnly: self specificConcernMethodsOnly not;
		changed: #specificConcernMethodsOnly;
		redrawPathMapIfPossible.! !

Object subclass: #SPMPathMap
	instanceVariableNames: 'testRunner tracer rootMorph project selectedAnalysis options sortMorphsByStaticMetric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Base'!

!SPMPathMap class methodsFor: 'instance creation' stamp: 'mp 7/9/2010 11:34:55.413'!
on: aTestRunner

	^ self new
		testRunner: aTestRunner;
		yourself! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/16/2010 17:17:35.116'!
getAllMethodMorphs
	| morphs |
	morphs := OrderedCollection new.
	self rootMorph traverseAllChildsAndDo: [:each | 
		each isMethodMorph ifTrue: [morphs add: each]].
	^ morphs! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 3/24/2011 16:59:54.952'!
getCategoryMorph: aCategory
	^ self rootMorph childrenMorphs at: aCategory
! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/23/2010 15:29:03.726'!
getClassMorph: aClass
	| categoryMorph |
	categoryMorph := self rootMorph childrenMorphs at: aClass instanceSide category.
	^ categoryMorph childrenMorphs at: aClass instanceSide.! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 3/24/2011 17:14:35.534'!
getMethodCategoryMorph: aClass and: aMethodCategory
	^ (self getClassMorph: aClass) childrenMorphs at: aMethodCategory
! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/29/2010 14:03:04.697'!
getMethodMorph: aClass and: aMethodSymbol
	|  classMorph methodCategory |
	"Inherited test selector"
	((aClass isTestCaseClass and: 
		[aMethodSymbol isTestSelector]) and: 
			[(aClass testSelectors includes: aMethodSymbol) not])
		ifTrue: [	^ ((self getClassMorph: aClass) childrenMorphs 
					at: SPMMethodCategoryMorph inheritedTestSelectorId) childrenMorphs 
						at: aMethodSymbol].		
	((self globalOptions showQuickAndAccessorMethods not) and: 
		[(aClass>>aMethodSymbol) isQuick])
			ifTrue: ["Null Object" ^ SPMNullMethodMorph new].
	classMorph := self getClassMorph: aClass.
	self globalOptions showMethodCategories
		ifTrue: [methodCategory := aClass organization categoryOfElement: aMethodSymbol]
		ifFalse: [methodCategory := 'no category'].
	aClass isClassSide 
		ifTrue: [methodCategory := (methodCategory asString, ' (class)') asSymbol].		
	^ (classMorph childrenMorphs at: methodCategory) childrenMorphs at: aMethodSymbol
! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/28/2010 11:57:17.958'!
globalOptions

	^ self options at: #globalOptions! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 8/11/2010 14:51:14.941'!
hideAllMethodAndCategoryMorphs

	self rootMorph traverseAllChildsAndDo: [:each | 
		(each isMethodMorph or: [each isMethodCategoryMorph])
			ifTrue: [each hide]].! !

!SPMPathMap methodsFor: 'initialize-release' stamp: 'mp 9/22/2010 18:21:25.377'!
initialize
	self rootMorph: (SPMRootMorph on: self).
	self options: (Dictionary new
					at: #testQuality put: (SPMTestQualityOptions on: self);
					at: #traceability put: (SPMTracabilityOptions on: self);
					at: #faultLocalization put: (SPMFaultLocalizationOptions on: self);
					at: #profiling put: (SPMProfilingOptions on: self);
					at: #globalOptions put: (SPMGlobalOptions on: self);
					at: #none put: (SPMOptions on: self);	
					yourself).	! !

!SPMPathMap methodsFor: 'updating' stamp: 'mp 7/13/2010 14:56:45.559'!
newProjectSelected: aProject
	self project: aProject;
		 changed: #projectStatisticText.! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 8/12/2010 11:23:58.571'!
numberOfTests
	^ self testRunner suiteAll tests size! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/15/2010 13:31:54.079'!
options
	"Answer the value of options"

	^ options! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/15/2010 13:31:54.084'!
options: anObject
	"Set the value of options"

	options := anObject! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 13:32:06.012'!
project
	"Answer the value of project"

	^ project! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 13:32:06.016'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SPMPathMap methodsFor: 'spec commands' stamp: 'mp 7/9/2010 14:04:36.155'!
projectStatisticText

	^ self project metricsOverviewString! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 9/28/2010 11:39:41.215'!
rebuildPathMap
	self rootMorph 
		reset;
		buildChildren.! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 10/26/2010 11:56:10.623'!
rebuildPathMapWithSortByMetric
	self sortMorphsByStaticMetric: true.
	self rootMorph 
		reset;
		buildChildren.
	self sortMorphsByStaticMetric: false.! !

!SPMPathMap methodsFor: 'menu' stamp: 'mp 9/15/2010 13:15:36.118'!
requestMenuFor: aCollection title: aString
	^ UIManager default 
		chooseFrom: (aCollection collect: [:each | each value])
		values: (aCollection collect: [:each | each key])
		lines: #() 
		title: aString! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 8/11/2010 14:36:11.645'!
resetAllChildren

	self rootMorph traverseAllChildsAndDo: [:each | 
		each 
			resetColor;
			resetAdditionalInfo;
			resetVisibility].! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 11:30:06.972'!
rootMorph
	"Answer the value of rootMorph"

	^ rootMorph! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 11:30:06.975'!
rootMorph: anObject
	"Set the value of rootMorph"

	rootMorph := anObject! !

!SPMPathMap methodsFor: 'public api' stamp: 'mp 9/16/2010 15:01:42.335'!
runAllTests
	self selectedAnalysis: #none.
	self runWithTestRunnerTracer: SPMTestRunnerTracer.! !

!SPMPathMap methodsFor: 'public api' stamp: 'mp 9/28/2010 13:16:29.72'!
runAllTestsWith: aSymbol
	self selectedAnalysis: aSymbol.
	self globalOptions showEmptyCategoriesAndClasses
		ifTrue: [ self globalOptions showEmptyCategoriesAndClasses: false.
				self rebuildPathMap].
	self selectedAnalysis caseOf: {
		[#testQuality] -> [self runTestQualityCoverage].
		[#traceability] -> [self runTraceabilityCoverage].
		[#faultLocalization] -> [self runFaultLocalization].
		[#profiling] -> [self runProfiling].
	}	! !

!SPMPathMap methodsFor: 'run tracer' stamp: 'mp 9/22/2010 16:36:53.004'!
runFaultLocalization
	self runWithTestRunnerTracer: SPMTRFaultLocalizationTracer! !

!SPMPathMap methodsFor: 'run tracer' stamp: 'mp 9/28/2010 13:21:34.158'!
runProfiling
	| tracer |
	self selectedOptions kindOfProfiling caseOf: {
		[#numberOfMethodCalls] -> [tracer := SPMTRMethodCallTracer].
		[#numberOfInstances] -> [self globalOptions showEmptyCategoriesAndClasses
										ifFalse: [self globalOptions 
													showEmptyCategoriesAndClasses: true.
												self rebuildPathMap].
									tracer :=  SPMTRInstancesCountTracer].
		[#runtime] -> [self selectedOptions intentRuntime
						ifTrue: [tracer := SPMTRRuntimeIntentTracer]
						ifFalse: [tracer := SPMTRRuntimeExtentTracer]].
		[#runtimePerCall] -> [self selectedOptions intentRuntime
								ifTrue: [tracer := SPMTRRuntimeIntentRatioTracer]
								ifFalse: [tracer := SPMTRRuntimeExtentRatioTracer]].
	}.
	self runWithTestRunnerTracer: tracer.! !

!SPMPathMap methodsFor: 'public api' stamp: 'mp 7/14/2010 09:29:44.285'!
runSpecificTest: aMethodRef
	self tracer entryPoints: {STestCaseEntryPoint onTestMethodReference: aMethodRef}.
	self tracer run.! !

!SPMPathMap methodsFor: 'run tracer' stamp: 'mp 9/16/2010 15:54:20.162'!
runTestQualityCoverage
	self runWithTestRunnerTracer: SPMTRCoverageTracer! !

!SPMPathMap methodsFor: 'run tracer' stamp: 'mp 9/22/2010 10:31:34.27'!
runTraceabilityCoverage
	self runWithTestRunnerTracer: SPMTRConcernCoverageTracer! !

!SPMPathMap methodsFor: 'run tracer' stamp: 'mp 7/13/2010 15:25:43.652'!
runWithTestRunnerTracer: aClass
	self tracer: (aClass on: self project pathMap: self).
	self tracer run.! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/15/2010 13:19:17.55'!
selectedAnalysis
	"Answer the value of selectedAnalysis"

	^ selectedAnalysis! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/15/2010 13:19:17.554'!
selectedAnalysis: anObject
	"Set the value of selectedAnalysis"

	selectedAnalysis := anObject! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 9/16/2010 15:25:14.4'!
selectedOptions

	^ self options at: self selectedAnalysis ifAbsent: [SPMOptions new]! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 9/30/2010 11:35:21.47'!
setColorPropagation: aClass

	self rootMorph traverseAllChildsAndDo: [:each | 
		each colorPropagation: aClass].! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 9/30/2010 11:35:33.309'!
setDominantColorPropagation

	self setColorPropagation: SPMDominantColorStrategy.! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 9/30/2010 11:35:40.471'!
setHighestColorPropagation

	self setColorPropagation: SPMHighestColorStrategy.! !

!SPMPathMap methodsFor: 'visualization' stamp: 'mp 9/30/2010 11:35:47.506'!
setPercentageColorPropagation

	self setColorPropagation: SPMPercentageColorStrategy.! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 10/26/2010 11:57:50.758'!
sortMorphsByStaticMetric
	"Answer the value of sortMorphsByStaticMetric"

	^ sortMorphsByStaticMetric ifNil: [sortMorphsByStaticMetric := false]! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 10/26/2010 11:54:20.239'!
sortMorphsByStaticMetric: anObject
	"Set the value of sortMorphsByStaticMetric"

	sortMorphsByStaticMetric := anObject! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 11:30:06.956'!
testRunner
	"Answer the value of testRunner"

	^ testRunner! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 11:30:06.96'!
testRunner: anObject
	"Set the value of testRunner"

	testRunner := anObject! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 11:30:06.965'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SPMPathMap methodsFor: 'accessing' stamp: 'mp 7/9/2010 11:30:06.968'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

!SPMPathMap methodsFor: 'updating' stamp: 'mp 9/28/2010 11:39:16.461'!
update: what

	(what == #categorySelected)
		ifTrue: [	self newProjectSelected: SProject current.
				self rebuildPathMap].! !

Object subclass: #SPMStaticMetric
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

SPMStaticMetric subclass: #SPMAuthorStaticMetric
	instanceVariableNames: 'authors colorMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

!SPMAuthorStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 19:05:45.825'!
addCodeMetricAt: aPosition toColorLegendLabel: aStream
	| index |	
	aStream nextPutAll: ' / Last change by '.
	self authors
		ifNil: [aStream nextPutAll: 'Unkown']	
		ifNotNil: [index := (aPosition x * self authors size) ceiling.
				index < 1 ifTrue: [index := 1].
				index > self authors size ifTrue: [index := self authors size].
				aStream nextPutAll: (self authors at: index)].
	aStream nextPutAll: '.'.! !

!SPMAuthorStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 18:40:52.254'!
addMetricInfo: aString to: aMorph
	aMorph additionalInfo: aMorph additionalInfo, 
		'Last change by ', aString, Character cr.

! !

!SPMAuthorStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 18:00:20.265'!
authors
	"Answer the value of authors"

	^ authors! !

!SPMAuthorStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 18:00:20.27'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!SPMAuthorStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 18:22:09.642'!
colorMapping
	"Answer the value of colorMapping"

	^ colorMapping! !

!SPMAuthorStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 18:22:09.647'!
colorMapping: anObject
	"Set the value of colorMapping"

	colorMapping := anObject! !

!SPMAuthorStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 19:03:23.07'!
createColorMapping
	self colorMapping: Dictionary new.
	self authors withIndexDo: [:each :index | 
		self colorMapping 
			at: each 
			put: (Color h: 360 * ((index) / self authors size) s: self class saturation v: 1.0)].! !

!SPMAuthorStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 18:50:23.966'!
getLegendColors
	| colors |
	self authors 
		ifNil: [^ {1.0 -> {Color white}}]
		ifNotNil: [colors := OrderedCollection new.
				self authors withIndexDo: [:each :index | 
					colors add: (index / self authors size) -> {self colorMapping at: each}].
				^ colors]! !

!SPMAuthorStaticMetric methodsFor: 'accessing' stamp: 'mp 10/26/2010 10:20:21.434'!
getMetricValue: aCompiledMethod
	^ aCompiledMethod lastChange first! !

!SPMAuthorStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 19:14:00.171'!
visualizeMorphs: aCollectionOfMorphs
	| author |
	self authors: (aCollectionOfMorphs 
					inject: Set new 
					into: [:set :each | 
						set 
							add: each methodReference compiledMethod lastChange first;
							yourself]) asSortedCollection.
	self createColorMapping.
	self options refreshColorLegend.
	aCollectionOfMorphs do: [:each | 
		author := each methodReference compiledMethod lastChange first.
		self addMetricInfo: author to: each.
		each propagateColor: (self colorMapping at: author)].
	! !

SPMStaticMetric subclass: #SPMContinuousStaticMetric
	instanceVariableNames: 'maxValue minValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

SPMContinuousStaticMetric subclass: #SPMComplexityStaticMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

!SPMComplexityStaticMetric methodsFor: 'accessing' stamp: 'mp 10/25/2010 22:27:51.135'!
getMetricValue: aCompiledMethod
	^ aCompiledMethod complexity! !

!SPMComplexityStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 14:49:28.56'!
metricName
	^ 'complexity'! !

!SPMContinuousStaticMetric class methodsFor: 'constants' stamp: 'mp 9/20/2010 16:43:11.618'!
isLogarithmic

	^ true! !

!SPMContinuousStaticMetric class methodsFor: 'constants' stamp: 'mp 9/20/2010 14:35:30.364'!
maxHue
	^ 240! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 17:03:07.522'!
addCodeMetricAt: aPosition toColorLegendLabel: aStream
	aStream nextPutAll: ' / '.
	self maxValue
		ifNil: [aStream nextPutAll: 'Unkown']
		ifNotNil: [
			self class isLogarithmic
				ifTrue: [aStream nextPutAll: (self logarithmicLabelFor: aPosition).]
				ifFalse: [aStream nextPutAll: (self linearLabelFor: aPosition)]].
	aStream nextPutAll: ' ', self metricName, '.'.! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 14:39:52.089'!
addMetricInfo: aNumber to: aMorph
	aMorph additionalInfo: aMorph additionalInfo, 
		aNumber asString, ' ', self metricName, '.', Character cr.! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 14:34:49.895'!
getLegendColors
	^ {	1.0 -> ((Interval from: self class maxHue to: 0 by: -10) 
					collect: [:each | Color h: each s: self class saturation v: 1.0])}! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 14:44:32.385'!
getMaxMetricValueFrom: aCollectionOfMorphs
	^ (aCollectionOfMorphs collect: [:each | self getMetricValueFrom: each]) sort last! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 10/25/2010 22:24:19.76'!
getMetricValueFrom: aMorph
	^ self getMetricValue: aMorph methodReference compiledMethod! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 16:40:15.29'!
getMinMetricValueFrom: aCollectionOfMorphs
	^ 0! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 16:48:16.934'!
linearColorFor: aNumber
	^ Color 
		h: (self class maxHue - 
			(((aNumber - self minValue) / 
				(self maxValue - self minValue)) * self class maxHue) asInteger)
		s: self class saturation 
		v: 1.0! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 17:03:19.872'!
linearLabelFor: aPosition
	^ ((aPosition x * (self maxValue - self minValue)) + self minValue) ceiling asString! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 16:52:27.607'!
logarithmicColorFor: aNumber
	aNumber = self minValue 
		ifTrue: [^ Color 
					h: self class maxHue
					s: self class saturation 
					v: 1.0]
		ifFalse: [^ Color 
					h: (self class maxHue - 
						(((aNumber - self minValue) ln / 
							(self maxValue - self minValue) ln) * self class maxHue) asInteger)
					s: self class saturation 
					v: 1.0]! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 17:53:03.504'!
logarithmicLabelFor: aPosition
	^ (((aPosition x * (self maxValue - self minValue) ln)) exp + self minValue) ceiling asString! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 14:34:24.566'!
maxValue
	"Answer the value of maxValue"

	^ maxValue! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 14:34:24.57'!
maxValue: anObject
	"Set the value of maxValue"

	maxValue := anObject! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 14:36:54.829'!
metricName
	self subclassResponsibility.! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 16:37:59.546'!
minValue
	"Answer the value of minValue"

	^ minValue! !

!SPMContinuousStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 16:37:59.551'!
minValue: anObject
	"Set the value of minValue"

	minValue := anObject! !

!SPMContinuousStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 16:45:45.013'!
visualizeMorphs: aCollectionOfMorphs
	| value |
	self minValue: (self getMinMetricValueFrom: aCollectionOfMorphs).
	self maxValue: (self getMaxMetricValueFrom: aCollectionOfMorphs).
	aCollectionOfMorphs do: [:each | 
		value := self getMetricValueFrom: each.
		self addMetricInfo: value to: each.
		self class isLogarithmic
			ifTrue: [each propagateColor: (self logarithmicColorFor: value)]
			ifFalse: [each propagateColor: (self linearColorFor: value)]].! !

SPMContinuousStaticMetric subclass: #SPMLastChangeStaticMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

!SPMLastChangeStaticMetric class methodsFor: 'constants' stamp: 'mp 9/20/2010 17:52:23.532'!
isLogarithmic

	^ false! !

!SPMLastChangeStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 17:38:49.907'!
addMetricInfo: aNumber to: aMorph
	| dateTime |
	dateTime := DateAndTime fromSeconds: aNumber.
	aMorph additionalInfo: aMorph additionalInfo, 
		self metricName, ': ', dateTime asDate asString, ' ', dateTime asTime asString, '.', Character cr.! !

!SPMLastChangeStaticMetric methodsFor: 'accessing' stamp: 'mp 10/25/2010 22:27:12.708'!
getMetricValue: aCompiledMethod
	^ aCompiledMethod lastChange second asSeconds! !

!SPMLastChangeStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 16:12:54.48'!
getMinMetricValueFrom: aCollectionOfMorphs
	^ (aCollectionOfMorphs collect: [:each | self getMetricValueFrom: each]) sort first! !

!SPMLastChangeStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 17:28:41.289'!
linearLabelFor: aPosition
	^ ((DateAndTime fromSeconds: (super linearLabelFor: aPosition) 
		asInteger) asDate) asString! !

!SPMLastChangeStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 16:09:43.906'!
metricName
	^ 'last change'! !

SPMContinuousStaticMetric subclass: #SPMLinesOfCodeStaticMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

!SPMLinesOfCodeStaticMetric methodsFor: 'accessing' stamp: 'mp 10/25/2010 22:13:52.461'!
getMetricValue: aCompiledMethod
	^ aCompiledMethod linesOfCode! !

!SPMLinesOfCodeStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 14:38:53.384'!
metricName
	^ 'lines of code'! !

SPMContinuousStaticMetric subclass: #SPMVariableAccessStaticMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Metrics'!

!SPMVariableAccessStaticMetric methodsFor: 'accessing' stamp: 'mp 10/25/2010 22:26:26.078'!
getMetricValue: aCompiledMethod
	^ aCompiledMethod numberOfVariableAccess! !

!SPMVariableAccessStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 15:50:30.698'!
metricName
	^ 'variable(s) accessed'! !

!SPMStaticMetric class methodsFor: 'instance creation' stamp: 'mp 9/20/2010 19:12:38.894'!
on: options
	^ self new
		options: options;
		yourself! !

!SPMStaticMetric class methodsFor: 'constants' stamp: 'mp 9/20/2010 19:02:43.395'!
saturation
	^ 0.35! !

!SPMStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 13:58:09.709'!
addCodeMetricAt: aPosition toColorLegendLabel: aStream
! !

!SPMStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 12:59:30.641'!
getLegendColors
	^ {	1.0 -> {Color white}}! !

!SPMStaticMetric methodsFor: 'accessing' stamp: 'mp 10/25/2010 22:32:48.428'!
getMetricValue: aCompiledMethod
	^ 0! !

!SPMStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 19:12:05.509'!
options
	"Answer the value of options"

	^ options! !

!SPMStaticMetric methodsFor: 'accessing' stamp: 'mp 9/20/2010 19:12:05.514'!
options: anObject
	"Set the value of options"

	options := anObject! !

!SPMStaticMetric methodsFor: 'visualization' stamp: 'mp 9/20/2010 13:04:52.303'!
visualizeMorphs: aCollectionOfMorphs
	aCollectionOfMorphs do: [:each | each propagateColor: Color white].! !

Object subclass: #SPartialTraceObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

!SPartialTraceObject methodsFor: 'private' stamp: 'mp 3/8/2010 16:32'!
doSomething

	^ true! !

Object subclass: #SProject
	instanceVariableNames: 'projectName categories classesCache concerns typesBucket coverage'
	classVariableNames: 'CurrentProject ProjectRegistry'
	poolDictionaries: ''
	category: 'SightL-Projects'!

!SProject class methodsFor: 'class initialization' stamp: 'mp 7/8/2010 16:51:03.467'!
addPredefinedProjects
	self 
		addProject: self nullProject;
		addProject: self monticelloProject;
		addProject: self sunitProject;
		addProject: self systemBrowserProject;
		addProject: self sandboxProject;
		addProject: self observerExampleProject.! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:20'!
addProject: aProject

	self projectAt: aProject projectName put: aProject.! !

!SProject class methodsFor: 'system events' stamp: 'mp 3/8/2011 20:14:22.804'!
addSystemChangeNotifierForAddedClasses
	"self addSystemChangeNotifierForAddedClasses"
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofEvents: {'classAddedEvent:'. 'classModifiedEvent:'. 'classRecategorizedEvent:'. 'classRemovedEvent:'. 'classRenamedEvent:'. 'classReorganizedEvent:'. 'classModifiedEvent:'. 'classModifiedEvent:'} 
		using: #systemClassChanged:
	! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:04'!
allProjectNames

	^ ProjectRegistry keys! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:04'!
allProjects

	^ ProjectRegistry values! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 09:27:21.988'!
allProjectsWithoutNull

	^ ProjectRegistry values select: [:each | (each projectName == #null) not]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 18:28'!
current

	^ CurrentProject! !

!SProject class methodsFor: 'class initialization' stamp: 'mp 3/8/2011 20:02:54.872'!
initialize
	"self initialize"
	super initialize.
	self
		reset;
		addPredefinedProjects;
		addSystemChangeNotifierForAddedClasses;
		setCurrent: #null.! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:10'!
monticelloProject

	^ self 
		name: #monticello 
		categories: #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks')! !

!SProject class methodsFor: 'instance creation' stamp: 'mp 6/11/2010 15:07'!
name: aSymbol categories: aCollection

	^ self new
		projectName: aSymbol;
		categories: aCollection;
		yourself! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 7/7/2010 09:11:08.894'!
nullProject

	^ self 
		name: #null
		categories: #()! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 7/8/2010 16:51:56.132'!
observerExampleProject

	^ self 
		name: #observerExample
		categories: #(#'SightL-Example-Observer')! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:14'!
projectAt: aSymbol

	^ self projectRegistry
		at: aSymbol ifAbsent: [nil]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:14'!
projectAt: aSymbol put: aProject

	^ self projectRegistry 
		at: aSymbol 
		put: aProject! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:13'!
projectRegistry

	^ ProjectRegistry ifNil: [ProjectRegistry := Dictionary new]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:24'!
projectRegistry: aProjectRegistry
	"Mostly required for testing purposes"
	ProjectRegistry := aProjectRegistry.! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 12:01:56.049'!
removeProjectAt: aSymbol

	CurrentProject == (self projectAt: aSymbol)
		ifTrue: [CurrentProject := self projectAt: #null].
	^ self projectRegistry
		removeKey: aSymbol! !

!SProject class methodsFor: 'class initialization' stamp: 'mp 6/11/2010 18:31'!
reset
	
	ProjectRegistry := nil.
	CurrentProject := nil.! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 7/7/2010 11:59:30.591'!
sandboxProject

	^ self 
		name: #sandbox 
		categories: #(#'SightL-Tests-Sandbox')! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 18:37'!
setCurrent: aSymbol

	CurrentProject := self projectAt: aSymbol.
	CurrentProject ifNotNil: [CurrentProject resetClassesCache].! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/16/2010 12:57'!
setCurrentProject: aProject
	CurrentProject := aProject.
	CurrentProject ifNotNil: [CurrentProject resetClassesCache].! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 09:18:13.796'!
setNullProjectAsCurrent

	self setCurrent: #null.! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:11'!
sunitProject

	^ self 
		name: #sunit 
		categories: #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:12'!
systemBrowserProject

	^ self 
		name: #systemBrowser 
		categories: #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SProject class methodsFor: 'system events' stamp: 'mp 3/8/2011 20:28:34.845'!
systemClassChanged: anEvent
	self current resetClassesCache.! !

!SProject methodsFor: 'classes' stamp: 'mp 7/9/2010 14:04:02.186'!
allClasses

	^ classesCache ifNil: [classesCache := (Smalltalk allClasses select: [:each | 
											self categories includes: each category]) asArray].! !

!SProject methodsFor: 'tests' stamp: 'mp 6/23/2010 16:36'!
allMethods
	^ self allClasses inject: OrderedCollection new into: [:col :klass | 
		klass methodDict keys do: [:selector | col add: (MethodReference class: klass selector: selector)].
		klass class methodDict keys do: [:selector | col add: (MethodReference class: klass class selector: selector)].
		col]! !

!SProject methodsFor: 'tests' stamp: 'mp 3/24/2011 10:55:27.37'!
allTests
	| tests |
	tests := OrderedCollection new.
	self testClasses do: [:testClass | 
		testClass isAbstract 
			ifFalse: [testClass inheritedTestSelectors 
						do: [:selector | tests add: (MethodReference 
													class: testClass selector: selector)]]].
	^ tests! !

!SProject methodsFor: 'tests' stamp: 'mp 1/24/2011 17:07:40.738'!
allTestsAsEntryPoints
	^ self allTests collect: [:each | STestCaseEntryPoint onTestMethodReference: each]! !

!SProject methodsFor: 'tests' stamp: 'mp 6/23/2010 16:49'!
allTestsWithoutLongRunning
	^ self allTests reject: [:each | each actualClass inheritsFrom: LongTestCase]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:52'!
categories
	"Answer the value of categories"

	^ categories ifNil: [categories := #()]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
categories: anObject
	"Set the value of categories"

	categories := anObject! !

!SProject methodsFor: 'categories' stamp: 'mp 6/11/2010 16:43'!
categoriesOrderedByTestsFirst
	| testCategories allOtherCategories |
	testCategories := self categoriesWithTests asSortedCollection asOrderedCollection.
	allOtherCategories := self categories asSortedCollection asOrderedCollection
					 reject: [:each | testCategories includes: each].
	^ (testCategories, allOtherCategories) asArray! !

!SProject methodsFor: 'categories' stamp: 'mp 6/11/2010 16:43'!
categoriesWithTests

	^ (self testClasses inject: Set new into: [:sum :each | 
		sum 
			add: each category; 
			yourself]) asArray! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.676'!
classesCache
	"Answer the value of classesCache"

	^ classesCache! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.681'!
classesCache: anObject
	"Set the value of classesCache"

	classesCache := anObject! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:53'!
classesOfCategory: aCategory

	^ self allClasses select: [:each | each category = aCategory]! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:21:43.434'!
concerns
	"Answer the value of concerns"

	^ concerns ifNil: [concerns := SConcernsRepository new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.688'!
concerns: anObject
	"Set the value of concerns"

	concerns := anObject! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/21/2011 14:40:04.827'!
coverage
	"Answer the value of coverage"

	^ coverage ifNil: [coverage := Dictionary new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/21/2011 14:39:49.332'!
coverage: anObject
	"Set the value of coverage"

	coverage := anObject! !

!SProject methodsFor: 'coverage' stamp: 'mp 3/21/2011 15:39:39.244'!
coveredTestsFor: aMethodReference
	| coveringTests |
	(self isClassInProject: aMethodReference actualClass)
		ifTrue: [coveringTests := Set new.
				self coverage keysAndValuesDo: [:test :coveredMethods |
					(coveredMethods includesKey: aMethodReference)
						ifTrue: [coveringTests add: test]].
				^ coveringTests asOrderedCollection]
		ifFalse: [^ {}].! !

!SProject methodsFor: 'coverage' stamp: 'mp 3/21/2011 15:13:35.189'!
isClassInProject: aClass
	^ self allClasses includes: aClass! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:28'!
loc
	"Lines of Code"
	^ self allClasses inject: 0 into: [:sum :each | sum + each linesOfCode]! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:39:15.116'!
methodCategories: aClass withQuick: aBoolean
	| categories |
	categories := #().
	aClass organization elementArray ifNotEmpty: [
		categories := (aClass organization categories select: [:each | 
							(aClass organization isEmptyCategoryNamed: each) not]).
	aBoolean 
		ifFalse: [categories := categories 
						select: [:each | (aClass organization listAtCategoryNamed: each)
							anySatisfy: [:symbol | (aClass >> symbol) isQuick not]]]].
	aClass isMeta
		ifTrue: [categories := categories collect: [:each | (each, ' (class)') asSymbol]].					
	^ categories! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:08:56.934'!
methodCategoriesOfClass: aClass
	^ self methodCategoriesOfClass: aClass withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:34:13.497'!
methodCategoriesOfClass: aClass withQuick: aBoolean
	^ (self methodCategories: aClass withQuick: aBoolean), 
		(self methodCategories: aClass class withQuick: aBoolean)! !

!SProject methodsFor: 'classes' stamp: 'mp 9/28/2010 19:20:29.26'!
methodsPerClass: aClass 
	^ self methodsPerClass: aClass withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 13:52:52.311'!
methodsPerClass: aClass andMethodCategory: aCategory
	^ self methodsPerClass: aClass andMethodCategory: aCategory withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 13:55:06.804'!
methodsPerClass: aClass andMethodCategory: aCategory withQuick: aBoolean
	| categoryName symbols |
	(aCategory includesSubString: ' (class)')
		ifTrue: [
			"without  (class)"
			categoryName := (aCategory copyFrom: 1 to: aCategory size - 8) asSymbol. 
			symbols := aClass class organization listAtCategoryNamed: categoryName.
			aBoolean 
				ifFalse: [^ symbols select: [:each | (aClass class >> each) isQuick not]]]
		ifFalse: [symbols := aClass organization listAtCategoryNamed: aCategory.
			aBoolean 
				ifFalse: [^ symbols select: [:each | (aClass >> each) isQuick not]]].
		^ symbols! !

!SProject methodsFor: 'classes' stamp: 'mp 9/28/2010 19:51:06.388'!
methodsPerClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [^ (aClass methodDict keys 
							select: [:each | (aClass >> each) isQuick not]) sorted].
	^ aClass methodDict keys sorted! !

!SProject methodsFor: 'printing' stamp: 'mp 6/11/2010 16:35'!
metricsOverviewString

	^ self nop asString, ' Categories, ',
		self noc asString, ' Classes, and ',
		self nom asString, ' Methods (', self loc asString, ' Lines of Code).'! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:27'!
noc
	"Number of Classes"
	^ self allClasses size! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:26'!
nom
	"Number of Methods"
	^ self categories inject: 0 into: [:sum :each | sum := sum + (self nomOfCategory: each)]! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 17:42:33.152'!
nomOfCategory: aCategory

	^ self nomOfCategory: aCategory withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 17:43:36.207'!
nomOfCategory: aCategory withQuick: aBoolean

	^ (self classesOfCategory: aCategory) 
		inject: 0 into: [:sum :each | sum := sum + (self nomOfClass: each withQuick: aBoolean)].! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:42:43.223'!
nomOfClass: aClass
	^ self nomOfClass: aClass withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:03:12.72'!
nomOfClass: aClass methodCategory: aCategory

	^ self nomOfClass: aClass methodCategory: aCategory withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:03:50.274'!
nomOfClass: aClass methodCategory: aCategory withQuick: aBoolean

	^ (self 
		methodsPerClass: aClass 
		andMethodCategory: aCategory 
		withQuick: aBoolean) size! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 14:47:07.991'!
nomOfClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [
		^ (aClass methodDict keys select: [:each | (aClass >> each) isQuick not]) size +
	(aClass class methodDict keys select: [:each | (aClass class >> each) isQuick not]) size].
	^ aClass methodDict size + aClass class methodDict size! !

!SProject methodsFor: 'metrics' stamp: 'mp 9/28/2010 19:43:13.278'!
nomOfOneSideClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [^ (aClass methodDict keys 
							select: [:each | (aClass >> each) isQuick not]) size].
	^ aClass methodDict size! !

!SProject methodsFor: 'metrics' stamp: 'mp 6/11/2010 16:27'!
nop
	"Number of Packages Here: Categories"
	^ self categories size! !

!SProject methodsFor: 'printing' stamp: 'mp 7/7/2010 16:55:02.887'!
printString

	^ self == SProject current
		ifTrue: [self projectName, ' <current>']
		ifFalse: [self projectName]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
projectName
	"Answer the value of projectName"

	^ projectName! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
projectName: anObject
	"Set the value of projectName"

	projectName := anObject! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:56'!
resetClassesCache

	classesCache := nil.! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:49'!
testClasses

	^ self allClasses select: [:each | each inheritsFrom: TestCase]! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:53'!
testClassesOfCategory: aCategory

	^ self testClasses select: [:each | each category = aCategory]! !

!SProject methodsFor: 'accessing' stamp: 'mp 1/24/2011 16:37:48.831'!
typesBucket
	"Answer the value of typesBucket"

	^ typesBucket! !

!SProject methodsFor: 'accessing' stamp: 'mp 1/24/2011 16:37:48.836'!
typesBucket: anObject
	"Set the value of typesBucket"

	typesBucket := anObject! !

Object subclass: #SReplayCache
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Record-Replay'!

!SReplayCache methodsFor: 'public API' stamp: 'mp 7/7/2010 16:58:15.942'!
at: aMethodReference receiver: anObject arguments: aCollection
	| record |
	record := self cache 
				at: (SReplayRecord method: aMethodReference receiver: anObject arguments: aCollection) 
				ifAbsent: [nil].
	record ifNotNil: [
		(record receiver = anObject and: [record arguments = aCollection])
			ifFalse: [record := nil]
		].
	^ record! !

!SReplayCache methodsFor: 'public API' stamp: 'mp 7/7/2010 16:58:19.13'!
at: aMethodReference receiver: anObject arguments: aCollection put: aResult
	| record |
	self flag: #mpe. "Refactor me!!!!!!"
	record := SReplayRecord method: aMethodReference receiver: anObject arguments: aCollection result: aResult.
	self cache 
		at: record 
		put: record.
	! !

!SReplayCache methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:24'!
cache
	"Answer the value of cache"

	^ cache! !

!SReplayCache methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:24'!
cache: anObject
	"Set the value of cache"

	cache := anObject! !

!SReplayCache methodsFor: 'initialize-release' stamp: 'mp 5/18/2010 11:24'!
initialize

	self cache: Dictionary new.! !

Object subclass: #SReplayRecord
	instanceVariableNames: 'methodReference receiver arguments recordedResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Record-Replay'!

!SReplayRecord class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 12:02'!
method: aMethodReference receiver: anObject arguments: aCollection

	^ self new
		methodReference: aMethodReference;
		receiver: anObject;
		arguments: aCollection;
		yourself! !

!SReplayRecord class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 11:54'!
method: aMethodReference receiver: anObject arguments: aCollection result: aResult

	^ self new
		methodReference: aMethodReference;
		receiver: anObject;
		arguments: aCollection;
		recordedResult: aResult;
		yourself! !

!SReplayRecord methodsFor: 'comparing' stamp: 'mp 5/18/2010 11:58'!
= anObject

	self class == anObject class ifFalse: [^ false].
	^ ((anObject methodReference = self methodReference) 
		and: 	[anObject receiver = self receiver]) 
		and: [anObject arguments = self arguments]! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!SReplayRecord methodsFor: 'comparing' stamp: 'mp 5/18/2010 11:59'!
hash

	^ (self methodReference hash bitXor: self receiver hash) bitXor: self arguments hash! !

!SReplayRecord methodsFor: 'initialize-release' stamp: 'mp 5/18/2010 11:23'!
initialize

	self arguments: #().! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:55'!
methodReference
	"Answer the value of methodReference"

	^ methodReference! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:55'!
methodReference: anObject
	"Set the value of methodReference"

	methodReference := anObject! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
recordedResult
	"Answer the value of recordedResult"

	^ recordedResult! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
recordedResult: anObject
	"Set the value of recordedResult"

	recordedResult := anObject! !

Object subclass: #SSBClassA
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Sandbox'!

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:13'!
+ aValue

	^ self myValue + aValue! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 7/7/2010 17:36:54.015'!
complexMethod: anObject
	"blub"
	| b |
	self myValue: anObject.
	self unaryMethod 
		ifTrue: [
			b := SSBClassB on: self.
			^ b compute]
		ifFalse: [self error: 'Should not happen.'].! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:52'!
delayedMethod

	self unaryMethod
		ifTrue: [(Delay forMilliseconds: 100) wait].
	^ true! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:36'!
doNothing! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 13:57:23.076'!
failingMethod: aBoolean
	self unaryMethod.
	^ aBoolean
		ifTrue: [aBoolean]
		ifFalse: [aBoolean not]! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:34'!
initialize

	self myValue: 0.! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 11/8/2010 16:56:15.457'!
manyParameters: a b: c d: e f: g long: tooLongForDisplayingAtOnce! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:48'!
methodChain: anInteger

	^ anInteger! !

!SSBClassA methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:12'!
myValue
	"Answer the value of myValue"

	^ myValue! !

!SSBClassA methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:26'!
myValue: anObject
	"Set the value of myValue"

	myValue := anObject.
	self changed.! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 18:35:21.138'!
param: anObject method: anotherObject
	anObject == 5 ifTrue: [^ 4].
	self myValue: (Array with: anObject with: anotherObject).
	^ self myValue! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:45'!
printString

	^ self myValue asString! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:33'!
recursionMethod: aNumber

	aNumber = 0
		ifTrue: [^ 0]
		ifFalse: [
			^ aNumber + (self recursionMethod: aNumber - 1)].! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/9/2010 18:11'!
unaryMethod

	^ true! !

SSBClassA subclass: #SSBClassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Sandbox'!

!SSBClassC methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 14:08:00.226'!
failingMethod: aBoolean
	^ super failingMethod: aBoolean not.! !

Object subclass: #SSBClassB
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Sandbox'!

!SSBClassB class methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:23'!
on: anObject

	^ self new
		myValue: anObject! !

!SSBClassB methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:25'!
compute

	self myValue unaryMethod not
		ifFalse: [^ self myValue + self myValue myValue].
	^ 0! !

!SSBClassB methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:13'!
myValue
	"Answer the value of myValue"

	^ myValue! !

!SSBClassB methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:13'!
myValue: anObject
	"Set the value of myValue"

	myValue := anObject! !

!SSBClassB methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:27'!
update: anObject

	self myValue: anObject myValue.! !

Object subclass: #SScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Scripts'!

!SScripts class methodsFor: 'menu' stamp: 'mp 2/24/2011 18:00:52.311'!
chooseScript
	"self chooseScript"
	| allScripts notListedSelectors |
	notListedSelectors := {#chooseScript. #label. #createButton. #isOn}.
	allScripts := (self class methodDict keys 
					reject: [:each | notListedSelectors includes: each]) sort.
	(UIManager default chooseFrom: allScripts title: 'Choose script to do it')
		ifNotNilDo: [:choice | 
			choice > 0
				ifTrue: [self perform: (allScripts at: choice)]]
	! !

!SScripts class methodsFor: 'clean up' stamp: 'mp 2/24/2011 17:43:14.589'!
countInstances
	"self countInstances"
	({MwMethodWrapper. SCallNode. SPMPathMapMorph. SClassViewMorph. SMiniMap. SStateViewTracer}
		inject: Dictionary new into: [:dict :each | 
			dict 
				at: each put: each allSubInstances size;
				yourself]) explore.! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:59:11.852'!
createButton
	"self createButton"
	(PluggableButtonMorphPlus 
		on: SScripts 
		getState: #isOn 
		action: #chooseScript 
		label: #label) openInHand! !

!SScripts class methodsFor: 'examples' stamp: 'mp 2/24/2011 17:40:13.732'!
examplePathState
	"self examplePathState"
	(SStateViewTracer 
	onClass: SOMInterpreter 
	instVarName: #frame) run valuesAsSet explore.! !

!SScripts class methodsFor: 'examples' stamp: 'mp 2/24/2011 17:38:39.685'!
examplePathView
	"self examplePathView"
	SPathView openOn: SOMInterpreter.! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:57:25.573'!
isOn
	^ true! !

!SScripts class methodsFor: 'button' stamp: 'mp 2/24/2011 17:57:13.313'!
label
	^ 'PathScripts'! !

!SScripts class methodsFor: 'clean up' stamp: 'mp 2/24/2011 17:53:12.827'!
nuke
	"self nuke"
	MwMethodWrapper nuke.
	SMiniMap allInstances do: [:each | each abandon].
	Smalltalk garbageCollect.
	self assert: [MwMethodWrapper allSubInstances size = 0].
	self assert: [SMiniMap allInstances size = 0]. 
	self inform: 'Clean up done'! !

!SScripts class methodsFor: 'access' stamp: 'mp 2/24/2011 17:44:18.439'!
typesOfCurrentProject
	"self typesOfCurrentProject"
	SProject current typesBucket explore.! !

Object subclass: #SSourceCodeEntityAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Models'!

SSourceCodeEntityAdapter subclass: #SCategoryAdapter
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Models'!

!SCategoryAdapter class methodsFor: 'instance creation' stamp: 'mp 1/21/2010 10:14'!
on: aCategory

	^ self new
		category: aCategory! !

!SCategoryAdapter methodsFor: 'accessing' stamp: 'mp 1/21/2010 10:13'!
category
	"Answer the value of category"

	^ category! !

!SCategoryAdapter methodsFor: 'accessing' stamp: 'mp 1/21/2010 10:13'!
category: anObject
	"Set the value of category"

	category := anObject! !

!SCategoryAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:14'!
isCategory

	^ true! !

!SCategoryAdapter methodsFor: 'printing' stamp: 'mp 1/21/2010 10:13'!
printString

	^ self category! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:10'!
isCategory

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:12'!
isTestCategory

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:10'!
isTestClass

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:11'!
isTestMethod

	^ false! !

Object subclass: #STestChooserModel
	instanceVariableNames: 'tracer test result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-TestChooser'!

!STestChooserModel class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 15:32'!
on: aTracer

	^ self new
		tracer: aTracer;
		yourself! !

!STestChooserModel methodsFor: 'private' stamp: 'mp 5/2/2010 12:25'!
analyzeTest

	| result |
	result := self test isString
		ifTrue: [self tracer traceSourceCode: self test]
		ifFalse: [self tracer traceTest: self test actualClass method: self test methodSymbol].
	self result: result.! !

!STestChooserModel methodsFor: 'spec commands' stamp: 'mp 4/15/2010 15:39'!
isTestAvailable

	^ self test notNil! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:57'!
normalRun

	self setProfilingStateTo: #normal.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:57'!
normalRunWithCounts	
	
	self setProfilingStateTo: #counts.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:57'!
profileRunWithMs

	self setProfilingStateTo: #ms.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:57'!
profileRunWithPercentage

	self setProfilingStateTo: #%.! !

!STestChooserModel methodsFor: 'private' stamp: 'mp 1/25/2010 13:23'!
resetCallgraph

	self tracer ifNil: [^ self].
	self tracer resetCallgraph.! !

!STestChooserModel methodsFor: 'accessing' stamp: 'mp 1/21/2010 12:39'!
result
	"Answer the value of result"

	^ result! !

!STestChooserModel methodsFor: 'accessing' stamp: 'mp 4/15/2010 16:21'!
result: anObject
	"Set the value of result"

	result := anObject.
	self changed: result.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:58'!
selectClassesView

	self setViewStateTo: #classes.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:58'!
selectIdentityView

	self setViewStateTo: #identities.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:58'!
selectObjectView

	self setViewStateTo: #objects.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 5/2/2010 12:21'!
setCurrentCode: aSourceCodeString

	self test: aSourceCodeString.
	self changed: #isTestAvailable.
	aSourceCodeString 
		ifNil: [self resetCallgraph.
	 		   ^ self].
	self analyzeTest.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 4/15/2010 15:41'!
setCurrentTest: aMethodReference

	self test: aMethodReference.
	self changed: #isTestAvailable.
	aMethodReference 
		ifNil: [self resetCallgraph.
	 		   ^ self].
	self analyzeTest.	! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:56'!
setProfilingStateTo: aSymbol 
	
	self tracer profilingMode: aSymbol.! !

!STestChooserModel methodsFor: 'actions' stamp: 'mp 1/21/2010 12:57'!
setViewStateTo: aSymbol 
	
	self tracer viewMode: aSymbol.! !

!STestChooserModel methodsFor: 'accessing' stamp: 'mp 4/15/2010 15:38'!
test
	"Answer the value of test"

	^ test! !

!STestChooserModel methodsFor: 'accessing' stamp: 'mp 4/15/2010 15:38'!
test: anObject
	"Set the value of test"

	test := anObject! !

!STestChooserModel methodsFor: 'accessing' stamp: 'mp 1/21/2010 09:59'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!STestChooserModel methodsFor: 'accessing' stamp: 'mp 1/21/2010 09:59'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

Object subclass: #STool
	instanceVariableNames: 'windowMorph windowSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

STool subclass: #SCategoryChooser
	instanceVariableNames: 'selectedCategoriesList userOk project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SCategoryChooser class methodsFor: 'accessing' stamp: 'mp 6/23/2010 11:38'!
allCategories

	| categories |
	categories := Set new.
	Smalltalk allClasses do: [:each | 
		each category ifNotNil: [	categories add: each category]].
	^ categories asSortedCollection asArray! !

!SCategoryChooser class methodsFor: 'instance creation' stamp: 'mp 6/16/2010 21:50'!
on: aProject
	| tool |
	tool := self open.
	tool
		project: aProject;
		setCategoryListFromNames.
	^ tool
! !

!SCategoryChooser class methodsFor: 'instance creation' stamp: 'mp 6/16/2010 21:49'!
open
	| tool |
	tool := super open.
	tool setCategoryListFromNames.
	^ tool! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
allCategoryNames
	^ self selectedCategoriesList collect: [ :each | each key ]! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/21/2010 09:45'!
buildButtonPanelOn: aBuilder

	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #vertical;
		frame: (0.00 @ 0.75 corner: 1.00 @ 1.00);
		children: {
			self buildButtonsWith: aBuilder from: self selectButtons.
			self buildButtonsWith: aBuilder from: self userButtons.
			};
		yourself).! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/21/2010 09:46'!
buildCategoryListOn: aBuilder

	| listSpec |
	listSpec := aBuilder pluggableMultiSelectionListSpec new.
	listSpec
		model: self;
		name: #categoryList;
		list: #allCategoryNames;
		menu: #categoryMenu:;
		getSelectionList: #selectedCategoryAt:;
		setSelectionList: #selectedCategoryAt:put:;
		frame: (0 @ 0 corner: 1 @ 0.75).
	self windowSpec children add: listSpec.
	! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 16:06'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildCategoryListOn: aBuilder;
		buildButtonPanelOn: aBuilder.

	^ super buildWith: aBuilder
! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
cancel

	self userOk: false.
	self windowMorph abandon.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 15:34'!
categoryMenu: aMenu

	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAll;
		add: 'Select inversion' action: #selectInverse;
		add: 'Select none' action: #selectNone;
		yourself.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
getSelectedCategoryNames
	^ (self selectedCategoriesList
		select: [:each | each value]
		thenCollect: [:each | each key]) asArray! !

!SCategoryChooser methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:34'!
initialExtent

	^ 300@300! !

!SCategoryChooser methodsFor: 'initialize-release' stamp: 'mp 7/7/2010 16:55:05.741'!
initialize

	self userOk: false.
	self project: SProject new.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 3/15/2010 16:58'!
label

	^ 'Select Categories'! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 3/8/2011 18:11:29.622'!
ok

	self userOk: true.
	self storeSelectedCategories.
	self changed.
	self windowMorph abandon.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:47'!
project
	"Answer the value of project"

	^ project! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:47'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectAll

	self selectedCategoriesList do: [:each | each value: true].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 9/1/2010 12:22:24.768'!
selectButtons

	^ #(
		( 'All' #selectAll #alwaysEnabled)
		( 'Inverse' #selectInverse #alwaysEnabled)
		( 'None' #selectNone #alwaysEnabled)	
		)! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectInverse

	self selectedCategoriesList do: [:each | each value: each value not].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectNone

	self selectedCategoriesList do: [:each | each value: false].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:34'!
selectedCategoriesList
	^ selectedCategoriesList ifNil: [selectedCategoriesList := #()]! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
selectedCategoriesList: anObject
	selectedCategoriesList := anObject! !

!SCategoryChooser methodsFor: 'list commands' stamp: 'mp 1/20/2010 15:34'!
selectedCategoryAt: anIndex 
	^ (self selectedCategoriesList at: anIndex) value! !

!SCategoryChooser methodsFor: 'list commands' stamp: 'mp 1/20/2010 15:50'!
selectedCategoryAt: anIndex put: aBoolean 
	| result |
	result := (self selectedCategoriesList at: anIndex) value: aBoolean.
	self windowMorph changed.
	^ result! !

!SCategoryChooser methodsFor: 'initialize-release' stamp: 'mp 6/16/2010 21:50'!
setCategoryListFromNames

	self selectedCategoriesList: (self class allCategories 
		inject: OrderedCollection new 
		into: [:coll :each | coll 
						add: each -> (self project categories includes: each);
						yourself]).
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 6/16/2010 21:51'!
storeSelectedCategories
	self project categories: self getSelectedCategoryNames.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 15:34'!
userButtons

	^ #(
		( 'Ok' #ok #alwaysEnabled)
		( 'Cancel' #cancel #alwaysEnabled)
		).! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
userOk
	^ userOk! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
userOk: anObject
	userOk := anObject! !

STool subclass: #SConcernChooser
	instanceVariableNames: 'project selectedConcernItem selectedTestItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SConcernChooser class methodsFor: 'instance creation' stamp: 'mp 9/1/2010 14:33:09.297'!
on: aProject
	| tool |
	tool := self open.
	tool 
		project: aProject;
		reloadUIData.
	^ tool! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/1/2010 18:37:25.589'!
addConcern
	| concern |
	concern := (UIManager default request: 'Please insert a concern name:').
	(self concernGroups at: self selectedGroup) add: concern.
	self concernColors at: concern put: (Color h: 360 atRandom s: 1.0 v: 1.0).
	self refreshDeselectedConcernTree.

	! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:27:23.146'!
addConcernGroup
	| group |
	group := (UIManager default request: 'Please insert concern group name:').
	((self concernGroups keys includes: group) or: [group isEmpty])
		ifTrue: [^ self inform: 'The group name is not allowed.'].
	self concernGroups at: group put: OrderedCollection new.
	self changed: #rootsConcerns.
	! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 3/24/2011 11:05:58.615'!
addMapping
	| tests |
	tests := OrderedCollection new.
	self isTestClassSelected
		ifTrue: [	self selectedTestClass inheritedTestSelectors 
					do: [:each | tests add: (MethodReference 
											class: self selectedTestClass 
											selector: each)].
				tests := tests select: [:each | (self project concerns 
												mappingExisting: self selectedConcern 
												and: each) not]]
		ifFalse: [tests add: self selectedTest].
	tests do: [:each | (self concernMapping 
						at: self selectedConcern 
						ifAbsentPut: [OrderedCollection new]) add: each].

! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/1/2010 12:20:53.209'!
buildButtonsOn: aBuilder

	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #vertical;
		frame: (0.00 @ 0.9 corner: 1.00 @ 1.00);
		children: {self buildButtonsWith: aBuilder from: self concernButtons};
		yourself).! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 13:04:31.219'!
buildConcernTreeOn: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #concernTree;
		roots: #rootsConcerns;
		hasChildren: #hasChildrenConcerns:;
		getChildren: #getChildrenConcerns:;
		label: #labelTree:;
		setSelected: #newSelectedConcernItem:;
		icon: #iconForConcernItem:;		
		frame: (0 @ 0 corner: 0.5 @ 0.9).
	self windowSpec children add: treeSpec.! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 15:02:21.691'!
buildTestTreeOn: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #testTree;
		roots: #rootsTestClasses;
		hasChildren: #hasChildrenTest:;
		getChildren: #getChildrenTest:;
		label: #labelTree:;
		setSelected: #newSelectedTestItem:;
		icon: #iconForConcernTestItem:;
		frame: (0.5 @ 0 corner: 1 @ 0.9).
	self windowSpec children add: treeSpec.! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/13/2010 19:05:15.178'!
buildWith: aBuilder 
	self 
		buildWindowOn: aBuilder;
		buildConcernTreeOn: aBuilder;
		buildTestTreeOn: aBuilder;
		buildButtonsOn: aBuilder.
	^ super buildWith: aBuilder! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/1/2010 18:37:51.663'!
colorAction
	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self windowMorph activeHand;
		target: self;
		selector: #setIconColorOfSelectedConcern:;
		originalColor: (self concernColors at: self selectedConcern);
		putUpFor: self windowMorph near: self windowMorph fullBoundsInWorld.! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/2/2010 09:20:19.808'!
colorEnabled

	^ self isConcernSelected
! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 09:21:08.885'!
concernButtonAction
	self isConcernGroupSelected
		ifTrue: [self addConcern].
	self isConcernSelected
		ifTrue: [self removeConcern].! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 15:29:16.295'!
concernButtonEnabled
	^ self isConcernGroupSelected or: [self isConcernSelected]
! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 09:20:41.945'!
concernButtonLabel
	self isConcernSelected ifTrue: [^ 'Remove Concern'].
	^ 'Add Concern'! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 15:50:07.879'!
concernButtons
	^ #(
		( #groupButtonLabel #groupButtonAction #groupButtonEnabled)
		( #concernButtonLabel #concernButtonAction #concernButtonEnabled)
		( 'Choose Color' #colorAction #colorEnabled)
		( #mappingButtonLabel #mappingButtonAction #mappingButtonEnabled)				
		)! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:36.941'!
concernColors
	^ self project concerns colors ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:44.839'!
concernGroups
	^ self project concerns groups ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:56.591'!
concernMapping
	^ self project concerns mapping ! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 14:19:21.001'!
getChildrenConcerns: aCollection
	"size corresponds to depth of tree"
	"concern groups"
	aCollection size = 1 
		ifTrue: [^ (self concernGroups at: aCollection first) asSortedCollection 
					collect: [:each | {aCollection first. each}]].
	"concerns"
	aCollection size = 2 
		ifTrue: [	^ (self project concerns testClassesOfConcern: aCollection second)
					collect: [:each | {aCollection first. aCollection second. each}]].
	"test classes"
	aCollection size = 3
		ifTrue: [^ (self project concerns 
					testSelectorsOfClass: aCollection third 
					andConcern: aCollection second)
						collect: [:each | {aCollection first. aCollection second. 
										aCollection third. each}]].! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:53.89'!
getChildrenTest: aCollection
	"size corresponds to depth of tree"
	| testRef concerns |
	"test classes"
	aCollection size = 1 
		ifTrue: [ ^ aCollection first inheritedTestSelectors collect: [:each | {aCollection first. each}]].
	"test selectors"
	aCollection size = 2 
		ifTrue: [	testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
				concerns := self project concerns concernsOfTest: testRef.
				^ (self project concerns groupsOfConcerns: concerns)
					collect: [:each | {aCollection first. aCollection second. each}]].
	"concern groups"
	aCollection size = 3
		ifTrue: [	testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
				^ (self project concerns concernsOfGroup: aCollection third andTest: testRef)
					collect: [:each | {aCollection first. aCollection second. 
									aCollection third. each}]].! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:16:11.317'!
getIconForConcernFrom: aCollection at: aNumber
	| icon |
	(aCollection size = aNumber) ifFalse: [^ nil].
	(self concernColors includesKey: (aCollection at: aNumber))
		ifTrue: [
			icon := Form extent: 15@15 depth: 32.
			icon fillColor: (self concernColors at: (aCollection at: aNumber)).
			^ icon].
	^ nil! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 09:24:02.229'!
groupButtonAction
	self isConcernGroupSelected
		ifTrue: [self removeConcernGroup]
		ifFalse: [self addConcernGroup].
	
	! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:51:53.281'!
groupButtonEnabled

	^ (self selectedConcernItem isNil or: 
		[self isConcernGroupSelected]) or: 
			[self isConcernSelected]! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 09:23:42.281'!
groupButtonLabel
	self isConcernGroupSelected
		ifTrue: [^ 'Remove Group']
		ifFalse: [^ 'Add Group'].
	! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 14:19:10.794'!
hasChildrenConcerns: aCollection		
	"size corresponds to depth of tree"
	"concern groups"
	aCollection size = 1 
		ifTrue: [^ (self concernGroups at: aCollection first) notEmpty].
	"concerns"
	aCollection size = 2 
		ifTrue: [	(self concernMapping includesKey: aCollection second)
					ifTrue: [^ (self concernMapping at: aCollection second) notEmpty]].	
	"test classes"
	^ aCollection size = 3 ! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:50.509'!
hasChildrenTest: aCollection
	"size corresponds to depth of tree"
	| testRef |
	"test classes"
	aCollection size = 1 
		ifTrue: [^ aCollection first inheritedTestSelectors notEmpty].
	"test selectors"
	aCollection size = 2 
		ifTrue: [testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
			^ (self project concerns concernsOfTest: testRef) notEmpty].
	"concern groups"
	^ aCollection size = 3! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 15:15:36.516'!
iconForConcernItem: aCollection
	^ self getIconForConcernFrom: aCollection at: 2! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 9/2/2010 15:16:39.3'!
iconForConcernTestItem: aCollection
	^ self getIconForConcernFrom: aCollection at: 4! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/1/2010 11:38:51.286'!
initialExtent

	^ 500@400! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 12:05:27.768'!
isConcernGroupSelected
	^ self selectedConcernItem notNil and: [self selectedConcernItem size = 1]! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 12:06:44.23'!
isConcernSelected
	^ self selectedConcernItem notNil and: [self selectedConcernItem size = 2]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 3/24/2011 11:05:44.091'!
isSelectedMappingExisting
	self isConcernSelected ifFalse: [^ false].
	(self concernMapping includesKey: self selectedConcern) ifFalse: [^ false].
	self isTestClassSelected
		ifTrue: [	^ ((self concernMapping at: self selectedConcern) 
				select: [:each | each actualClass == self selectedTestClass]) size = 
					self selectedTestClass inheritedTestSelectors size].
	self isTestSelectorSelected
		ifTrue: [^ self project concerns 
					mappingExisting: self selectedConcern and: self selectedTest].
	^ false! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 12:07:55.58'!
isTestClassSelected
	^ self selectedTestItem notNil and: [self selectedTestItem size = 1]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 12:08:04.046'!
isTestSelectorSelected
	^ self selectedTestItem notNil and: [self selectedTestItem size = 2]! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/22/2010 18:12:47.742'!
label

	^ 'Concern Mapping'! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 11:59:23.048'!
labelTree: aCollection

	^ aCollection last asString! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:29:37.712'!
mappingButtonAction
	self isSelectedMappingExisting
		ifTrue: [self removeMapping]
		ifFalse: [self addMapping].
	self 
		selectedConcernItem: nil;
		selectedTestItem: nil;
		reloadUIData.! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 09:25:38.111'!
mappingButtonEnabled

	^ self isConcernSelected and: [
		self isTestClassSelected or: [self isTestSelectorSelected]]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:13:07.302'!
mappingButtonLabel
	self isSelectedMappingExisting
		ifTrue: [^ 'Remove Mapping']
		ifFalse: [^ 'Add Mapping'].
! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 12:02:58.282'!
newSelectedConcernItem: anObject
	self 
		selectedConcernItem: anObject;
		refreshButtons.! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 9/2/2010 12:04:20.417'!
newSelectedTestItem: anObject
	self 
		selectedTestItem: anObject; 
		refreshButtons.! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:14:17.165'!
project
	"Answer the value of project"

	^ project! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:14:17.169'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:50:25.316'!
refreshButtons
	self
		changed: #groupButtonLabel;
		changed: #groupButtonEnabled;
		changed: #concernButtonLabel;
		changed: #concernButtonEnabled;
		changed: #colorEnabled;
		changed: #mappingButtonLabel;
		changed: #mappingButtonEnabled.! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 12:03:35.778'!
refreshDeselectedConcernTree
	self 
		selectedConcernItem: nil;
		refreshButtons;
		changed: #rootsConcerns.

	! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:42:58.909'!
refreshDeselectedTestTree
	self 
		selectedTestItem: nil;
		changed: #rootsTestClasses.

	! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/1/2010 17:10:35.498'!
reloadUIData

	self 
		changed: #rootsTestClasses;
		changed: #rootsConcerns;
		refreshButtons.
	! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 15:43:13.315'!
removeConcern
	| concerns |
	(UIManager default confirm: 'Remove concern?')
		ifTrue: [	concerns := self concernGroups at: self selectedGroup.
				concerns remove: self selectedConcern.
				self concernColors removeKey: self selectedConcern ifAbsent: [].
				self concernMapping removeKey: self selectedConcern ifAbsent: [].		
				self 
					refreshDeselectedTestTree;
					refreshDeselectedConcernTree].! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:46:49.899'!
removeConcernGroup
	(UIManager default confirm: 'Remove group and all included concerns?')
		ifTrue: [ (self concernGroups at: self selectedGroup) 
					do: [:each | 
						self concernColors removeKey: each ifAbsent: [].
						self concernMapping removeKey: each ifAbsent: []].
				self concernGroups removeKey: self selectedGroup.
				self 
					refreshDeselectedTestTree;
					refreshDeselectedConcernTree].! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:35:01.226'!
removeMapping
	self isTestClassSelected
		ifTrue: [((self concernMapping at: self selectedConcern) 
					select: [:each | each actualClass == self selectedTestClass])
					do: [:each | (self concernMapping at: self selectedConcern) remove: each]]
		ifFalse: [(self concernMapping at: self selectedConcern) remove: self selectedTest]
! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 12:58:01.373'!
rootsConcerns
	self project ifNil: [^ #()].
	^ self concernGroups keys asSortedCollection collect: [:each | {each}]! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:28.912'!
rootsTestClasses
	self project ifNil: [^ #()].
	^ (self project testClasses asSortedCollection: [:a :b | a asString <= b asString])
		select: [:each | each inheritedTestSelectors notEmpty] 
		thenCollect: [:each | {each}]! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:06:51.545'!
selectedConcern
	^ self selectedConcernItem second! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.053'!
selectedConcernItem
	"Answer the value of selectedConcernItem"

	^ selectedConcernItem! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.058'!
selectedConcernItem: anObject
	"Set the value of selectedConcernItem"

	selectedConcernItem := anObject! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:06:55.964'!
selectedGroup
	^ self selectedConcernItem first! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:08:14.08'!
selectedTest
	^ MethodReference 
		class: self selectedTestItem first 
		selector: self selectedTestItem second
	
	
	 ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:08:16.905'!
selectedTestClass
	^ self selectedTestItem first! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.062'!
selectedTestItem
	"Answer the value of selectedTestItem"

	^ selectedTestItem! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.066'!
selectedTestItem: anObject
	"Set the value of selectedTestItem"

	selectedTestItem := anObject! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/2/2010 15:09:23.677'!
setIconColorOfSelectedConcern: aColor
	self selectedConcernItem ifNil: [^ self].
	self concernColors at: self selectedConcern put: aColor.
	self 
		refreshDeselectedConcernTree;
		changed: #rootsTestClasses.! !

STool subclass: #SPathFinder
	instanceVariableNames: 'callgraphTracer callgraphModel testChooserModel coverageTracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

SPathFinder subclass: #SPathDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SPathDebugger methodsFor: 'building' stamp: 'mp 3/25/2011 12:40:13.291'!
callgraphModelClass
	^ SDebuggerCallgraphModel! !

!SPathDebugger methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:21:29.891'!
indentingListItemClass
	^ SDebuggerCodeExplorerIndentingListItemMorph! !

!SPathDebugger methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:44:20.145'!
toolName
	^ 'PathDebugger'! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 6/23/2010 11:23'!
convertMethodReferenceToString: aMethodReference
	^ aMethodReference classSymbol asString, 
		(aMethodReference classIsMeta ifTrue: [ ' class' ] ifFalse: ['']), 
		'>>', 
		aMethodReference methodSymbol asString! !

!SPathFinder class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 21:49:20.381'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathFinder'. {self. #open}}.! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/24/2011 09:58:07.381'!
openOn: aTestMethodReference

	| pathFinder |
	pathFinder := self open.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	pathFinder changed: #label.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:40.205'!
openOn: aTestMethodReference and: aMethodReference

	| pathFinder |
	pathFinder := self openOn: aTestMethodReference.
	pathFinder callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 11:47:55.942'!
openOn: aTestMethodReference and: aMethodReference coverageTracer: aTracer
	| pathFinder |
	pathFinder := self openOn: aTestMethodReference coverageTracer: aTracer.
	pathFinder callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 12:29:45.063'!
openOn: aTestMethodReference coverageTracer: aTracer
	| pathFinder |
	pathFinder := self open.
	pathFinder coverageTracer: aTracer.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	pathFinder changed: #label.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:45.221'!
openOnCode: aSourceCodeString

	| pathFinder |
	pathFinder := self open.
	pathFinder testChooserModel setCurrentCode: aSourceCodeString.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:49.691'!
openOnCode: aSourceCodeString and: aMethodReference

	| pathFinder |
	pathFinder := self openOnCode: aSourceCodeString.
	pathFinder callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'private' stamp: 'abc 5/7/2010 18:49'!
openWithPerformanceMesaureOn: aTestMethodReference
	| testExpander swFindNode |
	swFindNode := Stopwatch new.
	testExpander := self new.
	ToolBuilder open: testExpander.
	testExpander testChooserModel setCurrentTest: aTestMethodReference.
	swFindNode activate.
	(testExpander callgraphModel tracer getNode: (testExpander callgraphModel tracer currentId / 2) asInteger) setAsCurrentSelection.
	swFindNode suspend.
	testExpander windowMorph abandon.
	^ swFindNode duration asMilliSeconds! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 4/26/2010 17:14'!
openWithPerformanceMesaureOn: aTestMethodReference and: aMethodReference
	| testExpander swGui swShallowAnalysis swFindNode fullTime |
	Transcript clear.
	swGui := Stopwatch new.
	swShallowAnalysis := Stopwatch new.
	swFindNode := Stopwatch new.
	"Start: Build GUI"
	swGui activate.
	testExpander := self new.
	ToolBuilder open: testExpander.
	swGui suspend.
	"End: Build GUI"
	"Start: Shallow Analyzis"
	swShallowAnalysis activate.
	testExpander testChooserModel setCurrentTest: aTestMethodReference.
	swShallowAnalysis suspend.
	"End: Shallow Analyzis"
	"Start: Find Node in Tree"
	swFindNode activate.
	testExpander callgraphModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	swFindNode suspend.
	"End: Find Node in Tree"
	"Summary"
	fullTime := swGui duration + swShallowAnalysis duration + swFindNode duration.
	Transcript show: 'GUI: ', swGui duration asString; space; show: ((swGui duration / fullTime) * 100) asInteger asString; show: '%'; cr.	
	Transcript show: 'Shallow Analysis: ', swShallowAnalysis duration asString; space; show: ((swShallowAnalysis duration / fullTime) * 100) asInteger asString; show: '%'; cr.
	Transcript show: 'Find Node: ', swFindNode duration asString; space; show: ((swFindNode duration / fullTime) * 100) asInteger asString; show: '%'; cr.
	Transcript show: 'All: ', (fullTime) asString; cr.
	^ testExpander! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:20:29.516'!
buildCallGraphTreeOn: aBuilder frame: aRectangle 
	| treeSpec |
	treeSpec := SPluggableTreeSpec new.
	treeSpec
		model: self callgraphModel;
		name: #callGraphTree;
		roots: #rootCallNodes;
		hasChildren: #hasChildren:;
		getChildren: #getChildren:;
		setSelected: #newSelectedItem:;
		getSelectedPath: #getSelectedPath;
		menu: #callGraphMenu:;
		highlightItem: #highlightItem:;
		indentingListItemMorph: self indentingListItemClass;
		icon: #getIcon:;
		frame: aRectangle.
	self windowSpec children add: treeSpec! !

!SPathFinder methodsFor: 'building' stamp: 'mp 4/17/2010 20:45'!
buildCustomMorphs

	self 
		"buildNavigationBarMorphWithFrame: (0.007 @ 0.00 corner: 0.85 @ 0.05);"
		buildTestResultFeedbackMorphWithFrame: (0.008 @ 0.0 corner: 0.047 @ 0.061);
		buildDropDownMorphOn: self testChooserModel
			with: {'Class View' -> #selectClassesView. 
				   'Object View' -> #selectObjectView.
				   'Identity View' -> #selectIdentityView.}
			frame: (0.05 @ 0.0 corner:  0.254 @ 0.061);
		buildDropDownMorphOn: self testChooserModel
			with: {'Without Profiling' -> #normalRun. 
				   'Relative % Profiling' -> #profileRunWithPercentage. 
				   'Absolute ms Profiling' -> #profileRunWithMs.
				   'Call Counts' -> #normalRunWithCounts.}
			frame: (0.256 @ 0.0 corner:  0.46 @ 0.061).! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 7/7/2010 16:45:28.525'!
buildDropDownMorphOn: aModel with: aCollection frame: aRectangle
	| morph |
	morph := SDropDownMorph on: aModel with: aCollection.
	self setFrame: aRectangle in: morph.
	self windowMorph addMorph: morph.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 1/20/2010 17:03'!
buildHistoryButtonsOn: aBuilder frame: aRectangle 
	| buttonSpec |
	buttonSpec := self 
		buildButtonsWith: aBuilder
		from: self historyButtons
		model: self callgraphModel.
	buttonSpec frame: aRectangle.
	self windowSpec children add: buttonSpec! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 7/7/2010 16:49:09.621'!
buildNavigationBarMorphWithFrame: aRectangle
	| navigationBar |
	navigationBar := SPathFindNaviBarMorph new.
	self setFrame: aRectangle in: navigationBar.
	navigationBar borderWidth: 2; borderColor: #inset.
	self windowMorph addMorph: navigationBar.
	self callgraphModel addDependent: navigationBar.! !

!SPathFinder methodsFor: 'building' stamp: 'mp 4/17/2010 20:47'!
buildPluggableMorphsOn: aBuilder
	self
		buildWindowOn: aBuilder;
		buildHistoryButtonsOn: aBuilder frame: (0.85 @ 0.0 corner: 1.0 @ 0.062);
		buildSearchFieldOn: aBuilder frame: (0.456 @ 0.0 corner: 0.85 @ 0.062);
		buildCallGraphTreeOn: aBuilder frame: (0.0 @ 0.062 corner: 1.0 @ 1.0).
	super buildWith: aBuilder.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/4/2010 13:59'!
buildSearchFieldOn: aBuilder frame: aRectangle 
	| inputSpec |
	inputSpec := aBuilder pluggableInputFieldSpec new
		model: self callgraphModel;
		name: #searchInputField;
		getText: #getSearchQuery;
		setText: #searchNode:;
		frame: aRectangle.
	self windowSpec children add: inputSpec! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 3/24/2011 10:03:37.592'!
buildTestResultFeedbackMorphWithFrame: aRectangle
	| testResult |
	testResult := STestResultFeedbackMorph on: self selector: #rerunTest.
	self setFrame: aRectangle in: testResult.
	self windowMorph addMorph: testResult.
	self testChooserModel addDependent: testResult.! !

!SPathFinder methodsFor: 'building' stamp: 'mp 1/20/2010 17:03'!
buildWith: aBuilder 
	
	self 
		createModels;
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs;
		resizeWindow.
	^ self windowMorph! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphModel
	^ callgraphModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphModel: anObject 
	callgraphModel := anObject! !

!SPathFinder methodsFor: 'building' stamp: 'mp 3/25/2011 12:39:50.678'!
callgraphModelClass
	^ SCallgraphModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphTracer
	^ callgraphTracer! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
callgraphTracer: anObject
	callgraphTracer := anObject! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:28:01.534'!
chooseNewTest
	self testChooserModel	setCurrentTest: 
		(UIManager default 
				chooseFrom: SProject current allTests
				values: SProject current allTests
				lines: #() 
				title: 'Choose Test Case') ! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:34:57.774'!
chooseTestAction
	^ UIManager default 
				chooseFrom: {'Rerun current test'. 'Choose new test'}
				values: {#rerun. #newTest}
				lines: #() 
				title: 'Choose test action'

	! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 4/15/2010 15:46'!
clearAnalysis

	self testChooserModel setCurrentTest: nil.! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 3/25/2011 11:30:42.879'!
coverageTracer
	"Answer the value of coverageTracer"

	^ coverageTracer! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 3/25/2011 11:30:42.884'!
coverageTracer: anObject
	"Set the value of coverageTracer"

	coverageTracer := anObject! !

!SPathFinder methodsFor: 'building' stamp: 'mp 3/25/2011 12:46:53.604'!
createModels
	self callgraphTracer: (SCallgraphTracer on: SProject current categories).
	self callgraphModel: (self callgraphModelClass 
							on: self callgraphTracer
							pathFinder: self).
	self callgraphTracer callgraphModel: self callgraphModel.
	self testChooserModel: (STestChooserModel on: self callgraphTracer).! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 1/20/2010 17:03'!
historyButtons

	^ #(
		( '<<' #historyBack #historyBackButtonEnabled)
		( '>>' #historyPrevious #historyPreviousButtonEnabled)
		).! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:20:40.322'!
indentingListItemClass
	^ SCodeExplorerIndentingListItemMorph! !

!SPathFinder methodsFor: 'user interface' stamp: 'mp 11/8/2010 17:14:38.535'!
initialExtent

	^ 750@450! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:43:50.509'!
label
	| subhead |
	subhead := self testChooserModel test 
		ifNil: ['']
		ifNotNil: [
			self testChooserModel test isString
				ifTrue: ['Code Snippet']
				ifFalse: [self testChooserModel test stringVersionDefault]].
	^ self toolName, ': ', subhead! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:31:39.029'!
rerunTest
	| choice |
	self testChooserModel isTestAvailable
		ifTrue: [	choice := self chooseTestAction.
				choice caseOf: {
					[#rerun] -> [self testChooserModel analyzeTest].
					[#newTest] -> [self chooseNewTest]}]
		ifFalse: [self chooseNewTest].
	self changed: #label.

	! !

!SPathFinder methodsFor: 'building' stamp: 'mp 1/20/2010 17:03'!
resizeWindow

	self windowMorph extent: self initialExtent.
! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
testChooserModel
	^ testChooserModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
testChooserModel: anObject 
	testChooserModel := anObject! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:44:03.439'!
toolName
	^ 'PathFinder'! !

STool subclass: #SPathView
	instanceVariableNames: 'viewAreaMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SPathView class methodsFor: 'as yet unclassified' stamp: 'mp 3/7/2011 21:54:40.834'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathView'. {self. #open}}.! !

!SPathView class methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2011 14:48:50.048'!
openOn: aClass
	| tool |
	tool := self open.
	tool startWithClass: aClass.
	^ tool
	! !

!SPathView methodsFor: 'building' stamp: 'mp 1/26/2011 11:12:18.398'!
buildCustomMorphs

	self 
		buildScrollPaneWithFrame: (0.005 @ 0.005 corner: 0.995 @ 0.99);
		buildMiniMapWithFrame: (0.75 @ 0.75 corner: 0.95 @ 0.95).! !

!SPathView methodsFor: 'building' stamp: 'mp 1/26/2011 11:11:12.089'!
buildMiniMapWithFrame: aRectangle
	| miniMap |
	miniMap := SMiniMap on: self viewAreaMorph.
	self setFrame: aRectangle in: miniMap.
	self windowMorph addMorph: miniMap.! !

!SPathView methodsFor: 'building' stamp: 'mp 1/22/2011 14:51:09.636'!
buildPluggableMorphsOn: aBuilder
	self
		buildWindowOn: aBuilder.
"		buildHistoryButtonsOn: aBuilder frame: (0.85 @ 0.0 corner: 1.0 @ 0.062);
		buildSearchFieldOn: aBuilder frame: (0.456 @ 0.0 corner: 0.85 @ 0.062);
		buildCallGraphTreeOn: aBuilder frame: (0.0 @ 0.062 corner: 1.0 @ 1.0)."
	super buildWith: aBuilder.! !

!SPathView methodsFor: 'building' stamp: 'mp 1/26/2011 12:57:32.009'!
buildScrollPaneWithFrame: aRectangle
	| scrollPane |
	scrollPane := ScrollPane new.
	scrollPane borderWidth: 0.
	self viewAreaMorph: PasteUpMorph new.
	self viewAreaMorph 
		extent: 1500@1500;
		borderColor: Color gray;
		color: (Color r: 0.85 g: 0.85 b: 0.85).
	scrollPane scroller addMorph: self viewAreaMorph.
	self setFrame: aRectangle in: scrollPane.
	self windowMorph addMorph: scrollPane.! !

!SPathView methodsFor: 'building' stamp: 'mp 1/22/2011 16:35:55.097'!
buildWith: aBuilder 
	
	self 
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs;
		resizeWindow.
	^ self windowMorph! !

!SPathView methodsFor: 'initialize-release' stamp: 'mp 1/26/2011 11:21:13.514'!
initialExtent

	^ 600@600! !

!SPathView methodsFor: 'accessing' stamp: 'mp 1/26/2011 11:20:37.433'!
label

	^ 'PathView'! !

!SPathView methodsFor: 'building' stamp: 'mp 1/22/2011 16:35:58.117'!
resizeWindow

	self windowMorph extent: self initialExtent.! !

!SPathView methodsFor: 'initialize-release' stamp: 'mp 1/22/2011 16:53:28.882'!
startWithClass: aClass
	| classMorph |
	classMorph := SClassViewMorph on: aClass.
	self viewAreaMorph addMorph: classMorph.
	classMorph position: ((self initialExtent x / 2) - (classMorph width / 2)) @ 
							((self initialExtent y / 2) - (classMorph height / 2)).! !

!SPathView methodsFor: 'accessing' stamp: 'mp 1/22/2011 16:49:40.894'!
viewAreaMorph
	"Answer the value of viewAreaMorph"

	^ viewAreaMorph! !

!SPathView methodsFor: 'accessing' stamp: 'mp 1/22/2011 16:49:40.899'!
viewAreaMorph: anObject
	"Set the value of viewAreaMorph"

	viewAreaMorph := anObject! !

STool subclass: #SProjectChooser
	instanceVariableNames: 'selectedProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SProjectChooser class methodsFor: 'as yet unclassified' stamp: 'mp 3/7/2011 21:50:41.281'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathProjects'. {self. #open}}.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/8/2011 18:01:41.905'!
addProject
	| projectName |
	projectName := UIManager default request: 'Insert new project name' initialAnswer: ''.
	(projectName notNil and: [projectName notEmpty])
		ifTrue: [
			projectName := projectName asSymbol.
			(SProject projectAt: projectName) 
				ifNotNil: [^ self inform: 'Project name already exists.'].
			selectedProject := SProject 
									projectAt: projectName 
									put: (SProject name: projectName categories: #())].
	self 
		changed: #allRegisteredProjects;
		changed: #selectedProject;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 7/7/2010 16:55:20.267'!
allRegisteredProjects

	^ SProject allProjectsWithoutNull asSortedCollection: [:a :b | 
		a projectName < b projectName]! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 6/15/2010 22:33'!
buildProjectListOn: aBuilder frame: aRectangle
	| listSpec |
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: #projectList;
		list: #allRegisteredProjects;
		getSelected: #selectedProject;
		setSelected: #selectedProject:;
		frame: aRectangle.
	self windowSpec children add: listSpec.! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 6/16/2010 14:23'!
buildSelectedCategoriesListOn: aBuilder frame: aRectangle
	| listSpec |
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: #selectedCategoriesList;
		list: #selectedCategoriesOfProject;
		frame: aRectangle.
	self windowSpec children add: listSpec.
! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 3/8/2011 17:55:01.153'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildButtonsPanelWith: aBuilder 
			from: self projectControlButtons 
			model: self 
			frame: (0.0 @ 0.0 corner: 1.0 @ 0.1325);
		buildButtonsPanelWith: aBuilder 
			from: self specificProjectButtons 
			model: self 
			frame: (0.0 @ 0.83 corner: 1.0 @ 1.0);
		buildProjectListOn: aBuilder frame: (0.0 @ 0.1325 corner: 0.5 @ 0.83);
		buildSelectedCategoriesListOn: aBuilder frame: (0.5 @ 0.1325 corner: 1.0 @ 0.83).

	^ super buildWith: aBuilder! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/8/2011 18:08:25.275'!
chooseCategories

	| chooser |
	chooser := SCategoryChooser on: selectedProject.
	chooser addDependent: self.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 9/1/2010 11:13:04.681'!
chooseConcerns

	SConcernChooser on: selectedProject.! !

!SProjectChooser methodsFor: 'type harvesting' stamp: 'mp 1/24/2011 17:56:09.256'!
harvestTypes
	| tracer |
	tracer := STracer on: selectedProject.
	selectedProject typesBucket: ((THHarvester forCategories: selectedProject categories)
										eagerLeastSpecific
										harvestDisplayingProgress: 
											[tracer runEntryPoints];
										yourself) bucket
	! !

!SProjectChooser methodsFor: 'user interface' stamp: 'mp 1/24/2011 16:35:37.068'!
initialExtent

	^ 600@250! !

!SProjectChooser methodsFor: 'initialize-release' stamp: 'mp 7/7/2010 16:55:09.006'!
initialize

	selectedProject := SProject current.! !

!SProjectChooser methodsFor: 'user interface' stamp: 'mp 6/16/2010 09:46'!
isProjectSelected

	^ selectedProject notNil ! !

!SProjectChooser methodsFor: 'accessing' stamp: 'mp 3/7/2011 21:43:07.163'!
label

	^ 'PathProjects'! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 3/8/2011 20:29:02.126'!
projectControlButtons

	^ #(
		( 'Set Current' #selectCurrentProject #alwaysEnabled)
		( 'Add Project' #addProject #alwaysEnabled)
		( 'Choose Categories...' #chooseCategories #isProjectSelected)
		( 'Remove Project' #removeSelectedProject #isProjectSelected)
		( 'Reset Cache' #resetCacheOfSelectedProject #isProjectSelected)
		).! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 7/7/2010 16:55:29.145'!
removeSelectedProject

	SProject removeProjectAt: selectedProject projectName.
	selectedProject := SProject current.
	self 
		changed: #allRegisteredProjects;
		changed: #selectedProject;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 11:09'!
resetCacheOfSelectedProject

	selectedProject resetClassesCache.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/8/2011 19:42:40.308'!
selectCurrentProject
	selectedProject 
		ifNil: [SProject setNullProjectAsCurrent]
		ifNotNil: [SProject setCurrentProject: selectedProject].
	selectedProject resetClassesCache.
	self changed: #allRegisteredProjects.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 14:24'!
selectedCategoriesOfProject

	^ selectedProject
		 ifNil: [#()]
		ifNotNil: [selectedProject categories]! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 09:47'!
selectedProject

	^ selectedProject! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 14:25'!
selectedProject: aProject

	selectedProject := aProject.
	self 
		changed: #isProjectSelected;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'type harvesting' stamp: 'mp 3/8/2011 19:33:47.825'!
showTypes
	selectedProject typesBucket explore.! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 3/8/2011 19:21:21.1'!
specificProjectButtons

	^ #(
		( 'Concerns...' #chooseConcerns #isProjectSelected)
		( 'Type Harvesting' #typeHarvesting #isProjectSelected)
		( 'Entry Points...' #chooseEntryPoints #alwaysDisabled)
		( 'Record & Replay...' #chooseRecoredAndReplayMethods #alwaysDisabled)
		).! !

!SProjectChooser methodsFor: 'type harvesting' stamp: 'mp 3/8/2011 19:33:07.394'!
typeHarvesting
	| choice |
	choice := UIManager default
		chooseFrom: {'Show'. 'Harvest'} 
		values: #(showTypes harvestTypes) 
		lines: #() 
		title: 'Type Harvesting'.
	choice ifNotNil: [self perform: choice].! !

!SProjectChooser methodsFor: 'updating' stamp: 'mp 3/8/2011 18:11:56.975'!
update: aCategoryChooser

	self changed: #selectedCategoriesOfProject.! !

!STool class methodsFor: 'instance creation' stamp: 'mp 6/15/2010 21:56'!
open
	| tool |
	tool := self new.
	ToolBuilder open: tool.
	^ tool! !

!STool methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:33'!
alwaysDisabled

	^ false! !

!STool methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:33'!
alwaysEnabled

	^ true! !

!STool methodsFor: 'building' stamp: 'mp 3/8/2011 17:46:44.008'!
buildButtonsPanelWith: aBuilder from: anArray model: aModel frame: aRect
	
	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #horizontal;
		frame: aRect;
		children: {
			self buildButtonsWith: aBuilder from: anArray model: aModel.
			};
		yourself).! !

!STool methodsFor: 'building' stamp: 'mp 1/20/2010 15:33'!
buildButtonsWith: aBuilder from: anArray

	^ self buildButtonsWith: aBuilder from: anArray model: self! !

!STool methodsFor: 'building' stamp: 'mp 1/20/2010 16:04'!
buildButtonsWith: aBuilder from: anArray model: aModel

	^ aBuilder pluggablePanelSpec new
		model: aModel;
		layout: #horizontal;
		children: (anArray collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: aModel; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!STool methodsFor: 'building' stamp: 'mp 3/24/2011 10:00:05.812'!
buildWindowOn: aBuilder

	self windowSpec: aBuilder pluggableWindowSpec new.
	self windowSpec
		model: self;
		label: #label;
		children: OrderedCollection new.! !

!STool methodsFor: 'building' stamp: 'mp 3/4/2010 15:20'!
buildWith: aBuilder

	self windowMorph: (aBuilder build: self windowSpec).
	^ self windowMorph
	! !

!STool methodsFor: 'accessing' stamp: 'mp 6/15/2010 21:52'!
label

	^ 'tool title'! !

!STool methodsFor: 'building' stamp: 'mp 1/22/2011 14:56:58.095'!
setFrame: aRectangle in: aMorph

	| frame |
	frame := LayoutFrame new
				leftFraction: aRectangle left; 
				rightFraction: aRectangle right; 
				topFraction: aRectangle top; 
				bottomFraction: aRectangle bottom.
	aMorph layoutFrame: frame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowMorph
	^ windowMorph! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowMorph: anObject
	windowMorph := anObject! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowSpec
	^ windowSpec! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowSpec: anObject
	windowSpec := anObject! !

Object subclass: #STracer
	instanceVariableNames: 'entryPoints wrappers active project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tracer'!

STracer subclass: #SPMTestRunnerTracer
	instanceVariableNames: 'pathMap testResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

!SPMTestRunnerTracer commentStamp: 'mp 7/12/2010 15:24:23.428' prior: 0!
A SPMTestRunnerTracer is an abstract class for all path map analyses that require the test runner interface.

Instance Variables
	pathMap:		<Object>

pathMap
	- xxxxx
!

SPMTestRunnerTracer subclass: #SPMTRCoverageTracer
	instanceVariableNames: 'coveredMethods numberOfTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

SPMTRCoverageTracer subclass: #SPMTRConcernCoverageTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/2/2010 18:41:47.892'!
addConcernInfo: aCollection to: aMorph
	| concernString |
	concernString := String streamContents: [:s |
		aCollection 
			do: [:concern | s nextPutAll: concern asString]
			separatedBy: [s nextPut: Character cr]].
	aMorph additionalInfo: aMorph methodReference asStringOrText, Character cr,
						'was covered by the following concerns: ', Character cr,
						concernString.! !

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/22/2010 14:24:30.207'!
convertTestsToConcerns: aCollection
	^ ((aCollection 
		inject: IdentitySet new 
		into: [:coll :test | 
			coll, (self project concerns 
					concernsOfGroup: self options concernGroup 
					andTest: test asMethodReference)]) asSortedCollection)
				select: [:each | self options getSelectedConcerns includes: each].! !

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/22/2010 15:34:05.099'!
getConcernColor: aCollection
	| maxConcerns minGrayValue |
	aCollection ifEmpty: [^ Color white].
	aCollection size = 1 ifTrue: [^ self project concerns colors at: aCollection first].
	self options specificConcernMethodsOnly ifTrue: [^ Color white].
	maxConcerns := self options getSelectedConcerns size.
	minGrayValue := self class minGrayValue.
	^ Color h: 0 s: 0.0 v: (minGrayValue - ((aCollection size / maxConcerns) * minGrayValue)).! !

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/3/2010 17:50:19.495'!
setAdditionalColorsFrom: aCollection to: aMorph
	aCollection	size <= 1 ifTrue: [^ self].
	aMorph additionalColors: (aCollection collect: [:each | 
													self project concerns colors at: each]).! !

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/23/2010 18:35:55.251'!
visualizeAllInformation
	self visualizeConcernCoverageOf: self getAllCoveredMethods.! !

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/22/2010 10:10:14.093'!
visualizeConcernCoverageOf: aDictionary
	| morph tests concerns |
	aDictionary keysDo: [:each | 
		morph := self pathMap getMethodMorph: each actualClass and: each methodSymbol.
		tests := morph allCoveringTests.
		concerns := self convertTestsToConcerns: tests.
		self addConcernInfo: concerns to: morph.
		morph propagateColor: (self getConcernColor: concerns).
		(self options multipleColorsPerMethod 
			and: [self options specificConcernMethodsOnly not])
				ifTrue: [self setAdditionalColorsFrom: concerns to: morph]].! !

!SPMTRConcernCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/22/2010 09:31:51.162'!
visualizeEndExecutionOf: aTestCaseEntryPoint
	self visualizeConcernCoverageOf: self coveredMethods! !

!SPMTRCoverageTracer class methodsFor: 'constants' stamp: 'mp 9/17/2010 15:03:58.124'!
coverageGrayScale

	^ 0.5! !

!SPMTRCoverageTracer class methodsFor: 'constants' stamp: 'mp 9/17/2010 15:04:21.316'!
minGrayValue

	^ 0.75! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/16/2010 18:21:44.055'!
addIntensityCoveringInfo: aNumber to: aMorph
	aMorph additionalInfo: aMorph additionalInfo, 
							aNumber asString, ' test(s) covered this method.'.! !

!SPMTRCoverageTracer methodsFor: 'coverage events' stamp: 'mp 3/23/2011 16:45:09.125'!
addToCoveredMethods: aMethodReference
	self isActive
		ifTrue: [self coveredMethods 
					at: aMethodReference
					put: nil].
! !

!SPMTRCoverageTracer methodsFor: 'accessing' stamp: 'mp 8/9/2010 14:00:00.911'!
coveredMethods
	"Answer the value of coveredMethods"

	^ coveredMethods ifNil: [coveredMethods := Dictionary new]! !

!SPMTRCoverageTracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 15:46:02.117'!
coveredMethods: anObject
	"Set the value of coveredMethods"

	coveredMethods := anObject! !

!SPMTRCoverageTracer methodsFor: 'ignore setup/tearDown Code' stamp: 'mp 3/23/2011 17:29:32.734'!
createDeactivationWrapperFor: aSymbol in: aClass
	| wrapper |
	(aClass methodDict includesKey: aSymbol)
		ifTrue: [	wrapper := SPMDeactivateTracerWrapper 
								on: aSymbol 
								inClass: aClass 
								with: self.
				wrapper ifNotNil: [
					self wrappers add: wrapper.
					 wrapper install]].! !

!SPMTRCoverageTracer methodsFor: 'ignore setup/tearDown Code' stamp: 'mp 3/23/2011 17:31:48.081'!
createWrappers
	super createWrappers.
	self pathMap globalOptions ignoreTracingOfSetUpAndTearDownMethods
		ifTrue: [
			self entryPoints do: [:each | 
				(self testCaseSuperClassesOf: each) do: [:cls | 
					self 
						createDeactivationWrapperFor: #setUp in: cls;
						createDeactivationWrapperFor: #tearDown in: cls]]].
! !

!SPMTRCoverageTracer methodsFor: 'running' stamp: 'mp 7/13/2010 15:57:42.14'!
endExecutionOf: anEntryPoint withResult: anObject
	super endExecutionOf: anEntryPoint withResult: anObject.
	self resetCoveredMethods.! !

!SPMTRCoverageTracer methodsFor: 'accessing' stamp: 'mp 8/9/2010 15:00:46.637'!
getAllCoveredMethods
	| result |
	result := Dictionary new.
	self testResults valuesDo: [:each | result := result, each].
	^ result! !

!SPMTRCoverageTracer methodsFor: 'accessing' stamp: 'mp 11/5/2010 11:11:11.315'!
getCoveringTests: aMethodReference
	| coveringTests |
	coveringTests := Set new.
	self testResults keysAndValuesDo: [:test :coveredMethods |
		(coveredMethods includesKey: aMethodReference)
			ifTrue: [coveringTests add: test]].
	^ coveringTests asOrderedCollection! !

!SPMTRCoverageTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/12/2010 15:40:35.318'!
getWrapperClass

	^ SPMCoverageWrapper! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/16/2010 15:34:22.489'!
numberOfTests
	"I am a cache"
	^ numberOfTests ifNil: [numberOfTests := self pathMap numberOfTests]! !

!SPMTRCoverageTracer methodsFor: 'tracing' stamp: 'mp 3/21/2011 14:49:27.824'!
postProcessing
	super postProcessing.
	self project coverage: self testResults.! !

!SPMTRCoverageTracer methodsFor: 'tracing' stamp: 'mp 9/16/2010 17:51:05.017'!
preProcessing
	super preProcessing.
	self options visualizeStaticMetric.! !

!SPMTRCoverageTracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 15:46:48.064'!
resetCoveredMethods

	self coveredMethods: nil.! !

!SPMTRCoverageTracer methodsFor: 'color propagation' stamp: 'mp 7/13/2010 15:51:24.721'!
setColorPropagation
	self pathMap setPercentageColorPropagation.! !

!SPMTRCoverageTracer methodsFor: 'results' stamp: 'mp 7/13/2010 15:37:14.261'!
storeResultOf: anEntryPoint
	self testResults at: anEntryPoint put: self coveredMethods.! !

!SPMTRCoverageTracer methodsFor: 'ignore setup/tearDown Code' stamp: 'mp 3/23/2011 17:25:59.886'!
testCaseSuperClassesOf: aTestCaseEntryPoint

	^ (aTestCaseEntryPoint asMethodReference actualClass allSuperclasses) 
		addFirst: aTestCaseEntryPoint asMethodReference actualClass;
		removeLast; "TestCase"
		removeLast; "Object"
		removeLast; "ProtoObject"
		yourself.! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/29/2010 17:16:01.515'!
testCoverageIntensityFrom: aMorph
	| numberOfCoveringTests |
	numberOfCoveringTests := aMorph allCoveringTests size.
	self addIntensityCoveringInfo: numberOfCoveringTests to: aMorph.
	^ (numberOfCoveringTests ln / self numberOfTests ln) * self class minGrayValue! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 3/22/2011 11:35:23.857'!
visualizeAllInformation
	self options visualizeStaticMetric.
	self options showTestResults
		ifTrue: [self testResults keysDo: [:each | self visualizeTestResultOf: each]].
	self options intensityCoverageEnabled
		ifTrue: [self visualizeIntensityOfCoveredMethods: self getAllCoveredMethods]
		ifFalse: [self visualizeCoveredMethods: self getAllCoveredMethods]! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/17/2010 15:04:04.142'!
visualizeCoveredMethods: aDictionary
	| morph |
	aDictionary keysDo: [:each | 
		morph := self pathMap getMethodMorph: each actualClass and: each methodSymbol.
		morph propagateColor: (Color 
									h: morph color hue 
									s: morph color saturation 
									v: self class coverageGrayScale)].! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/16/2010 16:38:02.41'!
visualizeEndExecutionOf: anEntryPoint
	self options showTestResults
		ifTrue: [self visualizeTestResultOf: anEntryPoint].
	self options intensityCoverageEnabled
		ifTrue: [self visualizeIntensityOfCoveredMethods: self coveredMethods]
		ifFalse: [self visualizeCoveredMethods: self coveredMethods].! !

!SPMTRCoverageTracer methodsFor: 'visualization' stamp: 'mp 9/17/2010 15:05:14.889'!
visualizeIntensityOfCoveredMethods: aDictionary
	| morph  grayScale |
	aDictionary keysDo: [:each | 
		morph := self pathMap getMethodMorph: each actualClass and: each methodSymbol.
		grayScale := self class minGrayValue - (self testCoverageIntensityFrom: morph).
		morph propagateColor: (Color 
									h: morph color hue 
									s: morph color saturation 
									v: grayScale)].! !

SPMTRCoverageTracer subclass: #SPMTRFaultLocalizationTracer
	instanceVariableNames: 'faultFormula failuresAtMethod passedAtMethod allFailures allPassed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

!SPMTRFaultLocalizationTracer methodsFor: 'visualization' stamp: 'mp 9/9/2010 17:21:14.296'!
addInfo: aNumber to: aMorph
	| info |
	info := aMorph methodReference asStringOrText, Character cr, 
		self passedAtMethod asString, ' out of ', self allPassed asString, 
		' passed tests', Character cr,
		self failuresAtMethod asString, ' out of ', self allFailures asString, 
		' failed tests', Character cr,
		'Suspiciousness value: ', (aNumber * 100) floor asString, '%', Character cr.
	aMorph isSourceCodeEntityATestMethod
		ifFalse: [info := info, 'Single point of failure probability: ', 
							((aNumber * aMorph color saturation) * 100) floor asString, '%'].
	aMorph additionalInfo: info.! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.168'!
allFailures
	"Answer the value of allFailures"

	^ allFailures! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.172'!
allFailures: anObject
	"Set the value of allFailures"

	allFailures := anObject! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.176'!
allPassed
	"Answer the value of allPassed"

	^ allPassed! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.18'!
allPassed: anObject
	"Set the value of allPassed"

	allPassed := anObject! !

!SPMTRFaultLocalizationTracer methodsFor: 'visualization' stamp: 'mp 9/22/2010 18:19:50.429'!
color: aMorph suspiciousness: aNumber
	| hue visibility |
	hue := 120 * (1.0 - aNumber).
	visibility := (self allFailures = 0)
					ifTrue: [0.0]
					ifFalse: [self failuresAtMethod / self allFailures].
	aMorph isSourceCodeEntityATestMethod
		ifTrue: [visibility := 1.0].
	(self options singlePointOfFault and: [(visibility = 1.0) not])
		ifTrue: [	aMorph propagateColor: Color white]
		ifFalse: [aMorph propagateColor: (Color h: hue s: visibility v: 1.0)].! !

!SPMTRFaultLocalizationTracer methodsFor: 'fault localization' stamp: 'mp 9/9/2010 16:19:12.475'!
computePassFailCountsFor: aMorph
	| coveringTests |	
	coveringTests := aMorph allCoveringTests.
	self failuresAtMethod: (self failuresFrom: coveringTests).
	self allFailures: (self failuresFrom: self testResults keys).
	self passedAtMethod: (coveringTests size - self failuresAtMethod).
	self allPassed: (self testResults keys size - self allFailures).! !

!SPMTRFaultLocalizationTracer methodsFor: 'fault localization' stamp: 'mp 9/22/2010 17:00:00.712'!
computeSuspiciousness
	self options formula caseOf: {
		[#tarantula] -> [^ self tarantulaSuspiciousness].
		[#ochiai] -> [^ self ochiaiSuspiciousness].
		[#jaccard] -> [^ self jaccardSuspiciousness]
	}
	! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.151'!
failuresAtMethod
	"Answer the value of failuresAtMethod"

	^ failuresAtMethod! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.156'!
failuresAtMethod: anObject
	"Set the value of failuresAtMethod"

	failuresAtMethod := anObject! !

!SPMTRFaultLocalizationTracer methodsFor: 'fault localization' stamp: 'mp 9/9/2010 15:25:19.763'!
failuresFrom: testResults
	^ testResults inject: 0 into: [:sum :each | 
		each lastResult hasPassed ifFalse: [sum := sum + 1]. 
		sum].! !

!SPMTRFaultLocalizationTracer methodsFor: 'public api' stamp: 'mp 9/9/2010 17:53:17.093'!
getLocalizedMethodMorphsWithoutTests
	| morphs |
	morphs := OrderedCollection new.
	self pathMap rootMorph traverseAllChildsAndDo: [:each |
		(((each class == SPMMethodMorph) 
		and: [(each color = Color white) not]) 
		and: [each isSourceCodeEntityATestMethod not])
			ifTrue: [morphs add: each]].
	^ morphs! !

!SPMTRFaultLocalizationTracer methodsFor: 'fault localization' stamp: 'mp 9/22/2010 17:06:27.702'!
jaccardSuspiciousness
	self allFailures = 0 ifTrue: [^ 0.0].
	^ self failuresAtMethod / (self allFailures + self passedAtMethod)! !

!SPMTRFaultLocalizationTracer methodsFor: 'public api' stamp: 'mp 11/15/2010 13:56:31.034'!
mostOpportuneAuthors
	"This method only works properly if defect detection was executed before"
	| methods authors currentAuthor score suspicious confidence |
	authors := Dictionary new.
	methods := self mostSuspiciousMethods.
	methods do: [:each | 
		currentAuthor := each key compiledMethod authors first.
		score := authors at: currentAuthor ifAbsentPut: 0.
		suspicious := each value first.
		confidence := each value second.
		"F-Measure: Weighted harmonic mean"
		score := score + ((2 * suspicious * confidence) / (suspicious + confidence)).
		authors at: currentAuthor put: score].
	^ authors associations sort: [:a :b | a value > b value]! !

!SPMTRFaultLocalizationTracer methodsFor: 'public api' stamp: 'mp 9/9/2010 18:02:49.987'!
mostProbableSinglePointOfFailureMethods
	"This method only works properly if defect detection was executed before"
	| defects suspiciousness failureCompletness |
	defects := self getLocalizedMethodMorphsWithoutTests..
	defects := defects collect: [:each | 
		suspiciousness := 1.0 - (each color hue / 120.0).
		failureCompletness := each color saturation.
		each methodReference -> ((suspiciousness * failureCompletness) * 100.0)].
	^ defects sortBy: [:a :b | a value > b value]! !

!SPMTRFaultLocalizationTracer methodsFor: 'public api' stamp: 'mp 9/9/2010 18:49:26.959'!
mostProbableSinglePointOfFailureMethodsWithAllFailuresIncluded
	"This method only works properly if defect detection was executed before"
	"Returns only methods that were covered by all failures!!"
	| defects suspiciousness failureCompletness |
	defects := self getLocalizedMethodMorphsWithoutTests..
	defects := defects 
		select: [:each | each color saturation = 1.0] 
		thenCollect: [:each | 
			suspiciousness := 1.0 - (each color hue / 120.0).
			failureCompletness := each color saturation.
			each methodReference -> ((suspiciousness * failureCompletness) * 100.0)].
	^ defects sortBy: [:a :b | a value > b value]! !

!SPMTRFaultLocalizationTracer methodsFor: 'public api' stamp: 'mp 10/31/2010 10:15:15.351'!
mostSuspiciousMethods
	"This method only works properly if defect detection was executed before"
	| defects |
	defects := self getLocalizedMethodMorphsWithoutTests.
	defects := defects collect: [:each | 
		each methodReference -> {(1.0 - (each color hue / 120)). each color saturation}].
	^ defects sortBy: [:a :b | a value first > b value first]
! !

!SPMTRFaultLocalizationTracer methodsFor: 'fault localization' stamp: 'mp 9/28/2010 18:19:57.501'!
ochiaiSuspiciousness
	self allFailures = 0.0 ifTrue: [^ 0.0].
	"Required for Null Objects"
	(self failuresAtMethod + self passedAtMethod) = 0 ifTrue: [^ 0.0].
	^ self failuresAtMethod / 
		((self allFailures * (self failuresAtMethod + self passedAtMethod)) sqrt)! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.16'!
passedAtMethod
	"Answer the value of passedAtMethod"

	^ passedAtMethod! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:13:23.164'!
passedAtMethod: anObject
	"Set the value of passedAtMethod"

	passedAtMethod := anObject! !

!SPMTRFaultLocalizationTracer methodsFor: 'public api' stamp: 'mp 3/25/2011 11:56:42.762'!
pathFinderTool
	^ SPathDebugger! !

!SPMTRFaultLocalizationTracer methodsFor: 'accessing' stamp: 'mp 9/9/2010 16:14:47.735'!
resetPassFailCounts

	self 
		failuresAtMethod: 0;
		allFailures: 0;
		passedAtMethod: 0;
		allPassed: 0.! !

!SPMTRFaultLocalizationTracer methodsFor: 'color propagation' stamp: 'mp 9/30/2010 11:36:20.854'!
setColorPropagation
	self pathMap setHighestColorPropagation.! !

!SPMTRFaultLocalizationTracer methodsFor: 'fault localization' stamp: 'mp 9/28/2010 18:21:48.393'!
tarantulaSuspiciousness
	| passedRatio failedRatio |
	self allFailures = 0 ifTrue: [^ 0.0].
	self allPassed = 0 ifTrue: [^ 1.0].
	passedRatio := self passedAtMethod / self allPassed.
	failedRatio := self failuresAtMethod / self allFailures.
	"Required for null objects"
	(passedRatio + failedRatio) = 0 ifTrue: [^ 0.0].
	^ 1.0 - (passedRatio / (passedRatio + failedRatio))! !

!SPMTRFaultLocalizationTracer methodsFor: 'visualization' stamp: 'mp 9/17/2010 16:45:52.701'!
visualizeAllInformation
	"Adjust brightness of all covered morphs as now all failing tests are known"
	self visualizeFaultLocalization: self getAllCoveredMethods.! !

!SPMTRFaultLocalizationTracer methodsFor: 'visualization' stamp: 'mp 9/9/2010 14:55:49.75'!
visualizeEndExecutionOf: anEntryPoint
	self visualizeFaultLocalization: self coveredMethods.! !

!SPMTRFaultLocalizationTracer methodsFor: 'visualization' stamp: 'mp 9/9/2010 17:00:53.403'!
visualizeFaultLocalization: aDictionary
	| morph suspiciousness |
	aDictionary keysDo: [:each | 
		self resetPassFailCounts.
		morph := self pathMap getMethodMorph: each actualClass and: each methodSymbol.
		self computePassFailCountsFor: morph.
		suspiciousness := self computeSuspiciousness.
		self color: morph suspiciousness: suspiciousness.
		self addInfo: suspiciousness to: morph.].! !

SPMTestRunnerTracer subclass: #SPMTRProfilingTracer
	instanceVariableNames: 'maxValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

SPMTRProfilingTracer subclass: #SPMTRMethodCallTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

SPMTRMethodCallTracer subclass: #SPMTRInstancesCountTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

!SPMTRInstancesCountTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 12:07:45.708'!
addInstanceCountInfo: aNumber to: aMorph

	aMorph additionalInfo: aMorph sourceCodeEntity asString, Character cr,
						    aNumber asString, ' objects were created.'.! !

!SPMTRInstancesCountTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 8/11/2010 13:33:07.394'!
createWrappers
	self selectedClasses do: [:klass | self createWrapperOn: klass class and: #basicNew].! !

!SPMTRInstancesCountTracer methodsFor: 'tracing' stamp: 'mp 8/11/2010 14:44:15.44'!
preProcessing
	super preProcessing.
	self pathMap hideAllMethodAndCategoryMorphs.! !

!SPMTRInstancesCountTracer methodsFor: 'accessing' stamp: 'mp 9/23/2010 15:21:47.569'!
unitForLegend
	^ 'instances'! !

!SPMTRInstancesCountTracer methodsFor: 'visualization' stamp: 'mp 9/29/2010 16:11:09.699'!
visualizeEndExecutionOf: anEntryPoint
	| countBag morph heatColor |
	countBag := self collectAllCalls.
	self maxValue: (self maxCallCountFrom: countBag).

	countBag valuesAndCounts associationsDo: [:assoc | 
		morph := self pathMap getClassMorph: assoc key actualClass.
		self addInstanceCountInfo: assoc value to: morph.
		self maxValue = 1
			ifTrue: [heatColor := self class maxHue]
			ifFalse: [heatColor := self class maxHue - ((assoc value ln / self maxValue ln) * 
									self class maxHue)].
		morph propagateColor: (Color h: heatColor s: 1.0 v: 1.0)].! !

!SPMTRMethodCallTracer methodsFor: 'visualization' stamp: 'mp 9/23/2010 14:26:26.509'!
addMethodCallsInfo: aNumber to: aMorph
	aMorph additionalInfo: aMorph methodReference asStringOrText, Character cr,
						    'was called ', aNumber asString, ' times.'.! !

!SPMTRMethodCallTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 11:58:09.84'!
collectAllCalls
	| callBag |
	callBag := Bag new.
	self testResults valuesDo: [:methods | 
		methods associationsDo: [:each | callBag add: each key withOccurrences: each value]].
	^ callBag! !

!SPMTRMethodCallTracer methodsFor: 'results' stamp: 'mp 8/12/2010 14:09:50.283'!
getProfilingData
	| result |
	result := Dictionary new.
	self wrappers select: [:each | each calls > 0]
		thenDo: [:each | result at: each asMethodReference put: each calls].
	^ result! !

!SPMTRMethodCallTracer methodsFor: 'public api' stamp: 'mp 9/23/2010 13:12:34.922'!
getProfilingHighscore
	^ self collectAllCalls sortedCounts! !

!SPMTRMethodCallTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 8/11/2010 10:08:52.434'!
getWrapperClass

	^ SPMCallCountWrapper! !

!SPMTRMethodCallTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 11:58:40.392'!
maxCallCountFrom: aMethodCallBag
	"max doesn't work"
	^ aMethodCallBag sortedCounts first key! !

!SPMTRMethodCallTracer methodsFor: 'accessing' stamp: 'mp 9/23/2010 15:21:33.935'!
unitForLegend
	^ 'method calls'! !

!SPMTRMethodCallTracer methodsFor: 'visualization' stamp: 'mp 9/29/2010 16:09:22.833'!
visualizeEndExecutionOf: anEntryPoint
	| methodCallBag morph heatColor |
	methodCallBag := self collectAllCalls.
	self maxValue: (self maxCallCountFrom: methodCallBag).
	
	methodCallBag valuesAndCounts associationsDo: [:assoc | 
		morph := self pathMap 
						getMethodMorph: assoc key actualClass 
						and: assoc key methodSymbol.
		self addMethodCallsInfo: assoc value to: morph.
		self maxValue = 1
			ifTrue: [heatColor := self class maxHue]
			ifFalse: [heatColor := self class maxHue - ((assoc value ln / self maxValue ln) * 
									self class maxHue)].
		morph propagateColor: (Color h: heatColor s: 1.0 v: 1.0)].! !

!SPMTRProfilingTracer class methodsFor: 'constants' stamp: 'mp 9/23/2010 14:25:42.174'!
maxHue

	^ 240.0! !

!SPMTRProfilingTracer methodsFor: 'running' stamp: 'mp 8/9/2010 16:55:48.967'!
beginExecutionOf: anEntryPoint
	self wrappers do: [:each | each reset].! !

!SPMTRProfilingTracer methodsFor: 'results' stamp: 'mp 8/12/2010 14:09:27.863'!
getProfilingData
	
	self subclassResponsibility.! !

!SPMTRProfilingTracer methodsFor: 'public api' stamp: 'mp 9/23/2010 13:08:19.587'!
getProfilingHighscore
	self subclassResponsibility.! !

!SPMTRProfilingTracer methodsFor: 'accessing' stamp: 'mp 9/23/2010 14:47:23.477'!
maxValue
	"Answer the value of maxValue"

	^ maxValue! !

!SPMTRProfilingTracer methodsFor: 'accessing' stamp: 'mp 9/23/2010 14:47:23.481'!
maxValue: anObject
	"Set the value of maxValue"

	maxValue := anObject! !

!SPMTRProfilingTracer methodsFor: 'color propagation' stamp: 'mp 8/9/2010 15:57:18.094'!
setColorPropagation
	self pathMap setPercentageColorPropagation.! !

!SPMTRProfilingTracer methodsFor: 'results' stamp: 'mp 9/23/2010 14:27:35.188'!
storeResultOf: anEntryPoint
	self testResults at: anEntryPoint put: self getProfilingData.! !

!SPMTRProfilingTracer methodsFor: 'accessing' stamp: 'mp 9/23/2010 15:21:19.81'!
unitForLegend
	self subclassResponsibility.! !

SPMTRProfilingTracer subclass: #SPMTRRuntimeTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

SPMTRRuntimeTracer subclass: #SPMTRRuntimeExtentTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

SPMTRRuntimeExtentTracer subclass: #SPMTRRuntimeExtentRatioTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

!SPMTRRuntimeExtentRatioTracer methodsFor: 'results' stamp: 'mp 8/12/2010 14:10:22.241'!
getProfilingData
	| result |
	result := Dictionary new.
	self wrappers select: [:each | (each stopwatch duration isZero not) and: [each calls > 0]]
		thenDo: [:each | result 
							at: each asMethodReference 
							put: {each calls. each stopwatch duration}].
	^ result! !

!SPMTRRuntimeExtentRatioTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 17:32:26.288'!
visualizeEndExecutionOf: anEntryPoint
	self visualizeRuntimeRatio.! !

!SPMTRRuntimeExtentTracer methodsFor: 'results' stamp: 'mp 8/12/2010 14:10:13.163'!
getProfilingData
	| result |
	result := Dictionary new.
	self wrappers select: [:each | each stopwatch duration isZero not]
		thenDo: [:each | result at: each asMethodReference put: each stopwatch duration].
	^ result! !

!SPMTRRuntimeExtentTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 8/12/2010 10:39:16.781'!
getWrapperClass

	^ SPMCallRuntimeExtentWrapper! !

SPMTRRuntimeTracer subclass: #SPMTRRuntimeIntentTracer
	instanceVariableNames: 'stopwatches runtimes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

SPMTRRuntimeIntentTracer subclass: #SPMTRRuntimeIntentRatioTracer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Tracer'!

!SPMTRRuntimeIntentRatioTracer methodsFor: 'results' stamp: 'mp 8/12/2010 17:38:42.923'!
getProfilingData
	| duration |
	self wrappers select: [:each | each calls > 0] 
		thenDo: [:each | 
			duration := self runtimes at: each asMethodReference.
			self runtimes at: each asMethodReference put: {each calls. duration}].
	^ self runtimes! !

!SPMTRRuntimeIntentRatioTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 17:32:12.811'!
visualizeEndExecutionOf: anEntryPoint
	self visualizeRuntimeRatio.! !

!SPMTRRuntimeIntentTracer methodsFor: 'wrapper events' stamp: 'mp 8/12/2010 16:26:40.328'!
after: aMethodReference process: aProcess
	| stack pastRuntime |
	stack := self stopwatches at: aProcess.
	stack last value suspend.
	stack last key = aMethodReference
		ifFalse: [^ self error: 'Should not happen!!'].	
	pastRuntime := self runtimes at: aMethodReference ifAbsentPut: [Duration zero].
	self runtimes at: aMethodReference put: pastRuntime + stack last value duration.
	stack removeLast.
	stack ifNotEmpty: [stack last value activate].! !

!SPMTRRuntimeIntentTracer methodsFor: 'wrapper events' stamp: 'mp 8/12/2010 14:34:58.491'!
before: aMethodReference process: aProcess
	| stack |
	stack := self stopwatches at: aProcess ifAbsentPut: [OrderedCollection new].
	stack ifNotEmpty: [stack last value suspend].
	stack add: aMethodReference -> Stopwatch new activate.! !

!SPMTRRuntimeIntentTracer methodsFor: 'running' stamp: 'mp 8/12/2010 14:23:01.647'!
endExecutionOf: anEntryPoint withResult: anObject
	super endExecutionOf: anEntryPoint withResult: anObject.
	self reset.! !

!SPMTRRuntimeIntentTracer methodsFor: 'results' stamp: 'mp 8/12/2010 15:34:51.28'!
getProfilingData
	^ self runtimes! !

!SPMTRRuntimeIntentTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 8/12/2010 13:59:04.074'!
getWrapperClass

	^ SPMCallRuntimeIntentWrapper! !

!SPMTRRuntimeIntentTracer methodsFor: 'accessing' stamp: 'mp 8/12/2010 14:53:40.497'!
reset
	self 
		runtimes: nil;
		stopwatches: nil.! !

!SPMTRRuntimeIntentTracer methodsFor: 'accessing' stamp: 'mp 8/12/2010 14:25:05.467'!
runtimes
	"Answer the value of runtimes"

	^ runtimes ifNil: [runtimes := Dictionary new]! !

!SPMTRRuntimeIntentTracer methodsFor: 'accessing' stamp: 'mp 8/12/2010 14:21:29.423'!
runtimes: anObject
	"Set the value of runtimes"

	runtimes := anObject! !

!SPMTRRuntimeIntentTracer methodsFor: 'accessing' stamp: 'mp 8/12/2010 14:25:17.999'!
stopwatches
	"Answer the value of stopwatches"

	^ stopwatches ifNil: [stopwatches := Dictionary new]! !

!SPMTRRuntimeIntentTracer methodsFor: 'accessing' stamp: 'mp 8/12/2010 14:21:29.415'!
stopwatches: anObject
	"Set the value of stopwatches"

	stopwatches := anObject! !

!SPMTRRuntimeTracer methodsFor: 'visualization-ratio' stamp: 'mp 8/12/2010 17:37:10.428'!
addRuntime: aDuration calls: aNumber ratioInfo: aRatioNumber to: aMorph
	aMorph additionalInfo: aMorph methodReference asStringOrText, Character cr,
						'required ', (aRatioNumber // (10 raisedToInteger: 6)) asString, 	
						' ms per call.', Character cr, 
						'(', aDuration asMilliSeconds, 
						' ms / ', aNumber, ' calls).'.! !

!SPMTRRuntimeTracer methodsFor: 'visualization-runtime' stamp: 'mp 8/12/2010 17:41:03.01'!
addRuntimeInfo: aDuration to: aMorph

	aMorph additionalInfo: aMorph methodReference asStringOrText, Character cr,
						    'required ', aDuration asMilliSeconds asString, ' ms.'.! !

!SPMTRRuntimeTracer methodsFor: 'visualization-ratio' stamp: 'mp 8/12/2010 17:40:23.291'!
collectRuntimeAndCallsFromAllMethods
	| callsAndRuntime previousValue |
	callsAndRuntime := Dictionary new.
	self testResults valuesDo: [:methods | 
		methods associationsDo: [:each | 
			previousValue := callsAndRuntime at: each key ifAbsent: {0. Duration zero}.
			callsAndRuntime 
				at: each key 
				put: {previousValue first + each value first.
					  previousValue second + each value second}]].
	^ callsAndRuntime! !

!SPMTRRuntimeTracer methodsFor: 'visualization-runtime' stamp: 'mp 8/12/2010 17:15:42.889'!
collectRuntimeFromAllMethods
	| runtimeDict previousDuration |
	runtimeDict := Dictionary new.
	self testResults valuesDo: [:methods | 
		methods associationsDo: [:each |
			previousDuration := runtimeDict at: each key ifAbsent: Duration zero.
			runtimeDict at: each key put: each value + previousDuration]].
	^ runtimeDict! !

!SPMTRRuntimeTracer methodsFor: 'visualization-ratio' stamp: 'mp 8/12/2010 17:32:59.717'!
computeRatioAndSort: aDictionary
	| ratioCollection |
	ratioCollection := OrderedCollection new.
	aDictionary associationsDo: [:each | 
		ratioCollection add: (each key -> (each value second asNanoSeconds / 
											each value first))].
	^ ratioCollection asSortedCollection: [:a :b | a value > b value]! !

!SPMTRRuntimeTracer methodsFor: 'public api' stamp: 'mp 9/23/2010 13:44:57.748'!
getProfilingHighscore
	| highscore |
	highscore := OrderedCollection new.
	self options kindOfProfiling == #runtime
		ifTrue: [self collectRuntimeFromAllMethods	associationsDo: [:each | 
					highscore add: each value -> each key].]
		ifFalse: [self collectRuntimeAndCallsFromAllMethods associationsDo: [:each | 
					highscore add: (((each value second asNanoSeconds / 
										each value first) asFloat / 1000000) -> each key)].].
	^ highscore asSortedCollection: [:a :b | a key > b key]! !

!SPMTRRuntimeTracer methodsFor: 'visualization-runtime' stamp: 'mp 8/12/2010 17:16:48.514'!
maxRuntimeFrom: aDictionary
	| highscore |
	highscore := OrderedCollection new.
	aDictionary associationsDo: [:each | highscore add: each].
	^ (highscore asSortedCollection: [:a :b | a value > b value]) first! !

!SPMTRRuntimeTracer methodsFor: 'accessing' stamp: 'mp 9/23/2010 15:26:18.318'!
unitForLegend
	self options kindOfProfiling == #runtime
		ifTrue: [^ 'ns']
		ifFalse: [^ 'ns per call']! !

!SPMTRRuntimeTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 17:30:00.93'!
visualizeEndExecutionOf: anEntryPoint
	self visualizeRuntime.! !

!SPMTRRuntimeTracer methodsFor: 'visualization-runtime' stamp: 'mp 9/29/2010 16:12:02.342'!
visualizeRuntime
	| runtimeDict morph heatColor |
	runtimeDict := self collectRuntimeFromAllMethods.
	self maxValue: (self maxRuntimeFrom: runtimeDict) value asNanoSeconds.
	
	runtimeDict associationsDo: [:assoc | 
		morph := self pathMap 
						getMethodMorph: assoc key actualClass 
						and: assoc key methodSymbol.
		self addRuntimeInfo: assoc value to: morph.
		self maxValue = 1
			ifTrue: [heatColor := self class maxHue]
			ifFalse: [heatColor := self class maxHue - ((assoc value asNanoSeconds ln / 
									self maxValue ln) * self class maxHue)].
		morph propagateColor: (Color h: heatColor s: 1.0 v: 1.0)	].! !

!SPMTRRuntimeTracer methodsFor: 'visualization-ratio' stamp: 'mp 9/29/2010 16:13:10.513'!
visualizeRuntimeRatio
	| rawData sortedRatio morph heatColor |
	rawData := self collectRuntimeAndCallsFromAllMethods.
	sortedRatio := self computeRatioAndSort: rawData.
	self maxValue: sortedRatio first value.
	
	sortedRatio do: [:assoc | 
		morph := self pathMap getMethodMorph: assoc key actualClass 
					and: assoc key methodSymbol.
		self addRuntime: (rawData at: assoc key) second 
			 calls: (rawData at: assoc key) first 
			 ratioInfo: assoc value 
			 to: morph.
		self maxValue = 1
			ifTrue: [heatColor := self class maxHue]
			ifFalse: [heatColor := self class maxHue - ((assoc value ln / self maxValue ln) *
									 self class maxHue)].
		morph propagateColor: (Color h: heatColor s: 1.0 v: 1.0)	].! !

!SPMTestRunnerTracer class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 15:23:18.791'!
on: aProject pathMap: aPathMap
	^ (self on: aProject entryPoints: (STestCaseEntryPoint 
										convertTestSuite: aPathMap testRunner suiteAll))
		pathMap: aPathMap;
		yourself! !

!SPMTestRunnerTracer methodsFor: 'running' stamp: 'mp 9/16/2010 15:57:57.876'!
endExecutionOf: anEntryPoint withResult: aTestResult
	self 
		setTestRunnerResult: aTestResult;
		storeResultOf: anEntryPoint.
	self globalOptions visualizeIntermediateSteps
		ifTrue: [self visualizeEndExecutionOf: anEntryPoint].! !

!SPMTestRunnerTracer methodsFor: 'color propagation' stamp: 'mp 3/25/2011 14:35:36.343'!
getColorFromMapFor: aMethodRef
	^ (self pathMap 
		getMethodMorph: aMethodRef actualClass and: aMethodRef methodSymbol) color! !

!SPMTestRunnerTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 16:05:10.168'!
getWrapperClass

	^ SNullWrapper! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 9/16/2010 14:39:28.651'!
globalOptions

	^ self pathMap options at: #globalOptions! !

!SPMTestRunnerTracer methodsFor: 'initialize-release' stamp: 'mp 8/9/2010 14:47:05.668'!
initialize

	self testResults: IdentityDictionary new.! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 9/16/2010 15:07:22.25'!
options

	^ self pathMap selectedOptions! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 15:22:07.085'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 15:22:07.09'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPMTestRunnerTracer methodsFor: 'tracing' stamp: 'mp 9/17/2010 16:44:22.503'!
postProcessing
	self testRunner updateResults.
	self visualizeAllInformation.! !

!SPMTestRunnerTracer methodsFor: 'tracing' stamp: 'mp 7/13/2010 15:49:50.625'!
preProcessing
	self pathMap resetAllChildren.
	self testRunner reset.
	self setColorPropagation.! !

!SPMTestRunnerTracer methodsFor: 'color propagation' stamp: 'mp 7/13/2010 15:50:54.097'!
setColorPropagation
	self pathMap setDominantColorPropagation.! !

!SPMTestRunnerTracer methodsFor: 'results' stamp: 'mp 7/20/2010 16:11:11.488'!
setTestRunnerResult: aTestResult
	aTestResult errors 
		do: [:each | (self testRunner result instVarNamed: 'errors') add: each].
	aTestResult failures 
		do: [:each | (self testRunner result instVarNamed: 'failures') add: each].
	aTestResult passed 
		do: [:each | (self testRunner result instVarNamed: 'passed') add: each].						
	self testRunner updateStatus: true.! !

!SPMTestRunnerTracer methodsFor: 'results' stamp: 'mp 8/9/2010 14:17:15.624'!
storeResultOf: anEntryPoint
	self testResults 
			at: anEntryPoint 
			put: (Dictionary new 
					at: anEntryPoint asMethodReference put: nil;
					yourself).! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 7/13/2010 15:30:26.307'!
testResults
	"Answer the value of testResults"

	^ testResults! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 7/13/2010 15:30:26.311'!
testResults: anObject
	"Set the value of testResults"

	testResults := anObject! !

!SPMTestRunnerTracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 15:25:09.228'!
testRunner

	^ self pathMap testRunner! !

!SPMTestRunnerTracer methodsFor: 'visualization' stamp: 'mp 9/17/2010 16:44:29.329'!
visualizeAllInformation
	self testResults keysDo: [:each | self visualizeEndExecutionOf: each].! !

!SPMTestRunnerTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 11:16:58.731'!
visualizeEndExecutionOf: aTestCaseEntryPoint
	self visualizeTestResultOf: aTestCaseEntryPoint.! !

!SPMTestRunnerTracer methodsFor: 'visualization' stamp: 'mp 8/12/2010 11:17:08.872'!
visualizeTestResultOf: aTestCaseEntryPoint
	| morph |
	morph := self pathMap 
					getMethodMorph: aTestCaseEntryPoint testClass 
				    	and: aTestCaseEntryPoint selector.
	aTestCaseEntryPoint lastResult hasPassed
		ifTrue: [	morph propagateColor: Color green].
	aTestCaseEntryPoint lastResult hasFailures
		ifTrue: [	morph propagateColor: Color yellow].
	aTestCaseEntryPoint lastResult hasErrors
		ifTrue: [	morph propagateColor: Color red].! !

STracer subclass: #SStateViewTracer
	instanceVariableNames: 'observedClass instVarName valueDict gatheredValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-StateView'!

!SStateViewTracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:07:53.882'!
onClass: aClass instVarName: aSymbol
	^ (super 
		on: SProject current 
		entryPoints: (SProject current allTestsAsEntryPoints))
		observedClass: aClass;
		instVarName: aSymbol;
		yourself! !

!SStateViewTracer methodsFor: 'wrapper events' stamp: 'mp 9/29/2010 22:41:40.35'!
addValue: anObject

	self gatheredValues add: anObject.! !

!SStateViewTracer methodsFor: 'running' stamp: 'mp 9/29/2010 22:45:30.73'!
endExecutionOf: anEntryPoint withResult: anObject

	self gatheredValues ifNotEmpty: [
		self valueDict 
			at: anEntryPoint
			put: self gatheredValues].
	self reset.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.161'!
gatheredValues
	"Answer the value of gatheredValues"

	^ gatheredValues! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.166'!
gatheredValues: anObject
	"Set the value of gatheredValues"

	gatheredValues := anObject! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:52:01.306'!
getWrapperClass

	^ SStateWrapper! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:23:25.775'!
getWrapperOn: aSelector inClass: aClass
	((aClass whichSelectorsAccess: self instVarName) includes: aSelector)
		ifTrue: [	^ self getWrapperClass on: aSelector inClass: aClass with: self]
		ifFalse: [^ nil]! !

!SStateViewTracer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 22:39:31.28'!
initialize
	super initialize.
	self valueDict: Dictionary new.
	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.497'!
instVarName
	"Answer the value of instVarName"

	^ instVarName! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.501'!
instVarName: anObject
	"Set the value of instVarName"

	instVarName := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.809'!
observedClass
	"Answer the value of observedClass"

	^ observedClass! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.814'!
observedClass: anObject
	"Set the value of observedClass"

	observedClass := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:47.398'!
reset

	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:58:58.701'!
selectedClasses

	^ {self observedClass}! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.472'!
valueDict
	"Answer the value of valueDict"

	^ valueDict! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.476'!
valueDict: anObject
	"Set the value of valueDict"

	valueDict := anObject! !

!SStateViewTracer methodsFor: 'public api' stamp: 'mp 9/30/2010 10:46:18.705'!
valuesAsSet
	| resultSet |
	resultSet := Set new.
	self valueDict valuesDo: [:coll | 
		coll do: [:each | resultSet add: each]].
	^ resultSet sorted! !

!STracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:11:13.983'!
on: aProject
	^ self on: aProject entryPoints: aProject allTestsAsEntryPoints! !

!STracer class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 13:49:56.027'!
on: aProject entryPoints: aCollection
	^ self new
		project: aProject;
		entryPoints: aCollection;
		yourself! !

!STracer methodsFor: 'accessing' stamp: 'mp 3/23/2011 16:38:36.756'!
activate
	self active: true.! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:00:52.702'!
active
	"Answer the value of active"

	^ active ifNil: [active := false]! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:59:23.159'!
active: anObject
	"Set the value of active"

	active := anObject! !

!STracer methodsFor: 'running' stamp: 'mp 7/12/2010 13:20:53.66'!
beginExecutionOf: anEntryPoint

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/12/2010 12:52:07.13'!
createWrapperOn: aClass and: aSelector
	| wrapper |
	wrapper := self getWrapperOn: aSelector inClass: aClass.
	wrapper 
		ifNotNil: [self wrappers add: wrapper.
				 wrapper install].! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 11/19/2010 20:11:43.228'!
createWrappers
	self selectedClasses do: [:klass | 
			klass selectors do: [:selector | 
				self createWrapperOn: klass and: selector].		
			klass class selectors do: [:selector | 
				self createWrapperOn: klass class and: selector]].! !

!STracer methodsFor: 'accessing' stamp: 'mp 3/23/2011 16:38:42.169'!
deactivate
	self active: false.! !

!STracer methodsFor: 'running' stamp: 'mp 7/12/2010 13:21:16.932'!
endExecutionOf: anEntryPoint withResult: anObject

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.746'!
entryPoints
	"Answer the value of entryPoints"

	^ entryPoints! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.75'!
entryPoints: anObject
	"Set the value of entryPoints"

	entryPoints := anObject! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/12/2010 13:33:44.599'!
getWrapperClass
	"Wrapper should be a subclass of SWrapper 
	otherwise overwrite #getWrapperOn:inClass:"
	^ SWrapper! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 16:07:00.628'!
getWrapperOn: aSelector inClass: aClass

	^ self getWrapperClass on: aSelector inClass: aClass with: self! !

!STracer methodsFor: 'testing' stamp: 'mp 7/12/2010 12:59:46.127'!
isActive

	^ self active! !

!STracer methodsFor: 'public api' stamp: 'mp 3/25/2011 11:55:58.04'!
pathFinderTool
	^ SPathFinder! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 12:45:26.775'!
postProcessing

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 12:44:53.329'!
preProcessing

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:49:11.915'!
project

	^ project! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:49:23.782'!
project: anObject
	"Set the value of project"

	project := anObject! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 14:36:10.856'!
removeWrappers

	self wrappers do: [:each | each uninstall].
	self wrappers: nil.
	Smalltalk garbageCollect.! !

!STracer methodsFor: 'public api' stamp: 'mp 9/29/2010 22:11:04.213'!
run
	
	[self 
		preProcessing;
		createWrappers;
		runEntryPoints] 
	ensure: [self removeWrappers].
	self postProcessing.! !

!STracer methodsFor: 'running' stamp: 'mp 11/19/2010 18:00:44.938'!
runEntryPoint: anEntryPoint
	| result |
	self beginExecutionOf: anEntryPoint.
	self startTracing.
	result := anEntryPoint execute.
	self stopTracing.
	self endExecutionOf: anEntryPoint withResult: result.! !

!STracer methodsFor: 'running' stamp: 'mp 11/19/2010 17:59:42.277'!
runEntryPoints
	| size |
	size := self entryPoints size.
	self entryPoints 
		do: [:each |	self runEntryPoint: each	] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', size asString, ' Entry Points.'].! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:48:03.01'!
selectedClasses

	^ self project allClasses! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 13:41:19.462'!
startTracing
	"Can be overwritten in subclasses"
	self active: true.! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 13:41:22.317'!
stopTracing
	"Can be overwritten in subclasses"
	self active: false.! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:42:26.035'!
wrappers
	"Answer the value of wrappers"

	^ wrappers ifNil: [wrappers := OrderedCollection new]! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.758'!
wrappers: anObject
	"Set the value of wrappers"

	wrappers := anObject! !

Object subclass: #STreeModel
	instanceVariableNames: 'selectedItem highlightedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Models'!

STreeModel subclass: #SCallgraphModel
	instanceVariableNames: 'rootNode currentNode history currentHistoryNode tracer searchQuery pathFinder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SCallgraphModel class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 12:46:16.783'!
on: aTracer

	^ self on: aTracer pathFinder: nil! !

!SCallgraphModel class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 12:45:54.853'!
on: aTracer pathFinder: aPathFinder

	^ self new
		tracer: aTracer;
		pathFinder: aPathFinder.! !

!SCallgraphModel methodsFor: 'history' stamp: 'mp 1/25/2010 16:19'!
addToHistory: aNode

	aNode ifNotNil: [
		(self history notEmpty and: [((self history at: self currentHistoryNode) id = aNode id)])
			ifTrue: [^ self].			
		(self history size = self currentHistoryNode) not
			ifTrue: [self history: (self history copyUpTo: (self history at: self currentHistoryNode + 1))].
		self history add: aNode.
		self currentHistoryNode: self history size].
	self refreshHistoryButtons.! !

!SCallgraphModel methodsFor: 'menu' stamp: 'mp 4/15/2010 13:03'!
browseMethod

	self hasSelectedItem 
		ifTrue:[^ Browser fullOnClass: self selectedItem clientClass 
					       selector: self selectedItem clientSelector]! !

!SCallgraphModel methodsFor: 'menu' stamp: 'mp 3/4/2010 14:50'!
callGraphMenu: aMenu

	^ aMenu
		title: 'Node and Tree Actions';
		add: 'Browse' action: #browseMethod;
		add: 'Debug' action: #debugMethod;
		addLine;
		add: 'Expand Tree' action: #expandSelectedNode;
		yourself.! !

!SCallgraphModel methodsFor: 'searching' stamp: 'mp 1/16/2010 18:42'!
clearHighlighting

	self highlightedItems: nil! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/15/2010 14:52'!
currentHistoryNode
	^ currentHistoryNode! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/15/2010 14:52'!
currentHistoryNode: anObject
	currentHistoryNode := anObject! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/3/2010 13:45'!
currentNode
	^ currentNode! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/3/2010 13:45'!
currentNode: anObject
	currentNode := anObject! !

!SCallgraphModel methodsFor: 'menu' stamp: 'mp 1/25/2010 16:44'!
debugMethod

	self hasSelectedItem ifTrue: [self tracer debugAt: self selectedItem].! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/29/2010 10:32'!
expandNode: aNode

	aNode setAsCurrentSelection.
	self changed: #expandAllOfSelectedNode.! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/29/2010 10:15'!
expandRootNode

	self expandNode: self rootNode.! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 3/4/2010 14:46'!
expandSelectedNode

	self selectedItem
		ifNil: [self expandNode: self rootNode]
		ifNotNil: [self expandNode: self selectedItem]
	! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/3/2010 14:59'!
findNodeInSubGraph: aNumber startNode: aNode

	| lastNode |
	aNode nextCalls do: [:each | 
		each id = aNumber ifTrue: [^ each].
		each id < aNumber ifTrue: [lastNode := each].
		each id > aNumber ifTrue: [
			lastNode	ifNotNil: [^ self findNodeInSubGraph: aNumber startNode: lastNode]]].
	lastNode ifNotNil: [^ self findNodeInSubGraph: aNumber startNode: lastNode].
	^ nil! !

!SCallgraphModel methodsFor: 'spec commands' stamp: 'mp 1/3/2010 15:09'!
getChildren: aNode

	^ aNode nextCalls! !

!SCallgraphModel methodsFor: 'spec commands' stamp: 'mp 3/25/2011 14:40:30.034'!
getIcon: aCallNode
	| icon color |	
	color := self pathFinder coverageTracer 
				ifNotNil: [:tracer | 
					tracer getColorFromMapFor: (MethodReference 
													class: aCallNode clientClass 
													selector: aCallNode clientSelector)].
	(color isNil or: [color = Color white]) ifTrue: [^ nil].
	icon := Form extent: 15@15 depth: 32.
	icon fillColor: color.
	^ icon! !

!SCallgraphModel methodsFor: 'searching' stamp: 'mp 3/4/2010 13:57'!
getSearchQuery

	self searchQuery ifNil: [^ ''].
	^ self searchQuery! !

!SCallgraphModel methodsFor: 'spec commands' stamp: 'mp 3/1/2010 17:39'!
getSelectedPath

	^ self selectedItem getCallStack! !

!SCallgraphModel methodsFor: 'spec commands' stamp: 'mp 1/3/2010 15:10'!
hasChildren: aNode

	aNode ifNil: [^ false].
	^ aNode nextCalls notEmpty! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/15/2010 13:25'!
history
	^ history! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/15/2010 13:25'!
history: anObject
	history := anObject! !

!SCallgraphModel methodsFor: 'history' stamp: 'mp 1/15/2010 16:01'!
historyBack

	self currentHistoryNode: self currentHistoryNode - 1.
	(self history at: self currentHistoryNode) setAsCurrentSelection.
	self refreshHistoryButtons.! !

!SCallgraphModel methodsFor: 'history' stamp: 'mp 1/15/2010 15:12'!
historyBackButtonEnabled

	^ (self currentHistoryNode <= 1) not! !

!SCallgraphModel methodsFor: 'history' stamp: 'mp 1/15/2010 16:01'!
historyPrevious

	self currentHistoryNode: self currentHistoryNode + 1.
	(self history at: self currentHistoryNode) setAsCurrentSelection.
	self refreshHistoryButtons.! !

!SCallgraphModel methodsFor: 'history' stamp: 'mp 1/15/2010 15:10'!
historyPreviousButtonEnabled

	^ self history notEmpty and: [(self currentHistoryNode = self history size) not]! !

!SCallgraphModel methodsFor: 'initialize-release' stamp: 'mp 1/25/2010 13:29'!
initialize
	
	self reset.! !

!SCallgraphModel methodsFor: 'spec commands' stamp: 'mp 1/15/2010 13:28'!
newSelectedItem: aNode

	self
		selectedItem: aNode;
		addToHistory: aNode;
		changed: aNode.! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/8/2010 16:09'!
numberOfCallsBefore: aCallNode

	| numberOfCallsBefore |
	numberOfCallsBefore := 0.
	self traverseCallGraph: self rootNode 
		with: [:aNode | 
			((aNode clientClass == aCallNode clientClass) and: 
			[aNode clientSelector == aCallNode clientSelector])
				ifTrue: [
					aNode id < aCallNode id 
						ifTrue: [numberOfCallsBefore := numberOfCallsBefore + 1]]]
		abort: [:aNode | aNode id > aCallNode id].
	^ numberOfCallsBefore! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/25/2011 12:45:31.191'!
pathFinder
	"Answer the value of pathFinder"

	^ pathFinder! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/25/2011 12:45:31.196'!
pathFinder: anObject
	"Set the value of pathFinder"

	pathFinder := anObject! !

!SCallgraphModel methodsFor: 'printing' stamp: 'mp 10/31/2010 12:19:32.481'!
printInfosForNode: aCallNode

	"template method for printing additional information from the entire graph"
	^ ''! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/3/2010 14:21'!
refresh

	self changed: #rootCallNodes.! !

!SCallgraphModel methodsFor: 'history' stamp: 'mp 1/15/2010 16:00'!
refreshHistoryButtons

	self
		changed: #historyBackButtonEnabled;
		changed: #historyPreviousButtonEnabled.! !

!SCallgraphModel methodsFor: 'initialize-release' stamp: 'mp 3/4/2010 13:10'!
reset
	
	self 
		rootNode: nil;
		currentNode: nil;
		history: OrderedCollection new;
		currentHistoryNode: 0;
		newSelectedItem: nil;
		highlightedItems: nil.! !

!SCallgraphModel methodsFor: 'spec commands' stamp: 'mp 3/1/2010 17:41'!
rootCallNodes

	self rootNode ifNil: [^ ''].
	^ {self rootNode}! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/3/2010 13:45'!
rootNode
	^ rootNode! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/3/2010 13:45'!
rootNode: anObject
	rootNode := anObject! !

!SCallgraphModel methodsFor: 'searching' stamp: 'mp 3/9/2010 14:29'!
searchNode: aText

	| foundedNodes |
	self clearHighlighting.
	self rootNode ifNotNil: [
		self searchQuery: aText asString.
		foundedNodes := OrderedCollection new.
		self traverseCallGraph: self rootNode 
			with: [:aNode | (aNode asString includesSubString: self searchQuery) 
							ifTrue: [foundedNodes add: aNode]].
		self 
			highlightedItems: foundedNodes;
			changed: #highlightItem:;
			selectNextSearchResult: foundedNodes.
		^ foundedNodes]
	! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/4/2010 13:56'!
searchQuery
	"Answer the value of searchQuery"

	^ searchQuery! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/4/2010 13:56'!
searchQuery: anObject
	"Set the value of searchQuery"

	searchQuery := anObject! !

!SCallgraphModel methodsFor: 'searching' stamp: 'mp 3/4/2010 13:27'!
selectNextSearchResult: aCollection
	| nextSearchNode |
	aCollection ifEmpty: [^ self].
	self selectedItem 
		ifNil: [nextSearchNode := aCollection first]
		ifNotNil: [nextSearchNode := aCollection 
									detect: [:each | each id > self selectedItem id] 
									ifNone: [aCollection first]].
	nextSearchNode setAsCurrentSelection.! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/4/2010 15:51'!
startingCallNodes

	^ self rootNode nextCalls! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/18/2010 17:23'!
tracer
	^ tracer! !

!SCallgraphModel methodsFor: 'accessing' stamp: 'mp 1/18/2010 17:23'!
tracer: anObject
	tracer := anObject! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/4/2010 15:44'!
traverseCallGraph: aNode with: aBlock
	"Prefix Order"
	aNode nextCalls do: [:each | 
		aBlock value: each.
		self traverseCallGraph: each with: aBlock].! !

!SCallgraphModel methodsFor: 'graph functions' stamp: 'mp 1/8/2010 16:00'!
traverseCallGraph: aNode with: aBlock abort: anotherBlock
	"Prefix Order"
	aNode nextCalls do: [:each | 
		aBlock value: each.
		(anotherBlock value: each) 
			ifFalse: [self traverseCallGraph: each with: aBlock abort: anotherBlock]].! !

SCallgraphModel subclass: #SDebuggerCallgraphModel
	instanceVariableNames: 'suspiciousMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Debugger'!

!SDebuggerCallgraphModel methodsFor: 'icons' stamp: 'mp 3/25/2011 12:18:12.702'!
getIcon: aCallNode
	| icon suspiciousMethod |
	suspiciousMethod := self getSuspiciousnessAndConfidenceFor: aCallNode.
	suspiciousMethod ifNil: [^ nil].
	icon := Form extent: 15@15 depth: 32.
	icon fillColor: (Color 
					h: (1.0 - suspiciousMethod value first) * 120 
					s: suspiciousMethod value second 
					v: 1.0).
	^ icon! !

!SDebuggerCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/25/2011 12:25:43.124'!
getSuspiciousnessAndConfidenceFor: aCallNode
	| methodRef |
	methodRef := MethodReference 
					class: aCallNode clientClass selector: aCallNode clientSelector.
	^ self suspiciousMethods 
		detect: [:each | each key = methodRef] 
		ifNone: [nil].! !

!SDebuggerCallgraphModel methodsFor: 'printing' stamp: 'mp 10/31/2010 13:28:51.743'!
printInfosForNode: aCallNode
	| suspiciousMethod |
	suspiciousMethod := self getSuspiciousnessAndConfidenceFor: aCallNode.
	suspiciousMethod ifNil: [^ ''].
	^  '{', (suspiciousMethod value first * 100) asInteger asString, '%} '! !

!SDebuggerCallgraphModel methodsFor: 'searching' stamp: 'mp 10/31/2010 12:56:29.143'!
searchNode: aText
	| query |
	"Allows search queries such as {> 90 meaning all suspicious methods 
	with a value larger than 90 %"
	query := aText asString splitInteger.
	query first withBlanksTrimmed caseOf: {
	['{>'] -> [^ self searchSuspiciousNodes: query second operator: #>].
	['{<'] -> [^ self searchSuspiciousNodes: query second operator: #<].
	['{='] -> [^ self searchSuspiciousNodes: query second operator: #=].
	}
	otherwise: [^ super searchNode: aText].
	! !

!SDebuggerCallgraphModel methodsFor: 'searching' stamp: 'mp 10/31/2010 13:01:27.976'!
searchSuspiciousNodes: aNumber operator: aSymbol
	| foundedNodes nodeString |
	self clearHighlighting.
	self rootNode ifNotNil: [
		foundedNodes := OrderedCollection new.
		self traverseCallGraph: self rootNode 
			with: [:aNode | 
				nodeString := aNode asString.
				((nodeString first = ${) and: 
					[nodeString splitInteger second perform: aSymbol with: aNumber])
						ifTrue: [foundedNodes add: aNode]].
		self 
			highlightedItems: foundedNodes;
			changed: #highlightItem:;
			selectNextSearchResult: foundedNodes.
		^ foundedNodes].! !

!SDebuggerCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/25/2011 12:47:47.326'!
suspiciousMethods
	"Answer the value of suspiciousMethods"

	^ suspiciousMethods ifNil: [suspiciousMethods := 
								self pathFinder coverageTracer mostSuspiciousMethods]! !

!SDebuggerCallgraphModel methodsFor: 'accessing' stamp: 'mp 3/25/2011 12:25:31.106'!
suspiciousMethods: anObject
	"Set the value of suspiciousMethods"

	suspiciousMethods := anObject! !

!STreeModel methodsFor: 'public api' stamp: 'mp 12/11/2009 13:56'!
clearHighlightedItems

	self highlightedItems: nil.
	self changed: #highlightItem:.! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 14:07'!
getChildren: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 13:57'!
getIcon: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'private' stamp: 'mp 12/11/2009 13:58'!
getIconWithColor: aColor

	^ (Form extent: 10@10 depth: 32)
				fillColor: aColor! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 14:07'!
hasChildren: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 1/13/2010 19:06'!
hasSelectedItem

	^ self selectedItem notNil! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 13:59'!
highlightItem: aNode

	^ self highlightedItems includes: aNode! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
highlightedItems
	^ highlightedItems ifNil: [highlightedItems := Set new]! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
highlightedItems: anObject
	highlightedItems := anObject! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 1/21/2010 11:15'!
newSelectedItem: aNode

	self selectedItem: aNode.! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
selectedItem
	^ selectedItem! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
selectedItem: anObject
	selectedItem := anObject! !

Object subclass: #Subject
	instanceVariableNames: 'observers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

Subject subclass: #ClockTimer
	instanceVariableNames: 'hour minute second'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
hour
	"Answer the value of hour"

	^ hour! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
hour: anObject
	"Set the value of hour"

	hour := anObject! !

!ClockTimer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 15:06:34.806'!
initialize
	| time |
	super initialize.
	time := Time midnight.
	hour := time hour.
	minute := time minute.
	second := time second.! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
minute
	"Answer the value of minute"

	^ minute! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
minute: anObject
	"Set the value of minute"

	minute := anObject! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
second
	"Answer the value of second"

	^ second! !

!ClockTimer methodsFor: 'accessing' stamp: 'fg 4/12/2010 15:22'!
second: anObject
	"Set the value of second"

	second := anObject! !

!ClockTimer methodsFor: '-- all --' stamp: 'mp 4/28/2010 13:55'!
tick
	"update internal time-keeping state"
	| time |
	time := (Time hour: hour minute: minute second: second) addSeconds: 1.
	hour := time hour.
	minute := time minute.
	second := time second.
	self notify.! !

!Subject methodsFor: 'observation' stamp: 'fg 4/12/2010 15:14'!
attach: anObserver
	observers add: anObserver! !

!Subject methodsFor: 'observation' stamp: 'fg 4/12/2010 15:15'!
detach: anObserver
	observers remove: anObserver! !

!Subject methodsFor: 'initialize-release' stamp: 'fg 4/12/2010 15:14'!
initialize
	observers := OrderedCollection new! !

!Subject methodsFor: 'observation' stamp: 'mp 4/28/2010 13:32'!
notify
	observers do: [ :obs | obs update: self ].! !

PluggableTreeItemNode subclass: #SPluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableTreeItemNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:23'!
highlightingColor

	^ Color r: 110 / 256.0 g: 127 / 256.0 b: 223 / 256.0! !

PluggablePanelSpec subclass: #SPluggableFlapSpec
	instanceVariableNames: 'icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Specs'!

!SPluggableFlapSpec methodsFor: 'building' stamp: 'mp 9/13/2010 14:57:47.442'!
buildWith: builder
	^ builder buildPluggableFlap: self.! !

!SPluggableFlapSpec methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:54:11.991'!
icon
	"Answer the value of icon"

	^ icon! !

!SPluggableFlapSpec methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:54:11.995'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!Morph methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:00'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	self lock! !

!Morph methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:00'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	self unlock! !

!Morph methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:05'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Answer the system window.
	Restore the original keyboard focus when closed."

	|area mySysWin keyboardFocus|
	keyboardFocus := self activeHand keyboardFocus.
	mySysWin := self isSystemWindow ifTrue: [self] ifFalse: [self ownerThatIsA: SystemWindow].
	mySysWin ifNil: [mySysWin := self].
	mySysWin modalLockTo: aSystemWindow.
	area := RealEstateAgent maximumUsableArea.
	self class environment at: #Flaps ifPresent: [:cl |
		RealEstateAgent reduceByFlaps: area].
	aSystemWindow extent: aSystemWindow initialExtent.
	aSystemWindow position = (0@0)
		ifTrue: [aSystemWindow
				position: self activeHand position - (aSystemWindow extent // 2)].
	aSystemWindow
		bounds: (aSystemWindow bounds translatedToBeWithin: area).
	[ToolBuilder default runModal: aSystemWindow openAsIs]
		ensure: [mySysWin modalUnlockFrom: aSystemWindow.
				self activeHand newKeyboardFocus: keyboardFocus].
	^aSystemWindow! !

!Morph methodsFor: '*SightL' stamp: 'mp 1/25/2010 13:05'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean"
	(extension isNil and:[aBoolean]) ifTrue: [^ self].
	self visible == aBoolean ifTrue: [^ self].
	self assureExtension visible: aBoolean.
	self changed.
	owner ifNotNil: [owner layoutChanged]. "Changed for 3.9 compatibility and forward events again after hiding"! !

Morph subclass: #SClassViewMorph
	instanceVariableNames: 'klass menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SClassViewMorph class methodsFor: 'constants' stamp: 'mp 1/22/2011 19:07:08.403'!
backgroundColor

	^ Color white! !

!SClassViewMorph class methodsFor: 'constants' stamp: 'mp 1/7/2011 16:56:05.617'!
borderColor

	^ Color gray: 0.5! !

!SClassViewMorph class methodsFor: 'constants' stamp: 'mp 1/7/2011 16:35:44.016'!
borderWidth

	^ 0! !

!SClassViewMorph class methodsFor: 'instance creation' stamp: 'mp 1/22/2011 17:29:21.926'!
on: aClass
	| morph |
	morph := self new.
	morph klass: aClass.
	morph initializeClassMorphs.
	^ morph! !

!SClassViewMorph methodsFor: 'menu' stamp: 'mp 1/26/2011 10:00:42.224'!
addMenuMorphOn: anEntryMorph
	self menuMorph: (SPVMenuMorph on: anEntryMorph).
	self menuMorph targetMorph addMorph: self menuMorph.! !

!SClassViewMorph methodsFor: 'initialization' stamp: 'mp 1/25/2011 17:34:24.676'!
initialize
	super initialize.
	self 
		color: self class backgroundColor;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		layoutInset: 5.! !

!SClassViewMorph methodsFor: 'initialization' stamp: 'mp 1/25/2011 20:02:42.037'!
initializeClassLabel
	self addMorph: (SClassEntryMorph label: self klass asString on: self).! !

!SClassViewMorph methodsFor: 'initialization' stamp: 'mp 1/15/2011 19:34:37.197'!
initializeClassMorphs
	self 
		initializeClassLabel;
		initializeInstanceVariablesMorph;
		initializeMethodCategoriesMorph.
		.! !

!SClassViewMorph methodsFor: 'initialization' stamp: 'mp 1/25/2011 21:11:17.818'!
initializeInstanceVariablesMorph
	self addMorphBack: (SStateEntryMorph 
							label: self klass instVarNames size asString, ' Variables'
							on: self).! !

!SClassViewMorph methodsFor: 'initialization' stamp: 'mp 1/25/2011 21:15:39.249'!
initializeMethodCategoriesMorph
	self addMorphBack: (SBehaviorEntryMorph 
						label: self klass organization categories size asString, ' Categories'
						on: self).! !

!SClassViewMorph methodsFor: 'accessing' stamp: 'mp 1/7/2011 16:19:04.521'!
klass
	"Answer the value of klass"

	^ klass! !

!SClassViewMorph methodsFor: 'accessing' stamp: 'mp 1/7/2011 16:19:04.526'!
klass: anObject
	"Set the value of klass"

	klass := anObject! !

!SClassViewMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 17:37:05.618'!
menuMorph
	"Answer the value of menuMorph"

	^ menuMorph! !

!SClassViewMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 17:37:05.623'!
menuMorph: anObject
	"Set the value of menuMorph"

	menuMorph := anObject! !

!SClassViewMorph methodsFor: 'menu' stamp: 'mp 1/25/2011 19:37:59.834'!
menuMorphFor: anEntryMorph
	self menuMorph
		ifNil: [self addMenuMorphOn: anEntryMorph]
		ifNotNil: [self menuMorph targetMorph == anEntryMorph
				ifTrue: [self removeMenuMorph]
				ifFalse: [self 
						removeMenuMorph;
						addMenuMorphOn: anEntryMorph]]! !

!SClassViewMorph methodsFor: 'menu' stamp: 'mp 1/26/2011 10:01:30.119'!
removeMenuMorph
	self menuMorph targetMorph removeMorph: self menuMorph.
	self menuMorph abandon.
	self menuMorph: nil! !

!TheWorldMainDockingBar methodsFor: '*SightL' stamp: 'mp 3/7/2011 22:30:43.501'!
pathMenuItemsOn: aMenu
	"TheWorldMainDockingBar updateInstances"
	aMenu addLine.
	aMenu 
		addItem: [:item | 
		item 
			contents: 'PathProjects';
			help: 'Open the control panel for managing Path source code projects';
			icon: (self colorIcon: Color lightGray);
			target: SProjectChooser;
			selector: #open];
		addItem: [:item | 
		item 
			contents: 'PathBrowser';
			help: 'Open the specific Path Browser instead of the standard system browser.';
			icon: (self colorIcon: Color lightGray);
			target: SBrowser;
			selector: #open];
		addItem: [:item | 
		item 
			contents: 'PathFinder';
			help: 'Open PathFinder to explore the behavior of the system';
			icon: (self colorIcon: Color lightGray);
			target: SPathFinder;
			selector: #open];
		addItem: [:item | 
		item 
			contents: 'PathMap';
			help: 'Open PathMap to explore multiple behavioral paths through the system';
			icon: (self colorIcon: Color lightGray);
			target: SPathMapTestRunner;
			selector: #open];
		addItem: [:item | 
		item 
			contents: 'PathView';
			help: 'Open PathView to explore the structural system enhanced by dynamic information';
			icon: (self colorIcon: Color lightGray);
			target: SPathView;
			selector: #open].! !

!TheWorldMainDockingBar methodsFor: '*SightL-override' stamp: 'mp 3/7/2011 22:30:34.111'!
toolsMenuOn: aDockingBar 

	aDockingBar addItem: [ :item |
		item
			contents: 'Tools' translated;
			addSubMenu: [ :menu | 
				self
					browserMenuItemOn: menu;
					workspaceMenuItemOn: menu;
					transcriptMenuItemOn: menu;
					testRunnerMenuItemOn: menu.
				menu addLine.
				self 
					monticelloBrowserMenuItemOn: menu;
					monticelloConfigurationsMenuItemOn: menu;
					simpleChangeSorterMenuItemOn: menu;
					dualChangeSorterMenuItemOn: menu.
				menu addLine.
				self
					processBrowserMenuItemOn: menu;
					preferenceBrowserMenuItemOn: menu;
					fileListMenuItemOn: menu.
				self pathMenuItemsOn: menu.
			] ]! !

!Behavior methodsFor: '*SightL' stamp: 'mp 1/25/2010 10:26'!
classAndMethodFor: aSymbol do: binaryBlock ifAbsent: absentBlock
	"Looks up the selector aSymbol in the class chain. If it is found, binaryBlock is evaluated
	with the class that defines the selector and the associated method. Otherwise
	absentBlock is evaluated."

	| method |
	self withAllSuperclassesDo: [:class |
		method := class compiledMethodAt: aSymbol ifAbsent: [nil].
		method ifNotNil: [^ binaryBlock value: class value: method].
	].
	^ absentBlock value.! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 9/19/2010 16:24:44.577'!
authors
	self changes ifNil: [^ nil].
	^ (self changes collect: [:each | each first]) asSet asSortedCollection! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 9/29/2010 10:29:36.204'!
changes
	| versions subStrings |
	versions := self versions.
	versions ifNil: [^ nil].
	^ versions changeList collect: [:each | 
		each stamp
			ifEmpty: [{'Unknown'. TimeStamp now}]
			ifNotEmpty: [subStrings := (each stamp subStrings: String space).
		{subStrings first. ((subStrings second, ' ', subStrings third) asTimeStamp)}]]! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 9/19/2010 16:46:54.024'!
complexity
	| type complexity |
	complexity := self startpcsToBlockExtents keys size.
	self initialPC to: self endPC 
		do: [:each | 
			type := (self at: each) // 16.
			(type = 10 or: [type = 9])
				ifTrue: [complexity := complexity + 1]].
	^ complexity! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 9/20/2010 09:49:28.184'!
lastChange
	self changes ifNil: [^ nil].
	^ self changes first! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 7/7/2010 17:01:32.664'!
methodNode
	"Return the parse tree that represents self"

	| source |
	"Fix for debugging OMeta"
	(self methodClass inheritsFrom: OMeta2) ifTrue: [^ self decompile].
	SBreakpointManager installedNodes at: self ifPresent: [:node | ^ node].
	^ (source := self getSourceFromFile)
		ifNil: [self decompile]
		ifNotNil: [self parserClass new 
					parse: source 
					class: (self methodClass ifNil: [self sourceClass])]! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 9/20/2010 10:45:07.292'!
numberOfVariableAccess
	| access type offset skipNextByte |
	access := 0.
	skipNextByte := false.
	(self isQuick and: [self isReturnSpecial not]) ifTrue: [^ 1].
	self initialPC to: self endPC 
		do: [:each | 
			skipNextByte 
				ifTrue: [skipNextByte := false]
				ifFalse: [
			type := (self at: each) // 16.
			type = 0
				ifTrue: ["Read instance variable"
						access := access + 1].
			type = 1
				ifTrue: ["Read temporary variable"
						access := access + 1].	
			(type = 4 or: [type = 5])
				ifTrue: ["Read literal variable (class variable)"
						access := access + 1].	
			type = 6
				ifTrue: ["Pop receiver or temporary variable"
						access := access + 1].									
			type = 8
				ifTrue: ["Extended read/write for receiver, temporary and class variables"
						offset := (self at: each) \\ 16. 
						offset = 0
							ifTrue: ["read variables"
								access := access + 1].
						offset = 2
							ifTrue: ["write variables"
								access := access + 1].							
						].
			(type = 8 or: [type = 10])
				ifTrue: [skipNextByte := true]]].
	^ access! !

!CompiledMethod methodsFor: '*SightL' stamp: 'mp 9/19/2010 16:11:23.367'!
versions
	^ VersionsBrowser new
			scanVersionsOf: self 
			class: self methodClass 
			meta: self methodClass isMeta
			category: nil 
			selector: self selector.! !

!ContextPart methodsFor: '*SightL' stamp: 'mp 11/5/2010 13:52:09.08'!
runSimulatedMethodOnly: aBlock contextAtEachStep: block2
	| current |
	aBlock hasMethodReturn
		ifTrue: [self error: 'simulation of blocks with ^ can run loose'].
	current := aBlock asContext.
	current pushArgs: Array new from: self.
	[current == self]
		whileFalse:
			[(current sender receiver class inheritsFrom: MwMethodWrapper)
					ifTrue: [current := current step] "Ignore byte codes of method wrappers"
					ifFalse: [block2 value: current.
						 	current := current quickStep]].
	^self pop! !

TestRunner subclass: #SPathMapTestRunner
	instanceVariableNames: 'windowMorph pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SPathMapTestRunner class methodsFor: 'initialization' stamp: 'mp 7/8/2010 18:34:13.166'!
initialize
	"self initialize"
	self registerInWorldMenu.! !

!SPathMapTestRunner class methodsFor: 'initialization' stamp: 'mp 3/7/2011 21:49:49.479'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'PathMap' 
			with: (Array
				with: self
				with: #open)) ].! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/21/2010 13:51:38.749'!
addColorLegendOn: aModel to: aSymbol inFrame: aRectangle
	| flap colorLegend |
	flap := self getFlap: aSymbol.
	colorLegend := SColorLegendMorph on: aModel.
	aModel 
		colorLegend: colorLegend;
		refreshColorLegend.
	self setFrame: aRectangle in: colorLegend.
	flap addMorph: colorLegend.
	colorLegend hide.

! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/16/2010 13:28:46.221'!
addDropDownSelectionListTo: aSym on: aModel with: aColl inFrame: aRect
	| flap dropDownList |
	flap := self getFlap: aSym.
	dropDownList := SDropDownMorph on: aModel with: aColl.
	flap addMorph: dropDownList.
	self setFrame: aRect in: dropDownList.
	dropDownList 
		cornerStyle: #rounded;
		hResizing: #rigid;
		hide.! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/23/2010 16:09:34.338'!
addTitle: aString toFlap: aSymbol inFrame: aRectangle
	| title flap |
	flap := self getFlap: aSymbol.
	title := SLabelMorph label: aString.	
	self setFrame: aRectangle in: title.
	flap addMorph: title.
	title 
		hResizing: #rigid;
		width: 150; "ToDo: Change this hard value!!"
		hide.

! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 1/20/2010 15:29'!
alwaysEnabled

	^ true! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 3/15/2010 17:02'!
buildButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self buttons collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/22/2010 18:18:04.259'!
buildCustomMorphs

	self 
		buildPathMapMorphFrame: (0.224 @ 0.045 corner: 0.996 @ 0.944);
		buildTestQualityFlapCustomMorphs;
		buildTraceabilityFlapCustomMorphs;
		buildFaultLocalizationFlapCustomMorphs;
		buildProfilingFlapCustomMorphs;
		buildOptionsFlapCustomMorphs.! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 10/31/2010 10:02:10.841'!
buildFaultLocalizationFlapCustomMorphs
	| id options |
	id := #faultLocalization.
	options := self pathMap options at: id.
	self 
		addTitle: 'Fault Localization' 
			toFlap: id 
			inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.0825);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.19 corner: 1.0 @ 0.725);
		addDropDownSelectionListTo: id
			on: options
			with: {{'Ochiai'. #setFormula:. {#ochiai}}.
				   {'Tarantula'. #setFormula:. {#tarantula}}.
				   {'Jaccard'. #setFormula:. {#jaccard}}}
			inFrame: (0.0 @ 0.09 corner: 1.0 @ 0.18).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/24/2011 16:20:18.894'!
buildFaultLocalizationFlapWith: aBuilder
	| id |
	id := #faultLocalization.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository ladybugIconLarge;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.73 corner: 1.0 @ 0.821);
					label: 'Single Fault';
					action: #switchSinglePointOfFault;
					state: #singlePointOfFault;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.821 corner: 1.0 @ 0.912);
					label: 'Highscore';
					action: #showHighscore;
					yourself ).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.912 corner: 1.0 @ 1.0);
					label: 'Developer Ranking';
					action: #authorRanking;
					yourself ).
				};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/23/2010 16:14:41.766'!
buildOptionsFlapCustomMorphs
	self 
		addTitle: 'Global Options' 
		toFlap: #globalOptions 
		inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.19).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/24/2011 16:19:47.222'!
buildOptionsFlapWith: aBuilder
	| id |
	id := #globalOptions.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository worldIconLarge;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.2 corner: 1.0 @ 0.4);
				label: 'Show Meth. Categories';
				action: #switchShowMethodCategories;
				state: #showMethodCategories;
				yourself).
				(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.4 corner: 1.0 @ 0.6);
				label: 'Show Quick Methods';
				action: #switchShowQuickAndAccessorMethods;
				state: #showQuickAndAccessorMethods;
				yourself ).
				(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.6 corner: 1.0 @ 0.8);
				label: 'Ignore Setup Code';
				action: #switchIgnoreTracingOfSetUpAndTearDownMethods;
				state: #ignoreTracingOfSetUpAndTearDownMethods;
				yourself ).
				(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.8 corner: 1.0 @ 1.0);
				label: 'Visualize Inter-Steps';
				action: #switchVisualizeIntermediateSteps;
				state: #visualizeIntermediateSteps;
				yourself )};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 7/9/2010 15:14:05.901'!
buildPathMapMorphFrame: aRectangle

	self setFrame: aRectangle in: self pathMap rootMorph.
	self windowMorph addMorph: self pathMap rootMorph.! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 10/31/2010 09:50:42.58'!
buildPluggableMorphsOn: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; 
		label: self label; 
		extent: self extent;
		children: (OrderedCollection new 		
			add: ((self buildClassesWith: aBuilder)
				frame: (0.0 @ 0.00 corner: 0.22 @ 0.825 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.22 @ 0.00 corner: 1.00 @ 0.04);
				yourself);
			add: ((self buildProjectStatisticWith: aBuilder)
				frame: (0.22 @ 0.946 corner: 1.00 @ 1.00);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.825 corner: 0.22 @ 1.00);
				yourself);
			add: ((self buildTestQualityFlapWith: aBuilder)
				frame: (1.0 @ 0.0 corner: 1.3 @ 0.55);
				yourself);
			add: ((self buildTraceabilityFlapWith: aBuilder)
				frame: (1.0 @ 0.054 corner: 1.3 @ 0.654);
				yourself);
			add: ((self buildFaultLocalizationFlapWith: aBuilder)
				frame: (1.0 @ 0.115 corner: 1.3 @ 0.665);
				yourself);
			add: ((self buildProfilingFlapWith: aBuilder)
				frame: (1.0 @ 0.176 corner: 1.3 @ 0.676);
				yourself);
			add: ((self buildOptionsFlapWith: aBuilder)
				frame: (1.0 @ 0.237 corner: 1.3 @ 0.487);
				yourself);																
			yourself);
		yourself.
	self windowMorph: (aBuilder build: window).
	^ self windowMorph! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/23/2010 10:36:37.463'!
buildProfilingFlapCustomMorphs
	| id options |
	id := #profiling.
	options := self pathMap options at: id.	
	self 
		addTitle: '  Profiling  ' toFlap: #profiling inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.09);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.305 corner: 1.0 @ 0.895);
		addDropDownSelectionListTo: id
			on: options
			with: {{'Method Calls'. #setKindOfProfiling:. {#numberOfMethodCalls}}.
				   {'Instances Count'. #setKindOfProfiling:. {#numberOfInstances}}.
				   {'Run-time'. #setKindOfProfiling:. {#runtime}}.
				   {'Run-time per Call'. #setKindOfProfiling:. {#runtimePerCall}}}
			inFrame: (0.0 @ 0.1 corner: 1.0 @ 0.1975).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/24/2011 16:20:06.125'!
buildProfilingFlapWith: aBuilder
	| id |
	id := #profiling.
	^ aBuilder pluggableFlapSpec new
		name: #profiling;
		icon: SImageRepository stopwatchIconLarge;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.2 corner: 1.0 @ 0.2975);
				label: 'Run-time Intent'; "ToDo wie heisst das genau?"
				action: #switchIntentRuntime;
				state: #intentRuntime;
				enabled: #isRuntimeProfilingSelected;
				yourself).
				(aBuilder pluggableButtonSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.8975 corner: 1.0 @ 1.0);
				label: 'Highscore';
				action: #showHighscore;
				yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 7/8/2010 18:13:25.231'!
buildProjectStatisticWith: aBuilder

	^ aBuilder pluggableInputFieldSpec new
		model: self pathMap;
		getText: #projectStatisticText;
		yourself.! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 10/26/2010 11:31:17.043'!
buildTestQualityFlapCustomMorphs
	| id options |
	id := #testQuality.
	options := self pathMap options at: id.
	self 
		addTitle: 'Test Quality' toFlap: id inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.08);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.28 corner: 1.0 @ 0.805);
		addDropDownSelectionListTo: id
			on: options
			with: {'No Static Metric' -> #staticMetricNone. 
				   'Authors' -> #staticMetricAuthors.
				   'Last Changes' -> #staticMetricLastChanges.
				   'Lines of Code' -> #staticMetricLinesOfCode.
				   'Complexity' -> #staticMetricComplexity.
				   'Variables Access' -> #staticMetricAccessedVariables.}
			inFrame: (0.0 @ 0.09 corner: 1.0 @ 0.18)		
	

! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/24/2011 16:20:12.958'!
buildTestQualityFlapWith: aBuilder
	| id |
	id := #testQuality.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SImageRepository qualityIconLarge;
		model: self;
"		layout: #vertical;"
		children: {
				(aBuilder pluggableButtonSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.185 corner: 1.0 @ 0.27);
				label: 'Sort Methods by Metric';
				action: #sortMethodsToStaticMetric;
				enabled: #sortMethodsIsEnabled;
				yourself ).
				(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.81 corner: 1.0 @ 0.905);
				label: 'Intensity Coverage';
				action: #switchIntensityCoverage;
				state: #intensityCoverageEnabled;
				yourself ).
				(aBuilder pluggableCheckBoxSpec new
				model: (self pathMap options at: id); 
				frame: (0.0 @ 0.905 corner: 1.0 @ 1.0);
				label: 'Show Test Results';
				action: #switchShowTestResults;
				state: #showTestResults;
				yourself )};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/22/2010 10:56:56.202'!
buildTraceabilityFlapCustomMorphs
	| id options |
	id := #traceability.
	options := self pathMap options at: id.
	self 
		addTitle: 'Traceability' toFlap: #traceability inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.075);
		addDropDownSelectionListTo: id
			on: options
			with: (self pathMap project concerns groups keys 
					collect: [:each | {each. #setConcernGroup:. {each}}])
			inFrame: (0.0 @ 0.083 corner: 1.0 @ 0.166);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.659 corner: 1.0 @ 0.825).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 3/24/2011 16:20:00.224'!
buildTraceabilityFlapWith: aBuilder
	| id options |
	id := #traceability.
	options := self pathMap options at: id.
	^ aBuilder pluggableFlapSpec new
		name: #traceability;
		icon: SImageRepository traceabilityIconLarge;
		model: self;
		children: {(SPluggableMultiSelectionListSpec new
				model: options;
				name: #concernList;
				list: #allConcerns;
				itemColor: #concernColorAt:;
				getSelectionList: #selectedConcernAt:;
				setSelectionList: #selectedConcernAt:put:;
				frame: (0.0 @ 0.1725 corner: 1.0 @ 0.65);
				yourself ).
				(aBuilder pluggableCheckBoxSpec new
				model: options; 
				frame: (0.0 @ 0.83 corner: 1.0 @ 0.913);
				label: 'Specific Only';
				action: #switchSpecificConcernMethodsOnly;
				state: #specificConcernMethodsOnly;
				yourself ).
				(aBuilder pluggableCheckBoxSpec new
				model: options; 
				frame: (0.0 @ 0.913 corner: 1.0 @ 1.0);
				label: 'Multiple Colors';
				action: #switchMultipleColorsPerMethod;
				state: #multipleColorsPerMethod;
				yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/13/2010 19:09:46.801'!
buildWith: aBuilder
	self 
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs.
	^ self windowMorph! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 9/15/2010 11:40:43.001'!
buttons
	^ #(( 'Run Selected' #runAll #hasRunnable )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors ) )
! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 3/16/2010 14:09'!
extent

	^ 650 @ 580! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 7/7/2010 16:54:06.742'!
findCategories

	| foundedCategories |
	foundedCategories := super findCategories.
	^ foundedCategories select: [:each | SProject current categories includes: each]! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 3/2/2010 17:13'!
findClassesForCategories: aCollection

	| items |
	aCollection isEmpty 
		ifTrue: [ ^ #() ].
	items := aCollection gather: [ :category |
		((Smalltalk organization listAtCategoryNamed: category)
			collect: [ :each | Smalltalk at: each ])
			select: [ :each | each includesBehavior: self baseClass ] ].
	^ items asSet.! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 9/16/2010 11:50:05.225'!
getFlap: aSymbol
	^ self windowMorph paneMorphs 
		detect: [:each | each externalName asSymbol == aSymbol]! !

!SPathMapTestRunner methodsFor: 'initialization' stamp: 'mp 7/9/2010 11:34:42.537'!
initialize
	super initialize.
	"self suitesAt: 1 put: true. ""Select all tests"
	self pathMap: (SPMPathMap on: self).
	self addDependent: self pathMap.	
	self update. "Changed doesn't work'"! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 7/9/2010 09:53:13.247'!
label
	^ 'PathMap'! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/8/2010 18:12:23.231'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/8/2010 18:12:23.235'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 9/15/2010 15:53:04.098'!
runAll
	| flap |
	self flag: #mpe. "Refactor the fragile code without morphic methods!!"
	flap := self windowMorph paneMorphs 
		detect: [:each | (each isKindOf: SPluggableFlapMorph) and: [each isExpanded]] 
		ifNone: [nil].
	(flap isNil or: [flap externalName asSymbol == #globalOptions])
		ifTrue: [self pathMap runAllTests]
		ifFalse: [self pathMap runAllTestsWith: flap externalName asSymbol].! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 7/9/2010 10:03:09.201'!
runErrors
	self halt.
	super runErrors.! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 7/9/2010 10:02:47.879'!
runFailures
	self halt.
	super runFailures.! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:54:13.111'!
selectedClasses

	^ Smalltalk allClasses select: [:aClass | 
		(SProject current categories includes: aClass category) 
		and: [(aClass inheritsFrom: TestCase) not]]! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/15/2010 17:31:24.77'!
setFrame: aRectangle in: aMorph

	| frame |
	frame := LayoutFrame new
				leftFraction: aRectangle left; 
				rightFraction: aRectangle right; 
				topFraction: aRectangle top; 
				bottomFraction: aRectangle bottom.
	aMorph layoutFrame: frame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.! !

!SPathMapTestRunner methodsFor: 'updating' stamp: 'mp 5/27/2010 13:22'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categories.
	self changed: #categoryList; changed: #categorySelected.! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:29'!
windowMorph
	^ windowMorph! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:29'!
windowMorph: anObject
	windowMorph := anObject! !

RectangleMorph subclass: #SActionButtonMorph
	instanceVariableNames: 'actionModel actionSelector actionArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

SActionButtonMorph subclass: #SActionButtonIconMorph
	instanceVariableNames: 'iconForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SActionButtonIconMorph class methodsFor: 'instance creation' stamp: 'mp 5/2/2010 19:39'!
on: aModel selector: aSymbol args: aCollection icon: anIconForm

	^ (self on: aModel selector: aSymbol args: aCollection)
		iconForm: anIconForm;
		extentToIcon;
		yourself! !

!SActionButtonIconMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:38'!
on: aModel selector: aSymbol icon: anIconForm

	^ (self on: aModel selector: aSymbol)
		iconForm: anIconForm;
		extentToIcon;
		yourself! !

!SActionButtonIconMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 21:36'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas translucentImage: self iconForm at: bounds origin.! !

!SActionButtonIconMorph methodsFor: 'geometry' stamp: 'mp 4/15/2010 21:37'!
extentToIcon

	self extent: self iconForm extent.! !

!SActionButtonIconMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:17'!
iconForm
	"Answer the value of iconForm"

	^ iconForm! !

!SActionButtonIconMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:17'!
iconForm: anObject
	"Set the value of iconForm"

	iconForm := anObject! !

SActionButtonMorph subclass: #SActionButtonLabelMorph
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SActionButtonLabelMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 21:05'!
defaultExtensionFactor

	^ 1.5! !

!SActionButtonLabelMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:27'!
on: aModel selector: aSymbol args: aCollection name: aString

	^ (self on: aModel selector: aSymbol args: aCollection)
		createLabelMorph: aString! !

!SActionButtonLabelMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:07'!
on: aModel selector: aSymbol name: aString

	^ (self on: aModel selector: aSymbol)
		createLabelMorph: aString! !

!SActionButtonLabelMorph methodsFor: 'building' stamp: 'mp 4/20/2010 17:10'!
createLabelMorph: aString

	self labelMorph: (StringMorph contents: aString).
	self addMorph: self labelMorph.
	self extent: (self labelMorph fullBounds corner * self class defaultExtensionFactor).! !

!SActionButtonLabelMorph methodsFor: 'geometry' stamp: 'mp 4/24/2010 15:56'!
extent: aPoint

	| borderOffset |
	super extent: aPoint.
	self labelMorph position: self position.
	self labelMorph width < self width
		ifTrue: [self labelMorph position: 
				(self labelMorph position x + (self width / 2) - (self labelMorph width / 2)) @ 
					(self labelMorph position y + (self height / 2) - (self labelMorph height / 2))]
		ifFalse: [
			borderOffset := 5.
			self labelMorph position: 
				(self position x + borderOffset - 2) @ 
					(self labelMorph position y + (self height / 2) - (self labelMorph height / 2)).
			self labelMorph extent: (self width - borderOffset)@ self height.
			].! !

!SActionButtonLabelMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:05'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SActionButtonLabelMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:05'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

SActionButtonLabelMorph subclass: #SDropDownActionButtonMorph
	instanceVariableNames: 'dropDownMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SDropDownActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:35'!
dropDownMorph
	^ dropDownMorph! !

!SDropDownActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:35'!
dropDownMorph: anObject
	dropDownMorph := anObject! !

!SDropDownActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 18:47'!
mouseUp: anEvent
	super mouseUp: anEvent.
	self dropDownMorph newSelectedEntry: self labelMorph contents.! !

SActionButtonLabelMorph subclass: #SDropDownMorph
	instanceVariableNames: 'menuEntries selectedEntry menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SDropDownMorph class methodsFor: 'constants' stamp: 'mp 1/15/2010 17:51'!
defaultHeight

	^ 25! !

!SDropDownMorph class methodsFor: 'instance creation' stamp: 'mp 9/22/2010 16:13:26.977'!
on: aModel with: aCollection
	| labelString |
	labelString := aCollection 
					ifEmpty: ['No Menu Entry']
					ifNotEmpty: [aCollection first isCollection
									ifTrue: [aCollection first first]
									ifFalse: [aCollection first key]].
	^ self new
		actionModel: aModel;
		menuEntries: aCollection;
		createLabelMorph: labelString;
		createMenu;
		yourself! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/22/2010 16:07:40.548'!
createLabelMorph: aString

	| largestString |
	super createLabelMorph: aString.
	largestString := aString.
	self menuEntries ifNotEmpty: [
		self menuEntries first isCollection
			ifTrue: [self menuEntries do: [:each | 
					(each first size > largestString size) ifTrue: [largestString := each first]]]
			ifFalse: [self menuEntries do: [:each | 
					(each key size > largestString size) ifTrue: [largestString := each key]]]].
	self extent: largestString asStringMorph fullBounds corner * self class defaultExtensionFactor.! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/22/2010 11:00:37.443'!
createMenu
	| entryMorphs |
	entryMorphs := self createMenuEntries.
	self menuMorph: (AlignmentMorph inAColumn: entryMorphs).
	self addMorph: self menuMorph.
	self menuMorph 
		borderWidth: 0;
		position: (self position x - 1) @ (self position y + self height - 1);
		hide.! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/22/2010 16:08:31.592'!
createMenuEntries
	self menuEntries ifEmpty: [^ #()].
	self menuEntries first isCollection
		ifTrue: [	"Collection with args for action selector"
			^ self menuEntries collect: [:each | 
			(SDropDownActionButtonMorph 
				on: self actionModel selector: each second args: each third name: each first) 
				extent: self extent;
				dropDownMorph: self]]
		ifFalse: ["Associations"
			^ self menuEntries collect: [:each | 
				(SDropDownActionButtonMorph 
					on: self actionModel selector: each value name: each key) 
					extent: self extent;
					dropDownMorph: self]].! !

!SDropDownMorph methodsFor: 'geometry' stamp: 'mp 9/16/2010 13:38:22.437'!
extent: aPoint

	| oldHeight |
	oldHeight := self height.
	super extent: aPoint.
	"Required for collapse systemwindow"
	self flag: #mpe. "Creates a bug in PathMap Flap - Morph cannot be hided."
"	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show]."
	self menuMorph ifNotNil: [
	self menuMorph 
		position: (self menuMorph position x) @ 
					 (self menuMorph position y + self height - oldHeight).
	self menuMorph submorphs do: [:each | each extent: self extent]]! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:43'!
menuEntries
	^ menuEntries! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:43'!
menuEntries: anObject
	menuEntries := anObject! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:08'!
menuMorph
	^ menuMorph! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:08'!
menuMorph: anObject
	menuMorph := anObject! !

!SDropDownMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 18:34'!
mouseUp: anEvent

	self switchVisibilityOfMenu.! !

!SDropDownMorph methodsFor: 'private' stamp: 'mp 1/15/2010 18:39'!
newSelectedEntry: aString

	self switchVisibilityOfMenu.
	self selectedEntry: aString.
	self labelMorph contents: aString.
	self extent: self extent.! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:45'!
selectedEntry
	^ selectedEntry! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:45'!
selectedEntry: anObject
	selectedEntry := anObject! !

!SDropDownMorph methodsFor: 'private' stamp: 'mp 1/25/2010 13:04'!
switchVisibilityOfMenu

	self menuMorph visible: self menuMorph visible not.! !

!SActionButtonMorph class methodsFor: 'constants' stamp: 'mp 1/15/2010 17:32'!
defaultColor

	^ Color white! !

!SActionButtonMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 20:59'!
highlightBrightness

	^ 0.16! !

!SActionButtonMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:25'!
on: aModel selector: aSymbol

	^ self on: aModel selector: aSymbol args: #()! !

!SActionButtonMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:25'!
on: aModel selector: aSymbol args: aCollection

	^ self new 
		actionModel: aModel;
		actionSelector: aSymbol;
		actionArgs: aCollection;
		yourself! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:24'!
actionArgs
	"Answer the value of actionArgs"

	^ actionArgs! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:24'!
actionArgs: anObject
	"Set the value of actionArgs"

	actionArgs := anObject! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionModel
	^ actionModel! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionModel: anObject
	actionModel := anObject! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionSelector
	^ actionSelector! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionSelector: anObject
	actionSelector := anObject! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:30.911'!
defaultBorderColor

	^ Color gray: 0.5! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 2/25/2010 16:32'!
defaultBorderWidth

	^ 1! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/25/2010 11:45'!
handlesMouseDown: evt

	^ true! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 17:29'!
handlesMouseOver: anEvent

	^ true! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 1/15/2010 17:35'!
initialize
	super initialize.
	self color: self class defaultColor.! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/15/2010 21:00'!
mouseEnter: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness negated).! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/15/2010 21:00'!
mouseLeave: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness).! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/18/2010 20:26'!
mouseUp: anEvent
	
	self actionModel perform: self actionSelector withArguments: self actionArgs.! !

SActionButtonMorph subclass: #STestResultFeedbackMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-TestChooser'!

!STestResultFeedbackMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 16:08'!
defaultColor

	^ Color white! !

!STestResultFeedbackMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 16:08'!
errorColor

	^ Color r: 230 / 256.0 g: 59 / 256.0 b: 59 / 256.0 ! !

!STestResultFeedbackMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 16:08'!
failureColor

	^ Color r: 245 / 256.0 g: 237 / 256.0 b: 13 / 256.0 ! !

!STestResultFeedbackMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 16:09'!
passedColor

	^ Color r: 70 / 256.0 g: 189 / 256.0 b: 47 / 256.0 ! !

!STestResultFeedbackMorph methodsFor: 'initialization' stamp: 'mp 4/15/2010 16:15'!
initialize

	super initialize.
	self color: self class defaultColor.! !

!STestResultFeedbackMorph methodsFor: 'updating' stamp: 'mp 5/2/2010 12:52'!
update: aResult

	(aResult isNil or: [aResult isLiteral]) ifTrue: [^ self]. 
	(aResult isKindOf: TestResult) not ifTrue: [^ self].
	
	aResult passed ifNotEmpty: [self color: self class passedColor].
	aResult failures ifNotEmpty: [self color: self class failureColor].
	aResult errors ifNotEmpty: [self color: self class errorColor].! !

RectangleMorph subclass: #SCheckBoxMorph
	instanceVariableNames: 'checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:02:39.767'!
checked
	"Answer the value of checked"

	^ checked ifNil: [checked := false]! !

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:15:57.526'!
checked: anObject
	"Set the value of checked"
	checked := anObject.
	self changed.! !

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:31:48.299'!
drawOn: aCanvas
	aCanvas 
		frameRectangle: self bounds 
		color: Preferences standardButtonFont foregroundColor.
	self checked
		ifTrue: [aCanvas 
					fillRectangle: (self bounds expandBy: -2)
					color: Preferences standardButtonFont foregroundColor].
		! !

RectangleMorph subclass: #SCodePaneMorph
	instanceVariableNames: 'callNode definition objectExplorationMorphs objExpMorphsStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

SCodePaneMorph class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

SCodePaneMorph class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 14:42'!
borderOffset

	^ 2! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/18/2010 20:37'!
buttonWidth

	^ 15! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 17:16'!
codePaneHeight

	^ 125! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:44:47.619'!
codePaneWidth

	^ 480 - 3! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:43:42.541'!
definitionHeight

	^ self codePaneHeight - (2 * self borderOffset)! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:44:12.408'!
definitionWidth

	^ 400 - self labelHeight! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:32'!
labelHeight

	^ 15! !

!SCodePaneMorph class methodsFor: 'instance creation' stamp: 'mp 4/27/2010 16:17'!
on: aCallNode color: aColor

	^ self new
		callNode: aCallNode;
		color: aColor;
		createDefinitionMorph;
		createLabelMorph;
		createNodeButtons;
		createObjectExploreButtons;
		yourself! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/24/2010 17:12'!
addObjectExplorationMorph: aMorph

	(self objExpMorphsStack includes: aMorph) ifTrue: [self objExpMorphsStack remove: aMorph].
	self objExpMorphsStack addFirst: aMorph.
	self 
		addMorph: aMorph;
		adjustObjectExplorationMorphs.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/18/2010 20:15'!
adjustObjectExplorationMorphs

	| posX |
	posX := self position x + self width.
	self objExpMorphsStack do: [:each | 
		each position: posX @ self position y.
		posX := posX + each width].! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 3/24/2011 16:25:50.124'!
buttonSpec

	^ {
	{#openCodeBrowser. SImageRepository documentIcon }.
	{#byteCodeCoverage. SImageRepository leftRightIcon}.
	{#debugMethod. SImageRepository bugIcon}.
	{#expandTree. SImageRepository treeIcon}}! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 11/8/2010 15:47:11.928'!
byteCodeCoverage
	| byteCodes method map stream range |
	byteCodes := self tracer byteCodeCoverageAt: self callNode.
	method := self callNode compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	byteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each contextIsActiveContext: true.
					self definition text 
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:03'!
callNode
	"Answer the value of callNode"

	^ callNode! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:03'!
callNode: anObject
	"Set the value of callNode"

	callNode := anObject! !

!SCodePaneMorph methodsFor: 'definition' stamp: 'mp 3/24/2011 12:15:48.158'!
codePaneClass
	^ SPluggableTextMorphPlus! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 7/7/2010 16:39:05.034'!
createButtonFromSelector: aSymbol icon: aForm
	
	| button |
	button := SActionButtonIconMorph on: self selector: aSymbol icon: aForm.
	button extent: (self class buttonWidth @ self class buttonWidth).
	self addMorph: button.
	^ button! !

!SCodePaneMorph methodsFor: 'definition' stamp: 'mp 3/24/2011 11:57:08.733'!
createDefinitionMorph

	| widget model |
	widget := self codePaneClass new.
	widget useDefaultStyler.
	model := SDefinitionModel new.
	model setClass: self callNode clientClass andSelector: self callNode clientSelector.
	widget on: model
				text: #contents
				accept: nil
				readSelection: nil 
				menu: nil.
	widget textMorph addDependent: self.
	widget 
		font: Preferences standardCodeFont;
		getColorSelector: nil;
		borderColor: Color lightGray;
		borderWidth: 0;
		color: Color white.
	self definition: widget.
	self addMorph: self definition.
	self definition extent: self class definitionWidth@self class definitionHeight.
	self definition position: (self definition position x + self class labelHeight)@ 
						(self definition position y + self class borderOffset)! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 5/2/2010 12:54'!
createExploreButtonsForArgumentsAt: aNumber

	| arguments yPos |
	self callNode numArgsOfMethod isZero
		ifTrue: [^ aNumber]
		ifFalse: [arguments := self getArgumentsFromSource: self callNode methodReference sourceCode.
			yPos := aNumber.
			arguments size > 3 
				ifTrue: [self createMultipleArgumentsButton: arguments at: yPos.
					^ yPos + self class buttonWidth].
			arguments withIndexDo: [:each :index | 
				self createObjExpButtonWith: {#arguments. each. index} name: each atYPos: yPos.
				yPos := yPos + self class buttonWidth].
			^ yPos].! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 3/24/2011 16:26:32.788'!
createExploreButtonsForSelfAt: aNumber

	| button xPos label background |
	xPos := self definition position x + self definition width + self class borderOffset - 1.
	button := 	self createObjExpIconButtonWith: {#selfBefore. 'before'. 1} icon: SImageRepository beforeIcon.
	button position: xPos@(self definition position y + aNumber).
	background := RectangleMorph new.
	self addMorph: background.
	background
		color: Color white;
		borderWidth: 0;
		extent: 45@self class buttonWidth;
		position: (xPos + button width)@(self definition position y + aNumber).
	label := StringMorph contents: 'self'.
	self addMorph: label.
	label position: (xPos + button width + (label width / 2))@(self definition position y + aNumber).
	xPos := xPos + button width + 45.
	button := 	self createObjExpIconButtonWith: {#selfAfter. 'after'. 1} icon: SImageRepository afterIcon.	
	button position: xPos@(self definition position y + aNumber).
	^ aNumber + self class buttonWidth! !

!SCodePaneMorph methodsFor: 'label' stamp: 'mp 11/8/2010 17:45:13.953'!
createLabelMorph
	| stringMorph offsetPosX offsetPosY labelMorph |
	stringMorph := StringMorph contents: (self callNode views at: #receiver) asString.

	labelMorph := RectangleMorph new.
	labelMorph 
		extent: self class codePaneHeight @ self class labelHeight;
		color: self color;
		borderWidth: 1;
		borderColor: Color gray;
		addMorph: stringMorph.
		
	labelMorph width < self height
		ifTrue: [labelMorph width: self height].
	stringMorph width > (labelMorph width - 10)
		ifTrue: [stringMorph extent: (labelMorph width - 10) @ self class labelHeight.].
	
	offsetPosX := ((labelMorph width - stringMorph width) / 2) rounded.
	offsetPosY := ((labelMorph height - stringMorph height) / 2) rounded.
	stringMorph position: (stringMorph position x + offsetPosX)@(stringMorph position y + offsetPosY).	
	self addMorph: labelMorph.
	labelMorph heading: -90.
	labelMorph owner position: (self position x - 2) @ (self position y - 2).
	^ labelMorph! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 11/8/2010 17:05:13.691'!
createMultipleArgumentsButton: aCollection at: aNumber
	| button |
	button := SActionButtonLabelMorph 
				on: self 
				selector: #showChooseArgumentMenu:
				args: (Array with: aCollection)
				name: 'Args...'.
	self addMorph: button.
	button 
		extent: (self class buttonWidth * 3 + 30)@self class buttonWidth;
		position: (self definition position x + 
					self definition width + self class borderOffset - 1)@
					(self definition position y + aNumber);
		borderWidth: 0.! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 4/27/2010 16:42'!
createNodeButtons

	| button posX |
	posX :=  self definition position x + self definition width + self class borderOffset - 1.
	self buttonSpec do: [:each | 
		button := self createButtonFromSelector: each first icon: each second.
		button position: posX@(self position y + 1).
		button borderWidth: 0.
		posX := posX + button width].! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 11/8/2010 16:52:24.049'!
createObjExpButtonWith: aCollection name: aString atYPos: aNumber
	| button |
	button := SActionButtonLabelMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				name: aString.
	self addMorph: button.
	button 
		extent: (self class buttonWidth * 3 + 30)@self class buttonWidth;
		position: (self definition position x + self definition width + self class borderOffset - 1)@
					(self definition position y + aNumber);
		borderWidth: 0.
	button labelMorph position: (button position x + 2)@(button labelMorph position y)! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 7/7/2010 16:39:00.67'!
createObjExpIconButtonWith: aCollection icon: anIconForm
	| button |
	button := SActionButtonIconMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				icon: anIconForm.
	self addMorph: button.
	button borderWidth: 0.
	^ button! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 5/2/2010 19:49'!
createObjectExploreButtonSpec

	^ {
		{{#return. 'return'. 1}. 'return'}
	}! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 5/2/2010 19:22'!
createObjectExploreButtons
	| yPos |
	yPos := self position y + self class borderOffset + self class buttonWidth - 3.
	yPos := self createExploreButtonsForArgumentsAt: yPos.
	yPos := self createExploreButtonsForSelfAt: yPos.
	
	self createObjectExploreButtonSpec do: [:each |
		self createObjExpButtonWith: each first name: each second atYPos: yPos.
		yPos := yPos + self class buttonWidth].! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:22'!
debugMethod

	self tracer debugAt: self callNode.! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:48.984'!
defaultBorderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:45.332'!
defaultBorderWidth

	^ SCodeExplorerIndentingListItemMorph borderWidth! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:14'!
definition
	"Answer the value of definition"

	^ definition! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:14'!
definition: anObject
	"Set the value of definition"

	definition := anObject! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:35'!
expandTree

	self callNode callgraphModel expandNode: self callNode.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/24/2010 15:26'!
getArgumentsFromSource: aText

	| signature tokens index |
	signature := aText string lineCorrespondingToIndex: 1.
	tokens := signature findBetweenSubStrs: ' :'.
	index := 0.
	^ tokens select: [:each |
		index := index + 1.
		index even. ].
	! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 4/27/2010 14:51'!
initialize

	super initialize.
	self 
		color: Color white;
		extent: self class codePaneWidth@self class codePaneHeight.! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 3/24/2011 12:06:32.265'!
methodTypesLabelFor: aWord
	| method temps index type |
	self flag: #mpe. "Redundant code compare to implementors"
	method := self callNode compiledMethod.
	temps := method methodNode arguments, method methodNode temporaries.
	temps ifNotEmpty: [
		temps := temps collect: [:each | each name].
		index := temps indexOf: aWord.
		index = 0
			ifFalse: [SProject current typesBucket 
						ifNil: [^ 'Run type harvester first'].
				type := (SProject current typesBucket 	tempTypeAt: index in: method).
				type 
					ifNil: [^ 'No type available']
					ifNotNil: [^ type asString]]].
	(self callNode clientSelector asString beginsWith: aWord)
		ifTrue: [SProject current typesBucket 
					ifNil: [^ 'Run type harvester first'].
			type := (SProject current typesBucket 	returnTypeFor: method).
			type 
				ifNil: [^ '^ No type available']
				ifNotNil: [^ '^ ', type asString]].
	^ ''
! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:06'!
objExpMorphsStack
	"Answer the value of objExpMorphsStack"

	^ objExpMorphsStack ifNil: [objExpMorphsStack := OrderedCollection new]! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:06'!
objExpMorphsStack: anObject
	"Set the value of objExpMorphsStack"

	objExpMorphsStack := anObject! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:44'!
objectExplorationMorphs
	"Answer the value of objectExplorationMorphs"

	^ objectExplorationMorphs ifNil: [objectExplorationMorphs := Dictionary new]! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:18'!
objectExplorationMorphs: anObject
	"Set the value of objectExplorationMorphs"

	objectExplorationMorphs := anObject! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:22'!
openCodeBrowser

	Browser fullOnClass: self callNode clientClass selector: self callNode clientSelector! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/18/2010 20:11'!
removeObjectExplorationMorph: aMorph

	self objExpMorphsStack remove: aMorph.
	self 
		removeMorph: aMorph;
		adjustObjectExplorationMorphs.! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'mp 4/24/2010 17:09'!
showChooseArgumentMenu: aCollection

	| choice |
	choice := UIManager default 
				chooseFrom: aCollection 
					values: (1 to: aCollection size) 
					lines: #() 
					title: 'Choose argument'.
	choice ifNotNil: [self showObjectExploration: #arguments title: (aCollection at: choice) objectIndex: choice].! !

!SCodePaneMorph methodsFor: 'exploration' stamp: 'bs 7/17/2010 14:19:47.553'!
showObjectExploration: aSymbol title: aString objectIndex: aNumber

	| morph |
	morph := self objectExplorationMorphs 
				at: (aSymbol asString, aNumber asString) asSymbol
				ifAbsentPut: [SObjectExplorationMorph 
								on: self 
								title: aString 
								kindOfObjects: aSymbol 
								objectIndex: aNumber
								callNode: self callNode 
								color: self color].
	self addObjectExplorationMorph: morph.	! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 14:37'!
tracer

	^ self callNode callgraphModel tracer! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 3/24/2011 12:01:48.954'!
update: aWord with: aTextMorph
	aTextMorph labelMorph createLabelMorph: (self methodTypesLabelFor: aWord).
! !

SCodePaneMorph subclass: #SDebuggerCodePaneMorph
	instanceVariableNames: 'suspiciousColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Debugger'!

!SDebuggerCodePaneMorph class methodsFor: 'instance creation' stamp: 'mp 11/8/2010 16:19:27.344'!
on: aCallNode color: aColor
	"Label morph will be created later on"
	^ self new
		callNode: aCallNode;
		color: aColor;
		createDefinitionMorph;
		createNodeButtons;
		createObjectExploreButtons;
		yourself! !

!SDebuggerCodePaneMorph class methodsFor: 'instance creation' stamp: 'mp 11/8/2010 16:19:38.859'!
on: aCallNode color: aColor suspiciousColor: anotherColor

	^ (self on: aCallNode color: aColor)
		suspiciousColor: anotherColor;
		createLabelMorph;
		yourself
! !

!SDebuggerCodePaneMorph methodsFor: 'buttons' stamp: 'mp 3/24/2011 16:26:00.192'!
buttonSpec

	^ {
	{#openCodeBrowser. SImageRepository documentIcon }.
	{#byteCodeCoverage. SImageRepository leftRightIcon}.
	{#faultLocalizationForMethod. SImageRepository spiderIcon}.
	{#debugMethod. SImageRepository bugIcon}.
	{#expandTree. SImageRepository treeIcon}}! !

!SDebuggerCodePaneMorph methodsFor: 'button actions' stamp: 'mp 11/5/2010 16:49:13.466'!
computeOchiaiFor: aDictionary
	| allFailures allByteCodes failuresAtByteCode passedAtByteCode coveredTests |
	allFailures := self faultTracer failuresFrom: aDictionary keys.
	allByteCodes := Set new.
	aDictionary valuesDo: [:each | allByteCodes := allByteCodes, each].
	^ (allByteCodes collect: [:each | 
		coveredTests := aDictionary keys select: [:test | (aDictionary at: test) includes: each].
		failuresAtByteCode := self faultTracer 	failuresFrom: coveredTests.		
		passedAtByteCode := coveredTests size - failuresAtByteCode.
		(allFailures = 0 or: [failuresAtByteCode = 0])
			ifTrue: [each -> 0.0]
			ifFalse: [each -> (failuresAtByteCode / 
				((allFailures * (failuresAtByteCode + passedAtByteCode)) sqrt))]]) 
		sorted: [:a :b | a value < b value]! !

!SDebuggerCodePaneMorph methodsFor: 'label' stamp: 'mp 11/8/2010 16:28:29.768'!
createLabelMorph
	| labelMorph |
	labelMorph := super createLabelMorph.
	self suspiciousColor ifNotNil: [labelMorph color: self suspiciousColor].
	^ labelMorph! !

!SDebuggerCodePaneMorph methodsFor: 'button actions' stamp: 'mp 11/5/2010 19:53:17.743'!
faultLocalizationForMethod
	| supicousByteCodes map range method stream |
	supicousByteCodes := self computeOchiaiFor: self getCoveredByteCodes.
	method := self callNode compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	supicousByteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each key.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each key contextIsActiveContext: true.
					self definition text 
						addAttribute: (TextColor 
										color: (Color h: 120 * (1.0 - each value) s: 1.0 v: 1.0)) 
						from: range first 
						to: range last]].! !

!SDebuggerCodePaneMorph methodsFor: 'accessing' stamp: 'mp 3/25/2011 12:47:36.648'!
faultTracer
	self flag: #mpe. "ToDo: Refactor!! Law of Demeter is broken!!"
	^ self callNode callgraphModel pathFinder coverageTracer! !

!SDebuggerCodePaneMorph methodsFor: 'button actions' stamp: 'mp 11/5/2010 16:15:40.762'!
getCoveredByteCodes
	| coveredTests wrapper |
	coveredTests := self faultTracer getCoveringTests: self callNode methodReference.
	[wrapper := SMethodFaultLocalizationWrapper on: self callNode methodReference.
	wrapper install.
	coveredTests 
		do: [:each | wrapper currentTest: each.
				     each execute] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', coveredTests size asString, ' Entry Points.']]
	ensure: [wrapper uninstall].
	^ wrapper coveredByteCodes! !

!SDebuggerCodePaneMorph methodsFor: 'accessing' stamp: 'mp 11/8/2010 16:14:28.07'!
suspiciousColor
	"Answer the value of suspiciousColor"

	^ suspiciousColor! !

!SDebuggerCodePaneMorph methodsFor: 'accessing' stamp: 'mp 11/8/2010 16:14:28.075'!
suspiciousColor: anObject
	"Set the value of suspiciousColor"

	suspiciousColor := anObject! !

RectangleMorph subclass: #SColorLegendMorph
	instanceVariableNames: 'labelMorph optionsModel verticalColors horizontalColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SColorLegendMorph class methodsFor: 'constants' stamp: 'mp 9/16/2010 10:27:11.875'!
labelOffset
	^ 10@10! !

!SColorLegendMorph class methodsFor: 'instance creation' stamp: 'mp 9/16/2010 18:55:06.251'!
on: anOptionsModel

	^ self new
		optionsModel: anOptionsModel;
		yourself! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 13:43:32.438'!
convertToRelativePosition: aPoint
	| local |
	local := (self bounds topLeft - aPoint) * -1.
	^ (local x / self width) asFloat @ (local y / self height) asFloat.! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 22:32:04.587'!
defaultBorderColor

	^ Color gray: 0.5! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 22:31:58.354'!
defaultBorderWidth

	^ 1! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/16/2010 09:42:34.501'!
drawBordersOn: aCanvas
	aCanvas 
		frameRectangle: self bounds 
		width: self defaultBorderWidth 
		color: self defaultBorderColor.! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/20/2010 18:15:39.471'!
drawColorHorizontalOn: aCanvas
	| lasthorizontal insetRect fillStyle |
	lasthorizontal := 0.0.
	self horizontalColors do: [:each | 
		insetRect := self bounds 
						insetOriginBy: ((self bounds width * lasthorizontal) asInteger@0)
						cornerBy: ((self bounds width - (self bounds width * each key)) asInteger@0).
		lasthorizontal := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: insetRect width@0.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].
! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/20/2010 18:29:27.279'!
drawColorVerticalOn: aCanvas
	| lastVertical insetRect fillStyle |
	lastVertical := 0.0.
	self verticalColors do: [:each | 
		insetRect := self bounds 
						insetOriginBy: (0@(self bounds height * lastVertical) asInteger)
						cornerBy: (0@(self bounds height - 	(self bounds height * each key)) asInteger).
		lastVertical := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: 0@insetRect height.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].
! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/17/2010 17:03:16.045'!
drawOn: aCanvas
	self 
		drawColorHorizontalOn: aCanvas;
		drawColorVerticalOn: aCanvas;
		drawBordersOn: aCanvas.
! !

!SColorLegendMorph methodsFor: 'events-processing' stamp: 'mp 9/16/2010 09:56:16.082'!
handleMouseMove: anEvent
	anEvent wasHandled: true.
	self mouseMove: anEvent.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/16/2010 09:58:13.85'!
handlesMouseOver: evt

	^ true! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/17/2010 17:03:45.694'!
horizontalColors
	"Answer the value of horizontalColors"

	^ horizontalColors! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/17/2010 17:03:45.699'!
horizontalColors: anObject
	"Set the value of horizontalColors"

	horizontalColors := anObject! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/16/2010 10:01:13.69'!
initialize
	super initialize.
	self extent: 150@150.
	self labelMorph: (SLabelMorph label: 'ToDo').! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:00:46.979'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:00:46.984'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:54:55.868'!
mouseEnter: anEvent
	self flag: #mpe. "owner owner works but is very fragile"
	"Required to allow large labels to be shown outside the color legend"
	self owner owner addMorph: self labelMorph.
	self labelMorph position: anEvent cursorPoint + self class labelOffset.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:53:39.978'!
mouseLeave: anEvent
	self flag: #mpe. "owner owner works but is very fragile"
	self owner owner removeMorph: self labelMorph.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:26:12.973'!
mouseMove: anEvent
	| labelString relativePosition |
	relativePosition := self convertToRelativePosition: anEvent position.
	labelString := self optionsModel
		ifNil: [(relativePosition x printShowingDecimalPlaces: 2), '@',
								(relativePosition y printShowingDecimalPlaces: 2)]
		ifNotNil: [self optionsModel getLabelString: relativePosition].
	self labelMorph createLabelMorph: labelString.
	self labelMorph position: anEvent cursorPoint + self class labelOffset.! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:54:45.479'!
optionsModel
	"Answer the value of optionsModel"

	^ optionsModel! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:54:45.483'!
optionsModel: anObject
	"Set the value of optionsModel"

	optionsModel := anObject! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 19:03:38.679'!
verticalColors
	"Answer the value of verticalColors"

	^ verticalColors! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 19:03:38.685'!
verticalColors: anObject
	"Set the value of verticalColors"

	verticalColors := anObject! !

RectangleMorph subclass: #SLabelMorph
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SLabelMorph class methodsFor: 'constants' stamp: 'mp 9/15/2010 17:45:00.918'!
defaultColor

	^ Color white! !

!SLabelMorph class methodsFor: 'constants' stamp: 'mp 9/15/2010 18:44:58.329'!
defaultExtensionFactor

	^ 1.3! !

!SLabelMorph class methodsFor: 'instance creation' stamp: 'mp 9/15/2010 17:41:34.967'!
label: aString

	^ self new
		createLabelMorph: aString;
		yourself! !

!SLabelMorph methodsFor: 'building' stamp: 'mp 9/16/2010 10:33:13.194'!
createLabelMorph: aString
	self labelMorph ifNotNil: [self removeMorph: self labelMorph].
	self labelMorph: (StringMorph contents: aString).
	self addMorph: self labelMorph.
	self extent: (self labelMorph fullBounds corner * self class defaultExtensionFactor).! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:35.443'!
defaultBorderColor

	^ Color gray: 0.5! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:41.885'!
defaultBorderWidth

	^ 1! !

!SLabelMorph methodsFor: 'geometry' stamp: 'mp 9/15/2010 17:46:46.341'!
extent: aPoint

	| borderOffset |
	super extent: aPoint.
	self labelMorph position: self position.
	self labelMorph width < self width
		ifTrue: [self labelMorph position: 
				(self labelMorph position x + (self width / 2) - (self labelMorph width / 2)) @ 
				(self labelMorph position y + (self height / 2) - (self labelMorph height / 2))]
		ifFalse: [
			borderOffset := 5.
			self labelMorph position: 
				(self position x + borderOffset - 2) @ 
				(self labelMorph position y + (self height / 2) - (self labelMorph height / 2)).
			self labelMorph extent: (self width - borderOffset)@ self height].! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:51.141'!
initialize
	super initialize.
	self color: self class defaultColor.! !

!SLabelMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 17:40:59.973'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SLabelMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 17:40:59.978'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

RectangleMorph subclass: #SObjectExplorationMorph
	instanceVariableNames: 'codePane title callNode kindOfObject objectIndex objectToExplore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 16:43:57.664'!
borderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/20/2010 15:57'!
borderOffset

	^ 2! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:57'!
buttonWidth

	^ 15! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 16:44:42.262'!
explorationHeight

	^ SCodePaneMorph codePaneHeight! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 17:13'!
explorationMinWidth

	^ 150! !

!SObjectExplorationMorph class methodsFor: 'instance creation' stamp: 'mp 4/24/2010 16:16'!
on: aCodePane title: aString kindOfObjects: aSymbol objectIndex: aNumber callNode: aCallNode color: aColor

	^ self new
		codePane: aCodePane;
		title: aString;
		callNode: aCallNode;
		kindOfObject: aSymbol;
		objectIndex: aNumber;
		color: aColor;
		createMorphs;
		yourself! !

!SObjectExplorationMorph class methodsFor: 'instance creation' stamp: 'mp 4/27/2010 19:52'!
on: aCodePane title: aString object: anObject color: aColor

	^ self new
		codePane: aCodePane;
		title: aString;
		objectToExplore: anObject;
		color: aColor;
		createMorphs;
		yourself! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:53'!
titleBorderWidth

	^ 1! !

!SObjectExplorationMorph methodsFor: 'actions' stamp: 'mp 4/20/2010 16:36'!
browseClass: aClass

	Browser fullOnClass: aClass! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
callNode
	"Answer the value of callNode"

	^ callNode! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
callNode: anObject
	"Set the value of callNode"

	callNode := anObject! !

!SObjectExplorationMorph methodsFor: 'actions' stamp: 'mp 4/18/2010 18:50'!
close

	self codePane removeObjectExplorationMorph: self.! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:44'!
codePane
	"Answer the value of codePane"

	^ codePane! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:44'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 7/7/2010 16:39:45.521'!
createCloseButton

	| closeButton |
	closeButton := SActionButtonLabelMorph on: self selector: #close name: 'X'.
	self addMorph: closeButton.
	closeButton 
		extent: (self class buttonWidth -1)@self class buttonWidth;
		position: (self position x + self width - closeButton width) @ (self position y);
		color: self color.
	! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 16:55'!
createMorphs

	| exploredObject |
	exploredObject := self getObjectToExplore.
	self 
		createObjectExplorerOn: exploredObject;
		createCloseButton.
! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 7/7/2010 17:07:53.172'!
createObjectExplorerOn: anObject
	| listMorph |
	listMorph := (SObjectExplorer on: self codePane) explorerListMorphFor: anObject.
	self addMorph: listMorph.
	listMorph 
		borderWidth: 0;
		position: self position x @ (self position y + self class buttonWidth);
		extent: (self width - 1)@(self height - self class buttonWidth - 1).
! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:54.844'!
defaultBorderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:52.227'!
defaultBorderWidth

	^ SCodeExplorerIndentingListItemMorph borderWidth! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 16:52'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self title ifNil: [^ self].
	self 
		drawTitleRectangleOn: aCanvas;
		drawTitleOn: aCanvas.! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 20:23'!
drawTitleOn: aCanvas

	| string |
	string := self title, ': ',  self getObjectToExplore class asString.
	aCanvas 
		drawString: string
		in: ((self position x + 2@self position y) 
			corner: ((self position x + self width - 2 - self class buttonWidth) @ 
				(self position y + self class buttonWidth))).! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 16:59'!
drawTitleRectangleOn: aCanvas

	| rect |
	rect := ((self position x - 1) @ self position y) 
			corner: ((self position x + self width) @ 
					(self position y + self class buttonWidth)).
	aCanvas 
		frameAndFillRectangle: rect 
		fillColor: self color 
		borderWidth: self class titleBorderWidth 
		borderColor: self class borderColor.! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 19:53'!
getObjectToExplore

	| objects |
	self objectToExplore ifNotNil: [^ self objectToExplore].
	objects := self callNode explore: self kindOfObject.
	objects size = 1 ifTrue: [
		self kindOfObject == #arguments
			ifTrue: [^ objects first at: self objectIndex].
		^ objects first].
	^ objects! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 4/20/2010 17:01'!
initialize

	super initialize.
	self extent: self class explorationMinWidth @ self class explorationHeight.
	! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
kindOfObject
	"Answer the value of kindOfObject"

	^ kindOfObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
kindOfObject: anObject
	"Set the value of kindOfObject"

	kindOfObject := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 16:16'!
objectIndex
	"Answer the value of objectIndex"

	^ objectIndex! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 16:16'!
objectIndex: anObject
	"Set the value of objectIndex"

	objectIndex := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:52'!
objectToExplore
	"Answer the value of objectToExplore"

	^ objectToExplore! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:52'!
objectToExplore: anObject
	"Set the value of objectToExplore"

	objectToExplore := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:56'!
title
	"Answer the value of title"

	^ title! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:56'!
title: anObject
	"Set the value of title"

	title := anObject! !

RectangleMorph subclass: #SPMLabelMorph
	instanceVariableNames: 'parentMorph mouseEnterDeletion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMLabelMorph class methodsFor: 'instance creation' stamp: 'mp 3/30/2010 19:03'!
on: aMorph

	^ self new
		parentMorph: aMorph! !

!SPMLabelMorph methodsFor: 'event handling' stamp: 'mp 7/2/2010 17:38'!
handlesMouseOver: anEvent

	^ self mouseEnterDeletion! !

!SPMLabelMorph methodsFor: 'event handling' stamp: 'mp 7/2/2010 17:35'!
mouseEnter: anEvent
	| currentMorph |
	currentMorph := self.
	self owner class == TransformationMorph
		ifTrue: [currentMorph := self owner].
	self parentMorph removeMorph: currentMorph.! !

!SPMLabelMorph methodsFor: 'accessing' stamp: 'mp 7/2/2010 17:37'!
mouseEnterDeletion
	"Answer the value of mouseEnterDeletion"

	^ mouseEnterDeletion ifNil: [mouseEnterDeletion := true]! !

!SPMLabelMorph methodsFor: 'accessing' stamp: 'mp 7/2/2010 17:36'!
mouseEnterDeletion: anObject
	"Set the value of mouseEnterDeletion"

	mouseEnterDeletion := anObject! !

!SPMLabelMorph methodsFor: 'accessing' stamp: 'mp 3/30/2010 19:03'!
parentMorph
	"Answer the value of parentMorph"

	^ parentMorph! !

!SPMLabelMorph methodsFor: 'accessing' stamp: 'mp 3/30/2010 19:03'!
parentMorph: anObject
	"Set the value of parentMorph"

	parentMorph := anObject! !

RectangleMorph subclass: #SPMMenuMorph
	instanceVariableNames: 'targetMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMMenuMorph class methodsFor: 'constants' stamp: 'mp 6/30/2010 11:32'!
backgroundColor

	^ Color r:0.9 g:0.9 b: 0.9! !

!SPMMenuMorph class methodsFor: 'constants' stamp: 'mp 6/30/2010 11:32'!
labelBorderColor

	^ Color gray! !

!SPMMenuMorph class methodsFor: 'constants' stamp: 'mp 6/30/2010 11:32'!
labelBorderWidth

	^ 1! !

!SPMMenuMorph class methodsFor: 'instance creation' stamp: 'mp 6/30/2010 13:54'!
on: aTestMapMorph

	^ self new
		targetMorph: aTestMapMorph;
		createMenu;
		yourself! !

!SPMMenuMorph methodsFor: 'initialization' stamp: 'mp 7/9/2010 10:49:25.484'!
createMenu
	| buttons pos |
	buttons := self targetMorph menuActions 
					inject: OrderedCollection new 
					into: [:col :each |
						col 
							add: (SActionButtonIconMorph 
									on: self targetMorph 
									selector: each third 
									icon: each second);
							yourself].
	pos := 0.
	buttons do: [:each |
		self addMorph: each.
		each position: (self position x + pos @ self position y).
		pos := pos + each width].
	self extent: pos @ self height.
! !

!SPMMenuMorph methodsFor: 'event handling' stamp: 'mp 7/1/2010 17:32'!
handlesMouseOver: anEvent

	^ true! !

!SPMMenuMorph methodsFor: 'initialization' stamp: 'mp 1/26/2011 10:07:44.646'!
initialize

	super initialize.
	self 	
		extent: 100@15;
		color: self class backgroundColor;
		borderWidth: self class labelBorderWidth;
		borderColor: self class labelBorderColor.! !

!SPMMenuMorph methodsFor: 'event handling' stamp: 'mp 7/1/2010 17:33'!
mouseLeave: anEvent

	self owner ifNotNil: [self owner removeMenuMorph]! !

!SPMMenuMorph methodsFor: 'accessing' stamp: 'mp 6/30/2010 11:48'!
targetMorph
	"Answer the value of targetMorph"

	^ targetMorph! !

!SPMMenuMorph methodsFor: 'accessing' stamp: 'mp 6/30/2010 11:48'!
targetMorph: anObject
	"Set the value of targetMorph"

	targetMorph := anObject! !

SPMMenuMorph subclass: #SPVMenuMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-Morphic'!

!SPVMenuMorph methodsFor: 'event handling' stamp: 'mp 1/26/2011 10:13:54.814'!
handlesMouseOver: anEvent

	^ false! !

RectangleMorph subclass: #SPMPathMapMorph
	instanceVariableNames: 'labelMorph parentMorph childrenMorphs sourceCodeEntity pathMap weight expandMorph menuMorph colorPropagation additionalInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

SPMPathMapMorph subclass: #SPMCategoryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMCategoryMorph class methodsFor: 'constants' stamp: 'mp 9/30/2010 11:01:24.452'!
minimumSize
	"Border of classes"
	^ super minimumSize + 1! !

!SPMCategoryMorph methodsFor: 'menu actions' stamp: 'mp 7/9/2010 17:36:24.04'!
browse

	SystemBrowser default newOnCategory: self sourceCodeEntity.! !

!SPMCategoryMorph methodsFor: 'building' stamp: 'mp 9/28/2010 17:41:24.665'!
children
	| classes |
	classes := self project classesOfCategory: self sourceCodeEntity.
	self globalOptions showEmptyCategoriesAndClasses
		ifTrue: [^ classes]
		ifFalse: [^ classes select: [:each | 
					(self project 
						nomOfClass: each 
						withQuick: self globalOptions showQuickAndAccessorMethods) > 0]]! !

!SPMCategoryMorph methodsFor: 'building' stamp: 'mp 7/7/2010 17:55:28.692'!
childrenMorphClass

	^ SPMClassMorph! !

!SPMCategoryMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:49:50.233'!
isCategoryMorph
	^ true! !

!SPMCategoryMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:32'!
mouseEnter: evt

	super mouseEnter: evt.
	self labelMorph position: self position x @ (self position y - (self labelMorph height)).! !

!SPMCategoryMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 15:39'!
segmentationDirection
	"return either #vertical or #horizontal"

	^ #vertical! !

!SPMCategoryMorph methodsFor: 'initialization' stamp: 'mp 9/28/2010 17:43:25.55'!
setWeight

	self weight: (self project 
					nomOfCategory: self sourceCodeEntity 
					withQuick: self globalOptions showQuickAndAccessorMethods).! !

SPMPathMapMorph subclass: #SPMClassMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMClassMorph class methodsFor: 'instance creation' stamp: 'mp 3/30/2010 11:16'!
on: aTestMap categoryMorph: aCategoryMorph class: aClass

	^ (super on: aTestMap)
		categoryMorph: aCategoryMorph;
		klass: aClass;
		yourself! !

!SPMClassMorph methodsFor: 'menu actions' stamp: 'mp 7/9/2010 17:36:31.242'!
browse

	SystemBrowser default fullOnClass: self sourceCodeEntity.! !

!SPMClassMorph methodsFor: 'building' stamp: 'mp 9/29/2010 13:25:24.834'!
children
	| categories |
	categories := OrderedCollection new.
	self globalOptions showMethodCategories
		ifTrue: [categories := (self project 
					methodCategoriesOfClass: self sourceCodeEntity
					withQuick: self globalOptions showQuickAndAccessorMethods) 
						asOrderedCollection]
		ifFalse: [
			(self project nomOfOneSideClass: self sourceCodeEntity
				withQuick: self globalOptions showQuickAndAccessorMethods) > 0
					ifTrue: [categories add: #'no category'].
			(self project nomOfOneSideClass: self sourceCodeEntity class
				withQuick: self globalOptions showQuickAndAccessorMethods) > 0
					ifTrue: [categories add: #'no category (class)']].
	((self sourceCodeEntity isTestCaseClass and: 
		[self sourceCodeEntity shouldInheritSelectors]) and: 
			[self sourceCodeEntity testSelectors size ~= 
			 	self sourceCodeEntity allTestSelectors size])
					ifTrue: [categories 
						add: SPMMethodCategoryMorph inheritedTestSelectorId].
	^ categories! !

!SPMClassMorph methodsFor: 'building' stamp: 'mp 9/28/2010 19:17:22.392'!
childrenMorphClass
	self globalOptions showMethodCategories
		ifTrue: [	^ SPMMethodCategoryMorph]
		ifFalse: [^ SPMAllMethodCategoriesMorph]! !

!SPMClassMorph methodsFor: 'dimension' stamp: 'mp 5/27/2010 13:18'!
dimension
	"Show the additional border of class morphs"
	self segmentationDirection == #horizontal
		ifTrue: [^ self width - 1].
	self segmentationDirection == #vertical
		ifTrue: [^ self height - 1]! !

!SPMClassMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:50:04.196'!
isClassMorph
	^ true! !

!SPMClassMorph methodsFor: 'building' stamp: 'mp 5/14/2010 17:29'!
labelMorphMinWidth

	^ self height! !

!SPMClassMorph methodsFor: 'event handling' stamp: 'mp 5/18/2010 10:52'!
mouseEnter: evt

	super mouseEnter: evt.
	self labelMorph heading: -90.
	self labelMorph owner position: (self position x - (self labelMorph height) - 2) @ (self position y - 2).! !

!SPMClassMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:41'!
mouseLeave: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness).
	self labelMorph owner ifNotNil: [self rootMorph removeMorph: self labelMorph owner].! !

!SPMClassMorph methodsFor: 'dimension' stamp: 'mp 5/27/2010 13:19'!
oppositeDimension
	"Show the additional border of class morphs"
	self segmentationDirection == #horizontal
		ifTrue: [^ self height - 1].
	self segmentationDirection == #vertical
		ifTrue: [^ self width - 1]! !

!SPMClassMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 15:47'!
segmentationDirection
	"return either #vertical or #horizontal"

	^ #horizontal! !

!SPMClassMorph methodsFor: 'initialization' stamp: 'mp 9/28/2010 14:46:02.034'!
setWeight

	self weight: (self project 
					nomOfClass: self sourceCodeEntity 
					withQuick: self globalOptions showQuickAndAccessorMethods).! !

SPMPathMapMorph subclass: #SPMExpandRootMorph
	instanceVariableNames: 'targetMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMExpandRootMorph class methodsFor: 'constants' stamp: 'mp 7/2/2010 13:29'!
borderWidth

	^ 3! !

!SPMExpandRootMorph class methodsFor: 'constants' stamp: 'mp 7/2/2010 13:41'!
frameColor

	^  Color gray! !

!SPMExpandRootMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 10:50:13.889'!
minWidth

	^ 25! !

!SPMExpandRootMorph class methodsFor: 'instance creation' stamp: 'mp 7/2/2010 17:46'!
on: childrenMorphs

	^ self new 
		targetMorph: childrenMorphs;
		expandSizeOfTarget;
		arrangeTarget;
		buildExpandMorph;
		yourself! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/2/2010 14:13'!
addAndArrangeChildrenOf: aMorph
	aMorph children do: [:each | aMorph addMorph: (aMorph childrenMorphs at: each)].
	aMorph arrangeChildren.
	aMorph childrenMorphs valuesDo: [:each | self addAndArrangeChildrenOf: each].! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/2/2010 14:31'!
arrangeTarget
	self addAndArrangeChildrenOf: self.
	self childrenMorphs valuesDo: [:each | each parentMorph: self]! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/2/2010 17:45'!
buildExpandMorph
	self 
		buildFrame;
		buildFrameButtons;
		buildTargetLabel.! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/2/2010 17:44'!
buildFrame
	self width: self width + (self class borderWidth * 2).
	self height: self height + 24.
	self color: self class frameColor.
	self borderStyle: (BorderStyle complexAltRaised width: self class borderWidth).
	self submorphs do: [:each | each position: (each position x + self class borderWidth) @ (each position y + 21)].
! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 3/24/2011 16:27:22.843'!
buildFrameButtons
	| closeBtn |
	closeBtn := SActionButtonIconMorph on: self selector: #close icon: SImageRepository closeIcon.
	self addMorph: closeBtn.
	closeBtn position: (self position x + self width - closeBtn width - self class borderWidth) @ 
						(self position y + self class borderWidth).
! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/7/2010 10:50:56.817'!
buildTargetLabel
	"Center label on top of frame"
	self labelMorph mouseEnterDeletion: false.
	self addMorph: self labelMorph.
	self labelMorph position: (self position x - ((self labelMorph width - self width) / 2)) @
								(self position y - self labelMorph height).
! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/1/2010 17:53'!
children

	^ self targetMorph children! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/1/2010 17:53'!
childrenMorphClass

	^ self targetMorph childrenMorphClass! !

!SPMExpandRootMorph methodsFor: 'accessing' stamp: 'mp 7/1/2010 18:23'!
childrenMorphs

	^ self targetMorph childrenMorphs! !

!SPMExpandRootMorph methodsFor: 'actions' stamp: 'mp 7/2/2010 14:14'!
close
	self targetMorph expandMorph: nil.
	self childrenMorphs valuesDo: [:each | each parentMorph: self targetMorph].
	self abandon.! !

!SPMExpandRootMorph methodsFor: 'drawing' stamp: 'mp 7/2/2010 12:58'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas 
		fillRectangle: (self bounds bottom: self bounds origin y + 21) 
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.! !

!SPMExpandRootMorph methodsFor: 'building' stamp: 'mp 7/2/2010 14:59'!
expandSizeOfTarget
	| minSize width |
	self extent: self targetMorph extent.
	minSize := self targetMorph children size * self class minimumSize.
	self segmentationDirection == #horizontal
		ifTrue: [
			width := self targetMorph width * (minSize / self targetMorph width) ceiling.
			width > self class minWidth
				ifTrue: [^ self width: width]
				ifFalse: [^ self width: self class minWidth]].
	self segmentationDirection == #vertical
		ifTrue: [
			self width > self class minWidth
				ifFalse: [self width: self class minWidth].			
			^ self height: self targetMorph height * (minSize / self targetMorph height) ceiling].
	self extent: self targetMorph extent * 2.
	! !

!SPMExpandRootMorph methodsFor: 'event handling' stamp: 'mp 7/2/2010 10:03'!
handlesMouseDown: evt

	^ false! !

!SPMExpandRootMorph methodsFor: 'event handling' stamp: 'mp 7/2/2010 17:25'!
handlesMouseOver: evt

	^ false! !

!SPMExpandRootMorph methodsFor: 'accessing' stamp: 'mp 7/1/2010 17:53'!
segmentationDirection

	^ self targetMorph segmentationDirection! !

!SPMExpandRootMorph methodsFor: 'initialization' stamp: 'mp 7/1/2010 17:53'!
setWeight

	^ self targetMorph setWeight! !

!SPMExpandRootMorph methodsFor: 'accessing' stamp: 'mp 7/1/2010 18:28'!
sourceCodeEntity

	^ self targetMorph sourceCodeEntity! !

!SPMExpandRootMorph methodsFor: 'accessing' stamp: 'mp 7/1/2010 17:52'!
targetMorph
	"Answer the value of targetMorph"

	^ targetMorph! !

!SPMExpandRootMorph methodsFor: 'accessing' stamp: 'mp 7/1/2010 17:52'!
targetMorph: anObject
	"Set the value of targetMorph"

	targetMorph := anObject! !

SPMPathMapMorph subclass: #SPMMethodCategoryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

SPMMethodCategoryMorph subclass: #SPMAllMethodCategoriesMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMAllMethodCategoriesMorph methodsFor: 'building' stamp: 'mp 10/26/2010 12:12:55.264'!
children
	| children |
	self isInheritedTestSelectorsMethodCategory
		ifTrue: [^ self inheritedTestSelectors].
	self isClassCategory
		ifTrue: [children :=  self project
					methodsPerClass: self parentMorph sourceCodeEntity class
					withQuick: self globalOptions showQuickAndAccessorMethods]
		ifFalse: [children := self project
					methodsPerClass: self parentMorph sourceCodeEntity 
					withQuick: self globalOptions showQuickAndAccessorMethods].
	self pathMap sortMorphsByStaticMetric 
		ifTrue: [^ self sortChildrenByStaticMetric: children]
		ifFalse: [^ children].! !

!SPMAllMethodCategoriesMorph methodsFor: 'building' stamp: 'mp 9/29/2010 13:36:29.118'!
setWeight
	self isInheritedTestSelectorsMethodCategory
		ifTrue: [^ self weight: self inheritedTestSelectors size].
	self isClassCategory
		ifTrue: [self weight: (self project
					nomOfOneSideClass: self parentMorph sourceCodeEntity class
					withQuick: self globalOptions showQuickAndAccessorMethods)]
		ifFalse: [self weight: (self project
					nomOfOneSideClass: self parentMorph sourceCodeEntity
					withQuick: self globalOptions showQuickAndAccessorMethods)].! !

!SPMMethodCategoryMorph class methodsFor: 'constants' stamp: 'mp 9/29/2010 13:25:05.566'!
inheritedTestSelectorId
	^ #'inherited test selectors'! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/28/2010 10:48:29.404'!
adjustMorphsInDimension: aCollection
	| requiredDimension remainingDimension pos |
	requiredDimension := aCollection inject: 0 into: [:sum : each | 
								sum := sum + (self getChildDimension: each)].
	remainingDimension := self dimension - requiredDimension.
	[remainingDimension > 0] whileTrue: [
		"Scale and set position of all childs + 1"
		aCollection reverseDo: [:each | 
			remainingDimension = 0 ifTrue: [^ self].
			remainingDimension := remainingDimension - 1.
			self setChild: each 
				position: each positionOppositeDimension + remainingDimension 
				oppositePosition: each positionDimension.
			self setChild: each dimension: (self getChildDimension: each) + 1].
	
		"push all childs to top of dimension"
		remainingDimension = 0 ifTrue: [^ self].
		pos := self positionDimension.
		aCollection do: [:each | 
			self setChild: each 
				position: pos 
				oppositePosition: each positionDimension..
			pos := pos + each oppositeDimension]].! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/28/2010 11:21:00.693'!
adjustOppositeDimensionOfLastMorphs: aCollection matrixDimension: aPoint
	"Adjust opposite dimension of included morphs in case of method morphs it means width adjusment"
	| rest |
	rest := self oppositeDimension - ((self oppositeDimension / aPoint y) floor * aPoint y).
	rest = 0 ifFalse: [aCollection do: [:each | 
					self setChild: each 
						oppositeDimension: ((self getChildOppositeDimension: each) + rest)]].! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/29/2010 10:20:08.865'!
arrangeChildren
	"Set extent and position of morphs"
	"Arranging morphs in a matrix instead of a list (better space usage)"
	| children maxPossibleChildrenInList |
	children := self children.
	maxPossibleChildrenInList := (self dimension / self class minimumSize) floor.
	maxPossibleChildrenInList = 0 
		ifTrue: [self availableSize: maxPossibleChildrenInList isNotSufficientFor: children. 
				^ false].
	children size > maxPossibleChildrenInList
		ifTrue: [^ self arrangeChildrenInMatrix: children]
		ifFalse: [^ super arrangeChildren].! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 7/9/2010 17:25:15.213'!
arrangeChildrenInMatrix: aCollection
	| childrenDim childrenOppDim matrixDim enoughSpace |
	childrenDim := (self dimension / self class minimumSize) floor.
	childrenOppDim := (aCollection size / childrenDim) ceiling.
	matrixDim := childrenDim@childrenOppDim.
	enoughSpace := (self 
						enoughSpaceForCollection: aCollection 
						matrixDimension: matrixDim).
	enoughSpace 
		ifTrue: [self arrangeMorphsInMatrixLayout: aCollection matrixDimension: matrixDim].
	^ enoughSpace! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/28/2010 11:16:15.08'!
arrangeMorphsInMatrixLayout: aCollection matrixDimension: aPoint
	|  lastChildren |
	lastChildren := self setMorphsInMatrixLayout: aCollection matrixDimension: aPoint.
	self adjustOppositeDimensionOfLastMorphs: lastChildren matrixDimension: aPoint.! !

!SPMMethodCategoryMorph methodsFor: 'menu actions' stamp: 'mp 7/9/2010 17:36:40.1'!
browse

	SystemBrowser default fullOnClass: self parentMorph sourceCodeEntity.! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 10/26/2010 12:04:02.268'!
children
	| children |
	self isInheritedTestSelectorsMethodCategory
		ifTrue: [^ self inheritedTestSelectors].
	children := self project 
		methodsPerClass: self parentMorph sourceCodeEntity 
		andMethodCategory: self sourceCodeEntity
		withQuick: self globalOptions showQuickAndAccessorMethods.
	self pathMap sortMorphsByStaticMetric 
		ifTrue: [^ self sortChildrenByStaticMetric: children]
		ifFalse: [^ children].
	! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 7/7/2010 17:54:07.515'!
childrenMorphClass

	^ SPMMethodMorph! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 6/30/2010 10:10'!
enoughSpaceForCollection: aCollection matrixDimension: aPoint
	| enoughSpaceIsAvailable |
	enoughSpaceIsAvailable := (self oppositeDimension / aPoint y) >= self class minimumSize.
	enoughSpaceIsAvailable ifFalse: [self availableSize: aPoint x * (self oppositeDimension / self class minimumSize) 
								 isNotSufficientFor: aCollection].
	^ enoughSpaceIsAvailable! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/29/2010 13:32:28.941'!
inheritedTestSelectors
	| klass |
	klass := self parentMorph sourceCodeEntity.
	^ (klass allTestSelectors reject: [:each | klass testSelectors includes: each]) 
		asOrderedCollection
		! !

!SPMMethodCategoryMorph methodsFor: 'testing' stamp: 'mp 10/26/2010 12:19:43.913'!
isClassCategory
	^ self sourceCodeEntity includesSubString: ' (class)'! !

!SPMMethodCategoryMorph methodsFor: 'testing' stamp: 'mp 9/29/2010 13:34:04.634'!
isInheritedTestSelectorsMethodCategory
	^ self sourceCodeEntity = self class inheritedTestSelectorId! !

!SPMMethodCategoryMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:50:17.559'!
isMethodCategoryMorph
	^ true! !

!SPMMethodCategoryMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:32'!
mouseEnter: evt

	super mouseEnter: evt.
	self labelMorph position: self position x @ (self position y + self height).! !

!SPMMethodCategoryMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 15:58'!
segmentationDirection
	"return either #vertical or #horizontal"

	^ #vertical! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/28/2010 11:08:12.163'!
setMorphsInMatrixLayout: aCollection matrixDimension: aPoint
	| positionD positionOD childrenLeftFirstDim morph  morphsPerFirstDim lastMorphs | 	
	morphsPerFirstDim := (aCollection size / aPoint y) ceiling.
	positionD := self positionDimension.
	positionOD := self positionOppositeDimension.
	childrenLeftFirstDim := morphsPerFirstDim.
	lastMorphs := OrderedCollection new.
	aCollection do: [:each | 
		morph := self childrenMorphs at: each.
		lastMorphs add: morph.
		self 
			setChild: morph dimension: (self dimension / morphsPerFirstDim) floor;
			setChild: morph oppositeDimension: (self oppositeDimension / aPoint y) floor;
			setChild: morph position: positionD oppositePosition: positionOD.
		positionD := positionD + (self getChildDimension: morph).
		childrenLeftFirstDim := childrenLeftFirstDim - 1.
		childrenLeftFirstDim = 0
			ifTrue: [childrenLeftFirstDim := morphsPerFirstDim.
				positionD := self positionDimension.
				positionOD := positionOD + (self oppositeDimension / aPoint y) floor.
				self adjustMorphsInDimension: lastMorphs.
				lastMorphs := OrderedCollection new]].
	lastMorphs ifNotEmpty: [self adjustMorphsInDimension: lastMorphs].
	lastMorphs
		ifEmpty: [^ (aCollection last: morphsPerFirstDim) collect: [:each | self childrenMorphs at: each]]
		ifNotEmpty: [^ lastMorphs]! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 9/29/2010 13:36:31.557'!
setWeight
	self isInheritedTestSelectorsMethodCategory
		ifTrue: [^ self weight: self inheritedTestSelectors size].
	self weight: (self project 
					nomOfClass: self parentMorph sourceCodeEntity 
					methodCategory: self sourceCodeEntity
					withQuick: self globalOptions showQuickAndAccessorMethods).! !

!SPMMethodCategoryMorph methodsFor: 'building' stamp: 'mp 10/26/2010 12:20:23.832'!
sortChildrenByStaticMetric: aCollection
	| klass |
	self isClassCategory
		ifTrue: [klass := self parentMorph sourceCodeEntity class]
		ifFalse: [klass := self parentMorph sourceCodeEntity].
	^ aCollection sort: [:a :b | 
		((self pathMap options at: #testQuality) 
			staticCodeMetric getMetricValue: klass>>a) >=
		((self pathMap options at: #testQuality) 
			staticCodeMetric getMetricValue: klass>>b)]
	! !

SPMPathMapMorph subclass: #SPMMethodMorph
	instanceVariableNames: 'additionalColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 9/3/2010 17:26:17.579'!
additionalColors
	"Answer the value of additionalColors"

	^ additionalColors! !

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 9/3/2010 17:26:17.583'!
additionalColors: anObject
	"Set the value of additionalColors"

	additionalColors := anObject! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 8/9/2010 14:33:04.392'!
allCoveringTests
	| coveringTests methodRef |
	coveringTests := Set new.
	methodRef := self methodReference.
	self pathMap tracer ifNil: [^ coveringTests].
	self testResults keysAndValuesDo: [:test :coveredMethods |
		(coveredMethods includesKey: methodRef)
			ifTrue: [coveringTests add: test]].
	^ coveringTests asOrderedCollection! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 7/9/2010 17:36:47.365'!
browse

	SystemBrowser default fullOnClass: self parentSCEClass selector: self sourceCodeEntity! !

!SPMMethodMorph methodsFor: 'building' stamp: 'mp 5/16/2010 19:20'!
buildChildren

	self flag: #mpe. "It should not be necessary to overwrite this method if this is the last child node"! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 10/31/2010 11:21:15.32'!
chooseTestCaseFrom: aCollection
	| label |
	^ UIManager default 
		chooseFrom: (aCollection collect: [:each | label := each asString.
			each lastResult hasPassed ifTrue: [label := label, ' (passed)'].
			each lastResult hasFailures ifTrue: [label := label, ' (failed)'].
			each lastResult hasErrors ifTrue: [label := label, ' (error)'].
			label])
		values: aCollection
		lines: #() 
		title: 'Choose a test case'.! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 3/22/2011 11:21:06.896'!
debugMethod
	| tests choice |
	tests := self allCoveringTests asSortedCollection: [:a :b | 
										a asMethodReference <= b asMethodReference].
	tests ifEmpty: [^ self inform: 'No covering test found.'].
	tests size = 1 ifTrue: [^ self debugMethodFromTest: tests first asMethodReference].
	choice := self chooseTestCaseFrom: tests.
	choice ifNotNil: [self debugMethodFromTest: choice asMethodReference].! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 7/13/2010 22:00:56.865'!
debugMethodFromTest: aMethodReference
	| klass selector |
	klass := self parentSCEClass.
	selector := self sourceCodeEntity.
	[SBreakpointManager installInClass: klass selector: selector.
	aMethodReference actualClass run: aMethodReference methodSymbol] 
		ensure: [SBreakpointManager unInstall:  klass >> selector].! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 3/24/2011 16:27:06.977'!
defaultMenu
	^ OrderedCollection 
		with: {'Browse'. SImageRepository documentIcon. #browse}
		with: {'Pathfinder'. SImageRepository pathfinderIcon. #pathfinderMethod}
		with: {'Debug'. SImageRepository bugIcon. #debugMethod}! !

!SPMMethodMorph methodsFor: 'drawing' stamp: 'mp 9/3/2010 17:52:04.134'!
drawAdditionalColorsOn: aCanvas
	| offset rect orgRect cornRect |
	super drawOn: aCanvas.
	offset := ((self bounds width - 2) / self additionalColors size) rounded.
	offset <= 2 ifTrue: [^ self]. 
	self additionalColors withIndexDo: [:each :index | 
		(index = 1)
			ifTrue: [orgRect := (((index - 1) * offset) + 1)@1]
			ifFalse: [orgRect := (((index - 1) * offset))@1].
		(index = self additionalColors size)
			ifTrue: [cornRect := ((self additionalColors size - index * offset) + 1)@1]
			ifFalse: [cornRect := (self additionalColors size - index * offset)@1].
		rect := self bounds insetBy: (Rectangle origin: orgRect corner: cornRect).
		aCanvas fillRectangle: rect color: each].! !

!SPMMethodMorph methodsFor: 'drawing' stamp: 'mp 9/3/2010 17:27:13.313'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self additionalColors
		ifNotNil: [self drawAdditionalColorsOn: aCanvas].! !

!SPMMethodMorph methodsFor: 'testing' stamp: 'mp 9/29/2010 16:32:53.83'!
isInheritedTestSelector
	^ self parentMorph sourceCodeEntity = 
		SPMMethodCategoryMorph inheritedTestSelectorId! !

!SPMMethodMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:50:34.3'!
isMethodMorph
	^ true! !

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 9/29/2010 13:43:26.227'!
isSourceCodeEntityATestMethod
	self isInheritedTestSelector ifTrue: [^ true].
	(self parentSCEClass methodDict keys includes: self sourceCodeEntity)
		ifTrue: [^ (self parentSCEClass >> self sourceCodeEntity) isTestMethod]
		ifFalse: [^ (self parentSCEClass class >> self sourceCodeEntity) isTestMethod]! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 3/24/2011 16:27:54.343'!
menuActions
	| menu |
	menu := self defaultMenu.
	self isSourceCodeEntityATestMethod
		ifTrue: [menu 
					add: {'Rerun Test'. SImageRepository replayIcon. #rerunTest} 
					afterIndex: 1].
	self hasAdditionalInformation 
		ifTrue: [menu add: {'Additional Information'. 
							SImageRepository infoIcon. 
							#showAdditionalInformation}
	  				   afterIndex: 1].				
	^ menu! !

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 7/13/2010 16:40:02.72'!
methodReference

	^ MethodReference class: self parentSCEClass selector: self sourceCodeEntity! !

!SPMMethodMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:47'!
mouseEnter: evt

	| methodCategoryLabel |
	super mouseEnter: evt.
	"self labelMorph position: self position x @ (self position y + self height)."
	methodCategoryLabel := self parentMorph labelMorph.
	self labelMorph position: methodCategoryLabel position x @ 
						(methodCategoryLabel position y + methodCategoryLabel height - 1).! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 3/25/2011 12:02:29.173'!
openPathFinderToolOn: aMethodReference					
	^ self pathMap tracer pathFinderTool
		openOn: aMethodReference 
		and: self methodReference
		coverageTracer: self pathMap tracer! !

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 7/23/2010 15:42:24.405'!
parentSCEClass

	^ (self parentMorph sourceCodeEntity includesSubString: ' (class)')
		ifTrue: [self parentMorph parentMorph sourceCodeEntity class]
		ifFalse: [self parentMorph parentMorph sourceCodeEntity]! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 3/25/2011 12:02:40.412'!
pathfinderMethod
	| tests choice |
	tests := self allCoveringTests asSortedCollection: [:a :b | 
										a asMethodReference <= b asMethodReference].
	tests ifEmpty: [^ self inform: 'No covering test found.'].
	tests size = 1 
		ifTrue: [^ self openPathFinderToolOn: tests first asMethodReference].
	choice := self chooseTestCaseFrom: tests.
	choice 	ifNotNil: [^ self openPathFinderToolOn: choice asMethodReference].
					
! !

!SPMMethodMorph methodsFor: 'menu actions' stamp: 'mp 7/14/2010 09:02:45.327'!
rerunTest

	self pathMap runSpecificTest: self methodReference.! !

!SPMMethodMorph methodsFor: 'coloring' stamp: 'mp 9/3/2010 17:30:40.747'!
resetColor

	super resetColor.
	self additionalColors: nil.! !

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 16:00'!
segmentationDirection
	"return either #vertical or #horizontal"

	^ #horizontal! !

!SPMMethodMorph methodsFor: 'initialization' stamp: 'mp 5/18/2010 16:46'!
setWeight

	"| class method |
	class := self parentMorph parentMorph sourceCodeEntity.
	method := (class methodDict at: self sourceCodeEntity 
		ifAbsent: [class class methodDict at:  self sourceCodeEntity]).
	self weight: method linesOfCode."
	self weight: 1.! !

!SPMMethodMorph methodsFor: 'accessing' stamp: 'mp 7/13/2010 16:16:22.238'!
testResults

	^ self pathMap tracer testResults! !

SPMMethodMorph subclass: #SPMNullMethodMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMNullMethodMorph methodsFor: 'menu actions' stamp: 'mp 9/28/2010 18:08:33.756'!
additionalInfo
	^ ''! !

!SPMNullMethodMorph methodsFor: 'menu actions' stamp: 'mp 9/28/2010 18:08:49.999'!
additionalInfo: aString! !

!SPMNullMethodMorph methodsFor: 'menu actions' stamp: 'mp 9/28/2010 18:05:06.113'!
allCoveringTests
	^ #()! !

!SPMNullMethodMorph methodsFor: 'accessing' stamp: 'mp 9/28/2010 18:17:45.459'!
isSourceCodeEntityATestMethod

	^ false! !

!SPMNullMethodMorph methodsFor: 'accessing' stamp: 'mp 9/28/2010 18:14:13.677'!
methodReference

	^ MethodReference class: self class selector: #methodReference! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 3/16/2010 16:34'!
highlightBrightness

	^ 0.16! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 5/14/2010 17:25'!
labelBorderColor

	^ Color gray! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 5/14/2010 17:25'!
labelBorderWidth

	^ 1! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 5/14/2010 17:24'!
labelColor

	^ Color r:0.9 g:0.9 b: 0.9! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 5/14/2010 17:22'!
labelResizeFactor

	^ 1.3! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 3/16/2010 14:56'!
minimumExtent

	^ self minimumSize @ self minimumSize! !

!SPMPathMapMorph class methodsFor: 'constants' stamp: 'mp 5/27/2010 08:51'!
minimumSize

	^ 4! !

!SPMPathMapMorph class methodsFor: 'instance creation' stamp: 'mp 7/13/2010 14:58:06.234'!
parent: aMorph sourceCodeEntity: anObject pathMap: aPathMap
	^ self new
		parentMorph: aMorph;
		sourceCodeEntity: anObject;
		pathMap: aPathMap;
		setWeight;
		yourself! !

!SPMPathMapMorph methodsFor: 'menu' stamp: 'mp 7/7/2010 17:54:33.495'!
addMenuMorphOn: aTestMapMorph

	self menuMorph: (SPMMenuMorph on: aTestMapMorph).
	self addMorph: self menuMorph.
	self menuMorph position: aTestMapMorph position x @ (aTestMapMorph position y - self menuMorph height).! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 8/10/2010 15:34:12.078'!
additionalInfo
	"Answer the value of additionalInfo"

	^ additionalInfo! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 8/10/2010 15:34:12.082'!
additionalInfo: anObject
	"Set the value of additionalInfo"

	additionalInfo := anObject! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 9/27/2010 17:29:10.49'!
adjustMorphs: aCollection
	| requiredDimension remainingDimension morph |
	requiredDimension := self childrenMorphs values 
						inject: 0 into: [:sum : each | sum := sum + (self getChildDimension: each)].
	remainingDimension := self dimension - requiredDimension.
	aCollection reverseDo: [:each |
		remainingDimension = 0 ifTrue: [^ self].
		remainingDimension := remainingDimension - 1.
		morph := self childrenMorphs at: each.
		self setChild: morph position: morph positionOppositeDimension + remainingDimension.
		self setChild: morph dimension: (self getChildDimension: morph) + 1].
			! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 9/27/2010 16:55:34.504'!
arrangeChildren
	"Set extent and position of morphs"
	| children maxPossibleChildren position remainingDimension maxWeight morph |
	children := self children.
	maxPossibleChildren := (self dimension / self class minimumSize) floor.
	children size > maxPossibleChildren
		ifTrue: [
			self availableSize: maxPossibleChildren isNotSufficientFor: children.
			^ false].	
	
	position := self positionDimension.
	remainingDimension := self dimension - (children size * self class minimumSize).
	maxWeight := self childrenMorphs inject: 0 into: [:sum :each | sum := sum + each weight].
	maxWeight = 0 ifTrue: [^ true].
	children do: [:each |
		morph := self childrenMorphs at: each.
		self setChild: morph dimension: (self class minimumSize + 
									((morph weight / maxWeight) * remainingDimension) floor).
		self setChild: morph oppositeDimension: self oppositeDimension.		
		self setChild: morph position: position.
		position := position + (self getChildDimension: morph).
		].
	children ifNotEmpty: [self adjustMorphs: children].
	^ true		
! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 6/29/2010 15:16'!
availableSize: maxPossibleChildren isNotSufficientFor: children

	Transcript 
		show: children size asString, ' entities exceed the limit of ', 
			  maxPossibleChildren asString, ' entities for ', self knownName, '.'; 
		cr.! !

!SPMPathMapMorph methodsFor: 'menu actions' stamp: 'mp 7/1/2010 17:15'!
browse
	
	self subclassResponsibility.! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 6/29/2010 15:23'!
buildChildren

	self buildChildren: true.! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 6/29/2010 15:27'!
buildChildren: aBoolean
	| sufficientSpace |
	self createChildren: aBoolean.
	sufficientSpace := self arrangeChildren.
	sufficientSpace ifFalse: [self childrenMorphs valuesDo: [:each | self removeMorph: each]].
	self childrenMorphs valuesDo: [:each | each buildChildren: sufficientSpace].! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 5/14/2010 17:44'!
children

	^ #()! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 5/14/2010 17:46'!
childrenMorphClass

	self subclassResponsibility! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/14/2010 15:38'!
childrenMorphs
	"Answer the value of childrenMorphs"

	^ childrenMorphs ifNil: [childrenMorphs := Dictionary new]! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/14/2010 15:37'!
childrenMorphs: anObject
	"Set the value of childrenMorphs"

	childrenMorphs := anObject! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/9/2010 16:08:27.099'!
colorPropagation
	"Answer the value of colorPropagation"

	^ colorPropagation ifNil: [colorPropagation := SPMColorStrategy]! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 10:53:56.962'!
colorPropagation: anObject
	"Set the value of colorPropagation"

	colorPropagation := anObject! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 7/13/2010 14:58:37.721'!
createChildren: aBoolean
	| morph |
	self children do: [:each | 
		morph := self childrenMorphClass 
					parent: self sourceCodeEntity: each pathMap: self pathMap.
		aBoolean ifTrue: [self addMorph: morph].
		self childrenMorphs at: each put: morph].! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 7/9/2010 16:57:20.087'!
createLabelMorph
	| stringMorph offsetPosX offsetPosY |
	stringMorph := StringMorph contents: self sourceCodeEntity asString.
	self labelMorph: (SPMLabelMorph on: self).
	self labelMorph 
		extent: stringMorph extent * self class labelResizeFactor;
		color: self class labelColor;
		borderWidth: self class labelBorderWidth;
		borderColor: self class labelBorderColor;
		addMorph: stringMorph.
	
	self labelMorph width < self labelMorphMinWidth
		ifTrue: [self labelMorph width: self labelMorphMinWidth].
	
	offsetPosX := ((self labelMorph width - stringMorph width) / 2) rounded.
	offsetPosY := ((self labelMorph height - stringMorph height) / 2) rounded.
	stringMorph position: (stringMorph position x + offsetPosX) @ 
							(stringMorph position y + offsetPosY).
	^ self labelMorph! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:41'!
dimension
	self segmentationDirection == #horizontal
		ifTrue: [^ self width].
	self segmentationDirection == #vertical
		ifTrue: [^ self height]! !

!SPMPathMapMorph methodsFor: 'menu actions' stamp: 'mp 7/7/2010 17:55:18.01'!
expandChildren
	(self expandMorph isNil or: [self expandMorph owner isNil])
		ifTrue: [self expandMorph: (SPMExpandRootMorph on: self).
			   self expandMorph openInWorld].
	self expandMorph position: (self position x + 5) @ (self position y + 5)! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/2/2010 13:48'!
expandMorph
	"Answer the value of expandMorph"

	^ expandMorph! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/2/2010 13:48'!
expandMorph: anObject
	"Set the value of expandMorph"

	expandMorph := anObject! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:41'!
getChildDimension: aMorph
	self segmentationDirection == #horizontal
		ifTrue: [^ aMorph width].
	self segmentationDirection == #vertical
		ifTrue: [^ aMorph height]! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/18/2010 17:40'!
getChildOppositeDimension: aMorph
	self segmentationDirection == #horizontal
		ifTrue: [^ aMorph height].
	self segmentationDirection == #vertical
		ifTrue: [^ aMorph width]! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 9/27/2010 17:22:53.329'!
globalOptions

	^ self pathMap options at: #globalOptions! !

!SPMPathMapMorph methodsFor: 'event handling' stamp: 'mp 3/16/2010 16:37'!
handlesMouseDown: evt

	^ true! !

!SPMPathMapMorph methodsFor: 'event handling' stamp: 'mp 3/30/2010 17:51'!
handlesMouseOver: anEvent

	^ true! !

!SPMPathMapMorph methodsFor: 'menu actions' stamp: 'mp 8/10/2010 15:34:28.733'!
hasAdditionalInformation

	^ self additionalInfo notNil! !

!SPMPathMapMorph methodsFor: 'coloring' stamp: 'mp 3/7/2011 21:13:25.747'!
highlight
	self darken.
	[(Delay forMilliseconds: 500) wait.
	self lighten] fork.! !

!SPMPathMapMorph methodsFor: 'initialization' stamp: 'mp 5/14/2010 15:26'!
initialize

	super initialize.
	self 
		extent: self class minimumExtent;
		color: Color white;
		borderColor: #complexFramed;
		borderWidth: 1.! !

!SPMPathMapMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:49:34.643'!
isCategoryMorph
	^ false! !

!SPMPathMapMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:49:26.601'!
isClassMorph
	^ false! !

!SPMPathMapMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:49:20.455'!
isMethodCategoryMorph
	^ false! !

!SPMPathMapMorph methodsFor: 'testing' stamp: 'mp 8/11/2010 14:49:14.952'!
isMethodMorph
	^ false! !

!SPMPathMapMorph methodsFor: 'testing' stamp: 'mp 5/14/2010 18:06'!
knownName

	^ self sourceCodeEntity asString! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/15/2010 17:40'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph ifNil: [self createLabelMorph]! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 3/30/2010 15:56'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!SPMPathMapMorph methodsFor: 'building' stamp: 'mp 5/14/2010 17:28'!
labelMorphMinWidth
	
	^ self width! !

!SPMPathMapMorph methodsFor: 'menu actions' stamp: 'mp 3/24/2011 16:27:43.229'!
menuActions
	| menu |
	menu := OrderedCollection
		with: {'Browse'. SImageRepository documentIcon. #browse}
		with: {'Expand Children'. SImageRepository loupeIcon. #expandChildren}.
	self hasAdditionalInformation 
		ifTrue: [menu add: {'Additional Information'. 
							SImageRepository infoIcon. 
							#showAdditionalInformation}].
	^ menu! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/2/2010 17:14'!
menuMorph
	"Answer the value of menuMorph"

	^ menuMorph! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/2/2010 17:14'!
menuMorph: anObject
	"Set the value of menuMorph"

	menuMorph := anObject! !

!SPMPathMapMorph methodsFor: 'menu' stamp: 'mp 7/2/2010 17:13'!
menuMorphFor: aTestMapMorph
	aTestMapMorph == self ifTrue: [^ self removeMenuMorph]. "Just a click on the menu morph"
	self menuMorph 
		ifNil: [self addMenuMorphOn: aTestMapMorph]
		ifNotNil: [
			self menuMorph targetMorph == aTestMapMorph
				ifTrue: [self removeMenuMorph]
				ifFalse: [self 
						removeMenuMorph;
						addMenuMorphOn: aTestMapMorph]].! !

!SPMPathMapMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:32'!
mouseEnter: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness negated).
	self rootMorph addMorph: self labelMorph.! !

!SPMPathMapMorph methodsFor: 'event handling' stamp: 'mp 7/1/2010 17:36'!
mouseLeave: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness).
	self labelMorph owner ifNotNil: [self rootMorph removeMorph: self labelMorph].! !

!SPMPathMapMorph methodsFor: 'event handling' stamp: 'mp 6/30/2010 11:19'!
mouseUp: anEvent

	self rootMorph menuMorphFor: self.! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:42'!
oppositeDimension
	self segmentationDirection == #horizontal
		ifTrue: [^ self height].
	self segmentationDirection == #vertical
		ifTrue: [^ self width]! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/14/2010 15:37'!
parentMorph
	"Answer the value of parentMorph"

	^ parentMorph! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/14/2010 15:37'!
parentMorph: anObject
	"Set the value of parentMorph"

	parentMorph := anObject! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:55:59.437'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:55:59.441'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:43'!
positionDimension
	self segmentationDirection == #horizontal
		ifTrue: [^ self position x].
	self segmentationDirection == #vertical
		ifTrue: [^ self position y]! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/18/2010 16:17'!
positionOppositeDimension
	self segmentationDirection == #horizontal
		ifTrue: [^ self position y].
	self segmentationDirection == #vertical
		ifTrue: [^ self position x]! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:56:10.896'!
project
	"Answer the value of project"

	^ self pathMap project! !

!SPMPathMapMorph methodsFor: 'coloring' stamp: 'mp 7/9/2010 16:04:05.137'!
propagateColor: aColor
	aColor = self color 
		ifFalse: [super color: aColor.
				self parentMorph 
					ifNotNil: [self parentMorph colorPropagation for: self parentMorph]].
! !

!SPMPathMapMorph methodsFor: 'menu' stamp: 'mp 7/2/2010 17:13'!
removeMenuMorph
	self menuMorph ifNotNil: [
		self removeMorph: self menuMorph.
		self menuMorph abandon.
		self menuMorph: nil].! !

!SPMPathMapMorph methodsFor: 'menu actions' stamp: 'mp 8/10/2010 15:46:49.931'!
resetAdditionalInfo

	self additionalInfo: nil.! !

!SPMPathMapMorph methodsFor: 'coloring' stamp: 'mp 7/9/2010 16:19:19.704'!
resetColor

	self color: Color white.
	self colorPropagation: nil.! !

!SPMPathMapMorph methodsFor: 'coloring' stamp: 'mp 8/11/2010 14:40:23.27'!
resetVisibility
	
	self visible ifFalse: [self show].! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 12:43'!
rootMorph

	self parentMorph ifNil: [^ self ].
	^ self parentMorph rootMorph! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 15:38'!
segmentationDirection
	"return either #vertical or #horizontal"

	self subclassResponsibility.! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:44'!
setChild: aMorph dimension: anInteger
	self segmentationDirection == #horizontal
		ifTrue: [^ aMorph width: anInteger].
	self segmentationDirection == #vertical
		ifTrue: [^ aMorph height: anInteger]! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:45'!
setChild: aMorph oppositeDimension: anInteger
	self segmentationDirection == #horizontal
		ifTrue: [^ aMorph height: anInteger].
	self segmentationDirection == #vertical
		ifTrue: [^ aMorph width: anInteger]! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/16/2010 15:46'!
setChild: aMorph position: anInteger
	self segmentationDirection == #horizontal
		ifTrue: [^ aMorph position: anInteger@self position y].
	self segmentationDirection == #vertical
		ifTrue: [^ aMorph position: self position x@anInteger]! !

!SPMPathMapMorph methodsFor: 'dimension' stamp: 'mp 5/18/2010 16:45'!
setChild: aMorph position: anInteger oppositePosition: anOppInteger
	self segmentationDirection == #horizontal
		ifTrue: [^ aMorph position: anInteger@anOppInteger].
	self segmentationDirection == #vertical
		ifTrue: [^ aMorph position: anOppInteger@anInteger]! !

!SPMPathMapMorph methodsFor: 'initialization' stamp: 'mp 5/16/2010 12:49'!
setWeight

	self weight: 1.! !

!SPMPathMapMorph methodsFor: 'menu actions' stamp: 'mp 8/11/2010 15:06:21.264'!
showAdditionalInformation

	self additionalInfo ifNil: [^ self].
	self inform: self additionalInfo asString.! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/14/2010 15:40'!
sourceCodeEntity
	"Answer the value of sourceCodeEntity"

	^ sourceCodeEntity! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/14/2010 15:40'!
sourceCodeEntity: anObject
	"Set the value of sourceCodeEntity"

	sourceCodeEntity := anObject! !

!SPMPathMapMorph methodsFor: 'tree functions' stamp: 'mp 5/17/2010 10:23'!
traverseAllChildsAndDo: aBlock

	self childrenMorphs do: [:each | 
		aBlock value: each.
		each traverseAllChildsAndDo: aBlock].! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 12:47'!
weight
	"Answer the value of weight"

	^ weight! !

!SPMPathMapMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 12:47'!
weight: anObject
	"Set the value of weight"

	weight := anObject! !

SPMPathMapMorph subclass: #SPMRootMorph
	instanceVariableNames: 'lineMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Morphic'!

!SPMRootMorph class methodsFor: 'as yet unclassified' stamp: 'mp 9/30/2010 11:12:35.289'!
minimumSize
	"border of classes"
	^ super minimumSize + 1! !

!SPMRootMorph class methodsFor: 'instance creation' stamp: 'mp 7/13/2010 15:00:06.384'!
on: aPathMap

	^ self new
		pathMap: aPathMap;
		yourself! !

!SPMRootMorph class methodsFor: 'constants' stamp: 'mp 7/9/2010 15:11:59.792'!
size
	^ 500@500! !

!SPMRootMorph methodsFor: 'building' stamp: 'mp 3/23/2011 18:33:50.887'!
buildChildren
	| lastTestCategoryMorph left |
	super buildChildren.
	lastTestCategoryMorph := self childrenMorphs at: self project 
										categoriesWithTests asSortedCollection last.
	left := lastTestCategoryMorph position x + lastTestCategoryMorph width - 1.
	self lineMorph: (LineMorph 
					from: left@(self position y)
					to: left@(self position y + self height - 2)
					color: Color black 
					width: 3).
	self addMorph: self lineMorph.! !

!SPMRootMorph methodsFor: 'building' stamp: 'mp 3/23/2011 17:54:45.15'!
children
	| categories |
	categories := self project categoriesOrderedByTestsFirst.
	self globalOptions showEmptyCategoriesAndClasses
		ifTrue: [^ categories]
		ifFalse: [^ categories select: [:each | 
					(self project 
						nomOfCategory: each 
						withQuick: self globalOptions 
											showQuickAndAccessorMethods) > 0]]! !

!SPMRootMorph methodsFor: 'building' stamp: 'mp 7/7/2010 17:55:38.452'!
childrenMorphClass

	^ SPMCategoryMorph! !

!SPMRootMorph methodsFor: 'initialization' stamp: 'mp 5/14/2010 16:30'!
initialize

	super initialize.
	self 
		extent: self class size;
		borderColor: Color lightGray.! !

!SPMRootMorph methodsFor: 'accessing' stamp: 'mp 3/23/2011 18:31:06.456'!
lineMorph
	"Answer the value of lineMorph"

	^ lineMorph! !

!SPMRootMorph methodsFor: 'accessing' stamp: 'mp 3/23/2011 18:31:06.462'!
lineMorph: anObject
	"Set the value of lineMorph"

	lineMorph := anObject! !

!SPMRootMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:35'!
mouseEnter: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness negated).! !

!SPMRootMorph methodsFor: 'event handling' stamp: 'mp 5/16/2010 19:35'!
mouseLeave: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness).! !

!SPMRootMorph methodsFor: 'building' stamp: 'mp 3/23/2011 18:32:19.255'!
reset

	self color: Color white.
	self lineMorph ifNotNil: [
		self removeMorph: self lineMorph.
		self lineMorph abandon].
	self childrenMorphs valuesDo: [:each | each abandon].
	self childrenMorphs: nil.
	Smalltalk garbageCollect. "Many objects are ready to be removed"! !

!SPMRootMorph methodsFor: 'accessing' stamp: 'mp 5/16/2010 15:39'!
segmentationDirection
	"return either #vertical or #horizontal"

	^ #horizontal! !

RectangleMorph subclass: #SViewEntryMorph
	instanceVariableNames: 'borders label classMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

SViewEntryMorph subclass: #SClassEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SClassEntryMorph methodsFor: 'menu actions' stamp: 'mp 1/25/2011 20:49:06.14'!
browseClass

	self klass browse.! !

!SClassEntryMorph methodsFor: 'menu' stamp: 'mp 3/24/2011 16:26:57.785'!
menuActions
	^ OrderedCollection
		with: {'Browse'. SImageRepository documentIcon. #browseClass}
		with: {'Super Class'. SImageRepository bugIcon. #openSuperClass}! !

!SClassEntryMorph methodsFor: 'menu actions' stamp: 'mp 1/25/2011 20:49:16.535'!
openSuperClass
	| morph |
	morph := (SClassViewMorph on: self klass superclass) openInHand.
	NCAAConnectorMorph fromMorph: self classMorph toMorph: morph.! !

SViewEntryMorph subclass: #SExpandableViewEntryMorph
	instanceVariableNames: 'expanded entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

SExpandableViewEntryMorph subclass: #SBehaviorEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SBehaviorEntryMorph methodsFor: 'expanding' stamp: 'mp 1/26/2011 10:20:09.556'!
addEntries
	| morph |
	self klass organization categories withIndexDo: [:each :index | 
		morph := SMethodCategoryEntryMorph label: each on: self classMorph.
		self addMorphBack: morph.
		self entries add: morph].! !

!SExpandableViewEntryMorph methodsFor: 'expanding' stamp: 'mp 1/25/2011 21:04:17.975'!
addEntries! !

!SExpandableViewEntryMorph methodsFor: 'expanding' stamp: 'mp 1/25/2011 21:04:00.914'!
collapseMorphs
	self expanded: false.
	self removeEntries.! !

!SExpandableViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 20:55:22.409'!
entries
	"Answer the value of entries"

	^ entries! !

!SExpandableViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 20:55:22.414'!
entries: anObject
	"Set the value of entries"

	entries := anObject! !

!SExpandableViewEntryMorph methodsFor: 'expanding' stamp: 'mp 1/26/2011 10:16:21.287'!
expandMorphs
	self expanded ifFalse: [self addEntries.].
	self expanded: true.! !

!SExpandableViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 20:55:22.398'!
expanded
	"Answer the value of expanded"

	^ expanded! !

!SExpandableViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 20:55:22.404'!
expanded: anObject
	"Set the value of expanded"

	expanded := anObject! !

!SExpandableViewEntryMorph methodsFor: 'initialization' stamp: 'mp 1/25/2011 21:00:11.054'!
initialize

	super initialize.
	self 
		entries: OrderedCollection new;
		listDirection: #topToBottom;
		expanded: false.! !

!SExpandableViewEntryMorph methodsFor: 'menu' stamp: 'mp 3/24/2011 16:26:07.413'!
menuActions
	| menu |
	menu := super menuActions.
	self expanded
		ifTrue: [menu add: {'Collapse'. SImageRepository loupeIcon. #collapseMorphs}]
		ifFalse: [menu add: {'Expand'. SImageRepository treeIcon. #expandMorphs}].
	^ menu! !

!SExpandableViewEntryMorph methodsFor: 'expanding' stamp: 'mp 1/25/2011 21:04:08.829'!
removeEntries
	self entries do: [:each | self removeMorph: each].! !

SExpandableViewEntryMorph subclass: #SMethodCategoryEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SMethodCategoryEntryMorph class methodsFor: 'constants' stamp: 'mp 1/26/2011 10:35:23.803'!
borders

	^ #()! !

!SMethodCategoryEntryMorph class methodsFor: 'constants' stamp: 'mp 1/26/2011 10:36:16.616'!
labelEmphasis

	^ 2! !

!SMethodCategoryEntryMorph methodsFor: 'expanding' stamp: 'mp 1/26/2011 10:27:19.672'!
addEntries
	| method |
	(self klass organization listAtCategoryNamed: self label) withIndexDo: [:each :index | 
		method := SMethodEntryMorph label: each on: self classMorph.
		self addMorphBack: method.
		self entries add: method].! !

SExpandableViewEntryMorph subclass: #SMethodEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SMethodEntryMorph class methodsFor: 'constants' stamp: 'mp 1/26/2011 10:27:59.241'!
borders

	^ #()! !

!SMethodEntryMorph class methodsFor: 'constants' stamp: 'mp 1/26/2011 10:27:52.418'!
inset

	^ 0! !

!SMethodEntryMorph class methodsFor: 'constants' stamp: 'mp 1/26/2011 10:28:32.08'!
labelPosition

	^ #left! !

!SMethodEntryMorph methodsFor: 'expanding' stamp: 'mp 1/26/2011 11:14:43.006'!
addEntries
	| model definitionPanel |
	model := SDefinitionModel new.
	model setClass: self klass andSelector: self label asSymbol.
	definitionPanel := PluggableTextMorphPlus new.
	definitionPanel useDefaultStyler.
	definitionPanel 
		on: model 
		text: #contents 
		accept: nil
		readSelection: nil 
		menu: nil.
	definitionPanel 
		font: Preferences standardCodeFont;
		getColorSelector: nil;
		borderColor: Color lightGray;
		borderWidth: 1;
		color: Color white;
		extent: 400@100.
	self addMorphBack: definitionPanel.
	self entries add: definitionPanel! !

SExpandableViewEntryMorph subclass: #SStateEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SStateEntryMorph methodsFor: 'expanding' stamp: 'mp 1/25/2011 21:32:18.899'!
addEntries
	| instVar |
	self klass instVarNames withIndexDo: [:each :index | 
		instVar := SInstVarEntryMorph label: each on: self classMorph.
		self addMorphBack: instVar.
		self entries add: instVar].! !

SViewEntryMorph subclass: #SInstVarEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-ClassMorph'!

!SInstVarEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 21:24:04.679'!
borders

	^ #()! !

!SInstVarEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 21:26:46.444'!
inset

	^ 0! !

!SInstVarEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 21:24:26.235'!
labelPosition

	^ #left! !

!SInstVarEntryMorph methodsFor: 'menu' stamp: 'mp 3/24/2011 16:28:35.902'!
menuActions
	^ super menuActions
		add: {'Open Association'. 
			   SImageRepository pathfinderIcon. 
			   #openNewClassViewFrom};
		yourself! !

!SInstVarEntryMorph methodsFor: 'menu actions' stamp: 'mp 1/26/2011 10:03:05.677'!
openNewClassViewFrom
	| string klass morph |
	string := self label.
	(SProject current typesBucket includesMemberTypeMapFor: self klass)
		ifTrue: [	klass := SProject current typesBucket 
							memberTypeFor: (self klass instVarIndexFor: string ifAbsent: []) 
							in: self klass].
	klass 
		ifNil: [string := UIManager default request: 'Insert class'.
			  klass := Smalltalk at: string asSymbol ifAbsent: [^ self inform: 'Class not found.']].
	morph := (SClassViewMorph on: klass) openInHand.
	NCAAConnectorMorph fromMorph: self classMorph toMorph: morph.! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/23/2011 14:54:44.625'!
borderColor

	^ Color gray! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/23/2011 14:53:49.403'!
borders

	^ #(left right top bottom)! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 20:47:57.817'!
defaultColor

	^ Color white! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 13:26:47.305'!
highlightBrightness

	^ 0.16! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 21:25:16.256'!
inset

	^ 2! !

!SViewEntryMorph class methodsFor: 'instance creation' stamp: 'mp 1/25/2011 17:39:03.463'!
label: aString on: aClassViewMorph

	^ self new
		label: aString;
		classMorph: aClassViewMorph;
		initializeLabel;
		yourself! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/26/2011 10:33:37.214'!
labelEmphasis

	^ 0! !

!SViewEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 21:24:17.499'!
labelPosition

	^ #center! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/23/2011 14:37:32.689'!
borders
	"Answer the value of borders"

	^ borders ifNil: [borders := OrderedCollection new]! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/23/2011 14:37:18.814'!
borders: anObject
	"Set the value of borders"

	borders := anObject! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 17:40:06.307'!
classMorph
	"Answer the value of classMorph"

	^ classMorph! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 17:40:06.311'!
classMorph: anObject
	"Set the value of classMorph"

	classMorph := anObject! !

!SViewEntryMorph methodsFor: 'drawing' stamp: 'mp 1/23/2011 15:10:25.373'!
drawLine: aCanvas from: aPointFrom to: aPointTo
	aCanvas 
		line: aPointFrom
		to: aPointTo
		width: self borderWidth 
		color: self borderColor! !

!SViewEntryMorph methodsFor: 'drawing' stamp: 'mp 1/23/2011 15:14:19.935'!
drawOn: aCanvas
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle.
	"Draw borders as desired"
	(self class borders includes: #left)
		ifTrue: [self 
				drawLine: aCanvas from: self bounds topLeft to: self bounds bottomLeft].
	(self class borders includes: #right)
		ifTrue: [self 
				drawLine: aCanvas from: self bounds topRight to: self bounds bottomRight].
	(self class borders includes: #top)
		ifTrue: [self 
				drawLine: aCanvas from: self bounds topLeft to: self bounds topRight].
	(self class borders includes: #bottom)
		ifTrue: [self 
				drawLine: aCanvas from: self bounds bottomLeft to: self bounds bottomRight].! !

!SViewEntryMorph methodsFor: 'event handling' stamp: 'mp 1/25/2011 17:42:26.7'!
handlesMouseDown: anEvent
	^ true! !

!SViewEntryMorph methodsFor: 'event handling' stamp: 'mp 1/25/2011 13:49:23.264'!
handlesMouseOver: anEvent
	^ true! !

!SViewEntryMorph methodsFor: 'initialization' stamp: 'mp 1/25/2011 21:25:29.232'!
initialize

	super initialize.
	self 
		color: self class defaultColor;
		borderColor: self class borderColor;
		borderWidth: 1;
		hResizing: #spaceFill;
		layoutPolicy: TableLayout new;
		vResizing: #shrinkWrap;
		layoutInset: self class inset;
		wrapCentering: self class labelPosition.! !

!SViewEntryMorph methodsFor: 'initialization' stamp: 'mp 1/26/2011 10:33:29.319'!
initializeLabel
	| morph |
	morph := StringMorph contents: self label.
	morph emphasis: self class labelEmphasis.
	self addMorph: morph.
	! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/25/2011 18:17:41.296'!
klass

	^ self classMorph klass! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/23/2011 14:38:45.794'!
label
	"Answer the value of label"

	^ label! !

!SViewEntryMorph methodsFor: 'accessing' stamp: 'mp 1/23/2011 14:38:45.799'!
label: anObject
	"Set the value of label"

	label := anObject! !

!SViewEntryMorph methodsFor: 'menu' stamp: 'mp 1/25/2011 20:47:43.652'!
menuActions
	^ OrderedCollection new! !

!SViewEntryMorph methodsFor: 'event handling' stamp: 'mp 1/25/2011 13:33:54.528'!
mouseEnter: anEvent

	self color = self class defaultColor
		ifTrue: [self color: (self color 
								adjustBrightness: self class highlightBrightness negated)].! !

!SViewEntryMorph methodsFor: 'event handling' stamp: 'mp 1/25/2011 13:28:43.48'!
mouseLeave: anEvent

	self color: self class defaultColor.! !

!SViewEntryMorph methodsFor: 'event handling' stamp: 'mp 1/25/2011 20:48:53.517'!
mouseUp: anEvent

	self classMorph menuMorphFor: self.! !

!ToolBuilder methodsFor: '*SightL' stamp: 'mp 9/13/2010 14:44:42.133'!
pluggableFlapSpec
	^SPluggableFlapSpec! !

PluggableTreeSpec subclass: #SPluggableTreeSpec
	instanceVariableNames: 'highlightItem indentingListItemMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:51'!
highlightItem
	^ highlightItem! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:51'!
highlightItem: anObject
	highlightItem := anObject! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:18'!
indentingListItemMorph
	"Answer the value of indentingListItemMorph"

	^ indentingListItemMorph! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:18'!
indentingListItemMorph: anObject
	"Set the value of indentingListItemMorph"

	indentingListItemMorph := anObject! !

!Bitmap methodsFor: '*SightL' stamp: 'mp 7/9/2010 11:11:20.572'!
uncompressedBits
	| stream |
	stream := WriteStream on: OrderedCollection new.
	self writeUncompressedOn: stream.
	^ stream contents! !

!ObjectExplorer methodsFor: '*SightL' stamp: 'mp 7/7/2010 16:39:58.474'!
explorerListMorphFor: anObject
	|  listMorph |
	rootObject := anObject.
	listMorph := SPluggableTreeMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: #explorerKey:from:.
	listMorph setSelectedSelector: #noteNewSelection:.
	listMorph
		autoDeselect: false;
		color: Color white;
		alwaysShowScrollBars: false.
	^ listMorph! !

ObjectExplorer subclass: #SObjectExplorer
	instanceVariableNames: 'codePane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Callgraph'!

!SObjectExplorer class methodsFor: 'instance creation' stamp: 'mp 4/27/2010 19:55'!
on: aCodePane

	^ self new
		codePane: aCodePane;
		yourself! !

!SObjectExplorer methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:55'!
codePane
	"Answer the value of codePane"

	^ codePane! !

!SObjectExplorer methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:55'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SObjectExplorer methodsFor: 'menus' stamp: 'mp 7/7/2010 16:46:23.101'!
genericMenu: aMenu 
	|  menu morph |
	currentSelection
		ifNil: [menu := aMenu.
			menu
				add: '*nothing selected*'
				target: self
				selector: #yourself]
		ifNotNil: [
			morph := SObjectExplorationMorph 
						on: self codePane 
						title: currentSelection asString
						object: currentSelection 
						color: self codePane color.
			self codePane addObjectExplorationMorph: morph].
	^ aMenu! !

!SObjectExplorer methodsFor: 'accessing' stamp: 'mp 4/27/2010 20:15'!
getList
	^ (ObjectExplorerWrapper with: rootObject name: '' model: nil) contents! !

!SObjectExplorer methodsFor: 'as yet unclassified' stamp: 'mp 4/27/2010 18:39'!
noteNewSelection: anObject

	currentSelection := anObject.! !

!IndentingListItemMorph methodsFor: '*SightL' stamp: 'mp 4/16/2010 17:50'!
drawOn: aCanvas

	
	| tRect sRect columnScanner columnLeft |
	tRect := self toggleRectangle.

	sRect := self stringRectangle withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	self drawRectangleOn: aCanvas in: sRect.

	icon isNil ifFalse:[
		aCanvas
			translucentImage: icon
	
			at: sRect left @ (self top + (self height - icon height // 2)).
	

		sRect := sRect left: sRect left + icon width + 2.
	].

	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		sRect := sRect top: sRect top + sRect bottom - self fontToUse height // 2.
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: color.
	
	] ifFalse: [
		columnLeft := sRect left.
		columnScanner := ReadStream on: contents asString.
		container columns do: [ :width | | columnRect columnData |
			columnRect := columnLeft @ sRect top extent: width @ sRect height.
			columnData := columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: color
.
			].
			columnLeft := columnRect right + 5.
		].
	]
! !

!IndentingListItemMorph methodsFor: '*SightL' stamp: 'mp 4/16/2010 17:50'!
drawRectangleOn: aCanvas in: aRectangle! !

!IndentingListItemMorph methodsFor: '*SightL' stamp: 'mp 12/8/2009 09:33'!
icon: anIcon

	icon := anIcon.! !

!IndentingListItemMorph methodsFor: '*SightL' stamp: 'mp 4/14/2010 11:33'!
isCodeExplorerIndentingListItemMorph

	^ false! !

!IndentingListItemMorph methodsFor: '*SightL' stamp: 'mp 4/14/2010 12:11'!
stringRectangle

	^ bounds ! !

IndentingListItemMorph subclass: #SCodeExplorerIndentingListItemMorph
	instanceVariableNames: 'isCodeExpanded codePane minWidthOfMorph previousSibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 13:36'!
backgroundColorEven

	^ Color gray: 1.0! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 13:35'!
backgroundColorOdd

	^ Color gray: 0.9! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/16/2010 18:30'!
borderColor

	^ Color gray:0.5! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 14:27'!
borderOffset

	^  4! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 15:48'!
borderWidth
	
	^ 1! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 10:56'!
buttonSpace

	^ 3! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 20:40'!
indentingPixel

	^ 12! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 21:49'!
itemHeight
	
	^ 15! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 15:45'!
adjustCustomMorphs

	codePane ifNotNil: [ "direct access to prevent lazy initialization"
		self codePane position: (self class indentingPixel * (indentLevel + 1)) 
							@ (self position y)].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 11:56'!
callNode

	^ self complexContents item! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 13:19'!
callgraphModel

	^ self callNode callgraphModel! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:44:34.542'!
codePane
	"Answer the value of codePane"

	^ codePane ifNil: [codePane := SCodePaneMorph on: self callNode color: self getBackgroundColor].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 13:45'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/16/2010 19:39'!
computeMaxWidthOfSiblings

	| max |
	max := 0.
	self withSiblingsDo: [:each |  max := each minWidth max: max].
	self withPreviousSiblingsDo: [:each |  max := each minWidth max: max].
	^ max! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:55'!
container

	^ container! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 15:48'!
drawRectangleOn: aCanvas in: aRectangle
	| rect |
	rect := Rectangle 
			origin: (aRectangle origin x - self class borderOffset) @ (aRectangle origin y)
			corner: (aRectangle origin x + self visibleWidth + self class borderOffset) @ (aRectangle corner y).
	aCanvas 
		frameAndFillRectangle: rect 
		fillColor: self getBackgroundColor 
		borderWidth: 0 
		borderColor: self class borderColor.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/17/2010 16:54'!
getBackgroundColor

	| bgColor |
	bgColor := self class backgroundColorOdd.
	self indentLevel even ifTrue: [bgColor := self class backgroundColorEven].
	^ bgColor! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'actions' stamp: 'mp 3/24/2011 17:27:21.627'!
highlightInPathMapIfPossible
	SPMPathMap allInstances do: [:each |
		[(each 
			getMethodMorph: self callNode clientClass 
			and: self callNode clientSelector) highlight] on: Error do: []].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'initialization' stamp: 'mp 4/24/2010 14:16'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	super initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel.
	self 
		extent: self minWidth@self class itemHeight;
		isCodeExpanded: false;
		previousSibling: priorMorph.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:52'!
isCodeExpanded
	"Answer the value of isCodeExpanded"

	^ isCodeExpanded! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:52'!
isCodeExpanded: anObject
	"Set the value of isCodeExpanded"

	isCodeExpanded := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'testing' stamp: 'mp 4/14/2010 11:33'!
isCodeExplorerIndentingListItemMorph

	^ true! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:17'!
minWidthOfMorph
	"Answer the value of minWidthOfMorph"

	^ minWidthOfMorph ifNil: [minWidthOfMorph := self computeMaxWidthOfSiblings]! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
minWidthOfMorph: anObject
	"Set the value of minWidthOfMorph"

	minWidthOfMorph := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
previousSibling
	"Answer the value of previousSibling"

	^ previousSibling! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
previousSibling: anObject
	"Set the value of previousSibling"

	previousSibling := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 20:50'!
stringRectangle

	self isCodeExpanded ifFalse: [^ super stringRectangle].
	^ bounds origin corner: (bounds corner x @ (bounds origin y + self class itemHeight))! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'actions' stamp: 'mp 4/27/2010 15:47'!
toggleCodeView

	self isCodeExpanded
		ifTrue: [self 
				extent: self width@self class itemHeight;
				removeMorph: self codePane]
		ifFalse: [self 
				addMorph: self codePane;
				extent: self width@(self codePane height)].
	self isCodeExpanded: self isCodeExpanded not.
	self container adjustSubmorphPositions.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 20:51'!
toggleRectangle

	self isCodeExpanded ifFalse: [^ super toggleRectangle].
	^(bounds left + (self class indentingPixel * indentLevel)) @ bounds top 
		extent: self class indentingPixel@self class itemHeight! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/24/2010 14:20'!
visibleWidth

	^ self minWidthOfMorph! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'siblings' stamp: 'mp 4/16/2010 19:39'!
withPreviousSiblingsDo: aBlock
	"Iterate also previous siblings"
	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node previousSibling
	].! !

SCodeExplorerIndentingListItemMorph subclass: #SDebuggerCodeExplorerIndentingListItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Debugger'!

!SDebuggerCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 11/8/2010 16:32:22.369'!
codePane
	"Answer the value of codePane"
	| suspiciousColor |
	^ codePane ifNil: [
		self icon ifNotNil: [suspiciousColor := self icon colorAt: 1@1].
		codePane := SDebuggerCodePaneMorph 
										on: self callNode 
										color: self getBackgroundColor
										suspiciousColor: suspiciousColor].! !

PluggableTreeMorph subclass: #SPluggableTreeMorph
	instanceVariableNames: 'highlightItemSelector indentingListItemMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/20/2010 17:55'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean 
	"Hook for highlighting currently expanded tree nodes"
	| result |
	result := super 
		addSubmorphsAfter: parentMorph
		fromCollection: aCollection
		allowSorting: sortBoolean.
	self highlightItemSelector ifNotNil:[
		self refreshHighlightingOf: parentMorph.
		result do: [:each | self refreshHighlightingOf: each]].
	^ result! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 4/14/2010 11:34'!
adjustSubmorphPositions

	super adjustSubmorphPositions.
	scroller submorphsDo: [ :each | 
		each isCodeExplorerIndentingListItemMorph 
			ifTrue: [each adjustCustomMorphs]].! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 7/7/2010 16:42:50.962'!
contentsOfNode: node
	"Overwritten for interchanging PluggableTreeItemNode"
	| children |
	self getChildrenSelector ifNil:[^#()].
	children := self model perform: self getChildrenSelector with: node item.
	^children collect:[:item | SPluggableTreeItemNode with: item model: self]! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/29/2010 10:34'!
expandAllOfSelectedNode
	
	selectedMorph ifNil: [^ self].
	selectedMorph isExpanded ifTrue: [self toggleExpandedState: selectedMorph].
	self expandAll.! !

!SPluggableTreeMorph methodsFor: 'geometry' stamp: 'mp 3/4/2010 14:35'!
extent: aPoint

	super extent: aPoint.
	"Required for collapse systemwindow"
	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show].! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 1/20/2010 17:55'!
firstRootTreeEntry

	^ self scroller submorphs first! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:55'!
highlightItemSelector
	^ highlightItemSelector! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:55'!
highlightItemSelector: anObject
	highlightItemSelector := anObject! !

!SPluggableTreeMorph methodsFor: 'initialization' stamp: 'mp 4/14/2010 11:21'!
indentingItemClass
	
	^ self indentingListItemMorphClass! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:17'!
indentingListItemMorphClass
	"Answer the value of indentingListItemMorphClass"

	^ indentingListItemMorphClass ifNil: [indentingListItemMorphClass := IndentingListItemMorph]! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:17'!
indentingListItemMorphClass: anObject
	"Set the value of indentingListItemMorphClass"

	indentingListItemMorphClass := anObject! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/20/2010 17:55'!
insertNewMorphs: morphList 
	"Hook for highlighting root nodes after init or refresh"
	self highlightItemSelector 
		ifNotNil: [morphList do: [ :each | self refreshHighlightingOf: each ]].
	super insertNewMorphs: morphList! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refresh: aBlock fromNode: aMorph
	aMorph withSiblingsDo: [:sib | 
		aBlock value: sib.
		sib firstChild ifNotNil: [self refresh: aBlock fromNode: sib firstChild]].! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 9/22/2010 14:01:56.496'!
refreshHighlighting
	self refresh: [:node | self refreshHighlightingOf: node] fromNode: self firstRootTreeEntry! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refreshHighlightingOf: aMorph 
	(self model perform: self highlightItemSelector	with: aMorph complexContents item) 
		ifTrue: [aMorph highlight]
		ifFalse: [aMorph unhighlight]! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 18:36'!
refreshIconOf: aMorph
	aMorph icon: (self model 
					perform: self getIconSelector 
					with: aMorph complexContents item).
	aMorph changed.! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refreshIcons
	self refresh: [:node | self refreshIconOf: node] fromNode: self firstRootTreeEntry.! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 1/20/2010 17:55'!
rootMorphs
	"Answer the receiver's roots"
	^ self scroller submorphs
		select: [:each | each indentLevel isZero]! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:42:55.915'!
roots: anArray
	"Overwritten for interchanging PluggableTreeItemNode"
	roots := anArray collect:[:item| SPluggableTreeItemNode with: item model: self].
	self list: roots.! !

!SPluggableTreeMorph methodsFor: 'selection' stamp: 'mp 3/24/2011 17:26:09.673'!
setSelectedMorph: aMorph 
	| selected |
	selected := self selectedMorph.
	super setSelectedMorph: aMorph.
	(selected notNil and: [self highlightItemSelector notNil])
		ifTrue: [self refreshHighlightingOf: selected].
	(aMorph notNil and: [aMorph isCodeExplorerIndentingListItemMorph])
		ifTrue: [aMorph 
					highlightInPathMapIfPossible;
					toggleCodeView].! !

!SPluggableTreeMorph methodsFor: 'updating' stamp: 'mp 1/29/2010 10:32'!
update: what
	what ifNil:[^self].
	what == self highlightItemSelector ifTrue:[
		self refreshHighlighting.
		^self].
	what == self getIconSelector ifTrue:[
		self refreshIcons.
		^self].
	what == #expandAllOfSelectedNode ifTrue: [
		self expandAllOfSelectedNode.
		^ self].
	^super update: what! !

!ObjectExplorerWrapper methodsFor: '*SightL' stamp: 'mp 4/27/2010 18:37'!
item

	^ item! !

Browser subclass: #SBrowser
	instanceVariableNames: 'currentSelectedMethod cacheCoverage cacheConcerns refreshRequired previousMethod filterProjectCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tools'!

!SBrowser class methodsFor: 'constants' stamp: 'mp 5/3/2010 23:17'!
defaultExtent

	^ 750@390! !

!SBrowser class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 22:27:40.148'!
initialize

	self registerInAppRegistry.
	TheWorldMenu registerOpenCommand: {'PathBrowser'. {self. #open}}.! !

!SBrowser class methodsFor: 'instance creation' stamp: 'mp 3/23/2011 14:48:43.345'!
openBrowserView: aBrowserView label: aString 
	"Schedule aBrowserView, labelling the view aString."
	| morph |
	(aBrowserView isKindOf: ToolBuilderSpec) ifTrue:[
		morph := ToolBuilder open: aBrowserView label: aString.
		morph extent: self defaultExtent.
	] ifFalse:[
		aBrowserView isMorph
			ifTrue:  [(aBrowserView setLabel: aString) openInWorld]
			ifFalse: [aBrowserView label: aString.
					aBrowserView minimumSize: 300 @ 200.
					aBrowserView subViews do: [:each | each controller].
					aBrowserView controller open].
	].
	"Dependency required for label control within source code"
	(aBrowserView model dependents 
		detect: [:each | each isKindOf: SPluggableTextMorphPlus] ifNone: [nil])
		ifNotNil: [:each | 	each textMorph addDependent: aBrowserView model].
	aBrowserView model refreshAdditionalLists.
	^ aBrowserView model
! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:59:19.54'!
browsePath
	| tests |
	tests := self coveredTestsSortedFor: self selectedMethodReference.
	tests 
		ifEmpty: [self inform: 'The method is not covered by an entry point.', 
							  String cr, 
							  'Run PathMap first.']
		ifNotEmpty:[
			(self choseTest: tests asOrderedCollection)
				ifNotNil: [:choice | self openPathFinderOn: choice asMethodReference]].	! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/7/2011 22:12:22.13'!
browseWithPathView

	SPathView openOn: self selectedClassOrMetaClass.! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 5/12/2010 15:04'!
buildCodePaneWith: builder
	| textSpec top buttonSpec annoSpec |
	textSpec := builder pluggableCodePaneSpec new.
	textSpec 
		model: self;
		getText: #contents; 
		setText: #contents:notifying:; 
		selection: #contentsSelection; 
		menu: #codePaneMenu:shifted:.
	self wantsAnnotationPane ifTrue:[
		top ifNil:[
			top := builder pluggablePanelSpec new.
			top children: OrderedCollection new.
		].
		annoSpec := builder pluggableInputFieldSpec new.
		annoSpec model: self; getText: #annotation. 
		annoSpec frame: (0@0.88 corner: 1@1).
		top children add: annoSpec.
	].
	top ifNotNil:[
		textSpec frame: (0 @ (buttonSpec ifNil:[0] ifNotNil:[0.12])
			corner: 1 @ (annoSpec ifNil:[1] ifNotNil:[0.88])).
		top children add: textSpec.
	].
	^top ifNil:[textSpec]! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 3/23/2011 12:17:17.797'!
buildConcernTreeWith: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #concernTree;
		roots: #rootsConcerns;
		hasChildren: #hasChildrenConcerns:;
		getChildren: #getChildrenConcerns:;
		label: #labelConcern:;
		setSelected: #selectedConcernItem:;
		icon: #iconForConcernItem:.
	^ treeSpec! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 3/21/2011 16:12:16.756'!
buildTestCoverageListWith: builder
	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #coverageList;
		setIndex: #coverageListIndex:.
	^listSpec! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/23/2011 11:40:43.571'!
cacheConcerns
	"Answer the value of cacheConcerns"

	^ cacheConcerns ifNil: [IdentityDictionary new]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/23/2011 11:26:58.331'!
cacheConcerns: anObject
	"Set the value of cacheConcerns"

	cacheConcerns := anObject! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:06:25.408'!
cacheCoverage
	"Answer the value of cacheCoverage"

	^ cacheCoverage ifNil: [{}]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:05:36.58'!
cacheCoverage: anObject
	"Set the value of cacheCoverage"

	cacheCoverage := anObject! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/7/2011 22:10:54.281'!
choseTest: aCollectionOfTests

	^ UIManager default 
				chooseFrom: (aCollectionOfTests collect: [:each | each asStringOrText]) 
				values: aCollectionOfTests 
				lines: #() 
				title: 'Choose entry point'.! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/24/2011 16:49:40.894'!
classListIndex: anInteger 
	super classListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each getClassMorph: self selectedClass) highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/7/2011 22:12:37.138'!
classListMenu: aMenu shifted: shifted
	"Set up the menu to apply to the receiver's class list, honoring the #shifted boolean"
	(self menuHook: aMenu named: #classListMenu shifted: shifted) ifTrue:[^aMenu].
	shifted ifTrue:[^ self shiftedClassListMenu: aMenu].
	aMenu addList: #(
		-
		('browse full (b)'			browseMethodFull)
		('browse hierarchy (h)'		spawnHierarchy)
		('browse protocol (p)'		browseFullProtocol)
		('browse with PathView'	browseWithPathView)
		-
		('printOut'					printOutClass)
		('fileOut'					fileOutClass)
		-
		('show hierarchy'			hierarchy)
		('show definition'			editClass)
		('show comment'			editComment)
		-
		('inst var refs...'			browseInstVarRefs)
		('inst var defs...'			browseInstVarDefs)
		-
		('class var refs...'			browseClassVarRefs)
		('class vars'					browseClassVariables)
		('class refs (N)'				browseClassRefs)
		-
		('rename class ...'			renameClass)
		('copy class'				copyClass)
		('remove class (x)'			removeClass)
		-
		('find method...'				findMethod)
		('find method wildcard...'	findMethodWithWildcard)
		-
		('more...'					offerShiftedClassListMenu)).
	^ aMenu
! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:55:49.883'!
concernColors
	^ SProject current concerns colors! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:22:33.975'!
concernGroups
	^ SProject current concerns groups! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:25:05.84'!
concernMapping
	^ SProject current concerns mapping! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 3/21/2011 16:52:09.239'!
coverageList
	| coveredTests method |
	self refreshRequired ifFalse: [^ self cacheCoverage].
	method := self selectedMethodReference.
	method 
		ifNotNil: [coveredTests := self coveredTestsSortedFor: method.
				 self cacheCoverage: coveredTests].
	^ self cacheCoverage! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 3/24/2011 10:34:50.614'!
coverageListIndex: anInteger
	| testReference |
	anInteger <= 0 ifTrue: [^ self].
	testReference := self cacheCoverage at: anInteger.
	(UIManager default 
		chooseFrom: {'PathFinder'. 'Debugger'} 
		values: {#openPathFinderOn:. #openDebuggerOn:} 
		lines: #() 
		title: 'Choose tool')
			ifNotNil: [:choice | 
				self perform: choice with: testReference asMethodReference].
	! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 3/21/2011 16:52:32.908'!
coveredTestsSortedFor: aMethodReference
	^ (SProject current coveredTestsFor: aMethodReference)
		asSortedCollection: [:a :b | a asMethodReference <= b asMethodReference]! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 17:46'!
currentSelectedMethod
	"Answer the value of currentSelectedMethod"

	^ currentSelectedMethod! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 17:46'!
currentSelectedMethod: anObject
	"Set the value of currentSelectedMethod"

	currentSelectedMethod := anObject! !

!SBrowser methodsFor: 'initialize-release' stamp: 'mp 3/7/2011 21:41:49.34'!
defaultBrowserTitle

	^ 'PathBrowser'! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 18:26'!
filterProjectCategories
	"Answer the value of filterProjectCategories"

	^ filterProjectCategories ifNil: [filterProjectCategories := false]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 18:26'!
filterProjectCategories: anObject
	"Set the value of filterProjectCategories"

	filterProjectCategories := anObject! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:48:58.792'!
getChildrenConcerns: anObject
	^ (self cacheConcerns at: anObject) asSortedCollection! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:48:11.743'!
hasChildrenConcerns: anObject
	^ self cacheConcerns includesKey: anObject! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:56:03.104'!
iconForConcernItem: anObject
	| icon |
	(self concernColors includesKey: anObject)
		ifTrue: [
			icon := Form extent: 15@15 depth: 32.
			icon fillColor: (self concernColors at: anObject).
			^ icon].
	^ nil! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 3/19/2011 18:39:55.191'!
instVarTypeLabelFor: aWord
	| index type |
	index := self selectedClassOrMetaClass allInstVarNames indexOf: aWord.
	index = 0
		ifFalse: [
			SProject current typesBucket ifNil: [^ 'Run type harvester first'].
			type := (SProject current typesBucket 
					memberTypeFor: index 
					in: self selectedClassOrMetaClass).
			type 
				ifNil: [^ 'No type available']
				ifNotNil: [^ type asString]].
	^ ''! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:00:01.39'!
involvedConcerns
	| tests concerns projectConcerns |
	tests := self coveredTestsSortedFor: self selectedMethodReference.
	concerns := IdentityDictionary new. 
	tests 
		ifNotEmpty: [
			projectConcerns := SProject current concerns.
			projectConcerns groups keysDo: [:group |
				concerns at: group put: IdentitySet new.
				tests do: [:test | 
					concerns 
						at: group 
						put: ((concerns at: group),
							(projectConcerns 
								concernsOfGroup: group 
								andTest: test asMethodReference))]]].
		^ concerns! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:51:20.355'!
labelConcern: anObject

	^ anObject asString! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/24/2011 17:16:12.377'!
messageCategoryListIndex: anInteger
	super messageCategoryListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each 
						getMethodCategoryMorph: self selectedClassOrMetaClass 
						and: self selectedMessageCategoryName)
							highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/24/2011 16:55:23.466'!
messageListIndex: anInteger
	| ref |
	super messageListIndex: anInteger.
	anInteger = 0 "Deselect"
		ifTrue: [self 
					currentSelectedMethod: nil;
					resetCaches].
	self selectedMessageName 
		ifNil: [
			(self cacheCoverage size = 0 and: [self cacheConcerns isEmpty]) 
				ifTrue: [^ self].
			self resetCaches]
		ifNotNil: [
			ref := MethodReference 
					class: self selectedClassOrMetaClass 
					selector: self selectedMessageName.
			(self currentSelectedMethod isNil or: 
				[(self currentSelectedMethod = ref) not])
					ifTrue: [self refreshAdditionalLists].
			self currentSelectedMethod: ref].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each 
						getMethodMorph: self selectedClassOrMetaClass 
						and: self selectedMessageName) highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:50:52.934'!
messageListMenu: aMenu shifted: shifted 
	"Answer the message-list menu"
	(self menuHook: aMenu named: #messageListMenu shifted: shifted) ifTrue:[^aMenu].
	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].
	aMenu addList: #(
			('what to show...'			offerWhatToShowMenu)
			('toggle break on entry'		toggleBreakOnEntry)
			-
			('browse full (b)' 			browseMethodFull)
			('browse hierarchy (h)'			classHierarchy)
			('browse method (O)'			openSingleMessageBrowser)
			('browse protocol (p)'			browseFullProtocol)
			('browse path' 			browsePath)
			-
			('fileOut'				fileOutMessage)
			('printOut'				printOutMessage)
			-
			('senders of... (n)'			browseSendersOfMessages)
			('implementors of... (m)'		browseMessages)
			('inheritance (i)'			methodHierarchy)
			('versions (v)'				browseVersions)
			-
			('inst var refs...'			browseInstVarRefs)
			('inst var defs...'			browseInstVarDefs)
			('class var refs...'			browseClassVarRefs)
			('class variables'			browseClassVariables)
			('class refs (N)'			browseClassRefs)
			-
			('remove method (x)'			removeMessage)
			-
			('more...'				shiftedYellowButtonActivity)).
	^ aMenu! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 3/19/2011 18:46:29.873'!
methodTypesLabelFor: aWord
	| method temps index type |
	(SProject current allClasses includes: self selectedClassOrMetaClass)
		ifTrue: [
			method := self selectedClassOrMetaClass >> self selectedMessageName.
			temps := method methodNode arguments, method methodNode temporaries.
			temps ifNotEmpty: [
				temps := temps collect: [:each | each name].
				index := temps indexOf: aWord.
				index = 0
					ifFalse: [SProject current typesBucket 
								ifNil: [^ 'Run type harvester first'].
						type := (SProject current typesBucket 
									tempTypeAt: index in: method).
						type 
							ifNil: [^ 'No type available']
							ifNotNil: [^ type asString]]].
			(self selectedMessageName asString beginsWith: aWord)
				ifTrue: [SProject current typesBucket 
							ifNil: [^ 'Run type harvester first'].
					type := (SProject current typesBucket 
								returnTypeFor: method).
					type 
						ifNil: [^ '^ No type available']
						ifNotNil: [^ '^ ', type asString]]].
	^ ''! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:03:13.299'!
methodsCoveredBy: aCollection
	| key |
	^ aCollection inject: Set new into: [:set :each | 
		key := SProject current coverage keys 
							detect: [:test | test asMethodReference = each] ifNone: [nil].
		key ifNotNil: [set addAll: (SProject current coverage at: key) keys].
		set yourself]! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:29:04.11'!
openDebuggerOn: aMethodReference
	| method |
	method := self selectedMethodReference.
	[SBreakpointManager 
		installInClass: method actualClass selector: method methodSymbol.
	aMethodReference actualClass run: aMethodReference methodSymbol] 
		ensure: [SBreakpointManager unInstall: method compiledMethod].! !

!SBrowser methodsFor: 'initialize-release' stamp: 'mp 3/23/2011 11:20:02.69'!
openEditString: aString
        "Create a pluggable version of all the views for a Browser, including views and controllers."
	"Example: 
		Browser fullOnClass: Browser.
	"
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue:[0.42] ifFalse:[0.5].
	^self buildWindowWith: builder specs: {
		(0@0 corner: 0.2@max) -> [self buildSystemCategoryListWith: builder].
		(0.2@0 corner: 0.4@(max-0.08)) -> [self buildClassListWith: builder].
		(0.2@(max-0.08) corner: 0.4@max) -> [self buildSwitchesWith: builder].
		(0.4@0 corner: 0.6@max) -> [self buildMessageCategoryListWith: builder].
		(0.6@0 corner: 0.8@max) -> [self buildMessageListWith: builder].
		(0.8@0 corner: 1.0@max) -> [self buildTestCoverageListWith: builder].
		(0.8@0.5 corner: 1.0@1.0) -> [self buildConcernTreeWith: builder].
		(0@max corner: 1@0.5) -> [self buildOptionalButtonsWith: builder].
		(0@0.5 corner: 0.8@1) -> [self buildCodePaneWith: builder].
	}! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:25:17.585'!
openPathFinderOn: chosenTest

	^ SPathFinder openOn: chosenTest and: self selectedMethodReference! !

!SBrowser methodsFor: 'controls' stamp: 'mp 3/23/2011 11:58:42.824'!
optionalButtonPairs
	"Answer a tuple (formerly pairs) defining buttons, in the format:
			button label
			selector to send
			help message"

	| aList |

	aList := #(
	('browse'			browseMethodFull			'view this method in a browser')
	('senders' 			browseSendersOfMessages	'browse senders of...')
	('implementors'		browseMessages				'browse implementors of...')
	('versions'			browseVersions				'browse versions')), 

	(Preferences decorateBrowserButtons
		ifTrue:
			[{#('inheritance'		methodHierarchy 'browse method inheritance
green: sends to super
tan: has override(s)
mauve: both of the above
pink: is an override but doesn''t call super
pinkish tan: has override(s), also is an override but doesn''t call super' )}]
		ifFalse:
			[{#('inheritance'		methodHierarchy			'browse method inheritance')}]),

	#(
	('hierarchy'		classHierarchy				'browse class hierarchy')
	('inst vars'			browseInstVarRefs			'inst var refs...')
	('class vars'			browseClassVarRefs			'class var refs...')).

	^ aList! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 11:39'!
previousMethod
	"Answer the value of previousMethod"

	^ previousMethod! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 11:39'!
previousMethod: anObject
	"Set the value of previousMethod"

	previousMethod := anObject! !

!SBrowser methodsFor: 'updating' stamp: 'mp 3/23/2011 12:02:25.824'!
refreshAdditionalLists
	self 
		refreshRequired: true;
		changed: #coverageList;
		changed: #rootsConcerns;
		refreshRequired: false.! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 19:09'!
refreshRequired
	"Answer the value of refreshRequired"

	^ refreshRequired ifNil: [refreshRequired := false]! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 19:07'!
refreshRequired: anObject
	"Set the value of refreshRequired"

	refreshRequired := anObject! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/23/2011 11:28:21.757'!
resetCaches
	self 
		cacheCoverage: nil;
		cacheConcerns: nil;
		refreshAdditionalLists.! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:03:43.35'!
rootsConcerns
	(self refreshRequired and: [self selectedMethodReference notNil]) 
		ifTrue: [self cacheConcerns: self involvedConcerns].
	^ (self cacheConcerns keys 
		reject: [:each | (self cacheConcerns at: each) isEmpty]) asSortedCollection! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:51:21.96'!
selectedCategories
	
	^ SProject current categories! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 3/19/2011 18:15:03.922'!
selectedClassInPartialTrace
	^ SProject current allClasses includes: self selectedClassOrMetaClass! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:27:44.78'!
selectedConcernItem: anObject
	| tests group label |
	anObject ifNil: [^ self].
	group := self cacheConcerns includesKey: anObject.
	tests := group
				ifTrue: [self testsForConcerns: (self concernGroups at: anObject)]
				ifFalse: [self testsForConcerns: {anObject}].
	label := 'Methods of ', anObject asString, ' concern'.
	group ifTrue: [label := label, ' group'].
	SystemNavigation default
		browseMessageList: (self methodsCoveredBy: tests) asSortedCollection
		name: label
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:18:45.251'!
selectedMethodReference
	(self selectedClassOrMetaClass isNil or: [self selectedMessageName isNil])
		ifTrue: [^ nil].
	^ MethodReference 
		class: self selectedClassOrMetaClass selector: self selectedMessageName.! !

!SBrowser methodsFor: 'updating' stamp: 'mp 3/21/2011 16:25:26.401'!
setMethodRefAndRefreshSendersSelection: aMethodRef

	| prevRef |
	prevRef := self selectedMethodReference.
	self setClass: aMethodRef actualClass selector: aMethodRef methodSymbol.
	self setSelectionInSendersFrom: prevRef! !

!SBrowser methodsFor: 'updating' stamp: 'mp 5/12/2010 11:48'!
setSelectionInImplementorsFrom: aMethodReference

		self previousMethod: aMethodReference.
		self changed: #implementorsListIndex.
		self previousMethod: nil.
		self changed: #senderListIndex! !

!SBrowser methodsFor: 'updating' stamp: 'mp 5/12/2010 11:47'!
setSelectionInSendersFrom: aMethodReference

		self previousMethod: aMethodReference.
		self changed: #senderListIndex.
		self previousMethod: nil.
		self changed: #implementorsListIndex! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/24/2011 17:00:55.888'!
systemCategoryListIndex: anInteger 
	super systemCategoryListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each getCategoryMorph: self selectedSystemCategoryName)
						 highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:53:32.926'!
testsForConcerns: aCollection
	| set |
	set := Set new.
	aCollection do: [:concern | 
		set addAll: (self concernMapping at: concern)].
	^ set! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 3/19/2011 18:22:37.232'!
update: aWord with: aTextMorph
	| label |	
	label := ''.
	self selectedClassOrMetaClass
		ifNotNil: [self selectedClassInPartialTrace
					ifTrue: [label := self selectedMessageName
										ifNil: [self instVarTypeLabelFor: aWord]
										ifNotNil: [self methodTypesLabelFor: aWord]]].
	aTextMorph labelMorph createLabelMorph: label.! !

SketchMorph subclass: #SMiniMap
	instanceVariableNames: 'viewAreaMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PV-Morphic'!

!SMiniMap class methodsFor: 'instance creation' stamp: 'mp 1/22/2011 22:25:59.585'!
on: aPasteUpMorph

	^ self new
		viewAreaMorph: aPasteUpMorph;
		yourself! !

!SMiniMap methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2011 22:54:06.784'!
drawBorder
	originalForm getCanvas 
		frameRectangle: ((0@0) 
		corner: (self viewAreaMorph extent)) 
		width: 25
		color: Color gray.! !

!SMiniMap methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2011 22:48:31.731'!
refreshForm: aForm
	originalForm := aForm.
	self extent: originalForm extent.! !

!SMiniMap methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2011 22:38:00.127'!
step

	self refreshForm: self viewAreaMorph imageForm.
	self drawBorder.! !

!SMiniMap methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2011 22:33:43.697'!
stepTime
	
	^ 1000! !

!SMiniMap methodsFor: 'accessing' stamp: 'mp 1/22/2011 22:26:13.262'!
viewAreaMorph
	"Answer the value of viewAreaMorph"

	^ viewAreaMorph! !

!SMiniMap methodsFor: 'accessing' stamp: 'mp 1/22/2011 22:26:13.267'!
viewAreaMorph: anObject
	"Set the value of viewAreaMorph"

	viewAreaMorph := anObject! !

MwMethodWrapper subclass: #SAroundWrapperMethodOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

!SAroundWrapperMethodOne methodsFor: 'evaluating' stamp: 'mp 3/5/2010 12:48'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	self beforeMethod.
	^ [
		false
	] ensure: [self afterMethod]! !

MwMethodWrapper subclass: #SAroundWrapperMethodTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

!SAroundWrapperMethodTwo methodsFor: '-- all --' stamp: 'mp 3/5/2010 12:51'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."

	self beforeMethod.
	^ [
		(self clientMethod valueWithReceiver: anObject arguments: #(2)) + 1.
	] ensure: [self afterMethod]! !

MwMethodWrapper subclass: #SBeforeWrapper
	instanceVariableNames: 'touched'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

!SBeforeWrapper methodsFor: 'evaluating' stamp: 'mp 2/22/2010 09:32'!
beforeMethod

	self touched: self touched + 1.! !

!SBeforeWrapper methodsFor: '-- all --' stamp: 'mp 1/22/2010 14:58'!
initialize

	self touched: 0.! !

!SBeforeWrapper methodsFor: 'accessing' stamp: 'mp 1/22/2010 14:41'!
touched
	"Answer the value of touched"

	^ touched! !

!SBeforeWrapper methodsFor: 'accessing' stamp: 'mp 1/22/2010 14:41'!
touched: anObject
	"Set the value of touched"

	touched := anObject! !

MwMethodWrapper subclass: #SCallWrapper
	instanceVariableNames: 'ids tracer callsBefore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

!SCallWrapper class methodsFor: 'instance creation' stamp: 'mp 1/25/2010 14:25'!
on: aSymbol inClass: aClass withTracer: aTracer

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SCallWrapper methodsFor: 'evaluating' stamp: 'mp 1/25/2010 18:10'!
afterMethod

	self tracer returnFromNode: self ids removeLast.! !

!SCallWrapper methodsFor: 'evaluating' stamp: 'mp 6/15/2010 16:09'!
beforeMethod: anObject
	self ids add: (self tracer 
				createNewCallNodeOn: self wrappedClass 
				with: self clientSelector
				receiverType: anObject class
				callsBefore: self callsBefore).
	self callsBefore: self callsBefore + 1.! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 6/15/2010 16:08'!
callsBefore
	"Answer the value of callsBefore"

	^ callsBefore! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 6/15/2010 16:08'!
callsBefore: anObject
	"Set the value of callsBefore"

	callsBefore := anObject! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:09'!
ids
	"Answer the value of ids"

	^ ids! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:09'!
ids: anObject
	"Set the value of ids"

	ids := anObject! !

!SCallWrapper methodsFor: '-- all --' stamp: 'mp 6/15/2010 16:09'!
initialize

	self ids: OrderedCollection new.
	self callsBefore: 0.! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 15:22'!
selectedView: aSymbol! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:24'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SCallWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:24'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

!SCallWrapper methodsFor: 'evaluating' stamp: 'mp 5/5/2010 12:18'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	self 
		beforeMethod;
		beforeMethod: anObject.
	^ [
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod]! !

SCallWrapper subclass: #SExploreEvaluationWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Evaluation'!

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/6/2010 18:23'!
afterMethod! !

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/16/2010 20:15'!
aroundWithReceiver: aReceiver arguments: anArrayOfObjects
	
	| result types |
	"#arguments #selfBefore #selfAfter #return #types"
	self tracer isActive ifTrue: [
		self tracer stopTracing.
		anArrayOfObjects isEmpty not
			ifTrue: [	types := OrderedCollection new.
					anArrayOfObjects do: [:each | types add: each class].
					types add: aReceiver class.
					self tracer addView: types to: #types.
					"self tracer addView: anArrayOfObjects veryDeepCopy to: #arguments.
					self tracer addView: aReceiver veryDeepCopy to: #selfBefore."
					].
		self tracer startTracing].
	^ [result := self proceed: aReceiver arguments: anArrayOfObjects.
	     result]
		ensure: [ 	
			self tracer isActive ifTrue: [
				self tracer stopTracing.
				"self tracer addView: aReceiver veryDeepCopy to: #selfAfter.
				self tracer addView: result veryDeepCopy to: #result."
				self tracer addView: result class to: #resultType.
				self tracer startTracing]]! !

!SExploreEvaluationWrapper methodsFor: '-- all --' stamp: 'mp 2/6/2010 18:23'!
beforeMethod! !

SCallWrapper subclass: #SViewWrapper
	instanceVariableNames: 'selectedView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

SViewWrapper subclass: #SProfilingWrapper
	instanceVariableNames: 'stopwatchs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

!SProfilingWrapper methodsFor: 'evaluating' stamp: 'mp 1/26/2010 09:29'!
afterMethod

	| stopwatch |
	stopwatch := self stopwatchs removeLast.
	stopwatch suspend.
	self tracer addProfileInformation:  stopwatch duration node: self ids last.
	super afterMethod.! !

!SProfilingWrapper methodsFor: 'evaluating' stamp: 'mp 1/26/2010 09:28'!
beforeMethod

	super beforeMethod.
	self stopwatchs add: Stopwatch new.
	self stopwatchs last activate.! !

!SProfilingWrapper methodsFor: '-- all --' stamp: 'mp 1/26/2010 09:28'!
initialize

	super initialize.
	self stopwatchs: OrderedCollection new.! !

!SProfilingWrapper methodsFor: 'accessing' stamp: 'mp 1/26/2010 09:28'!
stopwatchs
	"Answer the value of stopwatchs"

	^ stopwatchs! !

!SProfilingWrapper methodsFor: 'accessing' stamp: 'mp 1/26/2010 09:28'!
stopwatchs: anObject
	"Set the value of stopwatchs"

	stopwatchs := anObject! !

!SViewWrapper methodsFor: 'accessing' stamp: 'mp 6/28/2010 22:28'!
getViewString: anObject

	self selectedView == #identities
		ifTrue: ["^ self wrappedClass asString, '(', anObject identityHash, ')'"
			^ anObject identityHash].		
	self selectedView == #objects
		ifTrue: [^ [anObject asString] ifError: ['Error cannot print object']].
	self selectedView == #classes
		ifTrue: [^ self wrappedClass asString].
! !

!SViewWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:38'!
selectedView
	"Answer the value of selectedView"

	^ selectedView! !

!SViewWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 14:38'!
selectedView: anObject
	"Set the value of selectedView"

	selectedView := anObject! !

!SViewWrapper methodsFor: 'evaluating' stamp: 'mp 5/5/2010 12:19'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| viewString |
	self tracer isActive
		ifTrue: [
			self 
				beforeMethod;
				beforeMethod: anObject.
			self tracer stopTracing.
			viewString := self getViewString: anObject.
			self tracer addView: viewString to: self selectedView.
			self tracer startTracing.
			[^ self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects] 
				ensure: [self afterMethod]]
		ifFalse: [^ self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects].


! !

MwMethodWrapper subclass: #SMethodFaultLocalizationWrapper
	instanceVariableNames: 'currentTest coveredByteCodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Debugger'!

!SMethodFaultLocalizationWrapper class methodsFor: 'instance creation' stamp: 'mp 11/5/2010 11:39:17.439'!
on: aMethodReference
	
	^ self on: aMethodReference methodSymbol inClass: aMethodReference actualClass! !

!SMethodFaultLocalizationWrapper methodsFor: 'accessing' stamp: 'mp 11/5/2010 14:23:30.532'!
coveredByteCodes
	"Answer the value of coveredByteCodes"

	^ coveredByteCodes ifNil: [coveredByteCodes := Dictionary new]! !

!SMethodFaultLocalizationWrapper methodsFor: 'accessing' stamp: 'mp 11/5/2010 14:23:08.362'!
coveredByteCodes: anObject
	"Set the value of coveredByteCodes"

	coveredByteCodes := anObject! !

!SMethodFaultLocalizationWrapper methodsFor: 'accessing' stamp: 'mp 11/5/2010 14:23:08.35'!
currentTest
	"Answer the value of currentTest"

	^ currentTest! !

!SMethodFaultLocalizationWrapper methodsFor: 'accessing' stamp: 'mp 11/5/2010 14:23:08.354'!
currentTest: anObject
	"Set the value of currentTest"

	currentTest := anObject! !

!SMethodFaultLocalizationWrapper methodsFor: 'evaluating' stamp: 'mp 11/5/2010 14:40:24.301'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| result byteCodes |
	result := thisContext
		runSimulatedMethodOnly: [self clientMethod 
										valueWithReceiver: anObject 
										arguments: anArrayOfObjects]
		contextAtEachStep: [ :ctx | 
			self compiledMethod == ctx method
				ifTrue: [	byteCodes := self coveredByteCodes 
											at: self currentTest ifAbsentPut: [Set new].
						byteCodes add: ctx pc]].
	^ result! !

MwMethodWrapper subclass: #SRecordReplayWrapper
	instanceVariableNames: 'replayCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Record-Replay'!

!SRecordReplayWrapper class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 11:36'!
on: aSymbol inClass: aClass with: aReplayCache
	
	^ (self on: aSymbol inClass: aClass)
		replayCache: aReplayCache;
		yourself! !

!SRecordReplayWrapper methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:36'!
replayCache
	"Answer the value of replayCache"

	^ replayCache! !

!SRecordReplayWrapper methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:36'!
replayCache: anObject
	"Set the value of replayCache"

	replayCache := anObject! !

!SRecordReplayWrapper methodsFor: 'evaluating' stamp: 'mp 5/18/2010 11:41'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| record result |
	record := self replayCache 
		at: (MethodReference class: self wrappedClass selector: self clientSelector) 
		receiver: anObject 
		arguments: anArrayOfObjects.
	record ifNotNil: [^ record recordedResult].
	self beforeMethod.
	^ [	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
		self replayCache 
			at: (MethodReference class: self wrappedClass selector: self clientSelector) 
			receiver: anObject 
			arguments: anArrayOfObjects
			put: result.
		result
	] ensure: [self afterMethod]! !

MwMethodWrapper subclass: #SSpecificWrapper
	instanceVariableNames: 'numberOfCallsBefore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

SSpecificWrapper subclass: #SByteCodeCoverageWrapper
	instanceVariableNames: 'coveredByteCodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

!SByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mp 11/8/2010 15:21:28.79'!
coveredByteCodes
	"Answer the value of coveredByteCodes"

	^ coveredByteCodes ifNil: [coveredByteCodes := OrderedCollection new]! !

!SByteCodeCoverageWrapper methodsFor: 'accessing' stamp: 'mp 11/8/2010 15:19:07.504'!
coveredByteCodes: anObject
	"Set the value of coveredByteCodes"

	coveredByteCodes := anObject! !

!SByteCodeCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 11/8/2010 15:54:55.976'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| result |
	self isSpecificCall 
		ifTrue: [self decrementCallCount.
				result := thisContext
							runSimulatedMethodOnly: [self clientMethod 
															valueWithReceiver: anObject 
															arguments: anArrayOfObjects]
							contextAtEachStep: [ :ctx | 
								self compiledMethod == ctx method
									ifTrue: [	self coveredByteCodes add: ctx pc]]]
		ifFalse: [self decrementCallCount.
				result := self clientMethod 
								valueWithReceiver: anObject 
								arguments: anArrayOfObjects].
	^ result! !

SSpecificWrapper subclass: #SDebugWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

!SDebugWrapper methodsFor: 'as yet unclassified' stamp: 'mp 7/7/2010 17:00:04.386'!
beforeMethod

	self numberOfCallsBefore = 1
		ifTrue: [SBreakpointManager installInClass: self wrappedClass selector: self clientSelector.].
	self decrementCallCount.! !

SSpecificWrapper subclass: #SExploreWrapper
	instanceVariableNames: 'objects exploreWhat found'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PF-Tracer'!

!SExploreWrapper class methodsFor: 'instance creation' stamp: 'mp 1/25/2010 17:37'!
on: aMethodSelector inClass: aClass waitingCalls: aNumber exploreWhat: aSymbol

	| wrapper |
	wrapper := self on: aMethodSelector inClass: aClass waitingCalls: aNumber.
	wrapper ifNotNil: [wrapper exploreWhat: aSymbol].
	^ wrapper! !

!SExploreWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 17:30'!
exploreWhat
	"Answer the value of exploreWhat"

	^ exploreWhat! !

!SExploreWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 17:30'!
exploreWhat: anObject
	"Set the value of exploreWhat"

	exploreWhat := anObject! !

!SExploreWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:48'!
found
	"Answer the value of found"

	^ found ifNil: [found := false]! !

!SExploreWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 18:48'!
found: anObject
	"Set the value of found"

	found := anObject! !

!SExploreWrapper methodsFor: 'exploring' stamp: 'mp 1/25/2010 17:34'!
getArguments: anArrayOfObjects

	(self isSpecificCall and: [self exploreWhat == #arguments])
		ifTrue: [self objects add: anArrayOfObjects veryDeepCopy].! !

!SExploreWrapper methodsFor: 'exploring' stamp: 'mp 3/5/2010 16:51'!
getReturn: anObject

	(self isSpecificCall and: [self exploreWhat == #return])
		ifTrue: [self objects add: anObject veryDeepCopy].! !

!SExploreWrapper methodsFor: 'exploring' stamp: 'bs 7/17/2010 14:32:28.652'!
getSelfAfter: anObject
	(self isSpecificCall and: [self exploreWhat == #selfAfter])
		ifTrue: [self objects add: anObject veryDeepCopy].! !

!SExploreWrapper methodsFor: 'exploring' stamp: 'mp 1/25/2010 17:35'!
getSelfBefore: anObject

	(self isSpecificCall and: [self exploreWhat == #selfBefore])
		ifTrue: [self objects add: anObject veryDeepCopy].! !

!SExploreWrapper methodsFor: 'exploring' stamp: 'mp 3/4/2010 09:50'!
getTypeInformation: anArrayOfObjects of: aSymbol

	| type |
	((self isSpecificCall and: [self exploreWhat == #types]) and: [anArrayOfObjects isEmpty not])
		ifTrue: [	anArrayOfObjects size = 1
					ifTrue: [type := anArrayOfObjects first class]
					ifFalse: [type := OrderedCollection new.
							anArrayOfObjects do: [:each | type add: each class]].
				self objects add: aSymbol -> type].! !

!SExploreWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 17:30'!
objects
	"Answer the value of objects"

	^ objects ifNil: [objects := OrderedCollection new]! !

!SExploreWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 17:30'!
objects: anObject
	"Set the value of objects"

	objects := anObject! !

!SExploreWrapper methodsFor: '-- all --' stamp: 'bs 7/17/2010 16:00:15.791'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| result |
	"#arguments #selfBefore #selfAfter #return #types"	
	self 
		getTypeInformation: anArrayOfObjects of: #arguments;
		getTypeInformation: (Array with: anObject) of: #self;
		getArguments: anArrayOfObjects;
		getSelfBefore: anObject.
	self isSpecificCall ifTrue: [self found: true].
	self decrementCallCount.
	^ [
		result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
		result.
	] ensure: [ self found 
				ifTrue: [self incrementCallCount.
					self 
						getSelfAfter: anObject;
						getReturn: result;
						getTypeInformation: (Array with: result) of: #result.
					self isSpecificCall 
						ifTrue: [self found: false. 
							      self decrementCallCount]]]
! !

!SSpecificWrapper class methodsFor: 'instance creation' stamp: 'mp 1/25/2010 16:40'!
on: aSymbol inClass: aClass waitingCalls: aNumber

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper ifNotNil: [wrapper numberOfCallsBefore: aNumber].
	^ wrapper! !

!SSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 16:39'!
decrementCallCount
	
	self numberOfCallsBefore: self numberOfCallsBefore - 1.! !

!SSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 19:07'!
incrementCallCount
	
	self numberOfCallsBefore: self numberOfCallsBefore + 1.! !

!SSpecificWrapper methodsFor: 'count' stamp: 'mp 1/25/2010 16:40'!
isSpecificCall
	
	^ self numberOfCallsBefore = 0! !

!SSpecificWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:39'!
numberOfCallsBefore
	"Answer the value of numberOfCallsBefore"

	^ numberOfCallsBefore! !

!SSpecificWrapper methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:39'!
numberOfCallsBefore: anObject
	"Set the value of numberOfCallsBefore"

	numberOfCallsBefore := anObject! !

MwMethodWrapper subclass: #STestCoverageWrapper
	instanceVariableNames: 'tests currentTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Evaluation'!

!STestCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 2/6/2010 15:09'!
beforeMethod
	
	self currentTest ifNotNil: [self tests add: self currentTest].! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
currentTest
	"Answer the value of currentTest"

	^ currentTest! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
currentTest: anObject
	"Set the value of currentTest"

	currentTest := anObject! !

!STestCoverageWrapper methodsFor: 'initialize-release' stamp: 'mp 1/28/2010 17:57'!
initialize

	self tests: Set new.! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
tests
	"Answer the value of tests"

	^ tests! !

!STestCoverageWrapper methodsFor: 'accessing' stamp: 'mp 1/28/2010 17:56'!
tests: anObject
	"Set the value of tests"

	tests := anObject! !

MwMethodWrapper subclass: #SWrapper
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tracer'!

SWrapper subclass: #SBlockMethodWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Evaluation'!

!SBlockMethodWrapper methodsFor: 'evaluating' stamp: 'mp 2/8/2011 14:55:03.156'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	^ self! !

SWrapper subclass: #SPMCallCountWrapper
	instanceVariableNames: 'calls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Wrapper'!

!SPMCallCountWrapper methodsFor: 'evaluating' stamp: 'mp 11/19/2010 20:11:31.395'!
beforeMethod
	self tracer active
		ifTrue: [self calls: self calls + 1].! !

!SPMCallCountWrapper methodsFor: 'accessing' stamp: 'mp 7/23/2010 16:50:20.319'!
calls
	"Answer the value of calls"

	^ calls! !

!SPMCallCountWrapper methodsFor: 'accessing' stamp: 'mp 7/23/2010 16:43:28.86'!
calls: anObject
	"Set the value of calls"

	calls := anObject! !

!SPMCallCountWrapper methodsFor: 'accessing' stamp: 'mp 8/9/2010 16:49:23.848'!
reset

	self calls: 0.! !

SPMCallCountWrapper subclass: #SPMCallRuntimeExtentWrapper
	instanceVariableNames: 'stopwatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Wrapper'!

!SPMCallRuntimeExtentWrapper methodsFor: 'evaluating' stamp: 'mp 8/9/2010 16:50:47.317'!
afterMethod

	self stopwatch suspend.! !

!SPMCallRuntimeExtentWrapper methodsFor: 'evaluating' stamp: 'mp 8/9/2010 16:50:28.395'!
beforeMethod

	super beforeMethod.
	self stopwatch reActivate.! !

!SPMCallRuntimeExtentWrapper methodsFor: 'accessing' stamp: 'mp 8/9/2010 16:49:34.461'!
reset
	super reset.
	self stopwatch reset.! !

!SPMCallRuntimeExtentWrapper methodsFor: 'accessing' stamp: 'mp 8/9/2010 16:49:14.047'!
stopwatch
	"Answer the value of stopwatch"

	^ stopwatch ifNil: [stopwatch := Stopwatch new]! !

!SPMCallRuntimeExtentWrapper methodsFor: 'accessing' stamp: 'mp 8/9/2010 16:49:09.763'!
stopwatch: anObject
	"Set the value of stopwatch"

	stopwatch := anObject! !

SPMCallCountWrapper subclass: #SPMCallRuntimeIntentWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Wrapper'!

!SPMCallRuntimeIntentWrapper methodsFor: 'evaluating' stamp: 'mp 8/12/2010 14:04:51.003'!
afterMethod
	self tracer after: self asMethodReference process: Processor activeProcess.! !

!SPMCallRuntimeIntentWrapper methodsFor: 'evaluating' stamp: 'mp 8/12/2010 14:04:03.527'!
beforeMethod

	super beforeMethod.
	self tracer before: self asMethodReference process: Processor activeProcess.! !

SWrapper subclass: #SPMCoverageWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Wrapper'!

!SPMCoverageWrapper methodsFor: 'evaluating' stamp: 'mp 7/12/2010 15:44:36.839'!
beforeMethod

	self tracer addToCoveredMethods: self asMethodReference.! !

SWrapper subclass: #SPMDeactivateTracerWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-PM-Wrapper'!

!SPMDeactivateTracerWrapper methodsFor: 'evaluating' stamp: 'mp 3/23/2011 16:41:54.48'!
afterMethod
	self tracer activate.! !

!SPMDeactivateTracerWrapper methodsFor: 'evaluating' stamp: 'mp 3/23/2011 16:41:47.75'!
beforeMethod
	self tracer deactivate.! !

SWrapper subclass: #SStateWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-StateView'!

!SStateWrapper methodsFor: 'evaluating' stamp: 'mp 9/30/2010 10:41:22.998'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."
	| value |
	self beforeMethod.
	^ [
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod.
			value := anObject instVarNamed: self tracer instVarName.
			value isLiteral
				ifTrue: [self tracer addValue: value copy]
				ifFalse: [self tracer addValue: value asString]]! !

!SWrapper class methodsFor: 'instance creation' stamp: 'mp 11/19/2010 19:30:08.821'!
canWrap: aSymbol inClass: aClass
	| selectors |
	(super canWrap: aSymbol inClass: aClass) ifFalse: [^ false].
	(aClass == SClassA) ifTrue: [^ false]. "Required for SBeforeWrapperTest"
	selectors := #( #addToCoveredMethods: #coveredMethods #coveredMethods:).
	(aClass == SPMTRCoverageTracer and: [selectors includes: aSymbol]) ifTrue: [^ false].
	((aClass == STracer) and: [aSymbol == #active]) ifTrue: [^ false].
	((aClass == SPMTRProfilingTracer) or: [aClass inheritsFrom: SPMTRProfilingTracer]) 
		ifTrue: [^ false].
	^ true! !

!SWrapper class methodsFor: 'class initialization' stamp: 'mp 7/12/2010 12:38:44.486'!
initialize
	"doIt: [self initialize]"

	super initialize.! !

!SWrapper class methodsFor: 'instance creation' stamp: 'mp 11/19/2010 16:28:44.67'!
on: aSymbol inClass: aClass with: aTracer
	| wrapper |
	wrapper := (self on: aSymbol inClass: aClass).
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SWrapper methodsFor: 'converting' stamp: 'mp 7/12/2010 15:45:00.131'!
asMethodReference

	^ MethodReference class: self wrappedClass selector: self clientSelector! !

!SWrapper methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:18.786'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SWrapper methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:18.79'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

BreakpointManager subclass: #SBreakpointManager
	instanceVariableNames: ''
	classVariableNames: 'InstalledNodes'
	poolDictionaries: ''
	category: 'SightL-PF-Debugger'!

!SBreakpointManager class methodsFor: 'as yet unclassified' stamp: 'mp 3/10/2010 18:48'!
compilePrototype: aSymbol in: aClass 
	"Compile and return a new method containing a break statement"

	| source node trailer method |
	source := self breakpointMethodSourceFor: aSymbol in: aClass.
	node := aClass compilerClass new
		compile: source
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	node isNil ifTrue: [^nil].
	trailer := CompiledMethodTrailer new.
	trailer sourceCode: source.
	method := node generate: trailer.
	self installedNodes at: method put: node.
	^ method! !

!SBreakpointManager class methodsFor: 'as yet unclassified' stamp: 'mp 3/10/2010 18:29'!
installedNodes
	InstalledNodes isNil ifTrue:[InstalledNodes := IdentityDictionary new].
	^InstalledNodes! !

!SBreakpointManager class methodsFor: 'as yet unclassified' stamp: 'mp 3/10/2010 18:40'!
nukeInstalledNodes

	"self nukeInstalledNodes"
	InstalledNodes := nil.! !

!SBreakpointManager class methodsFor: 'as yet unclassified' stamp: 'mp 3/10/2010 18:41'!
unInstall: breakMethod 

	self installedNodes removeKey: breakMethod.
	super unInstall: breakMethod.! !

TextMorphForEditView subclass: #STextMorphForEditView
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!STextMorphForEditView class methodsFor: 'preferences' stamp: 'mp 3/10/2010 11:52'!
requiredSpaceForTwoCodeDigits

	^ Preferences standardCodeFont widthOfString: '00'! !

!STextMorphForEditView class methodsFor: 'constants' stamp: 'mp 3/10/2010 11:48'!
scaleFactorLeftMargin

	^ 1.5! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 12:48'!
drawLineNumber: aNumber on: aCanvas

	| str line |
	str := self getStringFor: aNumber.
	line := self paragraph lines at: aNumber.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: Color gray.! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 11:58'!
drawLineNumbersBorderOn: aCanvas

	| xOffset |
	xOffset := 4.
	aCanvas
		line: (self margins left - xOffset) @ aCanvas clipRect top
		to: (self margins left - xOffset) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 12:19'!
drawLineNumbersOn: aCanvas

	1 to: self paragraph numberOfLines do: [:lineNumber | 
		self drawLineNumber: lineNumber on: aCanvas].! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 14:37'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self
		drawLineNumbersBorderOn: aCanvas;
		drawLineNumbersOn: aCanvas.! !

!STextMorphForEditView methodsFor: 'private' stamp: 'mp 3/10/2010 12:08'!
getStringFor: aNumber

	| twoDigits |
	twoDigits := aNumber \\ 100.
	^ (twoDigits < 10 ifTrue: ['  '] ifFalse: ['']), twoDigits asString.! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:52:07.713'!
handlesMouseOver: anEvent
	^ true! !

!STextMorphForEditView methodsFor: 'initialization' stamp: 'mp 3/10/2010 11:50'!
initialize

	| leftOffset |
	super initialize.
	leftOffset := (self class requiredSpaceForTwoCodeDigits * self class scaleFactorLeftMargin) rounded.
	self margins: ((leftOffset@0) corner: 0@0).! !

!STextMorphForEditView methodsFor: 'accessing' stamp: 'mp 3/18/2011 21:38:23.288'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph ifNil: [labelMorph := SLabelMorph label: '']! !

!STextMorphForEditView methodsFor: 'accessing' stamp: 'mp 3/18/2011 21:34:16.236'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:50:27.061'!
mouseLeave: evt
	super mouseLeave: evt.
	self removeMorph: self labelMorph.! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 22:30:57.413'!
mouseMove: evt
	| index word |
	super mouseMove: evt.
	index := (self paragraph characterBlockAtPoint: evt position) stringIndex.
	(self text notNil and: [index between: 1 and: self text size])
		ifTrue: [
			word := self wordAt: index.
			word isAllSeparators
				ifTrue: [self removeMorph: self labelMorph]
				ifFalse: [
					self changed: word with: self.
					self labelMorph labelMorph contents = ''
						ifTrue: [self removeMorph: self labelMorph]
						ifFalse: [self addMorph: self labelMorph.
								self labelMorph position: evt position + self position]]].! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:33:08.326'!
trimWord: aString
	^ aString select: [:each | each isLetter or: [each isDigit]]! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:22:47.069'!
wordAt: anIndex
	| start stop |
	start := anIndex.
	stop := anIndex.
	[stop <= self text size and: [(self text at: stop) isSeparator not]]
		whileTrue: [stop := stop + 1].
	[start >= 1 and: [(self text at: start) isSeparator not]]
		whileTrue: [start := start - 1].
	^self trimWord: (self text copyFrom: start to: stop) asString ! !

PluggableTextMorphPlus subclass: #SPluggableTextMorphPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableTextMorphPlus methodsFor: 'private' stamp: 'mp 7/7/2010 16:40:31.48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^ STextMorphForEditView! !

PluggablePanelMorph subclass: #SPluggableFlapMorph
	instanceVariableNames: 'flapIcon expandedFlap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableFlapMorph class methodsFor: 'constants' stamp: 'mp 9/14/2010 10:01:52.044'!
iconOffset
	^ 34! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/15/2010 13:23:31.387'!
closeAllOtherFlaps
	self owner ifNil: [^ self].
	self flag: #mpe. "Refactor the owner relationship to a more stable version, later on"
	"Add some kind of select flap selector..."
	self owner paneMorphs 
		select: [:each | (each isKindOf: self class) and: [(each == self) not]]
		thenDo: [:each | each closeFlap].! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/15/2010 09:59:34.425'!
closeFlap
	self expandedFlap: false.
	self submorphs do: [:each | each hide].
	self changed.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/13/2010 18:58:07.688'!
drawExpandedFlapOn: aCanvas
	"Icon Background"
	aCanvas 
		fillRectangle: self iconRectangle	
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.	
	"Draw Icon"
	aCanvas image: self flapIcon at: self iconRectangle origin + 2.
	"Main Background"
	aCanvas 
		fillRectangle: (self bounds insetOriginBy: 0@0 cornerBy: self class iconOffset@0)  		
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.
	"Left Border to System Window"
	aCanvas 
		fillRectangle: (self bounds origin 
						corner: ((self bounds origin x + 2)@(self bounds corner y))) 
		color: self color.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/13/2010 18:58:10.619'!
drawNotExpandedFlapOn: aCanvas
	"Icon Background"
	aCanvas 
		fillRectangle: self fullBounds	
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.
	aCanvas image: self flapIcon at: self fullBounds origin + 2.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/15/2010 09:52:56.7'!
drawOn: aCanvas
	self isExpanded
		ifTrue: [self drawExpandedFlapOn: aCanvas]
		ifFalse: [self drawNotExpandedFlapOn: aCanvas].! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:17:44.835'!
expandedFlap
	"Answer the value of expandedFlap"

	^ expandedFlap ifNil: [expandedFlap := false]! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:11:44.341'!
expandedFlap: anObject
	"Set the value of expandedFlap"

	expandedFlap := anObject! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:57:33.686'!
flapIcon
	"Answer the value of flapIcon"

	^ flapIcon! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:57:33.691'!
flapIcon: anObject
	"Set the value of flapIcon"

	flapIcon := anObject! !

!SPluggableFlapMorph methodsFor: 'layout' stamp: 'mp 9/15/2010 09:53:37.669'!
fullBounds
	| b |
	self isExpanded
		ifTrue: [^ super fullBounds]
		ifFalse: [b := super fullBounds.
				^ b origin corner: (b origin x + self class iconOffset) @ 
						     		   (b origin y + self class iconOffset)]! !

!SPluggableFlapMorph methodsFor: 'event handling' stamp: 'mp 9/15/2010 09:53:52.809'!
handlesMouseDown: evt
	self isExpanded
		ifTrue: [^ self iconRectangle containsPoint: evt cursorPoint]
		ifFalse: [^ self fullBounds containsPoint: evt cursorPoint]! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:05:09.219'!
iconRectangle
	^ (self bounds corner x - self class iconOffset)@(self bounds origin y)
			corner: ((self bounds corner x)@(self bounds origin y + self class iconOffset))! !

!SPluggableFlapMorph methodsFor: 'initialization' stamp: 'mp 9/13/2010 18:16:47.754'!
initialize
	super initialize.
	self switchExpandState.
! !

!SPluggableFlapMorph methodsFor: 'testing' stamp: 'mp 9/15/2010 09:52:09.29'!
isExpanded

	^ expandedFlap = true! !

!SPluggableFlapMorph methodsFor: 'testing' stamp: 'mp 9/15/2010 09:52:13.226'!
isNotExpanded

	^ expandedFlap = false! !

!SPluggableFlapMorph methodsFor: 'layout' stamp: 'mp 9/13/2010 19:03:35.28'!
layoutBounds
	^ super layoutBounds insetOriginBy: 0@0 cornerBy: self class iconOffset@0! !

!SPluggableFlapMorph methodsFor: 'event handling' stamp: 'mp 9/13/2010 18:16:14.717'!
mouseDown: evt
	self switchExpandState.
! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/16/2010 11:08:45.688'!
switchExpandState
	self expandedFlap: self expandedFlap not.
	self isExpanded
		ifTrue: [self submorphs do: [:each | each show].
				self closeAllOtherFlaps]
		ifFalse: [self submorphs do: [:each | each hide]].
	self changed.
! !

!LazyListMorph methodsFor: '*SightL' stamp: 'mp 9/22/2010 14:15:44.513'!
drawBackgroundForMulti: row on: aCanvas 
	"shade the background paler, if this row is selected, but not the current selected row"
	| selectionDrawBounds thisColor |
	thisColor := selectedRow = row
		ifTrue: [ self class listSelectionColor ]
		ifFalse: [ self class listSelectionColor lighter ].
	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas
		fillRectangle: selectionDrawBounds
		color: thisColor! !

LazyListMorph subclass: #SLazyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SLazyListMorph methodsFor: 'drawing' stamp: 'mp 9/23/2010 17:56:34.888'!
colorForRow: row
	| itemColor |
	itemColor := listSource itemColorAt: row.
	itemColor == false
		ifFalse: [^ itemColor].	
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ self class listSelectionTextColor ]
		ifFalse: [ self color ].
		! !

!SystemWindow methodsFor: '*SightL' stamp: 'mp 9/13/2010 17:30:44.37'!
addPaneHSplitters
	"reject flap morphs, too"
	| remaining targetY sameY |
	remaining := paneMorphs copy reject: [:each | each layoutFrame bottomFraction = 1 
													or: [each isKindOf: SPluggableFlapMorph]].
	[remaining notEmpty] whileTrue:
		[targetY := remaining first layoutFrame bottomFraction.
		sameY := paneMorphs select: [:each | each layoutFrame bottomFraction = targetY].
		self addPaneHSplitterBetween: remaining first and: sameY.
		remaining := remaining copyWithoutAll: sameY]! !

!SystemWindow methodsFor: '*SightL' stamp: 'mp 9/13/2010 17:30:50.57'!
addPaneVSplitters
	"reject flap morphs, too"
	| remaining targetX sameX |
	remaining := paneMorphs copy reject: [:each | each layoutFrame rightFraction = 1 
													or: [each isKindOf: SPluggableFlapMorph]].
	[remaining notEmpty] whileTrue:
		[targetX := remaining first layoutFrame rightFraction.
		sameX := paneMorphs select: [:each | each layoutFrame rightFraction = targetX].
		self addPaneVSplitterBetween: remaining first and: sameX.
		remaining := remaining copyWithoutAll: sameX]! !

!SystemWindow methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:03'!
modalLockTo: aSystemWindow
	"Lock the receiver as a modal owner of the given window."

	aSystemWindow
		setProperty: #modalOwner toValue: self.
	self setProperty: #modalChild toValue: aSystemWindow! !

!SystemWindow methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:05'!
modalUnlockFrom: aSystemWindow
	"Unlock the receiver as a modal owner of the given window."

	aSystemWindow removeProperty: #modalOwner.
	self removeProperty: #modalChild.
	self activate! !

AlignmentMorph subclass: #SNavigationBarMorph
	instanceVariableNames: 'itemList hiddenMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:29'!
addItem: anObject withSelector: aSymbol

	self itemList ifNotEmpty: [self addSeparator].	
	self itemList add: anObject.
	self createActionStringMorphOn: anObject withSelector: aSymbol.
	! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:15'!
addItems: aCollection withSelector: aSymbol

	aCollection do: [:each | self addItem: each withSelector: aSymbol].
	self reduceMorphsInTheMiddle.! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:27'!
addSeparator

	self addMorphBack: self separatorMorph.
	
! !

!SNavigationBarMorph methodsFor: 'building' stamp: 'mp 7/7/2010 16:43:21.452'!
createActionStringMorphOn: anObject withSelector: aSymbol

	| stringMorph |
	stringMorph := SActionStringMorph on: anObject selector: aSymbol.
	stringMorph font: (StrikeFont familyName: 'BitstreamVeraSans' size: 9).
	self addMorphBack: stringMorph.
	
! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 1/6/2010 16:09'!
defaultBorderColor
	"answer the default color/fill style for the receiver"
	^ Color r: 0.835 g: 0.835 b: 0.835! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 1/6/2010 15:48'!
defaultBorderWidth

	^ 1! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 1/6/2010 16:06'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!SNavigationBarMorph methodsFor: 'as yet unclassified' stamp: 'mp 3/4/2010 14:26'!
extent: aPoint

	super extent: aPoint.
	"Required for collapse systemwindow"
	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show].! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:17'!
getCurrentStringWidth

	^ self submorphs inject: 0 into: [:sum :each | each width + sum]! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:30'!
hiddenMorphs
	"Answer the value of hiddenMorphs"

	^ hiddenMorphs ifNil: [hiddenMorphs := OrderedCollection new]! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:29'!
hiddenMorphs: anObject
	"Set the value of hiddenMorphs"

	hiddenMorphs := anObject! !

!SNavigationBarMorph methodsFor: 'initialization' stamp: 'mp 3/4/2010 10:34'!
initialize
	super initialize.
	self 
		itemList: OrderedCollection new;
		addSeparator;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 15:43'!
itemList
	^ itemList! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 15:43'!
itemList: anObject
	itemList := anObject! !

!SNavigationBarMorph methodsFor: 'actions' stamp: 'mp 3/1/2010 16:47'!
listHiddenItems

	| choice |
	choice := UIManager default 
					chooseFrom: (self hiddenMorphs collect: [:each | each contents]) 
					values: self hiddenMorphs 
					lines: #() 
					title: 'Select Item'.
	choice ifNotNil: [choice performAction].
! !

!SNavigationBarMorph methodsFor: 'building' stamp: 'mp 7/7/2010 16:43:25.75'!
reduceMorphsInTheMiddle

	"summarize morphs [...] except the first and the last three strings"
	self getCurrentStringWidth > self width
		ifTrue: [
			self hiddenMorphs: (self submorphs copyFrom: 3 to: self submorphs size - 6).
			self removeAllMorphsIn: self hiddenMorphs.
			self hiddenMorphs: (self hiddenMorphs reject: [:each | each contents = self separator]).
			
			self addMorph: (SActionStringMorph on: self selector: #listHiddenItems name: '[...]') 
				asElementNumber: 4.
			self addMorph: self separatorMorph 
				asElementNumber: 5].
	! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:39'!
removeAllItems

	self itemList: OrderedCollection new.
	self removeAllMorphs.
	self addSeparator.! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:45'!
removeLastItem

	self itemList ifEmpty: [^ self].
	self itemList size = 1
		ifTrue: [
			self itemList removeLast.
			self removeAllMorphsIn: {self submorphs last.}.
			^ self].
	self itemList removeLast.
	self removeAllMorphsIn: {self submorphs last. self submorphs at: self submorphs size - 1.}! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 1/7/2010 17:42'!
separator

	^ ' >> '! !

!SNavigationBarMorph methodsFor: 'accessing' stamp: 'mp 3/1/2010 16:28'!
separatorMorph

	| stringMorph |
	stringMorph := StringMorph contents: self separator.
	stringMorph font: (StrikeFont familyName: 'BitstreamVeraSans' size: 9).
	^ stringMorph
	
! !

SNavigationBarMorph subclass: #SPathFindNaviBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPathFindNaviBarMorph methodsFor: 'building' stamp: 'mp 7/7/2010 16:43:32.392'!
createActionStringMorphOn: anObject withSelector: aSymbol

	| stringMorph |
	stringMorph := SActionStringMorph on: anObject selector: aSymbol name: anObject clientSelector asString.
	stringMorph font: (StrikeFont familyName: 'BitstreamVeraSans' size: 9).
	self addMorphBack: stringMorph.! !

!SPathFindNaviBarMorph methodsFor: 'accessing' stamp: 'mp 1/7/2010 17:47'!
separator

	^ ' -> '! !

!SPathFindNaviBarMorph methodsFor: 'updating' stamp: 'mp 1/31/2010 18:40'!
update: aCallNode

	aCallNode isNil 
		ifTrue: [self removeAllItems.
			      ^ self]. 
	aCallNode isLiteral
		ifTrue: [^ self].
	self 
		removeAllItems;
		addItems: aCallNode getCallStack withSelector: #setAsCurrentSelection.! !

!PluggableListMorphOfMany methodsFor: '*SightL' stamp: 'mp 9/22/2010 13:52:22.471'!
update: aSymbol 
	aSymbol == #allSelections ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self changed].
	aSymbol == getSelectionListSelector
		ifTrue: [self changed].
	^ super update: aSymbol! !

PluggableListMorphOfMany subclass: #SPluggableListMorphOfMany
	instanceVariableNames: 'itemColorSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'mp 9/23/2010 17:47:45.121'!
itemColorAt: index
	itemColorSelector ifNil: [^ false].
	^ model perform: itemColorSelector with: index! !

!SPluggableListMorphOfMany methodsFor: 'as yet unclassified' stamp: 'mp 9/23/2010 17:49:25.498'!
listMorphClass
	^SLazyListMorph! !

!SPluggableListMorphOfMany methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:46:22.699'!
setItemColorSelector: aSymbol
	"Set the value of iconSelector"

	itemColorSelector := aSymbol! !

PluggableButtonMorphPlus subclass: #SPluggableCheckBoxMorph
	instanceVariableNames: 'checkBoxMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:08:08.041'!
checkBoxMorph
	"Answer the value of checkBoxMorph"

	^ checkBoxMorph! !

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:08:08.046'!
checkBoxMorph: anObject
	"Set the value of checkBoxMorph"

	checkBoxMorph := anObject! !

!SPluggableCheckBoxMorph methodsFor: 'initialize-release' stamp: 'mp 9/16/2010 11:26:13.693'!
initialize
	super initialize.
	onColor := Color white.
	offColor := Color lightGray.! !

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 11:26:49.093'!
label: aStringOrTextOrMorph font: aFont
	"Label this button with the given string or morph."
	| r |
	self removeAllMorphs.
	"nest label in a row for centering"
	r := AlignmentMorph newRow
		borderWidth: 0;
		layoutInset: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		wrapCentering: #center; cellPositioning: #leftCenter.
	aStringOrTextOrMorph isMorph
		ifTrue: [
			label := aStringOrTextOrMorph.
			r addMorph: aStringOrTextOrMorph]
		ifFalse: [
			label := aStringOrTextOrMorph asString.
			r addMorph: (StringMorph contents: label font: aFont)].
	"space placeholder"
	r addMorph: ((Morph new extent: (aFont pointSize - 3)@(aFont pointSize - 3)) 
					color: Color transparent).
	self checkBoxMorph: (SCheckBoxMorph new 
							extent: (aFont pointSize)@(aFont pointSize)).
	self checkBoxMorph checked: self getModelState.
	r addMorph: self checkBoxMorph.
	self addMorph: r.! !

!SPluggableCheckBoxMorph methodsFor: 'updating' stamp: 'mp 9/15/2010 15:11:01.907'!
update: what
	| state |
	what ifNil:[^self].
	what == getLabelSelector ifTrue: [
		self label: (model perform: getLabelSelector)].
	what == getEnabledSelector ifTrue:[^self enabled: (model perform: getEnabledSelector)].

	getColorSelector ifNotNil: [ | cc |
		color = (cc := model perform: getColorSelector) ifFalse:[
			color := cc.
			self onColor: color offColor: color.
			self changed.
		].
	].
	state := self getModelState.
	self checkBoxMorph checked: state.
	state
		ifTrue: [self color: onColor]
		ifFalse: [self color: offColor].	
	getEnabledSelector ifNotNil:[
		self enabled: (model perform: getEnabledSelector).
	].
! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 9/15/2010 14:40:10.3'!
buildPluggableCheckBox: aSpec
	| widget label state action enabled |
	label := aSpec label.
	state := aSpec state.
	action := aSpec action.
	widget := SPluggableCheckBoxMorph on: aSpec model
				getState: (state isSymbol ifTrue:[state])
				action: nil
				label: (label isSymbol ifTrue:[label]).
	self register: widget id: aSpec name.
	enabled := aSpec enabled.
	enabled isSymbol
		ifTrue:[widget getEnabledSelector: enabled]
		ifFalse:[widget enabled: enabled].
	widget action: action.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec. 
	(label isSymbol or:[label == nil]) ifFalse:[widget label: label].
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 9/13/2010 19:02:48.438'!
buildPluggableFlap: aSpec
	| widget children frame |
	widget := self flapClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	aSpec icon ifNotNil: [widget flapIcon: aSpec icon].
	
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue: [
		widget getChildrenSelector: children.
		widget update: children.
		children := #()].
	self buildAll: children in: widget.
	
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	widget 
		layoutInset: 3;
		borderWidth: 2;
		borderColor: #raised.
	widget submorphsDo: [:sm |
		(frame := sm layoutFrame) ifNotNil:[
			(frame rightFraction = 0 or:[frame rightFraction = 1]) 
				ifFalse:[frame rightOffset: 1].
			(frame bottomFraction = 0 or: [frame bottomFraction = 1]) 
				ifFalse:[frame bottomOffset: 1]]].
	widget color: (Color r: 0.672 g: 0.672 b: 0.672).
	widget layoutFrame leftOffset: 1.
	widget switchExpandState.
	^widget! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 1/25/2010 11:28'!
buildPluggableTree: aSpec
	| widget |
	widget := (self pluggableTreeMorphClass: aSpec) new.
	self register: widget id: aSpec name.
	self setAdditionalTreeSpecs: aSpec on: widget.
	widget model: aSpec model.
	widget getSelectedPathSelector: aSpec getSelectedPath.
	widget setSelectedSelector: aSpec setSelected.
	widget getChildrenSelector: aSpec getChildren.
	widget hasChildrenSelector: aSpec hasChildren.
	widget getLabelSelector: aSpec label.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec help.
	widget getMenuSelector: aSpec menu.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getRootsSelector: aSpec roots.
	widget autoDeselect: aSpec autoDeselect.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec roots ifNotNil:[panes add: aSpec roots].
	].
	^widget! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 9/23/2010 17:46:34.678'!
buildSPluggableMultiSelectionList: aSpec
	| widget listClass |
	aSpec getSelected ifNotNil:[^self error:'There is no PluggableListMorphOfManyByItem'].
	listClass := SPluggableListMorphOfMany.
	widget := listClass on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	widget setItemColorSelector: aSpec itemColor.
	self register: widget id: aSpec name.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	parent isSystemWindow
		ifFalse: [widget 
					borderWidth: 1; 
					borderColor: #inset;
					color: Color white].
	^widget! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 3/24/2011 12:15:07.882'!
codePaneClass
	^ SPluggableTextMorphPlus! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 9/13/2010 15:05:41.639'!
flapClass

	^ SPluggableFlapMorph! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 7/7/2010 16:41:03.577'!
pluggableTreeMorphClass: aSpec

	(aSpec isKindOf: SPluggableTreeSpec) ifTrue: [^ SPluggableTreeMorph].
	^ PluggableTreeMorph! !

!MorphicToolBuilder methodsFor: '*SightL' stamp: 'mp 7/7/2010 16:41:07.354'!
setAdditionalTreeSpecs: aSpec on: aWidget

	(aSpec isKindOf: SPluggableTreeSpec) 
		ifTrue: [
			aWidget highlightItemSelector: aSpec highlightItem.
			aWidget indentingListItemMorphClass: aSpec indentingListItemMorph].! !

PluggableMultiSelectionListSpec subclass: #SPluggableMultiSelectionListSpec
	instanceVariableNames: 'itemColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Specs'!

!SPluggableMultiSelectionListSpec methodsFor: 'building' stamp: 'mp 9/23/2010 16:45:03.24'!
buildWith: builder
	^builder buildSPluggableMultiSelectionList: self! !

!SPluggableMultiSelectionListSpec methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:44:47.093'!
itemColor
	"Answer the value of itemColor"

	^ itemColor! !

!SPluggableMultiSelectionListSpec methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:44:47.098'!
itemColor: anObject
	"Set the value of itemColor"

	itemColor := anObject! !

TestCase subclass: #SBrowserExtensionTest
	instanceVariableNames: 'oldCurrentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-PathFinder'!

!SBrowserExtensionTest methodsFor: 'testing' stamp: 'mp 3/23/2011 14:59:20.509'!
openBrowserOnClass: aClass selector: aSelector
	
	| brow classToUse |
	classToUse := SystemBrowser default.
	brow := classToUse new.
	brow setClass: aClass selector: aSelector.
	^ classToUse 
		openBrowserView: (brow openEditString: nil)
		label: brow labelString! !

!SBrowserExtensionTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:51:50.264'!
setUp

	oldCurrentProject := SProject current.
	SProject setCurrent: #sandbox.! !

!SBrowserExtensionTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:51:53.575'!
tearDown

	SProject setCurrentProject: oldCurrentProject.! !

!SBrowserExtensionTest methodsFor: 'testing' stamp: 'mp 7/8/2010 17:59:15.977'!
testBrowseBehavior

	| browser testExpander |
	browser := self openBrowserOnClass: SSBClassA selector: #doNothing.
	testExpander := browser openPathFinderOn: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: testExpander notNil.
	self assert: testExpander testChooserModel isTestAvailable.
	self assert: testExpander testChooserModel test actualClass == SSBTest.
	self assert: testExpander testChooserModel test methodSymbol == #testDoNothing.
	self assert: testExpander callgraphModel selectedItem clientClass = SSBClassA.
	self assert: testExpander callgraphModel selectedItem clientSelector = #doNothing.
	self assert: testExpander callgraphModel searchQuery = 'SSBClassA>>doNothing'.
	browser dependents first abandon.
	testExpander windowMorph abandon.! !

!SBrowserExtensionTest methodsFor: 'testing' stamp: 'mp 3/23/2011 15:02:50.836'!
testEntryPointsOfClassADoNothing

	| browser tests |
	browser := self openBrowserOnClass: SSBClassA selector: #doNothing.
	tests := browser coveredTestsSortedFor: (MethodReference class: SSBClassA selector: #doNothing).
	self assert: tests size isZero.
	browser dependents first abandon.! !

TestCase subclass: #SCallNodeTest
	instanceVariableNames: 'rootNode calledNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
calledNode
	"Answer the value of calledNode"

	^ calledNode! !

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
calledNode: anObject
	"Set the value of calledNode"

	calledNode := anObject! !

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
rootNode
	"Answer the value of rootNode"

	^ rootNode! !

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
rootNode: anObject
	"Set the value of rootNode"

	rootNode := anObject! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:25.551'!
setUp

	| callgraph |
	callgraph := SCallgraphModel new.
	self rootNode: (SCallNode id: 0 class: SSBTest methodName: #testDoNothing fromSender: nil model: callgraph receiverType: SSBTest callsBefore: 0).
	self calledNode: (SCallNode id: 1 class: SSBClassA methodName: #doNothing fromSender: self rootNode model: callgraph receiverType: SSBClassA callsBefore: 0).! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:07'!
testAddCall

	self rootNode addCall: self calledNode.
	self assert: self rootNode nextCalls notEmpty.
	self assert: self rootNode nextCalls first == self calledNode.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:06'!
testFromRootSender

	self assert: self calledNode fromSender == self rootNode.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:11'!
testGetCallStackFromMultipleCalledNodes

	self rootNode addCall: self calledNode.
	self rootNode addCall: self calledNode.
	self rootNode addCall: self calledNode.
	self assert: self rootNode nextCalls size = 3.
	self assert: (self rootNode nextCalls second getCallStack = (OrderedCollection with: self rootNode with: self calledNode)).! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:12'!
testGetCallStackFromRoot

	self assert: self rootNode getCallStack = (OrderedCollection with: self rootNode).! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:47.397'!
testInitializationRootNode

	self assert: self rootNode id = 0.
	self assert: self rootNode fromSender = nil.
	self assert: self rootNode nextCalls isEmpty.
	self assert: self rootNode selectedView = #classes.
	self assert: self rootNode selectedProfile = #normal.
	self assert: self rootNode views notEmpty.
	self assert: (self rootNode views at: #classes) = SSBTest.
	self assert: self rootNode profiles isEmpty.
	self assert: self rootNode clientSelector == #testDoNothing.
	self assert: self rootNode clientClass == SSBTest.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:49.541'!
testPrintProfile

	self rootNode selectedProfile: #%.
	self rootNode profiles at: #% put: '100%'.
	self assert: self rootNode asString =  '[100%]SSBTest>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:56.338'!
testPrintString

	self assert: self rootNode asString =  'SSBTest>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 4/24/2010 17:55'!
testPrintView

	self rootNode selectedView: #objects.
	self rootNode views at: #objects put: 'a Test'.
	self assert: self rootNode asString =  'a Test>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 4/24/2010 17:55'!
testPrintViewAndProfile

	self rootNode selectedView: #objects.
	self rootNode views at: #objects put: 'a Test'.
	self rootNode selectedProfile: #%.
	self rootNode profiles at: #% put: '100%'.
	self assert: self rootNode asString =  '[100%]a Test>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:18'!
testSetAsCurrentSelection

	self assert: self rootNode callgraphModel selectedItem isNil.
	self rootNode setAsCurrentSelection.
	self assert: self rootNode callgraphModel selectedItem = self rootNode.! !

TestCase subclass: #SPathFinderTest
	instanceVariableNames: 'oldCurrentProject browserModel browserMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-PathFinder'!

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserModel
	"Answer the value of browserModel"

	^ browserModel! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserModel: anObject
	"Set the value of browserModel"

	browserModel := anObject! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserMorph
	"Answer the value of browserMorph"

	^ browserMorph! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserMorph: anObject
	"Set the value of browserMorph"

	browserMorph := anObject! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 3/14/2010 19:14'!
naviBar

	^ self browserMorph submorphs fourth! !

!SPathFinderTest methodsFor: 'testing' stamp: 'mp 7/8/2010 17:20:53.514'!
setUp

	oldCurrentProject := SProject current.
	SProject setCurrent: #sandbox.
	self browserModel: SPathFinder new.
	self browserMorph: (ToolBuilder build: self browserModel).
		
	! !

!SPathFinderTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:35.567'!
tearDown

	SProject setCurrentProject: oldCurrentProject.! !

SPathFinderTest subclass: #SPathFinderTestChooserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-PathFinder'!

!SPathFinderTestChooserTest methodsFor: 'accessing' stamp: 'mp 3/12/2010 17:18'!
getTestModel
	
	^ self browserModel testChooserModel! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:54.441'!
testAnalyzeTest

	self assert: self getTestModel result isNil.
	self assert: self browserModel callgraphModel rootNode isNil.
	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self getTestModel analyzeTest.
	self assert: self getTestModel result hasPassed.
	self assert: self browserModel callgraphModel rootNode notNil.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:56.285'!
testDeselectTest

	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self getTestModel setCurrentTest: nil.
	self assert: self browserModel callgraphModel rootNode isNil.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:52.501'!
testRerunTestButtonEnabled

	self deny: self getTestModel isTestAvailable.
	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: self getTestModel isTestAvailable.
	self getTestModel setCurrentTest: nil.
	self deny: self getTestModel isTestAvailable.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:50.293'!
testSelectAnotherTest

	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: self browserModel callgraphModel rootNode clientSelector == #testDoNothing.
	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testBinary).
	self assert: self browserModel callgraphModel rootNode clientSelector == #testBinary.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 3/14/2010 14:05'!
testSelectProfiling

	self assert: self getTestModel tracer profilingMode == #normal.
	self getTestModel normalRunWithCounts.
	self assert: self getTestModel tracer profilingMode == #counts.
	self getTestModel profileRunWithMs.
	self assert: self getTestModel tracer profilingMode == #ms.
	self getTestModel profileRunWithPercentage.
	self assert: self getTestModel tracer profilingMode == #%.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:57.973'!
testSelectTest

	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: self browserModel callgraphModel rootNode notNil.
	self getTestModel setCurrentTest: nil.
	self assert: self browserModel callgraphModel rootNode isNil.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 3/14/2010 14:04'!
testSelectView

	self assert: self getTestModel tracer viewMode == #classes.
	self getTestModel selectObjectView.
	self assert: self getTestModel tracer viewMode == #objects.
	self getTestModel selectIdentityView.
	self assert: self getTestModel tracer viewMode == #identities.! !

SPathFinderTest subclass: #SPathFinderToolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-PathFinder'!

!SPathFinderToolTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:40.696'!
testModelCreation

	self assert: self browserModel notNil.
	self assert: self browserModel callgraphTracer notNil.
	self assert: self browserModel callgraphModel notNil.
	self assert: self browserModel testChooserModel notNil.
	
	self assert: self browserModel callgraphTracer selectedCategories = SProject current categories.
	self assert: self browserModel callgraphTracer callgraphModel == self browserModel callgraphModel.
	self assert: self browserModel callgraphModel tracer == self browserModel callgraphTracer.
	
	self assert: self browserModel testChooserModel tracer == self browserModel callgraphTracer.! !

!SPathFinderToolTest methodsFor: 'testing' stamp: 'mp 3/24/2011 11:39:13.43'!
testMorphCreation

	self assert: self browserMorph notNil.
	
	self assert: (self browserMorph submorphs at: 1) class == SDropDownMorph.
	self assert: (self browserMorph submorphs at: 1) actionModel == self browserModel testChooserModel.	
	self assert: (self browserMorph submorphs at: 1) labelMorph contents = 'Without Profiling'.
	
	self assert: (self browserMorph submorphs at: 2) class == SDropDownMorph.
	self assert: (self browserMorph submorphs at: 2) actionModel == self browserModel testChooserModel.
	self assert: (self browserMorph submorphs at: 2) labelMorph contents = 'Class View'.

	self assert: (self browserMorph submorphs at: 3) class == STestResultFeedbackMorph.
	self assert: (self browserMorph submorphs at: 3) actionModel == self browserModel.

	self assert: (self browserMorph submorphs at: 5) class == PluggablePanelMorph.
	self assert: (self browserMorph submorphs at: 5) submorphs size = 2.
	self assert: (self browserMorph submorphs at: 5) submorphs first label = '<<'.
	self assert: (self browserMorph submorphs at: 5) submorphs second label = '>>'.

	self assert: (self browserMorph submorphs at: 6) class == PluggableTextMorphPlus.
	self assert: (self browserMorph submorphs at: 6) knownName = 'searchInputField'.
	self assert: (self browserMorph submorphs at: 6) model == self browserModel callgraphModel.

	self assert: (self browserMorph submorphs at: 7) class == SPluggableTreeMorph.
	self assert: (self browserMorph submorphs at: 7) knownName = 'callGraphTree'.
	self assert: (self browserMorph submorphs at: 7) model == self browserModel callgraphModel.
	
"feedback morph ist nue und muss noch getestet werden"! !

TestCase subclass: #SProjectTest
	instanceVariableNames: 'oldRegistry oldCurrentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Projects'!

SProjectTest subclass: #SProjectAccessTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Projects'!

!SProjectAccessTest methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:52:15.999'!
project
	"Answer the value of project"

	^ SProject current! !

!SProjectAccessTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:52:13.069'!
setUp
	super setUp.
	SProject addProject: SProject sunitProject.
	SProject setCurrent: #sunit.! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 6/11/2010 15:48'!
test01AllClasses

	self assert: self project allClasses = {ClassFactoryForTestCase. ClassFactoryForTestCaseTest. LongTestCase. LongTestCaseTest. LongTestCaseTestUnderTest. ResumableTestFailure. ResumableTestFailureTestCase. SUnitExtensionsTest. SUnitTest. SimpleTestResource. SimpleTestResourceTestCase. TestCase. TestFailure. TestResource. TestResult. TestSuite}.! !

!SProjectAccessTest methodsFor: 'category tests' stamp: 'mp 6/11/2010 16:43'!
test01CategoriesWithTest

	self assert: self project categoriesWithTests = #(#'SUnit-Extensions' #'SUnit-Tests').! !

!SProjectAccessTest methodsFor: 'method category tests' stamp: 'mp 3/24/2011 11:40:17.599'!
test01MethodCategoriesOfClass

	self assert: (self project methodCategoriesOfClass: TestCase) =  #(#accessing #dependencies #printing #running #testing #private #extensions #'*SightC' #'accessing (class)' #'building suites (class)' #'instance creation (class)' #'testing (class)' #'coverage (class)' #'history (class)' #'initialize - event (class)' #'*sunitgui (class)' #'Accessing (class)' #'*SwaUtil (class)' #'*SightL (class)').	! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 3/24/2011 11:40:36.065'!
test01NomOfClass

	self assert: (self project nomOfClass: TestFailure) = 2.
	self assert: (self project nomOfClass: TestResource) = 20.
	self assert: (self project nomOfClass: TestCase) = 106.! !

!SProjectAccessTest methodsFor: 'print tests' stamp: 'mp 6/11/2010 16:34'!
test01PrintMetricsOverview! !

!SProjectAccessTest methodsFor: 'project tests' stamp: 'mp 6/11/2010 16:09'!
test01ProjectInitialized

	self assert: self project notNil.
	self assert: self project projectName == #sunit.! !

!SProjectAccessTest methodsFor: 'category tests' stamp: 'mp 6/11/2010 16:44'!
test02CategoriesOrderedByTests

	self assert: self project categoriesOrderedByTestsFirst =  #(#'SUnit-Extensions' #'SUnit-Tests' #'SUnit-Kernel').! !

!SProjectAccessTest methodsFor: 'method category tests' stamp: 'mp 7/7/2010 10:10:07.065'!
test02MethodsOfMethodCategoryAndClass

	self assert: (self project methodsPerClass: TestCase andMethodCategory: #accessing ) =   #(#assert: #assert:description: #assert:description:resumable: #assert:equals: #deny: #deny:description: #deny:description:resumable: #resources #selector #should: #should:description: #should:raise: #should:raise:description: #should:raise:whoseDescriptionDoesNotInclude:description: #should:raise:whoseDescriptionIncludes:description: #shouldnt: #shouldnt:description: #shouldnt:raise: #shouldnt:raise:description: #shouldnt:raise:whoseDescriptionDoesNotInclude:description: #shouldnt:raise:whoseDescriptionIncludes:description: #signalFailure:).
	self assert: (self project methodsPerClass: TestCase andMethodCategory: #'accessing (class)') =   #(#allTestSelectors #resources #sunitVersion).! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 6/11/2010 16:50'!
test02NomOfClassAndMethodCategory

	self assert: (self project nomOfClass: TestCase methodCategory: 'printing') = 1.
	self assert: (self project nomOfClass: TestCase methodCategory: 'dependencies') = 2.
	self assert: (self project nomOfClass: TestCase methodCategory: 'accessing') = 22.! !

!SProjectAccessTest methodsFor: 'project tests' stamp: 'mp 6/11/2010 16:26'!
test02ResetClassesCache

	self assert: (self project instVarNamed: 'classesCache') isNil.
	self project allClasses.
	self assert: (self project instVarNamed: 'classesCache') notNil.
	self project resetClassesCache.
	self assert: (self project instVarNamed: 'classesCache') isNil.	! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 6/11/2010 15:50'!
test02TestClasses

	self assert: self project testClasses =  {ClassFactoryForTestCaseTest . LongTestCase . LongTestCaseTest . LongTestCaseTestUnderTest . ResumableTestFailureTestCase . SUnitExtensionsTest . SUnitTest . SimpleTestResourceTestCase}! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 6/11/2010 15:54'!
test03ClassesOfCategory

	self assert: (self project classesOfCategory: #'SUnit-Kernel') =  {ResumableTestFailure . TestCase . TestFailure . TestResource . TestResult . TestSuite}.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 3/24/2011 11:40:51.791'!
test03NomOfCategory

	self assert: (self project nomOfCategory: #'SUnit-Kernel') = 198.
	self assert: (self project categories inject: 0 into: [:sum :cat | 
				sum := sum + (self project nomOfCategory: cat)]) = self project nom.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 3/24/2011 11:41:05.43'!
test04LocOfProject

	self assert: self project loc =  1454.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 6/11/2010 16:25'!
test04NocOfProject

	self assert: self project noc = 16.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 3/24/2011 11:41:16.79'!
test04NomOfProject

	self assert: self project nom = 322.
	self assert: self project nom = (self project allClasses 
									inject: 0 
									into: [:sum :each | 
										sum + each methodDict size + each class methodDict size])! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 6/11/2010 16:27'!
test04NopOfProject

	self assert: self project nop = 3.! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 6/11/2010 15:54'!
test04TestClassesOfCategory

	self assert: (self project testClassesOfCategory: #'SUnit-Tests') =  {ClassFactoryForTestCaseTest . ResumableTestFailureTestCase . SUnitExtensionsTest . SUnitTest . SimpleTestResourceTestCase}.
	self assert: (self project testClassesOfCategory: #'SUnit-Kernel') isEmpty.! !

SProjectTest subclass: #SProjectRegistryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Projects'!

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:53:13.09'!
test01EmptyProjectRegistry

	self assert: SProject projectRegistry isEmpty.
	self assert: SProject allProjects isEmpty.
	self assert: SProject allProjectNames isEmpty.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:44.789'!
test02ProjectRegistryInitalizeWithStandardProjects

	SProject addPredefinedProjects.
	self deny: SProject projectRegistry isEmpty.
	self assert: (SProject projectAt: #NeverUseThisSymbolAsAProjectyxnbcvejg) isNil.
	self assert: (SProject projectAt: #sunit) notNil.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:32.351'!
test03aProjectRegistryAtMonticelloProject
	| project |
	SProject addPredefinedProjects.
	project := SProject projectAt: #monticello.
	self assert: project notNil.
	self assert: project projectName == #monticello.
	self assert: project categories = #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks').! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:57.294'!
test03bProjectRegistryAtSUnitProject
	| project |
	SProject addPredefinedProjects.
	project := SProject projectAt: #sunit.
	self assert: project notNil.
	self assert: project projectName == #sunit.
	self assert: project categories = #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:53:01.969'!
test03cProjectRegistryAtSystemBrowserProject
	| project |
	SProject addPredefinedProjects.
	project := SProject projectAt: #systemBrowser.
	self assert: project notNil.
	self assert: project projectName == #systemBrowser.
	self assert: project categories = #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:23.366'!
test04AddNewProject
	| project |
	project := SProject name: #myProject categories: #(#'DontExists').
	self assert: (SProject projectAt: #myProject) isNil.
	SProject addProject: project.
	self assert: (SProject projectAt: #myProject) notNil.	! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:51.204'!
test05RemoveProject

	SProject addPredefinedProjects.
	SProject removeProjectAt: #sunit.
	self assert: (SProject projectAt: #sunit) isNil.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:53:18.927'!
test06ResetProjectRegistry

	SProject addPredefinedProjects.
	SProject reset.
	self assert: SProject projectRegistry isEmpty.! !

!SProjectTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:52:00.248'!
setUp

	oldRegistry := SProject projectRegistry.
	oldCurrentProject := SProject current.
	SProject reset.! !

!SProjectTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:52:04.062'!
tearDown
	SProject projectRegistry: oldRegistry.
	SProject setCurrentProject: oldCurrentProject.! !

TestCase subclass: #SRecordAndReplayTest
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Record-Replay'!

!SRecordAndReplayTest methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:48'!
cache
	"Answer the value of cache"

	^ cache! !

!SRecordAndReplayTest methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:48'!
cache: anObject
	"Set the value of cache"

	cache := anObject! !

!SRecordAndReplayTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:58:36.095'!
setUp

	self cache: SReplayCache new.! !

!SRecordAndReplayTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:57:54.603'!
tearDown

	SRecordReplayWrapper nuke.
	Smalltalk garbageCollect.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:57:51.617'!
testRecordDateAndTimeNow
	| time |
	(SRecordReplayWrapper on: #now inClass: DateAndTime class with: self cache) install.
	time := DateAndTime now.
	(Delay forSeconds: 1) wait.
	self assert: time = DateAndTime now.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:57:58.805'!
testRecordDateAndTimeNowUninstallWrapper
	| time wrapper |
	wrapper := (SRecordReplayWrapper on: #now inClass: DateAndTime class with: self cache) install.
	time := DateAndTime now.
	(Delay forSeconds: 1) wait.
	self assert: time = DateAndTime now.
	wrapper uninstall.
	self deny: time = DateAndTime now.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:58:05.997'!
testRecordMultipleRandoms

	| result1 result2 |
	(SRecordReplayWrapper on: #atRandom inClass: Integer with: self cache) install.
	result1 := 10000 atRandom.
	result2 := 9999 atRandom.
	self assert: 10000 atRandom = result1.
	self assert: 9999 atRandom = result2.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:58:02.317'!
testRecordRandom

	| result |
	(SRecordReplayWrapper on: #atRandom inClass: Integer with: self cache) install.
	result := 10000 atRandom.
	self assert: 10000 atRandom = result.! !

TestCase subclass: #SSBFaultLocalizationTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Sandbox'!

!SSBFaultLocalizationTest methodsFor: 'accessing' stamp: 'mp 11/5/2010 10:04:18.32'!
a
	"Answer the value of a"

	^ a! !

!SSBFaultLocalizationTest methodsFor: 'accessing' stamp: 'mp 11/5/2010 10:04:18.325'!
a: anObject
	"Set the value of a"

	a := anObject! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 14:10:33.885'!
setUp

	self a: SSBClassA new.! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 10:01:40.681'!
testFailingMethodFault

	self deny: (self a failingMethod: false)! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 14:12:16.308'!
testFailingMethodPass

	self assert: (self a failingMethod: true).
	self a unaryMethod.! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 16:50:03.059'!
xtestFailingMethodError
	self a doNothing.
	self deny: (self a failingMethod: 1)! !

TestCase subclass: #SSBTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Sandbox'!

!SSBTest methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:35'!
a
	"Answer the value of a"

	^ a! !

!SSBTest methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:35'!
a: anObject
	"Set the value of a"

	a := anObject! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:28.17'!
setUp

	self a: SSBClassA new.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:35'!
tearDown

	self a doNothing.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:38'!
testBinary

	self assert: self a + 5 = 5.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:43'!
testComplexTrace

	self assert: (self a complexMethod: 5) = 10.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:12.736'!
testConstructor

	self assert: (SSBClassB on: 1) myValue = 1.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:52'!
testDelay

	"Required for Profiling"
	self assert: self a delayedMethod.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:38'!
testDoNothing

	self assert: self a doNothing = self a.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:34'!
testInitialize

	self assert: self a myValue = 0.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 11/8/2010 17:01:53.424'!
testLongParameterMethod
	self a param: 1 method: 2.
	self a manyParameters: 1 b: 2 d: 3 f: 4 long: 5! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:49'!
testMethodChain

	self assert: (self a methodChain: (self a methodChain: (self a methodChain: 1) + 1) + 1) = 3.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:14.617'!
testModelView

	| b |
	b := SSBClassB new.
	self a myValue: 1.
	self assert: b myValue isNil.
	self a addDependent: b.
	self a myValue: 2.
	self assert: b myValue = 2.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 11/8/2010 15:37:20.516'!
testMultipleByteCodePaths

	self assert: (self a param: 5 method: 2) = 4.
	self assert: (self a param: 3 method: 2) = #(3 2).! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:40'!
testParamMethod

	self assert: (self a param: 1 method: 2) = #(1 2).
	self assert: self a myValue = #(1 2).! !

!SSBTest methodsFor: 'testing' stamp: 'mp 11/5/2010 18:34:13.457'!
testParamMethod2

	self assert: (self a param: 5 method: 2) = 5.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:32:14.64'!
testPartial

	self assert: self a doNothing = self a.
	self assert: SPartialTraceObject new doSomething.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:47'!
testPrintString

	self a myValue: 5.
	self assert: self a asString = '5'.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:30.165'!
testRecursion

	self assert: (SSBClassA new recursionMethod: 5) = 15.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:37'!
testUnary

	self assert: self a unaryMethod.! !

TestCase subclass: #STracerTest
	instanceVariableNames: 'oldCurrentProject tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

STracerTest subclass: #SCallgraphTest
	instanceVariableNames: 'callgraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

SCallgraphTest subclass: #SCallgraphFunctionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:16.678'!
testBrowseSelectedNode

	| browser |
	self assert: self cg browseMethod == self cg.
	self cg newSelectedItem: (self getNode: 12).
	browser := self cg browseMethod.
	self assert: browser class == SystemBrowser default.
	self assert: browser selectedClass == SSBClassB.
	self assert: browser selectedMessageName == #compute.
	self flag: #mpe. "Find a better way to close the system window"
	browser dependents first delete.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:06'!
testExpandRootNode

	self assert: self cg selectedItem isNil.
	self cg expandRootNode.
	self assert: self cg selectedItem == self rootNode.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:07'!
testExpandSelectedNode

	self cg expandSelectedNode.
	self assert: self cg selectedItem == self rootNode.
	self cg newSelectedItem: (self getNode: 12).
	self cg expandSelectedNode.
	self assert: self cg selectedItem ==(self getNode: 12).! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:33'!
testFindNodeFromRoot

	self assert: (self cg findNodeInSubGraph: 0 startNode: self rootNode) isNil.
	self assert: (self cg findNodeInSubGraph: 12 startNode: self rootNode) id = 12.
	self assert: (self cg findNodeInSubGraph: 22 startNode: self rootNode) id = 22.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:34'!
testFindNodeWithinSubtree

	| node |
	node := self getNode: 12.
	self assert: (self cg findNodeInSubGraph: 0 startNode: node) isNil.
	self assert: (self cg findNodeInSubGraph: 12 startNode: node) isNil.
	self assert: (self cg findNodeInSubGraph: 22 startNode: node) isNil.
	
	self assert: (self cg findNodeInSubGraph: 13 startNode: node) id = 13.
	self assert: (self cg findNodeInSubGraph: 19 startNode: node) id = 19.	! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:35'!
testFindNotExistingNode

	self assert: (self cg findNodeInSubGraph: -1 startNode: self rootNode) isNil.
	self assert: (self cg findNodeInSubGraph: 23 startNode: self rootNode) isNil.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:04'!
testGetSelectedPath

	| path |
	self cg newSelectedItem: (self getNode: 12).
	path := self cg getSelectedPath.
	self assert: path = (OrderedCollection 
								with: self rootNode 
								with: (self getNode: 5) 
								with: (self getNode: 7) 
								with: (self getNode: 12))! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:51'!
testNewSelectedItem

	self assert: self cg selectedItem isNil.
	self cg newSelectedItem: (self getNode: 12).
	self assert: self cg selectedItem notNil.
	self assert: self cg selectedItem == (self getNode: 12).! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:49'!
testNumberOfCallsBefore

	| node |
	self assert: (self cg numberOfCallsBefore: self rootNode) = 0.
	node := self getNode: 12.
	self assert: (self cg numberOfCallsBefore: node) = 0.
	node := self getNode: 13.
	self assert: (self cg numberOfCallsBefore: node) = 0.
	node := self getNode: 15.
	self assert: (self cg numberOfCallsBefore: node) = 1.	
	node := self getNode: 16.
	self assert: (self cg numberOfCallsBefore: node) = 2.	! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:39'!
testTraversCallGraphFromRoot

	| collection |
	collection := OrderedCollection new.
	self cg traverseCallGraph: self rootNode with: [:each | collection add: each id].
	self assert: (1 to: 22) asOrderedCollection = collection.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:41'!
testTraversCallGraphFromRootWithAbort

	| collection |
	collection := OrderedCollection new.
	self cg traverseCallGraph: self rootNode with: [:each | collection add: each id] abort: [:each | each id > 10].
	self assert: #(1 2 3 4 5 6 7 8 9 10 11 12 20) asOrderedCollection = collection.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:42'!
testTraversCallGraphFromSubTree

	| collection node |
	node := self getNode: 12.
	collection := OrderedCollection new.
	self cg traverseCallGraph: node with: [:each | collection add: each id].
	self assert: (13 to: 19) asOrderedCollection = collection.! !

!SCallgraphFunctionsTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:43'!
testTraversCallGraphFromSubTreeWithAbort

	| collection node |
	node := self getNode: 12.
	collection := OrderedCollection new.
	self cg traverseCallGraph: node with: [:each | collection add: each id] abort: [:each | each id > 15].
	self assert: (13 to: 18) asOrderedCollection = collection.! !

SCallgraphTest subclass: #SCallgraphHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:10'!
testAddToHistory

	self assert: self cg history isEmpty.
	self assert: self cg currentHistoryNode = 0.
	self cg newSelectedItem: self rootNode.
	self assert: self cg history notEmpty.	
	self assert: self cg history size = 1.
	self assert: self cg history first == self rootNode.
	self assert: self cg currentHistoryNode = 1.! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:11'!
testAddToHistorySameItemTwice

	self cg newSelectedItem: self rootNode.
	self cg newSelectedItem: self rootNode.
	self assert: self cg history notEmpty.	
	self assert: self cg history size = 1.
	self assert: self cg history first == self rootNode.
	self assert: self cg currentHistoryNode = 1.! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:12'!
testAddToHistoryTwoItems

	self cg newSelectedItem: self rootNode.
	self cg newSelectedItem: (self getNode: 12).
	self assert: self cg history notEmpty.	
	self assert: self cg history size = 2.
	self assert: self cg history first == self rootNode.
	self assert: self cg history second == (self getNode: 12).
	self assert: self cg currentHistoryNode = 2.! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:14'!
testHistoryBack

	self cg newSelectedItem: self rootNode.
	self cg newSelectedItem: (self getNode: 12).
	self cg newSelectedItem: (self getNode: 1).
	self cg historyBack.
	self assert: self cg selectedItem == (self getNode: 12).
	self cg historyBack.
	self assert: self cg selectedItem == self rootNode.! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:15'!
testHistoryBackAndForth

	self cg newSelectedItem: self rootNode.
	self cg newSelectedItem: (self getNode: 12).
	self cg newSelectedItem: (self getNode: 1).
	self cg historyBack.
	self assert: self cg selectedItem == (self getNode: 12).
	self cg historyPrevious.
	self assert: self cg selectedItem == (self getNode: 1).! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:17'!
testHistoryBackAndNewSelectedItem

	self cg newSelectedItem: self rootNode.
	self cg newSelectedItem: (self getNode: 12).
	self cg newSelectedItem: (self getNode: 1).
	self cg historyBack.
	self cg historyBack.
	self cg newSelectedItem: (self getNode: 10).
	self assert: self cg history size = 2.
	self assert: self cg history first == self rootNode.
	self assert: self cg history second == (self getNode: 10).
! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:21'!
testHistoryBackButtonEnabled

	self deny: self cg historyBackButtonEnabled.
	self cg newSelectedItem: self rootNode.
	self deny: self cg historyBackButtonEnabled.
	self cg newSelectedItem: (self getNode: 12).
	self assert: self cg historyBackButtonEnabled.
	self cg historyBack.
	self deny: self cg historyBackButtonEnabled.
	self cg historyPrevious.
	self assert: self cg historyBackButtonEnabled.
	! !

!SCallgraphHistoryTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:19'!
testHistoryPreviousButtonEnabled

	self deny: self cg historyPreviousButtonEnabled.
	self cg newSelectedItem: self rootNode.
	self cg newSelectedItem: (self getNode: 12).
	self deny: self cg historyPreviousButtonEnabled.
	self cg historyBack.
	self assert: self cg historyPreviousButtonEnabled.
	self cg historyPrevious.
	self deny: self cg historyPreviousButtonEnabled.! !

SCallgraphTest subclass: #SCallgraphModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:28'!
testCallgraphCallstackOfNode12

	| node |
	node := self getNode: 12.
	self assert: node getCallStack notEmpty.
	self assert: node getCallStack size = 4.
	self assert: node getCallStack = (OrderedCollection 
								with: self rootNode 
								with: (self getNode: 5) 
								with: (self getNode: 7) 
								with: node)! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:22.72'!
testCallgraphCheckNode12

	| node |
	node := self getNode: 12.
	self assert: node clientClass == SSBClassB.
	self assert: node clientSelector == #compute.	! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:29'!
testCallgraphChildrenOfNode12

	| node |
	node := self getNode: 12.
	self assert: node nextCalls notEmpty.
	self assert: node nextCalls size = 6.
	self assert: node nextCalls = (OrderedCollection 
								with: (self getNode: 13) 
								with: (self getNode: 14) 
								with: (self getNode: 15) 
								with: (self getNode: 16)
								with: (self getNode: 17)
								with: (self getNode: 18))! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:31.892'!
testCallgraphFromSenderOfNode12

	| node |
	node := self getNode: 12.
	self assert: node fromSender clientClass == SSBClassA.
	self assert: node fromSender clientSelector == #complexMethod:.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:09:03.916'!
testCallgraphInitialization

	| testCallgraph |
	testCallgraph := SCallgraphModel on: self tracer.
	self assert: testCallgraph rootNode isNil.
	self assert: testCallgraph currentNode isNil.
	self assert: testCallgraph history isEmpty.
	self assert: testCallgraph currentHistoryNode = 0.
	self assert: testCallgraph selectedItem isNil.
	self assert: testCallgraph highlightedItems isEmpty.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:01.344'!
testCallgraphRootNode

	self assert: self cg rootNode clientClass == SSBTest.
	self assert: self cg rootNode clientSelector == #testComplexTrace.
	self assert: self cg rootNode nextCalls notEmpty.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:16'!
testGetChildren

	self assert: (self cg getChildren: self rootNode) size = 3.
	self assert: (self cg getChildren: (self getNode: 12)) size = 6.
	self assert: (self cg getChildren: (self getNode: 22)) isEmpty.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:10'!
testHasChildren

	self assert: (self cg hasChildren: self rootNode).
	self assert: (self cg hasChildren: (self getNode: 12)).
	self deny: (self cg hasChildren: (self getNode: 22)).! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:13'!
testNumberOfNodesWithinCallgraph

	| number |
	number := 0.
	self cg traverseCallGraph: self cg rootNode with: [:aNode | number := number + 1].
	self assert: number = 22.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:19'!
testReset

	self assert: self cg rootNode notNil.
	self cg reset.
	self assert: self cg rootNode isNil.
	self assert: self cg currentNode isNil.
	self assert: self cg history isEmpty.
	self assert: self cg currentHistoryNode = 0.
	self assert: self cg selectedItem isNil.
	self assert: self cg highlightedItems isEmpty.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:03.696'!
testRootCallNodes

	self assert: self cg rootCallNodes notEmpty.
	self assert: self cg rootCallNodes size = 1.
	self assert: self cg rootCallNodes first clientClass == SSBTest.
	self assert: self cg rootCallNodes first clientSelector == #testComplexTrace.! !

!SCallgraphModelTest methodsFor: 'testing' stamp: 'mp 3/9/2010 13:14'!
testStartingCallNodes

	self assert: self cg startingCallNodes notEmpty.
	self assert: self cg startingCallNodes size = 3.
	self assert: self cg startingCallNodes first clientSelector == #setUp.
	self assert: self cg startingCallNodes second clientSelector == #testComplexTrace.
	self assert: self cg startingCallNodes third clientSelector == #tearDown.! !

SCallgraphTest subclass: #SCallgraphSearchingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:33'!
testGetSearchQuery

	self assert: self cg searchQuery isNil.
	self cg searchNode: 'LSBClassB>>myValue'.
	self assert: self cg searchQuery = 'LSBClassB>>myValue'.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:32.144'!
testMultipleItemSearching

	| result |
	result := self cg searchNode: 'SSBClassB>>myValue'.
	self assert: result size = 4.
	self assert: result first id = 11.
	self assert: result second id = 13.
	self assert: result third id = 15.
	self assert: result fourth id = 16.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 3/9/2010 14:29'!
testNotExistingItemSearching

	| result |
	result := self cg searchNode: 'XXX'.
	self assert: result isEmpty.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:41:01.921'!
testSearchingAndHighlighting

	self cg searchNode: 'SSBClassB>>myValue'.
	self assert: self cg highlightedItems size = 4.
	self assert: self cg highlightedItems first id = 11.
	self assert: self cg highlightedItems second id = 13.
	self assert: self cg highlightedItems third id = 15.
	self assert: self cg highlightedItems fourth id = 16.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:16.535'!
testSearchingAndSelectFirstResult

	self assert: self cg selectedItem isNil.
	self cg searchNode: 'SSBClassB>>myValue'.
	self assert: self cg selectedItem id = 11.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:08.435'!
testSearchingAndSelectNextResult

	self assert: self cg selectedItem isNil.
	self cg searchNode: 'SSBClassB>>myValue'.
	self cg searchNode: 'SSBClassB>>myValue'.
	self assert: self cg selectedItem id = 13.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:41:08.358'!
testSearchingAndSelectNextResultAfterCurrentSelection

	self cg newSelectedItem: (self getNode: 14).
	self cg searchNode: 'SSBClassB>>myValue'.
	self assert: self cg selectedItem id = 15.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:41:13.605'!
testSearchingAndSelectNextResultAfterEndOfTree

	self cg newSelectedItem: (self getNode: 22).
	self cg searchNode: 'SSBClassB>>myValue'.
	self assert: self cg selectedItem id = 11.! !

!SCallgraphSearchingTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:41:18.821'!
testSingleItemSearching

	| result |
	result := self cg searchNode: 'SSBClassB>>compute'.
	self assert: result size = 1.
	self assert: result first = (self getNode: 12).! !

!SCallgraphTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 11:49'!
callgraph
	"Answer the value of callgraph"

	^ callgraph! !

!SCallgraphTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 11:49'!
callgraph: anObject
	"Set the value of callgraph"

	callgraph := anObject! !

!SCallgraphTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 13:06'!
cg
	"Answer the value of callgraph"

	^ self callgraph! !

!SCallgraphTest methodsFor: 'as yet unclassified' stamp: 'mp 3/9/2010 13:11'!
getNode: anId

	^ self callgraph findNodeInSubGraph: anId startNode: self callgraph rootNode! !

!SCallgraphTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:59.621'!
setUp

	super setUp.
	self tracer traceTest: SSBTest method: #testComplexTrace.
	self callgraph: self tracer callgraphModel.! !

SCallgraphTest subclass: #SObjectExplorerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Callgraph'!

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 4/24/2010 18:43'!
testClearObjectCache

	| callNode |
	callNode := self getNode: 12.
	self assert: callNode objects isEmpty.
	callNode explore: #return.
	self assert: callNode objects notEmpty.
	callNode clearObjectCache.
	self assert: callNode objects isEmpty.! !

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:25.56'!
testExploreFullCallNode

	| callNode |
	callNode := self getNode: 12.
	self assert: callNode objects isEmpty.
	callNode 
		explore: #types;
		explore: #arguments;
		explore: #selfBefore;
		explore: #selfAfter;
		explore: #return.
	self assert: callNode objects notNil.
	self assert: (callNode objects at: #types) = 
		(OrderedCollection with: #self->SSBClassB with: #result->SmallInteger)."types" 
	self assert: (callNode objects at: #arguments) first = #(). "args" 
	self assert: (callNode objects at: #selfBefore) first myValue myValue = 5. "selfBefore"
	self assert: (callNode objects at: #selfAfter) first myValue myValue = 5. "selfAfter"
	self assert: (callNode objects at: #return) first = 10. "return"
! !

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 4/24/2010 19:09'!
testExploreReturnObject

	| callNode |
	callNode := self getNode: 12.
	self assert: callNode objects isEmpty.
	self assert: ((callNode explore: #return) first = 10).
	self assert: callNode objects notEmpty.
	self assert: ((callNode objects at: #return) first = 10).
	callNode callgraphModel: nil. "get cached value without callgraph access - no reload is possible"
	self assert: ((callNode explore: #return) first = 10).! !

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 4/24/2010 18:51'!
testInitialization
	
	| callNode |
	callNode := self getNode: 12.
	self assert: callNode tracer == self tracer.
	self assert: callNode objects isEmpty.		! !

STracerTest subclass: #STracerCoreTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:42.43'!
testBinaryMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testBinary.
	nodes := self callgraphGetNodesFor: SSBClassA method: #+.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testBinary.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:31.131'!
testClassMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testConstructor.
	nodes := self callgraphGetNodesFor: SSBClassB class method: #on:.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testConstructor.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:40.144'!
testGetNode

	self tracer traceTest: SSBTest method: #testDoNothing.
	self assert: (self tracer getNode: 0) == self rootNode.
	self assert: (self tracer getNode: -1) isNil.
	self assert: (self tracer getNode: 1) == self rootNode nextCalls first.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:35.579'!
testMethodChainTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testMethodChain.
	nodes := self callgraphGetNodesFor: SSBClassA method: #methodChain:.
	self assert: nodes size = 3.
	nodes do: [:each | 
		self assert: each fromSender clientClass == SSBTest.
		self assert: each fromSender clientSelector == #testMethodChain].! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:47.602'!
testModelViewTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testModelView.
	nodes := self callgraphGetNodesFor: SSBClassA method: #myValue:.
	self assert: nodes size = 3.
	self assert: nodes first nextCalls isEmpty.
	self assert: nodes second nextCalls isEmpty.
	self assert: nodes third nextCalls notEmpty.
	self assert: nodes third nextCalls first == (self callgraphGetNodesFor: SSBClassB method: #update:) first.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:54'!
testNextId

	self assert: self tracer currentId = -1.
	self assert: self tracer nextId = 0.
	self assert: self tracer currentId = 0.
	self assert: self tracer nextId = 1.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:33.775'!
testParameterMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testParamMethod.
	nodes := self callgraphGetNodesFor: SSBClassA method: #param:method:.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testParamMethod.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:55.359'!
testPartialTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testPartial.
	nodes := self callgraphGetNodesFor: Behavior method: #new.
	self assert: nodes isEmpty.
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	self assert: nodes notEmpty.
	nodes := self callgraphGetNodesFor: SPartialTraceObject method: #doSomething.
	self assert: nodes isEmpty.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:45.578'!
testRecursionTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testRecursion.
	nodes := self callgraphGetNodesFor: SSBClassA method: #recursionMethod:.
	self assert: nodes size = 6.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testRecursion.
	self assert: nodes second fromSender clientClass == SSBClassA.
	self assert: nodes second fromSender clientSelector == #recursionMethod:.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:00.158'!
testRunSingleWrapper

	| wrappers nodes |
	wrappers := OrderedCollection new.
	self tracer createNewCallgraphOn: SSBTest with: #foobar.
	[self tracer createWrapperOn: SSBClassA and: #doNothing addTo: wrappers.
	SSBClassA new doNothing] 
		ensure: [wrappers first uninstall].
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #foobar.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:26.777'!
testSetUpTestTearDownTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callgraphGetNodesFor: SSBTest method: #setUp.
	self assert: nodes size = 1.
	self assert: nodes first fromSender == self rootNode.
	nodes := self callgraphGetNodesFor: SSBTest method: #testDoNothing.
	self assert: nodes size = 1.
	self assert: nodes first fromSender == self rootNode.
	nodes := self callgraphGetNodesFor: SSBTest method: #tearDown.
	self assert: nodes size = 1.
	self assert: nodes first fromSender == self rootNode.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:40.375'!
testTraceOverClassBorders

	| nodes |
	self tracer traceTest: SSBTest method: #testComplexTrace.
	nodes := self callgraphGetNodesFor: SSBClassA method: #complexMethod:.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testComplexTrace.
	nodes := self callgraphGetNodesFor: SSBClassB method: #compute.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBClassA.
	self assert: nodes first fromSender clientSelector == #complexMethod:.	! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:37.169'!
testUnaryMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testUnary.
	nodes := self callgraphGetNodesFor: SSBClassA method: #unaryMethod.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testUnary.! !

STracerTest subclass: #STracerInitializeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:35.514'!
testCreateCallNode

	| nodes |
	self tracer createNewCallgraphOn: SSBTest with: #testDoNothing.
	self assert: (self tracer 
				createNewCallNodeOn: SSBClassB with: #compute receiverType: SSBClassB callsBefore: 0) = 1.
	nodes := self callgraphGetNodesFor: SSBClassB method: #compute.
	self assert: nodes notEmpty.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testDoNothing.
	! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:46.602'!
testCreateNewCallGraph

	self assert: self rootNode isNil.
	self tracer createNewCallgraphOn: SSBTest with: #testDoNothing.
	self assert: self tracer currentId = self tracer rootId.
	self assert: self rootNode notNil.
	self assert: self rootNode nextCalls isEmpty.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:44.899'!
testCreateRootNode

	self assert: self tracer currentId = -1.
	self tracer createRootNode: SSBTest withTest: #testDoNothing.
	self assert: self tracer currentId = self tracer rootId.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:04.328'!
testCreateWrapper

	| wrappers |
	wrappers := OrderedCollection new.
	[self tracer createWrapperOn: SSBClassA and: #doNothing addTo: wrappers.
	self assert: wrappers size = 1.
	self assert: wrappers first tracer == self tracer.
	self assert: wrappers first wrappedClass == SSBClassA.
	self assert: wrappers first clientSelector == #doNothing.] 
		ensure: [wrappers first uninstall].! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'bs 7/4/2010 21:32:38.406'!
testCreateWrappers

	| wrappers |
	[wrappers := self tracer createWrappers.
	self assert: wrappers notEmpty.
	self assert: wrappers size > 1.
	wrappers do: [:each | 
		each wrappedClass isMeta
			ifFalse: [self assert: (each wrappedClass category beginsWith: 'SightL-Tests-Sandbox')]]
	] ensure: [self tracer removeWrappers: wrappers].! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:51.842'!
testResetCallGraph

	self tracer createNewCallgraphOn: SSBTest with: #testDoNothing.
	self tracer resetCallgraph.
	self assert: self tracer currentId = -1.
	self assert: self rootNode isNil.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:55'!
testRootId

	self assert: self tracer rootId = 0.
	self deny: self tracer rootId = self tracer currentId.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:50.325'!
testRunTestWithoutInstrumentation

	self tracer createNewCallgraphOn: SSBTest with: #testDoNothing.
	self tracer runRootNode.
	self assert: self rootNode nextCalls isEmpty.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 5/2/2010 12:09'!
testRunTestWithoutInstrumentationAndChoosenTest

	self should: [self tracer runRootNode] raise: MessageNotUnderstood.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:54:03.337'!
testSelectedCategories

	self assert: SProject current categories size = 1.
	self assert: (SProject current categories includes: #'SightL-Tests-Sandbox').! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:48.403'!
testTestCaseIsAvailable

	self assert: (SProject current categories includes: SSBTest category)! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:40'!
testTracerInitialActiveState

	self deny: self tracer active.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:45'!
testTracerInitialCallgraphModel

	self assert: self tracer callgraphModel notNil.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:59.223'!
testTracerInitialCategories

	self assert: self tracer selectedCategories = SProject current categories.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:53'!
testTracerInitialCurrentId

	self assert: self tracer currentId = -1.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:40'!
testTracerInitialProfilingMode

	self assert: self tracer profilingMode = #normal.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:40'!
testTracerInitialViewMode

	self assert: self tracer viewMode = #classes.! !

STracerTest subclass: #STracerProfilingTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:21:43.97'!
testGetCallWrapperClass

	self tracer profilingMode: #%.
	self assert: self tracer getCallWrapperClass == SProfilingWrapper.	
	self tracer profilingMode: #counts.
	self assert: self tracer getCallWrapperClass == SCallWrapper.
	self tracer profilingMode: #ms.
	self assert: self tracer getCallWrapperClass == SProfilingWrapper.	
	self tracer viewMode: #identities.
	self tracer profilingMode: #counts.
	self assert: self tracer getCallWrapperClass == SViewWrapper.		! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:10.401'!
testProfilingAndView

	| nodes |
	self tracer profilingMode: #%.
	self tracer viewMode: #objects.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callgraphGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles notEmpty.
	self assert: nodes first views notEmpty.
	self assert: (nodes first profiles at: #%) asInteger > 60.
	self assert: (nodes first views at: #classes) = SSBClassA.
	self assert: (nodes first views at: #objects) = '0'.
	self assert: nodes first asString = ('[', (nodes first profiles at: #%),']', 
								(nodes first views at: #objects), '>>delayedMethod').! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:21.284'!
testProfilingCounts

	| nodes |
	self tracer profilingMode: #counts.
	self tracer traceTest: SSBTest method: #testRecursion.
	nodes := self callgraphGetNodesFor: SSBClassA method: #recursionMethod:.
	nodes withIndexDo: [:each :index | 
		self assert: each profiles notEmpty.
		self assert: (each profiles at: #counts) asInteger = index.		
		self assert: (each asString beginsWith: '[', (each profiles at: #counts),']SSBClassA>>recursionMethod:')].
! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:16.268'!
testProfilingMilliSeconds

	| nodes |
	self tracer profilingMode: #ms.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callgraphGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles notEmpty.
	self assert: (nodes first profiles at: #ms) asInteger >= 95.
	self assert: nodes first asString = ('[', (nodes first profiles at: #ms),']SSBClassA>>delayedMethod').! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:26.185'!
testProfilingPercentage
	
	| nodes |
	self tracer profilingMode: #%.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callgraphGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles notEmpty.
	self assert: (nodes first profiles at: #%) asInteger > 60.
	self assert: nodes first asString = ('[', (nodes first profiles at: #%),']SSBClassA>>delayedMethod').! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:30.564'!
testWithoutProfiling

	| nodes |
	self tracer profilingMode: #normal.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callgraphGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles isEmpty.
	self assert: nodes first asString = 'SSBClassA>>delayedMethod'.! !

STracerTest subclass: #STracerRefinementTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:50.348'!
testCreateExploreWrapper

	| nodes wrapper |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	wrapper := self tracer createExploreWrapper: #selfBefore on: nodes first.
	self assert: wrapper notNil.
	self assert: wrapper objects isEmpty.
	self assert: wrapper wrappedClass == SSBClassA.
	self assert: wrapper clientSelector == #doNothing.
	self assert: wrapper numberOfCallsBefore = 0.
	self assert: wrapper exploreWhat == #selfBefore.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:18.981'!
testExploreArgumentsBinary

	| obj args |
	self tracer traceTest: SSBTest method: #testBinary.
	obj := self tracer 
				explore: #arguments 
				on: (self callgraphGetNodesFor: SSBClassA method: #+) first.
	args := obj first.
	self assert: args notEmpty.
	self assert: args size = 1.
	self assert: args first = 5.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:57.327'!
testExploreArgumentsMultiply

	| obj args |
	self tracer traceTest: SSBTest method: #testParamMethod.
	obj := self tracer 
				explore: #arguments 
				on: (self callgraphGetNodesFor: SSBClassA method: #param:method:) first.
	args := obj first.
	self assert: args notEmpty.
	self assert: args size = 2.
	self assert: args = #(1 2).! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:38.029'!
testExploreArgumentsUnary

	| args |
	self tracer traceTest: SSBTest method: #testUnary.
	args := self tracer 
				explore: #arguments 
				on: (self callgraphGetNodesFor: SSBClassA method: #unaryMethod) first.
	self assert: args first isEmpty.
	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:02.364'!
testExploreExplicitReturn

	| return |
	self tracer traceTest: SSBTest method: #testUnary.
	return := self tracer 
				explore: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #unaryMethod) first.
	self assert: return notEmpty.
	self assert: return first.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:17.204'!
testExploreOn

	| obj |
	self tracer traceTest: SSBTest method: #testDoNothing.
	 obj := self tracer explore: #selfBefore on: (self callgraphGetNodesFor: SSBClassA method: #doNothing) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first myValue = 0.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:45.538'!
testExploreRecursionMethodFirst

	| obj |
	self tracer traceTest: SSBTest method: #testRecursion.
	obj := self tracer 
				explore: #arguments 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) first.
	self assert: obj first first = 5.	
			
	obj := self tracer 
				explore: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) first.	
	self assert: obj first = 15.	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:00.292'!
testExploreRecursionMethodLast

	| obj |
	self tracer traceTest: SSBTest method: #testRecursion.
	obj := self tracer 
				explore: #arguments 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) last.
	self assert: obj first first = 0.	
			
	obj := self tracer 
				explore: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) last.	
	self assert: obj first = 0.	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:14.23'!
testExploreRecursionMethodMiddle

	| obj |
	self tracer traceTest: SSBTest method: #testRecursion.
	obj := self tracer 
				explore: #arguments 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) third.
	self assert: obj first first = 3.	
			
	obj := self tracer 
				explore: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) third.	
	self assert: obj first = 6.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:40.934'!
testExploreSelfAfter

	| obj |
	self tracer traceTest: SSBTest method: #testModelView.
	 obj := self tracer explore: #selfAfter on: (self callgraphGetNodesFor: SSBClassB method: #myValue:) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first class = SSBClassB.
	self assert: obj first myValue = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:45.163'!
testExploreSelfBefore

	| obj |
	self tracer traceTest: SSBTest method: #testModelView.
	 obj := self tracer explore: #selfBefore on: (self callgraphGetNodesFor: SSBClassB method: #myValue:) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first class = SSBClassB.
	self assert: obj first myValue = nil.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:37.393'!
testExploreSelfBeforeAndAfterDifference

	| before after node |
	self tracer traceTest: SSBTest method: #testModelView.
	node := (self callgraphGetNodesFor: SSBClassB method: #myValue:) first.
	before := (self tracer explore: #selfBefore on: node) first.
	after := (self tracer explore: #selfAfter on: node) first.
	self deny: before == after.
	self assert: before myValue isNil.
	self assert: after myValue = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:34.724'!
testExploreSelfReturn

	| obj |
	self tracer traceTest: SSBTest method: #testDoNothing.
	obj := self tracer explore: #return on: (self callgraphGetNodesFor: SSBClassA method: #doNothing) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first class == SSBClassA.
	self assert: obj first myValue = 0.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:10.635'!
testExploreTypes

	|  types |
	self tracer traceTest: SSBTest method: #testParamMethod.
	types := self tracer 
				explore: #types 
				on: (self callgraphGetNodesFor: SSBClassA method: #param:method:) first.
	self assert: types notEmpty.
	self assert: types size = 3.

	self assert: types first key == #arguments.
	self assert: types first value size = 2.
	self assert: types first value first = SmallInteger.
	self assert: types first value second = SmallInteger.

	self assert: types second key == #self.
	self assert: types second value == SSBClassA.

	self assert: types third key == #result.
	self assert: types third value == Array.	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:41.333'!
testNumberOfCallsBeforeMethodChain

	| wrapper |
	self tracer traceTest: SSBTest method: #testMethodChain.
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #methodChain:) first.
	self assert: wrapper numberOfCallsBefore = 0.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #methodChain:) second.
	self assert: wrapper numberOfCallsBefore = 1.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #methodChain:) third.
	self assert: wrapper numberOfCallsBefore = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:54.104'!
testNumberOfCallsBeforeRecursion

	| wrapper |
	self tracer traceTest: SSBTest method: #testRecursion.
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) first.
	self assert: wrapper numberOfCallsBefore = 0.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) last.
	self assert: wrapper numberOfCallsBefore = 5.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callgraphGetNodesFor: SSBClassA method: #recursionMethod:) third.
	self assert: wrapper numberOfCallsBefore = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:05.983'!
testRunOwnExploreWrapper

	| nodes wrapper a |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	[wrapper := self tracer createExploreWrapper: #selfBefore on: nodes first.
	wrapper install.
	a := SSBClassA new myValue: 123.
	a doNothing.
	self assert: wrapper objects notEmpty.
	self assert: wrapper objects size = 1.
	self assert: wrapper objects first myValue = a myValue.
	self deny: wrapper objects first == a]
		ensure: [wrapper uninstall].! !

!STracerTest methodsFor: 'helper' stamp: 'mp 3/8/2010 16:23'!
callgraphGetNodesFor: aClass method: aMethodSelector
	| nodes |
	nodes := OrderedCollection new.
	self tracer callgraphModel traverseCallGraph: self rootNode 
			with: [:aNode | 
				(aNode clientClass == aClass and: [aNode clientSelector == aMethodSelector])
					ifTrue: [nodes add: aNode]].
	^ nodes! !

!STracerTest methodsFor: 'helper' stamp: 'mp 3/8/2010 16:22'!
rootNode

	^ self tracer callgraphModel rootNode! !

!STracerTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:20:33.267'!
setUp

	oldCurrentProject := SProject current.
	SProject setCurrent: #sandbox.
	self tracer: (SCallgraphTracer on: SProject current categories).
	self tracer callgraphModel: (SCallgraphModel on: self tracer).! !

!STracerTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:51.492'!
tearDown

	SProject setCurrentProject: oldCurrentProject.! !

!STracerTest methodsFor: 'accessing' stamp: 'mp 3/5/2010 17:48'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!STracerTest methodsFor: 'accessing' stamp: 'mp 3/5/2010 17:48'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

STracerTest subclass: #STracerViewTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-Tracer'!

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:38.006'!
testClassesView

	| nodes |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	self assert: (nodes first views at: #classes) = SSBClassA.
	self assert: nodes first asString = 'SSBClassA>>doNothing'.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:21:48.899'!
testGetCallWrapperClass

	self tracer viewMode: #objects.
	self assert: self tracer getCallWrapperClass == SViewWrapper.
	self tracer viewMode: #classes.
	self assert: self tracer getCallWrapperClass == SCallWrapper.	
	self tracer viewMode: #identities.
	self assert: self tracer getCallWrapperClass == SViewWrapper.
	self tracer profilingMode: #%.
	self assert: self tracer getCallWrapperClass == SProfilingWrapper.	
	self tracer profilingMode: #counts.
	self assert: self tracer getCallWrapperClass == SViewWrapper.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:32.175'!
testIdentityView

	| nodes |
	self tracer viewMode: #identities.
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	self assert: (nodes first views at: #identities) asInteger > 0.
	self assert: (nodes first asString beginsWith: 'SSBClassA').
	self assert: (nodes first asString occurrencesOf: $() = 1.
	self assert: ((nodes first asString subStrings: '(') second subStrings: ')') first asInteger > 0.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:35.024'!
testObjectsView

	| nodes |
	self tracer viewMode: #objects.
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callgraphGetNodesFor: SSBClassA method: #doNothing.
	self assert: (nodes first views at: #objects) = '0'.
	self assert: nodes first asString = '0>>doNothing'.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:22.658'!
testPrintString

	| a |
	a := SSBClassA new.
	self assert: a asString = '0'.
	a myValue: 123.
	self assert: a asString = '123'.
	self assert: SSBClassB new asString = 'a SSBClassB'.! !

TestCase subclass: #SWrapperTest
	instanceVariableNames: 'myObject originalMethod methodRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

SWrapperTest subclass: #SAroundWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

!SAroundWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:45:09.713'!
tearDown

	SAroundWrapperMethodOne nuke.
	SAroundWrapperMethodTwo nuke.
	super tearDown.! !

!SAroundWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:45:13.183'!
testAround

	| wrapper |
	wrapper := SAroundWrapperMethodOne on: #methodOne inClass: SClassA.
	self assert: self myObject methodOne.
	wrapper install.
	self deny: self myObject methodOne.
	wrapper uninstall.
	self assert: self myObject methodOne.
	
	! !

!SAroundWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:59.159'!
testProceed

	| wrapper1 wrapper2 |
	wrapper1 := SAroundWrapperMethodTwo on: #methodTwo: inClass: SClassA.
	wrapper2 := SAroundWrapperMethodTwo on: #methodTwo: inClass: SClassA.	
	self assert: (self myObject methodTwo: 1) = 1.
	wrapper1 install.
	self assert: (self myObject methodTwo: 1) = 3.
	wrapper1 uninstall.
	self assert: (self myObject methodTwo: 1) = 1.
	wrapper2 install.
	self assert: (self myObject methodTwo: 1) = 3.
	wrapper2 uninstall.! !

SWrapperTest subclass: #SBeforeWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Tests-MethodWrappers'!

!SBeforeWrapperTest methodsFor: 'private' stamp: 'mp 1/22/2010 15:49'!
checkTouchs:  aWrapperAssocCollection

	aWrapperAssocCollection do: [:each | self assert: each key touched = each value].
	! !

!SBeforeWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:44:16.005'!
tearDown

	SBeforeWrapper nuke.
	super tearDown.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:12.745'!
testAccessCompiledMethod

	| wrappers |
	wrappers := OrderedCollection new.
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers first install.
	wrappers  second install.
	wrappers third install.
	self checkWrapperChain: #(Wrapper Wrapper Wrapper Original) of: self methodRef.
	self assert: wrappers third unwrappedMethod = originalMethod.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:22.331'!
testInstallationMultipleWrappers

	| wrappers |
	wrappers := OrderedCollection new.
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	self checkWrapperChain: #(Original) of: self methodRef.
	wrappers first install.
	self checkWrapperChain: #(Wrapper Original) of: self methodRef.
	wrappers  second install.
	self checkWrapperChain: #(Wrapper Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers second.
	wrappers third install.
	self checkWrapperChain: #(Wrapper Wrapper Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers third.
	self assert: self methodRef compiledMethod clientMethod == wrappers second.
	self assert: self methodRef compiledMethod clientMethod clientMethod  == wrappers first.
	wrappers first uninstall.
	self checkWrapperChain: #(Wrapper Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers third.
	self assert: self methodRef compiledMethod clientMethod  == wrappers second.
	wrappers third uninstall.
	self checkWrapperChain: #( Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers second.
	wrappers second uninstall.
	self checkWrapperChain: #( Original) of: self methodRef.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:27.061'!
testInstallationOneWrapper

	| wrapper |
	wrapper := SBeforeWrapper on: #methodOne inClass: SClassA.
	self deny: self methodRef compiledMethod isMwMethodWrapper.
	wrapper install.
	self assert: self methodRef compiledMethod isMwMethodWrapper.
	wrapper uninstall.
	self deny: self methodRef compiledMethod isMwMethodWrapper.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:18.542'!
testOneWrapper

	| wrapper |
	wrapper := SBeforeWrapper on: #methodOne inClass: SClassA.
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper -> 0}. 
	wrapper install.
	self checkTouchs: {wrapper -> 0}. 
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper -> 1}. 
	wrapper uninstall.
	self assert: ((MethodReference class: SClassA selector: #methodOne) compiledMethod isKindOf: CompiledMethod).
	self checkTouchs: {wrapper -> 1}. 
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper -> 1}.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:09.372'!
testTwoWrappers

	| wrapper1 wrapper2 |
	wrapper1 := SBeforeWrapper on: #methodOne inClass: SClassA.
	wrapper2 := SBeforeWrapper on: #methodOne inClass: SClassA.
	self checkTouchs: {wrapper1 -> 0. wrapper2 -> 0}. 
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper1 -> 0. wrapper2 -> 0}. 	
	wrapper1 install.
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper1 -> 1. wrapper2 -> 0}. 
	wrapper2 install.
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper1 -> 2. wrapper2 -> 1}. 	
	wrapper2 uninstall.
	self assert: self methodRef compiledMethod isMwMethodWrapper.
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper1 -> 3. wrapper2 -> 1}. 
	wrapper1 uninstall.
	self deny:  self methodRef compiledMethod isMwMethodWrapper.
	self assert: self myObject methodOne.
	self checkTouchs: {wrapper1 -> 3. wrapper2 -> 1}. 	! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 1/22/2010 17:02'!
testWithoutWrapper

	self assert: self myObject methodOne.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:30.095'!
testWrappingWrapper

	| wrappers |
	wrappers := OrderedCollection new.
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers first install.
	wrappers  second install.
	wrappers third install.
	self checkWrapperChain: #(Wrapper Wrapper Wrapper Original) of: self methodRef.
	self assert: wrappers third wrappingWrapper = nil.
	self assert: wrappers second wrappingWrapper = wrappers third.
	self assert: wrappers first wrappingWrapper = wrappers second.
	wrappers second uninstall.
	self assert: wrappers second wrappingWrapper = nil.
	self assert: wrappers first wrappingWrapper = wrappers third.! !

!SWrapperTest methodsFor: 'private' stamp: 'mp 3/5/2010 12:57'!
checkWrapperChain: anArray of: aMethodRef

	| item |
	item := aMethodRef compiledMethod.
	anArray do: [:each |
		each == #Wrapper
			ifTrue: [	self assert: item isMwMethodWrapper.
					item := item clientMethod].
		each == #Original
			ifTrue: [self deny: item isMwMethodWrapper]].! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:54'!
methodRef
	"Answer the value of methodRef"

	^ methodRef! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:54'!
methodRef: anObject
	"Set the value of methodRef"

	methodRef := anObject! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:55'!
myObject
	"Answer the value of myObject"

	^ myObject! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:55'!
myObject: anObject
	"Set the value of myObject"

	myObject := anObject! !

!SWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:43:07.462'!
setUp

	self myObject: SClassA new.
	originalMethod := (MethodReference class: SClassA selector: #methodOne) compiledMethod.
	self methodRef: (MethodReference class: SClassA selector: #methodOne).! !

!SWrapperTest methodsFor: '-- all --' stamp: 'mp 1/22/2010 16:56'!
tearDown

	self methodRef actualClass methodDictionary at: self methodRef methodSymbol put: originalMethod.! !

!TestCase class methodsFor: '*SightL' stamp: 'mp 3/24/2011 10:54:24.775'!
inheritedTestSelectors
	^ self shouldInheritSelectors
		ifTrue: [self allTestSelectors]
		ifFalse: [self testSelectors ]! !

TestCase subclass: #TestDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Example-Observer'!

!TestDriver methodsFor: 'testing' stamp: 'mp 9/29/2010 14:02:17.276'!
testNoop

	self assert: self class == TestDriver! !

!TestDriver methodsFor: 'testing' stamp: 'mp 4/28/2010 14:13'!
testRun
	| timer analogClock digitalClock |

	timer := ClockTimer new.
	analogClock := AnalogClock on: timer.
	digitalClock := DigitalClock on: timer.
	
	timer tick.! !

StringMorph subclass: #SActionStringMorph
	instanceVariableNames: 'actionModel actionSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SightL-Morphic'!

!SActionStringMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:11'!
on: aModel selector: aSymbol

	^ self on: aModel selector: aSymbol name: aModel asString! !

!SActionStringMorph class methodsFor: 'instance creation' stamp: 'mp 1/7/2010 17:44'!
on: aModel selector: aSymbol name: aString

	^ (self contents: aString)
		actionModel: aModel;
		actionSelector: aSymbol! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionModel
	^ actionModel! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionModel: anObject
	actionModel := anObject! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionSelector
	^ actionSelector! !

!SActionStringMorph methodsFor: 'accessing' stamp: 'mp 1/6/2010 16:25'!
actionSelector: anObject
	actionSelector := anObject! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 16:22'!
handlesMouseDown: evt

	^ true! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 14:01'!
handlesMouseOver: anEvent

	^ true! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 14:04'!
mouseEnter: anEvent

	self emphasis: (TextEmphasis underlined) emphasisCode.! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 1/6/2010 14:04'!
mouseLeave: anEvent

	self emphasis: (TextEmphasis normal) emphasisCode.! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 3/1/2010 16:47'!
mouseUp: anEvent

	self performAction.! !

!SActionStringMorph methodsFor: 'event handling' stamp: 'mp 3/1/2010 16:47'!
performAction

	self actionModel perform: self actionSelector.! !

!PasteUpMorph methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:01'!
modalLockTo: aSystemWindow
	"Don't lock the world!! Lock the submorphs.
	The modal window gets opened afterwards so is OK."
	
	|lockStates|
	lockStates := IdentityDictionary new.
	self submorphsDo: [:m |
		lockStates at: m put: m isLocked.
		m lock].
	self
		setProperty: #submorphLockStates
		toValue: lockStates! !

!PasteUpMorph methodsFor: '*SightL' stamp: 'mp 1/20/2010 19:02'!
modalUnlockFrom: aSystemWindow
	"Don't unlock the world!! Unlock the submorphs
	that were not originally locked."
	
	|lockStates|
	lockStates := self
		valueOfProperty: #submorphLockStates
		ifAbsent: [^self].
	self removeProperty: #submorphLockStates.
	lockStates keysAndValuesDo: [:m :locked |
		locked ifFalse: [m unlock]]! !
SProject initialize!
SPathFinder initialize!
SPathView initialize!
SProjectChooser initialize!
SPathMapTestRunner initialize!
SBrowser initialize!
SWrapper initialize!
